//----------------------------
// Hidden & Dangerous Deluxe
// CD-ROM AutoRun application
// Original by: Aley Keprt
// Updated by: Michal Bacik
//----------------------------

#define WIN32_LEAN_AND_MEAN
#include <windows.h>

#include <mmsystem.h>
#include <process.h>
#include <direct.h>
#include <stdlib.h>

#include <shellapi.h>
#include <rules.h>
#include <win_reg.h>
#include <c_string.hpp>

#include "resource.h"


                              //window size
#define WIN_WIDTH 600         
#define WIN_HEIGHT 450
                              //button size
#define BUT_WIDTH 124            
#define BUT_HEIGHT 27            

#define BUT_LEFT 31           //x position of left buttons
#define BUT_RIGHT (WIN_WIDTH-BUT_WIDTH-BUT_LEFT)  //x position of right buttons
#define BUT_TOP  84           //y position of 1st button
#define BUT_SPACING (15+BUT_HEIGHT) //button spacing


#define NUM_BUTTONS 35        //number of buttons
#define NUM_LEFT_BUTTONS 7


#define FILE_ABOUT TEXT_DIR   "About.html"
#define FILE_SETUP            "Bin\\IConfig.exe"

#define EXE_NAME              "Bin\\HDE.exe"
static const char INSTALL_NAME[] = "Setup.exe";
#define ERROR_TITLE           "Application error"
#define ERROR_MSG             "Unable to run: \"%s\""


static const char REGDIR[] = "Software\\Lonely Cat Games\\Hidden and Dangerous Deluxe\\1.50";
static const char INSTALL_TARGET[] = "Install target dir";
static const char UNINSTALL_REG[] = "Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\Hidden and Dangerous Deluxe";
static const char APP_TITLE[] = "Hidden and Dangerous Deluxe Autorun";

enum E_COMMAND{
   CMD_PLAY,                  //play the game (run executable)
   CMD_INSTALL,               //install root button
   CMD_CONFIG,
   CMD_HELP,
   CMD_LINKS,
   CMD_PLAY_ONLINE,
   CMD_QUIT,
   CMD_INSTALL_RUN,           //run installation
   CMD_UNINSTALL,
   CMD_README,
   CMD_FAQ,
   CMD_DRIVERS,
   CMD_LINK1,
   CMD_LINK2,
   CMD_LINK3,
   CMD_LAST
};

//----------------------------

enum DIR{
   DIR_NULL,
   DIR_TARGET,
   DIR_LOCAL,
};

//----------------------------

static const struct{
   const char *name;
   E_COMMAND cmd;
   DIR dir;
} document_info[] = {
   "Bin\\IConfig.exe", CMD_CONFIG, DIR_LOCAL,
   //"Readme.txt", CMD_README, DIR_LOCAL,
   //"faq.htm", CMD_FAQ, DIR_LOCAL,
   "faq.htm", CMD_HELP, DIR_LOCAL,
   //"drivers.htm", CMD_DRIVERS, DIR_LOCAL,         
   "http://www.illusionsoftworks.com", CMD_LINK1, DIR_LOCAL,
   "http://www.take2games.co.uk", CMD_LINK2, DIR_LOCAL,
   "http://www.lonelycatgames.com", CMD_LINK3, DIR_LOCAL,
   "http://www.gamespyarcade.com/features/launch.asp?svcname=hd", CMD_PLAY_ONLINE, DIR_LOCAL,
   NULL
};

//----------------------------

class C_autorun{
   C_string cmd_uninstall;    //uninstall string in the registry
   C_string install_target;

   HBITMAP button[NUM_BUTTONS];
   HBITMAP background;

                              //button index under mouse (-1 = no button)
   int button_index_l;        //left column
   int button_index_r;        //right column

   int num_r_buttons;         //number of buttons on right side
   int rbutofs;               //index into 1st button on right side

//----------------------------
// Show specified document (local or remote).
   bool ShowDocument(HWND hwnd, E_COMMAND cmd){

      for(int i=0; document_info[i].name; i++){
         if(document_info[i].cmd==cmd)
            break;
      }
      if(!document_info[i].name)
         return false;

      const char *dir_base;
      switch(document_info[i].dir){
      case DIR_TARGET: dir_base = install_target; break;
      default: dir_base = "";
      }
      C_fstring str("%s%s", dir_base, document_info[i].name);

      i = (int)ShellExecute(hwnd, NULL, str, NULL, "", SW_SHOWDEFAULT);
      if(i>32)
         return true;
      MessageBox(NULL, C_fstring(ERROR_MSG, (const char*)str), ERROR_TITLE, MB_OK);
      return false;
   }

//----------------------------
// Get button index under specified position.
   E_COMMAND CheckButtonHit(int button_left, int xpos, int ypos) {

      if(xpos>=button_left && xpos<(button_left+BUT_WIDTH)){
         ypos -= BUT_TOP;
         if(ypos>=0 && (ypos%BUT_SPACING) < BUT_HEIGHT){
            ypos /= BUT_SPACING;
            if(ypos>=0 && ypos< NUM_LEFT_BUTTONS)
               return (E_COMMAND)ypos;
         }
      }
      return CMD_LAST;
   }

//----------------------------
// Draw single button.
   void DrawButton(HDC hdc, int pos_x, int pos_y_indx, int but_indx){

      switch(but_indx/2){
      case CMD_PLAY:
         if(!install_target.Size())
            but_indx = 32;
         break;
      case CMD_UNINSTALL:
         if(!cmd_uninstall.Size())
            but_indx = 33;
         break;
      case CMD_PLAY_ONLINE:
         if(!install_target.Size())
            but_indx = 34;
         break;
      }


      HDC hdcImage = CreateCompatibleDC(0);
      SelectObject(hdcImage, button[but_indx]);
      BitBlt(hdc, pos_x, BUT_TOP + pos_y_indx * BUT_SPACING, BUT_WIDTH, BUT_HEIGHT, hdcImage, 0, 0, SRCCOPY);
      DeleteDC(hdcImage);
   }

   inline void DrawButtonL(HDC hdc, int index, int state) {
      DrawButton(hdc, BUT_LEFT, index, index*2+state);
   }

   inline void DrawButtonR(HDC hdc, int pos_y_indx, int state){
      DrawButton(hdc, BUT_RIGHT, pos_y_indx, (rbutofs+pos_y_indx)*2+state);
   }

//----------------------------

   BOOL CALLBACK dlgProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam){

      switch(uMsg){

      case WM_INITDIALOG:
         {
                              //center window
            RECT rc;
            GetWindowRect(hwnd, &rc);
            int x = (GetSystemMetrics(SM_CXSCREEN)-WIN_WIDTH) / 2;
            int y = (GetSystemMetrics(SM_CYSCREEN)-WIN_HEIGHT) / 2;
            SetWindowPos(hwnd, NULL, x, y, WIN_WIDTH, WIN_HEIGHT, SWP_NOACTIVATE | SWP_NOREDRAW);
            SetWindowText(hwnd, APP_TITLE);

#if !defined _DEBUG || 1
                              //play intro sound
            const char *res = MAKEINTRESOURCE(IDR_WAVE1);
            dword flags = SND_ASYNC | SND_RESOURCE | SND_NOWAIT;
            PlaySound(res, GetModuleHandle(NULL), flags);
#endif
         }
         return 1;

      case WM_ERASEBKGND:
         return 1;

      case WM_PAINT:
         {
            PAINTSTRUCT ps;
            BeginPaint(hwnd, &ps);
            HDC hdc;
            hdc = GetDC(hwnd);

                              //draw background
            HDC hdcImage = CreateCompatibleDC(0);
            SelectObject(hdcImage, background);
            BitBlt(hdc, 0, 0, WIN_WIDTH, WIN_HEIGHT, hdcImage, 0, 0, SRCCOPY);
            DeleteDC(hdcImage);

                              //draw left buttons
            int i;
            for(i=0; i<NUM_LEFT_BUTTONS; i++)
               DrawButtonL(hdc, i, (button_index_l==i));

                              //draw right buttons         
            for(i=0; i<num_r_buttons; i++)
               DrawButtonR(hdc, i, (button_index_r==i));

            ReleaseDC(hwnd,hdc);
            EndPaint(hwnd,&ps);
         }
         break;

      case WM_LBUTTONDOWN:
         {
            int xpos = LOWORD(lParam);
            int ypos = HIWORD(lParam);

                              //test mouse collision with buttons      
            E_COMMAND button_index = CheckButtonHit(BUT_LEFT, xpos, ypos);
            if(button_index==CMD_LAST){
               button_index = CheckButtonHit(BUT_RIGHT, xpos, ypos);
               if(button_index!=CMD_LAST)
                  button_index = (E_COMMAND)(button_index + rbutofs);
            }

            switch(button_index){
            case CMD_PLAY:
                              //check if installed
               if(install_target.Size()){
                  C_fstring full_name("%s"EXE_NAME, (const char*)install_target);
                  int i = spawnl(P_NOWAIT,
                     full_name,
                     C_fstring("\"%s\"", (const char*)full_name),
                     0);
                  if(i==-1)
                     MessageBox(hwnd, (const char*)C_fstring(ERROR_MSG, (const char*)full_name), ERROR_TITLE, MB_OK);
                  else
                     EndDialog(hwnd, 0);
               }
               break;

            case CMD_INSTALL_RUN:
               {
                  char buf[MAX_PATH], drive[MAX_PATH], dir[MAX_PATH], fname[MAX_PATH], ext[MAX_PATH];
                  GetModuleFileName(NULL, buf, sizeof(buf));
                  _splitpath(buf, drive, dir, fname, ext);
                  _makepath(buf, drive, dir, NULL, "");
                  _chdir(buf);

                  int i = spawnl(P_NOWAIT, INSTALL_NAME, INSTALL_NAME, NULL);
                  if(i==-1){
                     MessageBox(hwnd, C_fstring(ERROR_MSG, INSTALL_NAME), ERROR_TITLE, MB_OK);
                  }else
                     EndDialog(hwnd, 0);
               }
               break;

            case CMD_QUIT:
               EndDialog(hwnd, 0);
               break;

            case CMD_UNINSTALL:
               if(cmd_uninstall.Size()){
                  C_string cmd = cmd_uninstall;
                  bool is_quoted = false;
                  if(cmd[0] = '\"'){
                     is_quoted = true;
                     cmd = &cmd[1];
                  }
                  for(int i=0; i<(int)cmd.Size(); i++){
                     if(is_quoted){
                        if(cmd[i]=='\"'){
                           cmd[i] = 0;
                           break;
                        }
                     }else{
                        if(isspace(cmd[i])){
                           cmd[i] = 0;
                           break;
                        }
                     }
                  }
                  i = spawnl(P_NOWAIT, cmd, cmd_uninstall, NULL);
                  if(i==-1){
                     MessageBox(hwnd, C_fstring(ERROR_MSG, (const char*)cmd_uninstall), ERROR_TITLE, MB_OK);
                  }else
                     EndDialog(hwnd, 0);
               }
               break;

            case CMD_INSTALL:
               if(rbutofs!=CMD_INSTALL_RUN){
                  rbutofs = CMD_INSTALL_RUN;
                  num_r_buttons = 2;
                  button_index_r = -1;
                  InvalidateRect(hwnd, 0, 0);
               }
               break;

               /*
            case CMD_HELP:
               if(rbutofs!=CMD_README){
                  rbutofs = CMD_README;
                  num_r_buttons = 3;
                  button_index_r = -1;
                  InvalidateRect(hwnd, 0, 0);
               }
               break;
               */

            case CMD_LINKS:
               if(rbutofs!=CMD_LINK1){
                  rbutofs = CMD_LINK1;
                  num_r_buttons = 3;
                  button_index_r = -1;
                  InvalidateRect(hwnd, 0, 0);
               }
               break;

            case CMD_PLAY_ONLINE:
               if(!install_target.Size())
                  break;
                              //flow...
            default:
               ShowDocument(hwnd, button_index);
               break;
            }
         }
         break;

      case WM_MOUSEMOVE:
         {
            int xpos = LOWORD(lParam);
            int ypos = HIWORD(lParam);

            E_COMMAND new_index = CheckButtonHit(BUT_LEFT, xpos, ypos);
            if(new_index>=0 && new_index<NUM_LEFT_BUTTONS){
               if(new_index != button_index_l){
                  HDC hdc = GetDC(hwnd);
                  if(button_index_l!=-1)
                     DrawButtonL(hdc, button_index_l, 0);
                  button_index_l = new_index;
                  DrawButtonL(hdc, button_index_l, 1);
                  ReleaseDC(hwnd, hdc);
               }
            }else
            if(button_index_l != -1){
               HDC hdc = GetDC(hwnd);
               DrawButtonL(hdc, button_index_l, 0);
               ReleaseDC(hwnd, hdc);
               button_index_l = -1;
            }

            new_index = CheckButtonHit(BUT_RIGHT, xpos, ypos);
            if(new_index>=0 && new_index<num_r_buttons){
               if(new_index != button_index_r){
                  HDC hdc = GetDC(hwnd);

                  if(button_index_r!=-1)
                     DrawButtonR(hdc, button_index_r, 0);
                  button_index_r = new_index;
                  DrawButtonR(hdc, button_index_r, 1);
                  ReleaseDC(hwnd, hdc);
               }
            }else
            if(button_index_r != -1){
               HDC hdc = GetDC(hwnd);
               DrawButtonR(hdc, button_index_r, 0);
               ReleaseDC(hwnd, hdc);
               button_index_r = -1;
            }
         }
         break;

      case WM_COMMAND:
         switch(LOWORD(wParam)){
         case IDCANCEL:
            EndDialog(hwnd,CMD_QUIT);
         }
         break;
      }
      return 0;
   }

//----------------------------

   static BOOL CALLBACK dlgProc_thunk(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam){

      switch(uMsg){
      case WM_INITDIALOG:
         SetWindowLong(hwnd, GWL_USERDATA, lParam);
         break;
      }

      C_autorun *ar = (C_autorun*)GetWindowLong(hwnd, GWL_USERDATA);
      if(ar)
         return ar->dlgProc(hwnd, uMsg, wParam, lParam);
      return 0;
   }
   
public:
   C_autorun():
      button_index_l(-1),
      button_index_r(-1),
      background(NULL)
   {
      memset(button, 0, sizeof(button));
   }

   ~C_autorun(){
      if(background)
         DeleteObject(background);
      for(int i=NUM_BUTTONS; i--; ){
         if(button[i])
            DeleteObject(button[i]);
      }
   }

//----------------------------
   void Init(HINSTANCE hi){
                              //load bitmaps
      background = (HBITMAP)LoadImage(hi, MAKEINTRESOURCE(IDB_BACKGROUND), IMAGE_BITMAP, 0, 0, LR_CREATEDIBSECTION);
      assert(background);
      for(int i=0; i<NUM_BUTTONS; i++){
         button[i] = (HBITMAP)LoadImage(hi, MAKEINTRESOURCE(IDB_BUTTON0+i), IMAGE_BITMAP, 0, 0, LR_CREATEDIBSECTION);
         assert(button[i]);
      }

                              //find uninstall string
      int rkey = RegkeyOpen(UNINSTALL_REG);
      if(rkey!=-1){
         char buf[512];
         int i = RegkeyRdata(rkey, "UninstallString", (byte*)buf, sizeof(buf));
         if(i==-1)
            buf[0] = 0;
         RegkeyClose(rkey);
         cmd_uninstall = buf;
      }

                              //check if game is already installed
      rkey = RegkeyOpen(REGDIR);
      if(rkey!=-1){
         char buf[512];
         int i = RegkeyRdata(rkey, INSTALL_TARGET, (byte*)buf, sizeof(buf));
         if(i==-1)
            buf[0] = 0;
         else{
            int len = strlen(buf);
            if(buf[len-1] != '\\')
               buf[len++] = '\\';
               buf[len] = 0;
         }
         RegkeyClose(rkey);
         install_target = buf;
      }
   }

//----------------------------

   int Run(HINSTANCE hi){
      return DialogBoxParam(hi, "IDD_DIALOG_MAIN", NULL, (DLGPROC)dlgProc_thunk, (LPARAM)this);
   }
};

C_autorun autorun;

//----------------------------

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow){

                              //check if game is already running
                              // quit autorun if so
   HWND hwnd_app = FindWindow("IGraph_Window", NULL);
   if(hwnd_app)
      return 0;

                              //check if autorun is already running
   hwnd_app = FindWindow(NULL, APP_TITLE);
   if(hwnd_app){
      SetForegroundWindow(hwnd_app);
      return 0;
   }

   autorun.Init(hInstance);
   autorun.Run(hInstance);

   return 0;
}

//----------------------------
