

//----------------------------

enum{
   EXPLOSION_MINE=0,
   EXPLOSION_GRENADE=1,
   EXPLOSION_PANZER=2,
   EXPLOSION_TIMEBOMB=3,
   EXPLOSION_TANK_MISSILE=6,
};

                              //notify keys used
enum{
   NOTIFY_PUT = 30,
   NOTIFY_GET,
   NOTIFY_CHANGE,
   NOTIFY_THROW,
   NOTIFY_JUMP = 34,
   NOTIFY_FLARE_FIRE,
   NOTIFY_LOAD_GUN,
   NOTIFY_PULL_GUN,
   NOTIFY_GRAB = 38,
   NOTIFY_KNIFE_HIT,
   NOTIFY_GRAB_OK,
   NOTIFY_DOOR_OPEN,
};

//----------------------------

                              //icon image - small sprite showing interesting
                              //values to player
enum E_ICON_IMAGE{
   IIMG_AMMO=48,
   IIMG_TIME,
   IIMG_PETROL=53,
   IIMG_PHOTOS,
   IIMG_GRENADE,
};

//----------------------------

                              //friendship - relation of humans
enum E_RELATION{
   RELATION_FRIEND, RELATION_ENEMY, RELATION_NEUTRAL
};

//----------------------------

enum E_MOVE_REASON{
   MR_NORMAL,
   MR_USE_REACH,
   MR_FOLLOW_REACH,
   MR_ATTACK_REACH,
   MR_WALK_CP,
};

enum E_ATTACK_MODE{
   AM_NORMAL,
   AM_MUST_SUCCEED,
};

//----------------------------

struct S_obstacle_move{
   S_vector from, to;
   float necessity;
   S_obstacle_move(const S_vector &f, const S_vector &t, float n):
      from(f),
      to(t),
      necessity(n)
   {}
};

//----------------------------
                              //actor creation structures

struct S_gun_shoot_init{
   S_vector pos, dir;
   int shoot_item;
   LPC_actor shooter;
   dword delay;
   PI3D_sound gun_snd;
   PI3D_frame weapon;        //NULL = cross aiming
   LPC_actor cannon_actor;
   bool weapon_inverse;
   int power;
   const S_vector *aim_disp;  //for delayed shots
                              //network only:
   dword netw_actor;          //pid of network-controlled actor, or 0
   float hit_dist;            //hit distance
   S_gun_shoot_init(){ memset(this, 0, sizeof(S_gun_shoot_init)); }
};

//----------------------------

struct S_rocket_init{
   S_vector pos, dir;
   LPC_actor shooter;
   word id;
                              //network only:
   dword netw_actor;          //pid of network-controlled actor, or 0
   S_rocket_init(){ memset(this, 0, sizeof(S_rocket_init)); }
};

//----------------------------

struct S_explosion_init{
   S_vector pos;
   LPC_actor creator,         //what caused explosion (automobil, barrel...)
      actor_reason;           //who is responsible for this (human)
   word id;
                              //network only:
   dword netw_actor;          //pid of network-controlled actor, or 0
   S_explosion_init(){ memset(this, 0, sizeof(S_explosion_init)); }
};

//----------------------------

struct S_time_bomb_init{
   S_vector pos;
   dword count;
   LPC_actor who_put_it;
                              //network only:
   dword netw_actor;          //pid of network-controlled actor, or 0
   S_time_bomb_init(){ memset(this, 0, sizeof(S_time_bomb_init)); }
};

//----------------------------

struct S_mine_init{
   S_vector pos;
   word id;
                              //network only:
   dword netw_actor;          //pid of network-controlled actor, or 0
   S_mine_init(){ memset(this, 0, sizeof(S_mine_init)); }
};

//----------------------------

struct S_resource_init{
   S_vector pos;
   dword inv_id;
   dword amount;
                              //network only:
   dword netw_actor;          //pid of network-controlled actor, or 0
   S_resource_init(){ memset(this, 0, sizeof(S_resource_init)); }
};

//----------------------------

struct S_flare_init{
   S_vector pos;
   S_vector dir;
   LPC_actor shooter;
                              //network only:
   dword netw_actor;          //pid of network-controlled actor, or 0
   S_flare_init(){ memset(this, 0, sizeof(S_flare_init)); }
};

//----------------------------

struct S_grenade_init{
   S_vector pos;
   S_vector dir;
   dword inv_id;
   LPC_actor thrower;
   PI3D_frame model;
                              //network only:
   dword netw_actor;          //pid of network-controlled actor, or 0
   bool net_create;           //create this on network machines
   S_grenade_init(){ memset(this, 0, sizeof(S_grenade_init)); }
};

//----------------------------

struct S_particle_init{
   const S_vector *pos;
   const S_vector *dir;
   C_string model_name;
   C_string table_name;
   PI3D_frame link_to;
                              //network only:
   dword netw_actor;          //pid of network-controlled actor, or 0
   bool net_create;           //create this on network machines
   S_particle_init(){ memset(this, 0, sizeof(S_particle_init)); }
};

//----------------------------

#define GOTOFLAGS_RUN      1  //run
#define GOTOFLAGS_SMART    2  //use smart movement (side-steps, backsteps) for short distances (less than 2m)
#define GOTOFLAGS_FORCE_SMART 4  //use smart movement regardless of distance

                              //actor callback messages (continued)
enum{
   CB_UNUSED = CB_LAST_1,

   CB_RESERVE_USE,            //(LPC_actor user, int reserve_time), ret: ret = (int) use_pos_index (-1 = no free place)
   CB_DIE,                    //(int expl_dir) if(expl_dir==-1) use neutral
   CB_DIE_BY_KNIFE,           //(S_vector *knife_pos)
   CB_DIE_DROWN,              //
   CB_DIE_THROW_OUT,          //(LPC_actor caller)
   CB_SET_MINE_FIELD_RATIO,   //(int ratio)
   CB_ITEM_PICK,

                              //mine:
   CB_COLLISION,              //(LPC_actor who)

                              //change this weapon for other (good)
   CB_WEAPONCHANGE,           //ret: bool success

                              //failback situation
   CB_OUT_OF_GAME,

   CB_SHOW_AMMO,              //show icon info with ammo amount

   CB_INV_GRAB,               //grab communication,
                              //prm1 = message:
                              //0 - response to grabber: begin/end search, prm2=(LPC_actor)searched human; ret: bool success
                              //1 - show inv. on/off (prm2)
                              //2 - scroll inv (prm2=up)
                              //3 - grab item (ret=item id, *(dword*)prm2=amount)
                              //4 - to grabber: start anim, prm2=grabbed
                              //5 - grabber to victim: comfirm; ret: 0=fail, 1=success, 2=in progress
                              //6 - get item info; ret=item id, *(dword*)prm2=amount)

   CB_USE_CANNON,             //use cannon actor
                              //prm1 = message:
                              //0 - response to user: begin use, prm2=(LPC_actor)cannon or NULL
                              //1 - rotate cannon in X/Y axis, prm2 = float[3]{x_angle, y_angle, tsec}
                              ////2 - rotate cannon in Y axis, prm2 = float[2]{angle, tsec}
                              //3 - use item, prm2 = LPC_actor user
                              //4 - get cannon head dir, prm2 = (S_vector*)ret_dir
                              //5 - get cannon head pos, prm2 = (S_vector*)ret_pos
                              //6 - get cannon ammo
                              //7 - cannon to user: recompute direction, prm2 = time
                              //8 - get type; ret: 0=cannon, 1=reflector
                              //9 - get reflector state; ret: bool on
                              //10 - to user: adjust position/direction
                              //11 - get use_pos position; ret: (S_vector*)ret_pos
                              //12 - apply error and magnetism to the shoot dir, prm2 = LPS_vector pos_dir[2]

   CB_USE_AUTO,               //use automobil actor
                              //prm1 = message:
                              //0 - response to user: begin use, prm2=(LPC_actor)auto or NULL
                              //1 - accelerate, prm2 = int time
                              //2 - brake, prm2 = int time
                              //3 - tick, prm2 = int time
                              //4 - turn wheels, prm2 = float power
                              //5 - get seat type, prm2 = LPC_actor user, ret: 0 - seat, 1 - stay, 2 - bike-like
                              //6 - get seat frame (PI3D_frame), prm2 = LPC_actor user
                              //7 - get seat's entry pos (LPS_vector), prm2 = LPC_actor user
                              //8 - get speed; ret = int km/h
                              //9 - auto to driver: translate
                              //10 - get driver; ret = LPC_actor driver
                              //11 - get cannon status, prm2 = LPC_actor user; ret: bool present
                              //12 - get wheels turn (in degrees)
                              //13 - motor off and stop immediately
                              //14 - check if using weapons allowed from this position; ret = bool
                              //15 - check if it contains actor (LPC_actor)
                              //16 - get cannon ammo; ret = ammo | (-1 -> no cannon)

   CB_USE_TIME_BOMB,          //use (setup) time-bomb actor
                              //prm1 = message:
                              //0 - response to user: stop use
                              //1 - increase time; ret = bool status
                              //2 - decrease time; ret = bool status
                              //3 - activate
                              //4 - setup time directly (int time)
                              //5 - cancel time-bomb

   CB_USE_LADDER,             //use (setup) ladder actor
                              //prm1 = message:
                              //0 - response to user: begin use, prm2=(LPC_actor)ladder or NULL
                              //1 - get type; ret: bool up_ladder

   CB_USE_RESOURCE,           //use resource actor
                              //prm1 = message:
                              //0 - pick resource (LPC_actor picker)
                              //1 - get resource ID; ret = (int)id
                              //2 - resource to picker: ok, take me (LPC_actor resource)
                              //3 - set param - inv_id
                              //4 - set param - amount

   CB_GET_USING_ITEM,         //ret: LPC_actor using_item

   CB_SET_FRAME_SECTOR,

   CB_GET_FOLLOW_FORM,        //(LPC_actor master)

   CB_DEACTIVATE,             //(LPC_actor asker)
   CB_GET_AIM_DISP,           //ret: LPS_vector aim_disp
   CB_FIND_WEAPON,            //find some weapon around

   CB_SET_UNIFORM_ID,         //(E_UNIFORM_ID)
   CB_GET_UNIFORM_ID,         //ret: E_UNIFORM_ID

   CB_IGNORE_UNIFORMS,        //ret: bool

   CB_GET_GUN_SOUND,          //ret: PI3D_sound
   CB_ADD_OBJECTIVES,         //(vector<S_objective>*) to detector: add all objectives into list

   CB_DESTROY_PLR_MENU,       //C_player: destroy menu assigned by C_game_menu
   CB_CREATE_PLR_MENU,
};

//----------------------------

enum E_STAY_MODE{
   SM_NULL,
   SM_STAY, SM_BENCH, SM_LAY, SM_DEAD, SM_LADDER,
};

//----------------------------
bool I3DAPI FlyColRespGeo(I3D_collision_data &cd);
bool I3DAPI FlyColResp(I3D_collision_data &cd);

//----------------------------

