#include <windows.h>
#include <iostream>
#include <conio.h>
#include <C_string.hpp>
#include <win_reg.h>

using namespace std;

//----------------------------

#define REG_BASE "Software\\Lonely Cat Games\\Hidden and Dangerous Deluxe\\"
static const char REGDIR[] = REG_BASE"1.50";

static const char INSTALL_TYPE_KEY[] = "Install type";
static const char INSTALL_DIR_KEY[] = "Install source dir";
static const char INSTALL_DEST_DIR_KEY[] = "Install target dir";
static const char INSTALL_LANG_KEY[] = "Language";
static const char ERASE_LINE[] = "\r                                                                      \r";

const char *lang_names[] = {
   "english",                 //0
   "german",                  //1
   "french",                  //2
   "spanish",                 //3
   "italian",                 //4
   "japan",                   //5
   "portugal",                //6
   "czech",                   //7
   NULL
};

//----------------------------

enum E_ISNTALL_TYPE{
   INSTALL_MINIMAL,
   INSTALL_TYPICAL,
   INSTALL_FULL,
   INSTALL_FULL_EDITOR,
};

//----------------------------

bool GetInstallationInfo(E_ISNTALL_TYPE &install_type, C_string &inst_src, C_string &inst_dst, int &language){

                              //read installation info
   int i = RegkeyOpen(REGDIR, E_REGKEY_LOCAL_MACHINE);
   if(i==-1)
      return false;

   install_type = INSTALL_FULL;
   if(RegkeyRdata(i, INSTALL_TYPE_KEY, (byte*)&install_type, sizeof(E_ISNTALL_TYPE))==-1)
      return false;

   char buf[512];
   if(RegkeyRdata(i, INSTALL_DIR_KEY, (byte*)buf, sizeof(buf))==-1)
      buf[0] = 0;
   else
   if(buf[strlen(buf)-1] != '\\')
      *(word*)(&buf[strlen(buf)]) = '\\';
   inst_src = buf;

   if(RegkeyRdata(i, INSTALL_DEST_DIR_KEY, (byte*)buf, sizeof(buf))==-1)
      buf[0] = 0;
   else
   if(buf[strlen(buf)-1] != '\\')
      *(word*)(&buf[strlen(buf)]) = '\\';
   inst_dst = buf;

   if(RegkeyRdata(i, INSTALL_LANG_KEY, (byte*)buf, sizeof(buf))==-1)
      buf[0] = 0;
   RegkeyClose(i);
   language = 0;
   for(i=0; lang_names[i]; i++){
      if(!stricmp(lang_names[i], buf)){
         language = i;
         break;
      }
   }
   return true;
}

//----------------------------

enum{
   DTA_INSTALL_FULL = 1,
   DTA_INSTALL_TYPICAL = 2,
   DTA_INSTALL_MINIMAL = 4,
   DTA_INSTALL_LANG = 8,
};

static struct{
   char *filename;
   dword inst_flags;
} dta_files[] = {
   { "data\\data.dta", DTA_INSTALL_FULL | DTA_INSTALL_TYPICAL},
   { "data\\maps.dta", DTA_INSTALL_FULL | DTA_INSTALL_TYPICAL},
   { "data\\missions.dta", DTA_INSTALL_FULL | DTA_INSTALL_TYPICAL},
   { "data\\models.dta", DTA_INSTALL_FULL | DTA_INSTALL_TYPICAL},
   { "data\\anims.dta", DTA_INSTALL_FULL | DTA_INSTALL_TYPICAL},
   { "data\\sounds.dta", DTA_INSTALL_FULL | DTA_INSTALL_TYPICAL},
   { "data\\sounds_%s.dta", DTA_INSTALL_FULL | DTA_INSTALL_LANG},
   {NULL}
};

//----------------------------

static bool CompareFiles(const char *file1, const char *file2){

   FILE *f1, *f2;
                              //open both files
   f1 = fopen(file1, "rb");
   if(!f1){
      cout<<(const char*)C_fstring("File \"%s\" not found!\n", file1);
      return false;
   }
   f2 = fopen(file2, "rb");
   if(!f2){
      fclose(f1);
      cout<<(const char*)C_fstring("File \"%s\" not found!\n", file2);
      return false;
   }
                              //get sizes of files
   fseek(f1, 0, SEEK_END);
   fseek(f2, 0, SEEK_END);
   int sz1 = ftell(f1);
   int sz2 = ftell(f2);

   bool st = true;

   if(sz1 != sz2){
      cout<<(const char*)C_fstring("File sizes not equal:\n  file1: \"%s\"\n  file2: \"%s\"\n", file1, file2);
      st = false;
   }else{
                              //rewind
      fseek(f1, 0, SEEK_SET);
      fseek(f2, 0, SEEK_SET);

                              //compare entire contents
      const int BLOCK_SIZE = 1024*1024;
      byte *buf1 = new byte[BLOCK_SIZE];
      byte *buf2 = new byte[BLOCK_SIZE];
      for(int i=0; i<sz1; i+=BLOCK_SIZE){
                              //read from files
         int to_read = Min(BLOCK_SIZE, sz1-i);

         int per_cent = (int) ((float)(i+to_read) / (float)sz1 * 100.0f);
         cout<<(const char*)C_fstring("%3i%%\b\b\b\b", per_cent);

         int rl;
         rl = fread(buf1, 1, to_read, f1);
         if(rl!=to_read){
            cout<<ERASE_LINE <<(const char*)C_fstring("Failed to read from file: \"%s\"\n", file1);
            st = false;
            break;
         }
         rl = fread(buf2, 1, to_read, f2);
         if(rl!=to_read){
            cout<<ERASE_LINE <<(const char*)C_fstring("Failed to read from file: \"%s\"\n", file2);
            st = false;
            break;
         }
         if(memcmp(buf1, buf2, to_read)){
            cout<<ERASE_LINE <<(const char*)C_fstring("Files mismatch:\n  file1: \"%s\"\n  file2: \"%s\"\n", file1, file2);
            st = false;
            break;
         }
         if(kbhit() && _getch()==0x1b){
            cout<<ERASE_LINE <<"Canceled by user\n";
            st = false;
            break;
         }
      }
      delete[] buf1;
      delete[] buf2;
   }

   fclose(f1);
   fclose(f2);

   return st;
}

//----------------------------

void __cdecl main(){

   cout<<"Examining H&D Deluxe installation...\n\n";

   E_ISNTALL_TYPE install_type;
   C_string inst_src, inst_dst;
   int language;

   bool inst_ok = GetInstallationInfo(install_type, inst_src, inst_dst, language);
   if(!inst_ok){
      cout<<"Status: game not installed.\n";
   }else{
      cout<<(const char*)C_fstring(
         "Source: \"%s\"\n"
         "Dest: \"%s\"\n"
         "Installation type: %s\n"
         "Language: %s\n"
         ,
         (const char*)inst_src,
         (const char*)inst_dst,
         (install_type==INSTALL_MINIMAL ? "minimal" : install_type==INSTALL_TYPICAL ? "typical" : "full"),
         lang_names[language]
         );
      cout<<"\nExamining files...\n";

      bool st = true;
                              //all files in BIN directory
      /*
      HANDLE fh;
      WIN32_FIND_DATA fd;
      fh = FindFirstFile(C_fstring("%sBin\\*.*", (const char*)inst_src), &fd);
      if(fh!=INVALID_HANDLE_VALUE){
         do{
            if(fd.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY)
               continue;
            const char *file_name = fd.cFileName;
            cout<<(const char*)C_fstring("Comparing %s ... ", file_name);
            st = CompareFiles(C_fstring("%sBin\\%s", (const char*)inst_src, file_name),
               C_fstring("%sBin\\%s", (const char*)inst_dst, file_name));
            cout<<ERASE_LINE;
            if(!st)
               break;
         }while(FindNextFile(fh, &fd));
         FindClose(fh);
      }
      */
      {
         static const char *bin_files[] = {
            "i3d2.dll",
            "icom_rd.dll",
            "iexcpt.dll",
            "igraph2.dll",
            "inet2.dll",
            "isound2.dll",
            "itabler2.dll",
            "msvcp60.dll",
            "Msvcrt.dll",
            "nvlinker.dll",
            "HDE.exe",
            "IConfig.exe",
            NULL
         };
         for(int i=0; bin_files[i]; i++){
            const char *file_name = bin_files[i];
            cout<<(const char*)C_fstring("Comparing %s ... ", file_name);
            st = CompareFiles(C_fstring("%sBin\\%s", (const char*)inst_src, file_name),
               C_fstring("%sBin\\%s", (const char*)inst_dst, file_name));
            cout<<ERASE_LINE;
            if(!st)
               break;
         }
      }

      if(st){
         dword inst_mask = 0;
         switch(install_type){
         case 0: inst_mask = DTA_INSTALL_MINIMAL; break;
         case 1: inst_mask = DTA_INSTALL_TYPICAL; break;
         case 2:
         case 3: inst_mask = DTA_INSTALL_FULL; break;
         default: assert(0);
         }
         for(int i=0; dta_files[i].filename; i++){
            dword flags = dta_files[i].inst_flags;
            bool installed = (flags&inst_mask);
            if(!installed)
               continue;
            C_string file_name = dta_files[i].filename;
            if(flags&DTA_INSTALL_LANG)
               file_name = C_fstring(file_name, lang_names[language]);

            cout<<(const char*)C_fstring("Comparing %s ... ", (const char*)file_name);
            st = CompareFiles(C_fstring("%s%s", (const char*)inst_src, (const char*)file_name),
               C_fstring("%s%s", (const char*)inst_dst, (const char*)file_name));
            cout<<ERASE_LINE;
            if(!st)
               break;
         }
      }
      cout<<"\nStatus: " <<(st ? "Installation OK" : "!!! Installation corrupted !!!") <<".\n";
   }

   cout<<"\nPress any key to exit.\n";
   _getch();
}

//----------------------------
