#include "all.h"
#include <windows.h>
#include <malloc.h>
#include <set>
#include "winstuff.h"
#include "resource.h"



                              // *** Plugin editor ***
//----------------------------

                              //for groung collision testing
#define MAX_TEST_GROUND_DISTANCE 800.0f
#define NAME_FONT_SIZE 18


//----------------------------
struct S_cp_create_info{
   int suggested_id;
   S_vector pos;
   E_CHECKPOINT_TYPE type;
   int connect_id[1];         //terminated by -1
   char name[1];
};

struct S_cp_pos_undo{
   int cp_id;
   S_vector pos;
};

struct S_cp_type_undo{
   int cp_id;
   E_CHECKPOINT_TYPE type;
};

enum E_ACTION_CHKPT{
   E_CHKPT_CREATE,
   E_CHKPT_TOGGLE_SHOW,
   E_CHKPT_MODIFY_NOTIFY,
   E_CHKPT_CONFIG,
   E_CHKPT_CREATE_NAMED,      //(S_cp_create_info*)
   E_CHKPT_DESTROY_NAMED,     //(int cp_id)
   E_CHKPT_TOGGLE_CON,        //(int cp_id, int toggle_id[] - terminated by -1)
   E_CHKPT_EDIT,              //switch to edit mode
   E_CHKPT_CREATE_USER_PICKED,//at useser pick coll point
   E_CHKPT_RECONNECT_SELECTION,//do connection on selected cp again
   E_CHKPT_FALL_SELECTION,    //fall selected cp to ground distance from config table
   E_CHKPT_CHANGE_POS,        //(S_vector) - undo for changing CP position
   E_CHKPT_CLEAR_ALL,         //clear all checkpoints
   E_CHKPT_SET_TYPE,          //set type of selected checkpoint (and all connected)
   E_CHKPT_RENAME,            //rename selected checkpoint
   E_CHKPT_UNDO_TYPE,         // - internal (undo)
   E_CHKPT_UNDO_NAME,         // - internal (undo)
};

//----------------------------
                              //editor plugin: Mission
class C_edit_checkpoint: public C_editor_item{
   virtual const char *GetName() const{ return "CheckPoint"; }

   C_smart_ptr<C_editor_item> e_mouseedit;
   C_smart_ptr<C_editor_item> e_modify;
   C_smart_ptr<C_editor_item> e_slct;
   C_smart_ptr<C_editor_item> e_undo;

   C_smart_ptr<I3D_material> mat_icon[3]; //[0=path, 1=user, 1=howered]
   
   bool show_on;              //flag if cp's SHOULD BE visible
   bool visible;              //flag if cp's ARE visible

                              //user frames - frame representations for shown checkpoints
                              // kept due to editing purposes (editor plugins work better 
                              // with frames than with checkpoints)
   struct S_cp_info{
      C_smart_ptr<I3D_user> frm;
      C_smart_ptr<I3D_texture> name_texture;
      int txt_size[2];
      int id;
      bool visible;

      S_cp_info(){}
      S_cp_info(const S_cp_info &cpi){ operator =(cpi); }
      S_cp_info &operator =(const S_cp_info &cpi){
         frm = cpi.frm;
         name_texture = cpi.name_texture;
         txt_size[0] = cpi.txt_size[0];
         txt_size[1] = cpi.txt_size[1];
         id = cpi.id;
         visible = cpi.visible;
         return *this;
      }
      inline operator int() const{ return id; }
   };
   typedef map<LPC_checkpoint, S_cp_info> t_cp_map;
   t_cp_map cp_info;

   C_game_mission &mission;

                              //checkpoints, which position needs to be updated by user frame
   vector<LPC_checkpoint> dirty_cpts;

                              //currently dragged CP - making connection (NULL = no)
   C_smart_ptr<C_checkpoint> drag_cp;

   void *name_font;
//----------------------------

   void *GetNameFont(){

      if(!name_font){
         name_font = OsCreateFont(NAME_FONT_SIZE);
      }
      return name_font;
   }
//----------------------------

   void *hwnd_edit;
   C_smart_ptr<C_table> config_tab;
   enum{
      TAB_F_CFG_SCALE,        //in meters
      TAB_I_CFG_ALPHA,        //in percent
      TAB_F_OVERLAND_DISTANCE,//in meters

      TAB_F_MAX_CONNECT_DIST, //in meters
      TAB_F_MIN_SHORTCUT_DISTANCE, //in meters
      TAB_F_MAX_DETPH,        //in meters
      TAB_I_MAX_VISIBILITY,   //in meters

   };

   static void cbTabCfg(LPC_table tab, dword msg, dword cb_user, dword prm2, dword prm3){
      switch(msg){
      case TCM_CLOSE:
         {
            C_edit_checkpoint *ec = (C_edit_checkpoint*)cb_user;
            ec->ed->GetIGraph()->DeleteDlgHWND(ec->hwnd_edit);
            ec->hwnd_edit = NULL;
         }
         break;
      case TCM_MODIFY:
         switch(prm2){
         case TAB_F_CFG_SCALE:
            {
               C_edit_checkpoint *ec = (C_edit_checkpoint*)cb_user;
               ec->ed->GetScene()->Render(0);
               ec->ed->GetIGraph()->UpdateScreen(IGUPDATE_ENTIRE_AREA);
            }
            break;
         }
         break;
      }
   }
   static C_table_template *GetTemplate(){
                           //template
      static C_table_template templ_config={
         { 0x69b28e20, 0x2229, 0x11d4, { 0xbc, 0xb2, 0x50, 0xa4, 0x6e, 0xc1, 0x0, 0x0 } },
         "Checkpoint configuration",
         NULL,
         {
            {TE_FLOAT, TAB_F_CFG_SCALE, "Scale", 0, 5, 1},
            {TE_INT, TAB_I_CFG_ALPHA, "Opacity", 0, 100, 50},
            {TE_INT, TAB_I_MAX_VISIBILITY, "Visibility", .0, 500, 50},
            {TE_FLOAT, TAB_F_OVERLAND_DISTANCE, "Distance over land [m]", .0f, 10.0, 1.0f},
            {TE_FLOAT, TAB_F_MAX_CONNECT_DIST, "Max connection length", 1.0f, 100.0f, 10.0f},
            {TE_FLOAT, TAB_F_MIN_SHORTCUT_DISTANCE, "Min shortcut distance", 0.f, 20.0f, 2.0f},
            {TE_FLOAT, TAB_F_MAX_DETPH, "Max tolerable depth", .0f, 50.0f, 4.0f},
            {TE_NULL}
         }
      };
      return &templ_config;
   }
   
   void DestroyEdit(){
      if(hwnd_edit){
         ed->GetIGraph()->DeleteDlgHWND(hwnd_edit);
         DestroyWindow((HWND)hwnd_edit);
         hwnd_edit = NULL;
      }
   }

//----------------------------

   PI3D_material GetIcon(int indx){

      if(!mat_icon[indx]){
                              //load checkpoint texture
         I3D_CREATETEXTURE ct;
         memset(&ct, 0, sizeof(ct));
         ct.flags = TEXTMAP_TRANSP | TEXTMAP_MIPMAP;

         HGLOBAL hg = LoadResource(GetModuleHandle(NULL),
            FindResource(GetModuleHandle(NULL), "chkpoint.bmp", RT_BITMAP));
         if(hg){
            ct.text_mem  = hg;
            ct.flags |= TEXTMAP_DIFFUSE | TEXTMAP_MEM_PTR;
         }
         PI3D_texture tp;
         driver->CreateTexture(&ct, &tp);

         PI3D_material mat = driver->CreateMaterial();
         mat->SetTexture(tp);
         tp->Release();
         switch(indx){
         case 0: mat->SetDiffuse(S_vector(1, 1, 0)); break;
         case 1: mat->SetDiffuse(S_vector(0, 1, 0)); break;
         case 2: mat->SetDiffuse(S_vector(1, 0, .4f)); break;
         }

         mat_icon[indx] = mat;
         mat->Release();
      }
      return mat_icon[indx];
   }

//----------------------------

   struct S_con_text{
      C_smart_ptr<I3D_texture> txt;
      int size[2];
      C_string str;
      S_con_text(){}
      S_con_text(const S_con_text &ct){ operator =(ct); }
      S_con_text &operator =(const S_con_text &ct){
         txt = ct.txt;
         size[0] = ct.size[0];
         size[1] = ct.size[1];
         str = ct.str;
         return *this;
      }
   };
   vector<S_con_text> con_texts;

   void DrawConnectionText(const S_vector &pos, const C_string &str){

                              //find or create text
      for(int i=con_texts.size(); i--; ){
         if(con_texts[i].str==str)
            break;
      }           
      if(i==-1){
         i = con_texts.size();
         con_texts.push_back(S_con_text());
         S_con_text &ct = con_texts.back();
         ct.txt = CreateStringTexture(str, ct.size, driver, GetNameFont());
         ct.txt->Release();
         ct.str = str;
      }

      const float max_vis_dist = config_tab->ItemI(TAB_I_MAX_VISIBILITY);
      const S_con_text &ct = con_texts[i];

      DrawStringTexture(NULL, 0.0f, mission.GetScene(), ct.txt, ct.size,
         S_vector(1, 1, 1),
         max_vis_dist*.8f, max_vis_dist, .7f, .05f, &pos);
   }

//----------------------------

   void ShowCheckpoints(bool b){

      if(visible==b)
         return;

      visible = b;
      if(visible){
                              //create user frames for checkpoints and put to scene
         for(t_cp_map::iterator it =
            cp_info.begin(); it!=cp_info.end(); it++){

            LPC_checkpoint cp = (*it).first;
            PI3D_user usr = driver->CreateUserFrame();
                              //make cross-reference
            (*it).second.frm = usr;

            if(cp->GetName().Size())
               usr->SetName(C_fstring("<CP> %s", (const char*)cp->GetName()));
            else
               usr->SetName(C_fstring("<CP> %.4i", (*it).second.id));
            usr->SetData2((dword)cp);
            usr->SetPos(cp->GetPos());
            usr->LinkTo(ed->GetScene()->GetPrimarySector());
            usr->Update();
            e_modify->Action(E_MODIFY_ADD_FLAGS, &pair<PI3D_frame, dword>(usr,
               E_MODIFY_FLG_TEMPORARY));
            usr->Release();

                              //set debug visibility flag (for AI tests)
            cp->help_visited = false;
         }
         ed->RegForRender(this, 1120);
         e_modify->Action(E_MODIFY_ADD_NOTIFY, &pair<LPC_editor_item, dword>(this, E_CHKPT_MODIFY_NOTIFY));
      }else{
         for(t_cp_map::iterator it=cp_info.begin(); it!=cp_info.end(); it++){
            e_modify->Action(E_MODIFY_DEL_FRAME, (*it).second.frm);
                              //remove frame from selection
            e_slct->Action(E_SELECTION_DEL_FRAME, (*it).second.frm);
            (*it).second.frm = NULL;
         }
         ed->UnregForRender(this);
         e_modify->Action(E_MODIFY_DEL_NOTIFY, this);
      }
   }

//----------------------------

   void ShowCheckpoint(LPC_checkpoint cp, bool b, PI3D_user usr_frm = NULL){

      if(b){
         t_cp_map::iterator it = cp_info.find(cp);
         assert(it!=cp_info.end());
         if((*it).second.frm) return;
            
         PI3D_user usr = usr_frm;
         if(!usr) usr = driver->CreateUserFrame();
                              //make cross-reference
         (*it).second.frm = usr;

         usr->SetName(C_fstring("<chkpt> %.4i", (*it).second.id));
         usr->SetData2((dword)cp);
         usr->SetPos(cp->GetPos());
         usr->LinkTo(ed->GetScene()->GetPrimarySector());
         usr->Update();
         e_modify->Action(E_MODIFY_ADD_FLAGS, &pair<PI3D_frame, dword>(usr,
            E_MODIFY_FLG_TEMPORARY));
         if(!usr_frm)         //release if we've created this
            usr->Release();
      }else{
         t_cp_map::iterator it = cp_info.find(cp);
         assert(it!=cp_info.end());
         if(!(*it).second.frm) return;
         e_modify->Action(E_MODIFY_DEL_FRAME, (*it).second.frm);
                              //remove frame from selection
         e_slct->Action(E_SELECTION_DEL_FRAME, (*it).second.frm);
         (*it).second.frm = NULL;
      }
   }

//----------------------------

   LPC_checkpoint CreateCheckpoint(int suggested_id = -1, bool setup_pos = true){

      LPC_checkpoint cp = mission.CreateCheckpoint();

      if(setup_pos){
                     //put somewhere in front of camera
         PI3D_camera cam = mission.GetScene()->GetActiveCamera();
         cp->SetPos(cam->GetWorldPos() + cam->GetWorldDir() * 1.0f);
         //cp->SetPos(cam->GetWorldPos() + cam->GetWorldDir() * 3.0f);
      }

      t_cp_map::const_iterator it;
                        //create unique ID
      int new_id = suggested_id;

      if(new_id!=-1){
                              //check if we may use suggested id
         for(it = cp_info.begin(); it!=cp_info.end(); it++)
            if((*it).second.id==new_id){
               new_id = -1;
               break;
            }
      }
      if(new_id==-1){
                              //generate unique id
         vector<int> sorted_id; sorted_id.reserve(cp_info.size());
         for(it = cp_info.begin(); it!=cp_info.end(); it++)
            sorted_id.push_back((*it).second.id);

         sort(sorted_id.begin(), sorted_id.end());
         if(sorted_id.size()){
            for(int i=sorted_id.size()-1; i--; ){
               if(sorted_id[i] != sorted_id[i+1]-1)
                  new_id = sorted_id[i] + 1;
            }
            if(new_id==-1)
               new_id = sorted_id.back() + 1;
         }else
            new_id = 0;
      }
      cp_info[cp] = S_cp_info();
      cp_info[cp].id = new_id;

                        //add undo info
      S_edit_Undo_2 eu(GetName(), E_CHKPT_DESTROY_NAMED, &new_id, sizeof(int));
      e_undo->Action(E_UNDO_SAVE, &eu);

      return cp;
   }

//----------------------------

   void DestroyCP(LPC_checkpoint cp){

      for(t_cp_map::iterator it=cp_info.begin(); it!=cp_info.end(); it++)
         if((*it).first==cp) break;
      assert(it!=cp_info.end());

      if(visible) ShowCheckpoint(cp, false);
                        //add undo info
      {
         int len = sizeof(S_cp_create_info);
         int num_cons = cp->NumConnections();
         len += num_cons * sizeof(int);
         const C_string &name = cp->GetName();
         len += name.Size();
         S_cp_create_info *ci = (S_cp_create_info*)alloca(len);
         ci->suggested_id = (*it).second.id;
         ci->pos = cp->GetPos();
         ci->type = cp->GetType();
         strcpy((char*)&ci->connect_id[num_cons+1], name);

         ci->connect_id[num_cons] = -1; //terminate
                              //save connections
         while(num_cons--){
            LPC_checkpoint cp1 = cp->GetCPoint(num_cons);
            ci->connect_id[num_cons] = cp_info[cp1].id;
         }
         S_edit_Undo_2 eu(GetName(), E_CHKPT_CREATE_NAMED, ci, len);
         e_undo->Action(E_UNDO_SAVE, &eu);
      }

      cp_info.erase(it);
      mission.DestroyCheckpoint(cp);
   }

//----------------------------

   bool FallCheckpoint(LPC_checkpoint cp){

      assert(cp);

      S_vector pos = cp->GetPos();
      S_vector g_dir = S_vector(.0f, -1.0f*MAX_TEST_GROUND_DISTANCE, .0f);

      //DEBUG_LINE(pos, pos+g_dir , 0xffff0000);
      I3D_collision_data cd(pos, g_dir, I3DCOL_EXACT | I3DCOL_TEXTURE | I3DCOL_FORCE2SIDE);
      if(mission.GetScene()->TestCollision(cd)){
         g_dir.Normalize();
         pos += g_dir*(cd.GetClosestHit() - config_tab->ItemF(TAB_F_OVERLAND_DISTANCE));
         DebugLine(pos, pos + g_dir * config_tab->ItemF(TAB_F_OVERLAND_DISTANCE), 0xffff00ff, E_DEBUGLINE_ADD_TIMED);

                              //save undo
         {
            for(t_cp_map::iterator it=cp_info.begin(); it!=cp_info.end(); it++)
               if((*it).first==cp) break;
            assert(it!=cp_info.end());

            S_cp_pos_undo ui;
            ui.cp_id = (*it).second.id;
            ui.pos = cp->GetPos();
            S_edit_Undo_2 eu(GetName(), E_CHKPT_CHANGE_POS, &ui, sizeof(S_cp_pos_undo));
            e_undo->Action(E_UNDO_SAVE, &eu);
         }
                              //update position
         cp->SetPos(pos);
         t_cp_map::iterator it = cp_info.find(cp);
         assert(it!=cp_info.end());
         assert((*it).second.frm);
         (*it).second.frm->SetPos(pos);
         (*it).second.frm->Update();
         return true;
      }
      else
         return false;
   }

//----------------------------

   LPC_checkpoint CreateCheckpointOnPosition(S_vector pos, bool auto_connect, E_CHECKPOINT_TYPE t){

      if(!show_on)
         Action(E_CHKPT_TOGGLE_SHOW, 0);

      e_slct->Action(E_SELECTION_CLEAR);

      LPC_checkpoint cp = CreateCheckpoint(-1, false);
      if(config_tab->ItemF(TAB_F_OVERLAND_DISTANCE) > .0f){
         pos.y += config_tab->ItemF(TAB_F_OVERLAND_DISTANCE);
         DebugLine(pos, pos, 0xff00ff00, E_DEBUGLINE_ADD_TIMED);
      }
      cp->SetPos(pos);
      cp->SetType(t);

      assert(visible);
      if(visible) ShowCheckpoint(cp, true);

      if(auto_connect)
         AutoConnect(cp);
                     //add newly created CP to selection
      e_slct->Action(E_SELECTION_ADD_FRAME, cp_info[cp].frm);

      ed->SetModified();

      return cp;
   }

//----------------------------

   bool IsPointCloseToLine(S_vector point, S_vector lp1, S_vector lp2){

      float f1 = point.PositionOnLine(lp1, lp2 - lp1);   
      float f2 = point.PositionOnLine(lp2, lp1 - lp2);
      bool b1 = f1 >= .0f;
      bool b2 = f2 >= .0f;
                              //check if normal lie inside or outside of triangle
      if(b1 != b2) 
         return false;
      else{
         float d = point.DistanceToLine(lp1, lp2 - lp1);
         return (abs(d) < config_tab->ItemF(TAB_F_MIN_SHORTCUT_DISTANCE));
      }
   }


//----------------------------

   void SaveToggle(int cp_id1, int cp_id2){
                              //save undo
      //int num = 3;
      //int *id_list = (int*)alloca(sizeof(int)*num);
      int id_list[3];
      id_list[0] = cp_id1;
      id_list[1] = cp_id2;
      id_list[2] = -1;
      S_edit_Undo_2 eu(GetName(), E_CHKPT_TOGGLE_CON, id_list, 3*sizeof(int));
      e_undo->Action(E_UNDO_SAVE, &eu);
   }

//----------------------------

   static BOOL CALLBACK dlgCPConType(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam){

      static dword *flags;
      switch(uMsg){
      case WM_INITDIALOG:
         WinInitDialog(hwnd);
         flags = (dword*)lParam;
         //CheckDlgButton(hwnd, IDC_CHECK_ONEWAY, flags[0]&CP_CON_ONEWAY);
         CheckDlgButton(hwnd, IDC_CHECK_USE_LADDER, flags[0]&CP_CON_USE_LADDER);
         CheckDlgButton(hwnd, IDC_CHECK_USE_DOOR, flags[0]&CP_CON_USE_DOOR);
         //SetDlgItemInt(hwnd, IDC_EXPENCE, flags[1], true);
         ShowWindow(hwnd, SW_SHOW);
         return 1;
      case WM_COMMAND:
         switch(LOWORD(wParam)){
         case IDOK:
            {
               //flags[0] &= ~(CP_CON_ONEWAY | CP_CON_ONEWAYTO | CP_CON_USE_LADDER | CP_CON_USE_DOOR);
               flags[0] = 0;
               //if(IsDlgButtonChecked(hwnd, IDC_CHECK_ONEWAY)) flags[0] |= CP_CON_ONEWAY;
               if(IsDlgButtonChecked(hwnd, IDC_CHECK_USE_LADDER)) flags[0] |= CP_CON_USE_LADDER;
               if(IsDlgButtonChecked(hwnd, IDC_CHECK_USE_DOOR)) flags[0] |= CP_CON_USE_DOOR;
               //flags[1] = GetDlgItemInt(hwnd, IDC_EXPENCE, NULL, true);

               EndDialog(hwnd, 0);
            }
            break;
         case IDCANCEL: EndDialog(hwnd, -1); break;
         }
         break;
      }
      return 0;
   }

//----------------------------

   bool ToggleConnectionType(LPC_checkpoint cp1, LPC_checkpoint cp2){

      for(int i=cp1->NumConnections(); i--; ){
         if(cp1->GetCPoint(i)==cp2)
            break;
      }
      if(i==-1)
         return false;

      dword flags = cp1->GetConnectionData(i), save = flags;
      int st = DialogBoxParam(GetModuleHandle(NULL), "IDD_CPLINE_TYPE", (HWND)igraph->GetHWND(), dlgCPConType, (LPARAM)&flags);
      cp1->SetConnectionData(i, flags);
      if(st==0 && flags!=save){
         /*
         for(i=cp2->NumConnections(); i--; ){
            if(cp2->GetCPoint(i)==cp1){
               cp2->SetConnectionData(i, flags);
               break;
            }
         }
         */
         ed->Message("Changed connection type.");
         ed->SetModified();
         return true;
      }
      return false;
   }

//----------------------------
// Search for all adjacent connections of (cp1, cp2) and if angle between (cp1, cp2) & line
// is too small, remove connection.
   int RemoveRedundantConnections(LPC_checkpoint cp1, LPC_checkpoint cp2){

      int con_del = 0;
                              //must be connected
      if (!(cp1->IsConnected(cp2)))
         return con_del;

                              //collect all cp which are connectet with both
      vector<LPC_checkpoint> adjacent_list;

                              //optimize - select cp with less connections
      /*if(cp1->NumConnections() > cp2->NumConnections()){
         LPC_checkpoint t_cp = cp2;
         cp2 = cp1;
         cp1 = t_cp;
      }*/

      for(int i = cp1->NumConnections(); i--;){

         LPC_checkpoint adept = cp1->GetCPoint(i);

         if(adept->IsConnected(cp2))
            adjacent_list.push_back(adept);
      }
                              //go throw all connected triangles
      for(int j = adjacent_list.size(); j--; ){

         LPC_checkpoint cp3 = adjacent_list[j];
                              //here is some bug; befor cycle cp1 is connected to cp2
                              //but inside it turn to  false
                              //must be connected
         if (!(cp1->IsConnected(cp2)))
            return con_del;

                              //test 3 lines agains oppositte points

         bool b1 = IsPointCloseToLine(cp1->GetPos(), cp2->GetPos(), cp3->GetPos());
         bool b2 = IsPointCloseToLine(cp2->GetPos(), cp3->GetPos(), cp1->GetPos());
         bool b3 = IsPointCloseToLine(cp3->GetPos(), cp1->GetPos(), cp2->GetPos());

                              //remove only one
         //if((b1 + b2 + b3) > 1)
         {
                              
            float mg23 = (cp2->GetPos() - cp3->GetPos()).Magnitude();
            float mg13 = (cp1->GetPos() - cp3->GetPos()).Magnitude();
            float mg12 = (cp1->GetPos() - cp2->GetPos()).Magnitude();
                              //only longist side of triangel can be removed
            b1 &= ((mg23 > mg13) && (mg23 > mg12));
            b2 &= ((mg13 > mg23) && (mg13 > mg12));
            b3 &= ((mg12 > mg13) && (mg12 > mg23));
         }

         assert(b1+b2+b3 <= 1);
                              //todo:collect all which should be removed
         if(b3){
            //assert(cp1->IsConnected(cp2));
            cp1->Disconnect(cp2);
            assert(!cp1->IsConnected(cp2));
            con_del++;
            SaveToggle(cp_info[cp1].id, cp_info[cp2].id);
         }
         if(b2){
            //assert(cp3->IsConnected(cp1));
            cp3->Disconnect(cp1);
            assert(!cp3->IsConnected(cp1));
            con_del++;
            SaveToggle(cp_info[cp3].id, cp_info[cp1].id);
         }
         if(b1){
            //assert(cp2->IsConnected(cp3));
            cp2->Disconnect(cp3);
            assert(!cp2->IsConnected(cp3));
            con_del++;
            SaveToggle(cp_info[cp2].id, cp_info[cp3].id);
         }
      }
                              //make sure we don' remeve more then 1 shotcut in triangel
      return con_del;
   }


//----------------------------
// Return distance to ground at pos.
// If no collision is detected, the returned value is MAX_TEST_GROUND_DISTANCE.
   float GetDepthAt(const S_vector &pos) const{
   
      S_vector g_dir = S_vector(.0f, -1.0f, .0f);
      g_dir *= MAX_TEST_GROUND_DISTANCE;

      I3D_collision_data cd(pos, g_dir, I3DCOL_EXACT | I3DCOL_TEXTURE | I3DCOL_FORCE2SIDE);
      bool col = mission.GetScene()->TestCollision(cd);
      return (col ? cd.GetClosestHit() : MAX_TEST_GROUND_DISTANCE);
   }

//----------------------------

   void AutoConnect(LPC_checkpoint cp){

      int con_add = 0, con_del = 0;
                              //enum all check points

      const float max_dist = config_tab->ItemF(TAB_F_MAX_CONNECT_DIST);
      const float min_shortcut_dist = config_tab->ItemF(TAB_F_MIN_SHORTCUT_DISTANCE);
      const float max_depth = config_tab->ItemF(TAB_F_MAX_DETPH);

   
                              //collect all cc which can be connected with cp
      vector<LPC_checkpoint> adept_list;

      for(t_cp_map::iterator it = cp_info.begin(); it!=cp_info.end(); it++){

         LPC_checkpoint cc = (*it).first;
                              //skip self
         if(cp == cc || cp->GetType()!=cc->GetType())
            continue;

         const S_vector cc_cp = cp->GetPos() - cc->GetPos();
                              //compare distance between cp and connection candidate
         if(cc_cp.Magnitude() > max_dist)
            continue;
                              //test collision
         I3D_collision_data cd(cc->GetPos(), cc_cp, 0);
         if(mission.GetScene()->TestCollision(cd))
            continue;
                              //test depth (3 times)
         if(max_depth > .0f){
                              //center
            if(GetDepthAt(S_vector(cc->GetPos() + (cc_cp * .5f))) > max_depth)
               continue;
            if(GetDepthAt(S_vector(cc->GetPos() + (cc_cp * .25f))) > max_depth)
               continue;
            if(GetDepthAt(S_vector(cc->GetPos() + (cc_cp * .75f))) > max_depth)
               continue;
         }
         adept_list.push_back(cc);
      }

                              //collect toggled id's, so that we may save undo info
      vector<int> toggle_id;

                              //connect them all
      for(int ii = adept_list.size(); ii--; ){

         LPC_checkpoint cc1 = adept_list[ii];
         if(cp->IsConnected(cc1))
            continue;
         cp->Connect(cc1);
         con_add++;

         toggle_id.push_back(cp_info[cc1].id);

      }

                              //save undo
      int num = toggle_id.size() + 2;
      int *id_list = (int*)alloca(sizeof(int)*num);
      id_list[0] = cp_info[cp].id;
      for(int i=toggle_id.size(); i--; ){
         id_list[i+1] = toggle_id[i];
      }
      id_list[num-1] = -1;
      S_edit_Undo_2 eu(GetName(), E_CHKPT_TOGGLE_CON, id_list, num*sizeof(int));
      e_undo->Action(E_UNDO_SAVE, &eu);

                              //remove shortcuts
      for(int j = adept_list.size(); j--; ){
      
         LPC_checkpoint cc1 = adept_list[j];
         if(min_shortcut_dist > .0f){
            int num = RemoveRedundantConnections(cp, cc1);
            con_del += num;
         }
      }
                        //write message
      C_string str = C_fstring("connected: %i", con_add);
      if(con_del) 
         str += C_fstring(", disconnected: %i", con_del);
      ed->Message(str);
   }
//----------------------------
   enum E_HIT_RESULT{
      HIT_NO,
      HIT_GEOMETRY,
      HIT_CHECKPOINT,         //cpp1 is the hit CP
      HIT_LINE,               //line between cpp1 and cpp2 is hit
   };

   E_HIT_RESULT GetHit(S_vector &pos, S_vector &dir, LPC_checkpoint *cpp1, LPC_checkpoint *cpp2,
      float &closest_hit){

      ed->GetScene()->SetRenderMatrix(GetIdentityMatrix());
                              //we're currently editing, do some automatic support (cursor change)
      int mx = igraph->Mouse_x();
      int my = igraph->Mouse_y();
      ed->GetScene()->UnmapScreenPoint(mx, my, pos, dir);
      *cpp1 = NULL;
      *cpp2 = NULL;

      S_MouseEdit_picked pick_data;
      memset(&pick_data, 0, sizeof(pick_data));
      pick_data.pick_from = pos;
      pick_data.pick_dir = dir;
      pick_data.pick_dist = 1e+16f;
      pick_data.pick_action = S_MouseEdit_picked::PA_DEFAULT;

      I3D_collision_data cd(pos, dir, I3DCOL_EXACT | I3DCOL_TEXTURE | I3DCOL_FORCE2SIDE | I3DCOL_RAY);
      if(mission.GetScene()->TestCollision(cd)){
         pick_data.frm_picked = cd.GetHitFrm();
         pick_data.pick_dist = cd.GetClosestHit();
      }
      Action(EDIT_ACTION_PICK, &pick_data);
      E_HIT_RESULT rtn = HIT_NO;
      if(pick_data.frm_picked){
         if(pick_data.frm_picked->GetType()==FRAME_USER){
                              //find CP which is being deleted
            PI3D_user usr = I3DCAST_USER(pick_data.frm_picked);
            LPC_checkpoint cp = (LPC_checkpoint)usr->GetData2();
            if(cp_info[cp].visible){
               *cpp1 = cp;
               return HIT_CHECKPOINT;
            }
         }
         closest_hit = pick_data.pick_dist;
         rtn = HIT_GEOMETRY;
      }else
         closest_hit = 1e+16f;
                              //check if some connection is being hit (might be slow)
      map<LPC_checkpoint, S_cp_info>::const_iterator it;
      for(it=cp_info.begin(); it!=cp_info.end(); it++){
         LPC_checkpoint cp1 = (*it).first;
         const S_cp_info &cpi = (*it).second;
         if(!cpi.visible)
            continue;
                              //check all its connections
         for(int i=cp1->NumConnections(); i--; ){
            LPC_checkpoint cp2 = cp1->GetCPoint(i);
                              //don't check the same connection twice
            if((dword)cp1 > (dword)cp2)
               continue;
                              //also the other must be visible
            if(!cp_info[cp2].visible)
               continue;
            const S_vector &pos1 = cp1->GetPos();
            const S_vector &pos2 = cp2->GetPos();
            S_vector cp_dir = pos2 - pos1; 
            float u1, u2;
            if(LineIntersection(pos, dir, pos1, pos2-pos1, u1, u2)){
               if(u1>0.0f && u1<closest_hit && u2>0.0f && u2<1.0f){
                  S_vector xpt1 = pos + dir * u1;
                  S_vector xpt2 = pos1 + cp_dir * u2;
                  float a = (xpt1-pos).AngleTo(xpt2-pos);
                  if(a<PI*.005f){
                     closest_hit = u1;
                     *cpp1 = cp1;
                     *cpp2 = cp2;
                     rtn = HIT_LINE;
                  }
               }
            }
         }
      }
      return rtn;
   }

//----------------------------
// Make visibility info - set bool flag for each CP depending on if it might be visible on screen.
   void MakeVisibilityInfo(){

      const S_vector &cam_pos = ed->GetScene()->GetActiveCamera()->GetWorldPos();
      float max_dist_2 = config_tab->ItemI(TAB_I_MAX_VISIBILITY); max_dist_2 *= max_dist_2;

      map<LPC_checkpoint, S_cp_info>::iterator it;
      for(it=cp_info.begin(); it!=cp_info.end(); it++){
         LPC_checkpoint cp = (*it).first;
         S_cp_info &cpi = (*it).second;
         const S_vector &pos = cp->GetPos();
         S_vector dir_to_cam = cam_pos - pos;
         float dist_to_cam_2 = dir_to_cam.Dot(dir_to_cam);
         cpi.visible = (dist_to_cam_2 < max_dist_2);
      }
   }

//----------------------------

   void RecursiveSetType(LPC_checkpoint cp, E_CHECKPOINT_TYPE t){


      if(cp->GetType()==t)
         return;
                              //save undo
      {
         for(t_cp_map::iterator it=cp_info.begin(); it!=cp_info.end(); it++)
            if((*it).first==cp) break;
         assert(it!=cp_info.end());
         S_cp_type_undo ei = {
            (*it).second.id, cp->GetType()
         };

         S_edit_Undo_2 eu(GetName(), E_CHKPT_UNDO_TYPE, &ei, sizeof(ei));
         e_undo->Action(E_UNDO_SAVE, &eu);
      }

                     //recursively change all linked
      set<LPC_checkpoint> done;
      struct S_hlp{
         static void SetThis(LPC_checkpoint cp, const E_CHECKPOINT_TYPE t, set<LPC_checkpoint> &done){
            cp->SetType(t);
            done.insert(cp);
            for(int i=cp->NumConnections(); i--; ){
               LPC_checkpoint cp1 = cp->GetCPoint(i);
               if(done.find(cp1)==done.end())
                  SetThis(cp1, t, done);
            }
         }
      };
      S_hlp::SetThis(cp, t, done);
      ed->SetModified();
   }

//----------------------------

   void RenameCheckpoint(LPC_checkpoint cp, const C_string &str){

      t_cp_map::iterator it = cp_info.find(cp);
                              //save undo
      const C_string &old_name = cp->GetName();
      int len = sizeof(int) + old_name.Size() + 1;
      byte *buf = (byte*)alloca(len);
      *(int*)buf = (*it).second.id;
      strcpy((char*)buf+sizeof(int), old_name);
      S_edit_Undo_2 eu(GetName(), E_CHKPT_UNDO_NAME, buf, len);
      e_undo->Action(E_UNDO_SAVE, &eu);

                              //rename
      cp->SetName(str);
      (*it).second.name_texture = NULL;
      ed->SetModified();
   }
   
//----------------------------
public:
   C_edit_checkpoint(C_game_mission &m1):
      mission(m1),
      hwnd_edit(NULL),
      name_font(NULL),
      visible(false),
      show_on(false)
   {
      config_tab = CreateTable();
      config_tab->Open((dword)GetTemplate(), TABOPEN_TEMPLATE);
                              //setup defaults
      config_tab->ItemF(TAB_F_CFG_SCALE) = .7f;
      config_tab->Release();
   }

   ~C_edit_checkpoint(){
   }

   virtual bool Init(){
      //e_property = ed->FindPlugin("Properties");
      e_mouseedit = ed->FindPlugin("MouseEdit");
      e_modify = ed->FindPlugin("Modify");
      e_slct = ed->FindPlugin("Selection");
      e_undo = ed->FindPlugin("Undo");
      if(!e_modify || !e_mouseedit || !e_slct || !e_undo){
         e_modify = NULL;
         e_mouseedit = NULL;
         e_slct = NULL;
         e_undo = NULL;
         return false;
      }

      ed->AddShortcut(this, E_CHKPT_CREATE, "%80 Chec&kPoint\\&Create\tShift+K", K_K, SKEY_SHIFT);
      ed->AddShortcut(this, E_CHKPT_EDIT, "%80 Chec&kPoint\\&Edit\tK", K_K, 0);
      ed->AddShortcut(this, E_CHKPT_RECONNECT_SELECTION, "%80 Chec&kPoint\\&Reconnect selection\tCtrl+K", K_K, SKEY_CTRL);
      ed->AddShortcut(this, E_CHKPT_FALL_SELECTION, "%90 Chec&kPoint\\&Fall selection\tCtrl+Alt+K", K_K, SKEY_CTRL|SKEY_ALT);
      ed->AddShortcut(this, E_CHKPT_CLEAR_ALL, "%90 Chec&kPoint\\Clear all", 0, 0);
      ed->AddShortcut(this, E_CHKPT_TOGGLE_SHOW, "%80 Chec&kPoint\\%i &Show\tCtrl+Shift+K", K_K, SKEY_CTRL|SKEY_SHIFT);
      ed->AddShortcut(this, E_CHKPT_SET_TYPE, "%80 Chec&kPoint\\Set &type", K_NOKEY, 0);
      ed->AddShortcut(this, E_CHKPT_RENAME, "%80 Chec&kPoint\\&Rename\tCtrl+Shift+Alt+K", K_K, SKEY_CTRL|SKEY_SHIFT|SKEY_ALT);
      ed->AddShortcut(this, E_CHKPT_CONFIG, "%80 Chec&kPoint\\Confi&g", K_NOKEY, 0);
      return true;
   }

   virtual void Close(){
      
      if(hwnd_edit){
         DestroyWindow((HWND)hwnd_edit);
         hwnd_edit = NULL;
      }
      config_tab = NULL;

      e_modify = NULL;
      e_undo = NULL;
      e_mouseedit = NULL;
      e_slct = NULL;
      mat_icon[0] = NULL;
      mat_icon[1] = NULL;
      if(name_font){
         OsDestroyFont(name_font);
         name_font = NULL;
      }
   }

   virtual void Tick(byte skeys, int time, int mouse_rx, int mouse_ry, int mouse_rz, byte mouse_butt){

      if(dirty_cpts.size()){
         if(visible){
            for(int i=dirty_cpts.size(); i--; ){
               LPC_checkpoint cp = dirty_cpts[i];
               PI3D_user usr = cp_info[cp].frm;
               if(usr)
                  cp->SetPos(usr->GetWorldPos());
            }
         }
         dirty_cpts.clear();
         ed->SetModified();
      }

      if(drag_cp){
         if(!(mouse_butt&1)){
                              //dragged line released, evaluate
            S_vector pos, dir;
            float closest_hit;
            LPC_checkpoint cp1, cp2;
            switch(GetHit(pos, dir, &cp1, &cp2, closest_hit)){
            case HIT_CHECKPOINT:
               if(drag_cp!=cp1 && drag_cp->GetType()==cp1->GetType()){
                              //toggle connection among these
                  SaveToggle(cp_info[cp1].id, cp_info[drag_cp].id);
                  bool connected = (cp1->GetConnectionIndex(drag_cp)!=-1);
                  if(connected){
                     cp1->Disconnect(drag_cp);
                     ed->Message("Disconnected.");
                  }else{
                     cp1->Connect(drag_cp);
                     ed->Message("Connected.");
                  }
               }
               break;
            case HIT_GEOMETRY:
               {
                  LPC_checkpoint cp = CreateCheckpointOnPosition(pos + dir * closest_hit, false, drag_cp->GetType());
                  cp->Connect(drag_cp);
               }
               break;
            }
            drag_cp = NULL;
         }
      }
   }

   virtual dword Action(int id, void *context){

      dword ret = 0;          //dafault retunr value

      switch(id){
      case E_CHKPT_CREATE:
         {
            if(!ed->CanModify()) break;
            if(!show_on)
               Action(E_CHKPT_TOGGLE_SHOW, 0);

            e_slct->Action(E_SELECTION_CLEAR);

            LPC_checkpoint cp = CreateCheckpoint();
            AutoConnect(cp);

            assert(visible);
            ShowCheckpoint(cp, true);
                              //add newly created CP to selection
            e_slct->Action(E_SELECTION_ADD_FRAME, cp_info[cp].frm);

            ed->SetModified();
         }
         break;

      case E_CHKPT_CLEAR_ALL:
         {
            if(!ed->CanModify()) break;
            if(show_on)
               Action(E_CHKPT_TOGGLE_SHOW, 0);
            while(mission.NumCheckpoints())
               mission.DestroyCheckpoint(mission.GetCheckpoints()[0]);
         }
         break;

      case E_CHKPT_DESTROY_NAMED:
         {
            if(!ed->CanModify()) break;
            int id = *(int*)context;
            for(map<LPC_checkpoint, S_cp_info>::const_iterator it=cp_info.begin(); it!=cp_info.end(); it++)
               if((*it).second.id==id) break;
            assert(it!=cp_info.end());
            DestroyCP((*it).first);
         }
         break;

      case E_CHKPT_CREATE_NAMED:
         {
            if(!ed->CanModify()) break;
            const S_cp_create_info &ci = *(S_cp_create_info*)context;

            LPC_checkpoint cp = CreateCheckpoint(ci.suggested_id);
            cp->SetPos(ci.pos);
            cp->SetType(ci.type);
                              //re-connect
            for(int i=0; ci.connect_id[i]!=-1; i++){
               for(map<LPC_checkpoint, S_cp_info>::const_iterator it=cp_info.begin(); it!=cp_info.end(); it++)
                  if((*it).second.id==ci.connect_id[i]) break;
               if(it!=cp_info.end()){
                  cp->Connect((*it).first);
               }
            }
            const char *name = (const char*)&ci.connect_id[i+1];
            cp->SetName(name);

            if(visible) ShowCheckpoint(cp, true);
            ed->SetModified();
         }
         break;

      case E_CHKPT_TOGGLE_SHOW:
          {
            show_on = !show_on;
            ed->CheckMenu(this, E_CHKPT_TOGGLE_SHOW, show_on);
            ed->Message(C_fstring("Draw checkpoints %s", show_on ? "on" : "off"));
            ShowCheckpoints(show_on);
         }
         break;

      case E_CHKPT_TOGGLE_CON:
         {
            int *con_id = (int*)context;

            int con_add = 0, con_del = 0;

            for(map<LPC_checkpoint, S_cp_info>::const_iterator it=cp_info.begin(); it!=cp_info.end(); it++)
               if((*it).second.id==con_id[0]) break;
            assert(it!=cp_info.end());
            LPC_checkpoint cp = (*it).first;
            for(int i=1; con_id[i]!=-1; i++){
               for(it=cp_info.begin(); it!=cp_info.end(); it++)
                  if((*it).second.id==con_id[i]) break;
               assert(it!=cp_info.end());
               LPC_checkpoint cp1 = (*it).first;
                              //check if they're currently connected
               bool con = cp->IsConnected(cp1);
               if(!con){
                  cp->Connect(cp1);
                  ++con_add;
               }else{
                  cp->Disconnect(cp1);
                  ++con_del;
               }
               ed->SetModified();
            }
            int num = i + 1;
                              //save undo
            S_edit_Undo_2 eu(GetName(), E_CHKPT_TOGGLE_CON, context, num*sizeof(int));
            e_undo->Action(E_UNDO_SAVE, &eu);

                              //write message
            C_string str;
            if(con_add) str = C_fstring("connected: %i", con_add);
            if(con_del) str = C_fstring("%s%sdisconnected: %i", (const char*)str,
               str.Size() ? ", " : "", con_del);
            if(str.Size())
               ed->Message(str);
         }
         break;

      case E_CHKPT_MODIFY_NOTIFY:
         {
            if(!ed->CanModify()) break;
            pair<PI3D_frame, dword> *p = (pair<PI3D_frame, dword>*)context;
            if((p->second&E_MODIFY_FLG_POSITION) && p->first->GetType()==FRAME_USER){
               PI3D_user usr = I3DCAST_USER(p->first);
                              //move checkpoint to the same position as notified frame
               LPC_checkpoint cp = (LPC_checkpoint)usr->GetData2();
               if(find(dirty_cpts.begin(), dirty_cpts.end(), cp)==dirty_cpts.end())
                  dirty_cpts.push_back(cp);
            }
         }
         break;

      case E_CHKPT_SET_TYPE:
      case E_CHKPT_RENAME:
         {
            PI3D_frame sel_frm = (PI3D_frame)e_slct->Action(E_SELECTION_GET_SINGLE);
            if(!sel_frm){
               ed->Message("single selection required");
               break;
            }
            if(sel_frm->GetType()!=FRAME_USER){
               ed->Message("selected frame is not checkpoint");
               break;
            }
            PI3D_user usr = I3DCAST_USER(sel_frm);
            LPC_checkpoint cp = (LPC_checkpoint)usr->GetData2();

            switch(id){
            case E_CHKPT_SET_TYPE:
               {
                  int itm = WinSelectItem("Checkpoint type", "Path\0User\0Drive\0",
                     cp->GetType());
                  if(itm!=-1)
                     RecursiveSetType(cp, (E_CHECKPOINT_TYPE)itm);
               }
               break;

            case E_CHKPT_RENAME:
               {
                              //ask user for name
                  C_string str = cp->GetName();
                  while(true){
                     if(WinGetName("Checkpoint name:", str)){
                        if(!strcmp(str, cp->GetName()))
                           break;
                        if(str.Size()){
                              //check name duplication
                           const C_smart_ptr<C_checkpoint> *cpts = mission.GetCheckpoints();
                           for(int i=mission.NumCheckpoints(); i--; ){
                              if(!strcmp(str, cpts[i]->GetName()))
                                 break;
                           }
                           if(i!=-1){
                              OsMessageBox("Checkpoint with this name already exists. Please select different name.",
                                 "Rename error:", MBOX_OK);
                              continue;
                           }
                        }
                        RenameCheckpoint(cp, str);
                     }
                     break;
                  }
               }
               break;
            }
         }
         break;

      case E_CHKPT_CONFIG:
         {
            if(hwnd_edit) DestroyEdit();
            hwnd_edit = (HWND)config_tab->Edit(GetTemplate(), ed->GetIGraph()->GetHWND(), 
               cbTabCfg, (dword)this,
               TABEDIT_MODELESS | TABEDIT_IMPORT | TABEDIT_EXPORT,// | TABEDIT_HIDDEN,
               NULL, NULL);
            if(hwnd_edit)
               ed->GetIGraph()->AddDlgHWND(hwnd_edit);
         }
         break;

      case EDIT_ACTION_PICK:
         {
            if(!visible)
               break;
            
            S_MouseEdit_picked &mp = *(S_MouseEdit_picked*)context;
            const S_vector &from = mp.pick_from, &dir = mp.pick_dir;
                              //ckeck if some checkpoint is close to direction line
            const C_smart_ptr<C_checkpoint> *cps = mission.GetCheckpoints();

            float &best_dist = mp.pick_dist;
            LPC_checkpoint best_cp = NULL;
            if(!mp.frm_picked) best_dist = 1e+16f;
            for(int i=mission.NumCheckpoints(); i--; ){
               LPC_checkpoint cp = cps[i];
                              //get distance of the CP from direction vector
               float u = dir.Dot(cp->GetPos() - from);
               if(u>=0.0f && u < best_dist){
                  S_vector pol = from + dir * u;
                  float dist_to_line = (pol - cp->GetPos()).Magnitude();
                  if(dist_to_line < (config_tab->ItemF(TAB_F_CFG_SCALE) * .5f)){
                     best_dist = u;
                     best_cp = cp;
                  }
               }
            }
            if(best_cp){
               switch(mp.pick_action){
               case S_MouseEdit_picked::PA_DEFAULT:
               case S_MouseEdit_picked::PA_TOGGLE:
                  mp.frm_picked = cp_info[best_cp].frm;
                  break;
               case S_MouseEdit_picked::PA_LINK:
                  {
                     /*
                     int con_add = 0, con_del = 0;
                              //toggle connection with this frame
                     vector<PI3D_frame> &sel_list = *(vector<PI3D_frame>*)e_slct->Action(E_SELECTION_GETVECTOR);
                              //collect toggled id's, so that we may save undo info
                     vector<int> toggle_id;

                     for(int i=sel_list.size(); i--; ){
                        PI3D_frame frm = sel_list[i];
                        if(frm->GetType()!=FRAME_USER) continue;
                        LPC_checkpoint cp = (LPC_checkpoint)I3DCAST_USER(frm)->GetData2();
                        assert(cp);
                              //don't connect with ourselves
                        if(cp==best_cp) continue;
                               //check if they're currently connected 
                        bool con = best_cp->IsConnected(cp);
                        if(!con){
                           best_cp->Connect(cp);
                           ++con_add;
                        }else{
                           best_cp->Disconnect(cp);
                           ++con_del;
                        }
                        toggle_id.push_back(cp_info[cp].id);
                        ed->SetModified();
                     }
                              //save undo
                     int num = toggle_id.size() + 2;
                     int *id_list = (int*)alloca(sizeof(int)*num);
                     id_list[0] = cp_info[best_cp].id;
                     for(i=toggle_id.size(); i--; ){
                        id_list[i+1] = toggle_id[i];
                     }
                     id_list[num-1] = -1;
                     S_edit_Undo_2 eu(GetName(), E_CHKPT_TOGGLE_CON, id_list, num*sizeof(int));
                     e_undo->Action(E_UNDO_SAVE, &eu);

                              //write message
                     C_string str;
                     if(con_add) str = C_fstring("connected: %i", con_add);
                     if(con_del) str = C_fstring("%s%sdisconnected: %i", (const char*)str,
                        str.Size() ? ", " : "", con_del);
                     if(str.Size())
                        ed->Message(str);
                        */
                              //override linking
                     mp.pick_action = S_MouseEdit_picked::PA_NULL;
                  }
                  break;
               }
            }
         }
         break;

      case EDIT_ACTION_FRAME_DELETE:
         {
            PI3D_frame frm = (PI3D_frame)context;
            if(frm && frm->GetType()==FRAME_USER && visible){
                              //find CP which is being deleted
               PI3D_user usr = I3DCAST_USER(frm);
               LPC_checkpoint cp = (LPC_checkpoint)usr->GetData2();
               assert(cp);
               DestroyCP(cp);
            }
         }
         break;

      case EDIT_ACTION_FRAME_DUPLICATE:
         {
            const pair<PI3D_frame, PI3D_frame> &p = *(const pair<PI3D_frame, PI3D_frame>*)context;
            if(p.second->GetType()==FRAME_USER){
               LPC_checkpoint old_cp = (LPC_checkpoint)I3DCAST_USER(p.second)->GetData2();
               assert(old_cp);
               assert(visible);
               LPC_checkpoint cp = CreateCheckpoint(-1, false);
               cp->SetPos(old_cp->GetPos());
               cp->SetType(old_cp->GetType());
               cp->Connect(old_cp);
               ShowCheckpoint(cp, true, I3DCAST_USER(p.second));
            }
         }
         break;

         /*
      case EDIT_ACTION_MISSION_SAVE_1:
         {
            C_chunk *ck = (C_chunk*)context;
            const C_smart_ptr<C_checkpoint> *cps = mission.GetCheckpoints();
            int num_cps = mission.NumCheckpoints();
            const C_checkpoint **cp_ptr = (const C_checkpoint**)cps;

                              //write (optional) number of cpts
            if(num_cps)
               ck->WIntChunk(CT_NUM_CHECKPOINTS, num_cps);

                              //build temp indicies
            map<const C_checkpoint*, int> cp_map;
            for(int i=num_cps; i--; ){
               cp_map[cp_ptr[i]] = i;
            }
            
            for(i=0; i<num_cps; i++){ //count upwards, we're assuming that in CT_CP_CON_ID chunk
               const C_checkpoint *cp = cp_ptr[i];
               ck->WAscend(CT_CHECKPOINT);
               ck->WVectorChunk(CT_CHKPT_POS, cp->GetPos());
               if(cp->GetType())
                  ck->WByteChunk(CT_CHKPT_TYPE, cp->GetType());
               const C_string &n = cp->GetName();
               if(n.Size())
                  ck->WStringChunk(CT_CHKPT_NAME, n);
                              //write all connections which connect to lower index than ours
               for(int j=cp->NumConnections(); j--; ){
                  const C_checkpoint::S_connection &con = cp->GetConnection(j);
                  LPC_checkpoint cp1 = con.con_cp;
                  int cp_index = cp_map[cp1];
                  if(cp_index<i){
                     ck->WAscend(CT_CHKPT_CONNECTION);
                     {
                        ck->WAscend(CT_CP_CON_ID);
                        ck->Write((const char*)&cp_index, sizeof(word));
                        ck->Descend();
                        if(con.type!=CPT_DEFAULT){
                           assert(con.type<256);
                           ck->WByteChunk(CT_CP_CON_TYPE, con.type);
                        }
                     }
                     ck->Descend();
                  }
               }
               ck->Descend();
            }
         }
         break;
         */

      case EDIT_ACTION_BEFORE_FREE:
         ShowCheckpoints(false);
         cp_info.clear();
         break;

      case EDIT_ACTION_AFTER_LOAD:
         {
            ShowCheckpoints(false);
            cp_info.clear();

                              //assign checkpoints' IDs
            const C_smart_ptr<C_checkpoint> *cps = mission.GetCheckpoints();
            for(int i=mission.NumCheckpoints(); i--; )
               cp_info[cps[i]].id = i;

            ShowCheckpoints(show_on);
         }
         break;

      case E_CHKPT_EDIT:
         {
            S_MouseEdit_pick mp = {this, E_CHKPT_CREATE_USER_PICKED,
               LoadCursor(GetModuleHandle(NULL), "IDC_CURSOR_DEBUG_CP")};
            ed->Message("Checkpoints mouse mode");
            e_mouseedit->Action(E_MOUSE_SET_USER_PICK, &mp);
         }
         break;

      case E_CHKPT_CREATE_USER_PICKED:
         {
            if(!ed->CanModify())
               break;
            const S_MouseEdit_picked &mp = *(S_MouseEdit_picked*)context;
            {
                              //check if we delete existing checkpoint
               S_vector pos, dir;
               float closest_hit;
               LPC_checkpoint cp1, cp2;
               switch(GetHit(pos, dir, &cp1, &cp2, closest_hit)){
               case HIT_CHECKPOINT:
                  {
                     drag_cp = cp1;
                     PI3D_frame cp_frm = cp_info[cp1].frm;
                     switch(mp.pick_action){
                     case S_MouseEdit_picked::PA_DEFAULT:
                        {
                           e_slct->Action(E_SELECTION_CLEAR);
                           e_slct->Action(E_SELECTION_ADD_FRAME, cp_frm);
                        }
                        break;
                     case S_MouseEdit_picked::PA_TOGGLE:
                        {
                           vector<PI3D_frame> *sel_list = (vector<PI3D_frame>*)e_slct->Action(E_SELECTION_GETVECTOR);
                           for(int i=sel_list->size(); i--; ){
                              if((*sel_list)[i]==cp_frm)
                                 break;
                           }
                           e_slct->Action((i==-1) ? E_SELECTION_ADD_FRAME : E_SELECTION_DEL_FRAME, cp_frm);
                        }
                        break;
                     }
                  }
                  return 1;
               case HIT_LINE:
                  {
                     if(mp.pick_action==S_MouseEdit_picked::PA_TOGGLE){
                        ToggleConnectionType(cp1, cp2);
                     }else{
                        SaveToggle(cp_info[cp1].id, cp_info[cp2].id);
                        cp1->Disconnect(cp2);
                        ed->Message("Connection deleted.");
                        ed->SetModified();
                     }
                  }
                  return 1;
               }
            }
            if(mp.frm_picked){
               S_vector pos = mp.pick_from + mp.pick_dir * mp.pick_dist;
               CreateCheckpointOnPosition(pos, true, mp.pick_action==S_MouseEdit_picked::PA_DEFAULT ? CP_PATH : CP_USER);
               return true;
            }
         }
         break;

      case E_CHKPT_RECONNECT_SELECTION:
         {
            if(!ed->CanModify()) break;
            vector<PI3D_frame> &sel_list = *(vector<PI3D_frame>*)e_slct->Action(E_SELECTION_GETVECTOR);
            for(int i=sel_list.size(); i--; ){
               PI3D_frame frm = sel_list[i];
               if(frm->GetType()!=FRAME_USER) continue;
               LPC_checkpoint cp = (LPC_checkpoint)I3DCAST_USER(frm)->GetData2();
               assert(cp);

                              //collect toggled id's, so that we may save undo info
               vector<int> toggle_id;
                              //remove connections
               for(int j = cp->NumConnections(); j--;){
                  LPC_checkpoint con_cp = cp->GetCPoint(j);
                  assert(con_cp);
                  if(!cp->IsConnected(con_cp))
                     continue;
                  cp->Disconnect(con_cp);
                  toggle_id.push_back(cp_info[con_cp].id);
               }
//----------------------------
                              //save undo
               int num = toggle_id.size() + 2;
               int *id_list = (int*)alloca(sizeof(int)*num);
               id_list[0] = cp_info[cp].id;
               for(int i=toggle_id.size(); i--; ){
                  id_list[i+1] = toggle_id[i];
               }
               id_list[num-1] = -1;
               S_edit_Undo_2 eu(GetName(), E_CHKPT_TOGGLE_CON, id_list, num*sizeof(int));
               e_undo->Action(E_UNDO_SAVE, &eu);
               toggle_id.clear();
//----------------------------
                              //autoconnect again
               AutoConnect(cp);
               ed->SetModified();
            }
         }
         break;

      case E_CHKPT_FALL_SELECTION:
         {
            int sucess_num(0);
            if(!ed->CanModify()) break;
            vector<PI3D_frame> &sel_list = *(vector<PI3D_frame>*)e_slct->Action(E_SELECTION_GETVECTOR);
            for(int i=sel_list.size(); i--; ){
               PI3D_frame frm = sel_list[i];
               if(frm->GetType()!=FRAME_USER) continue;
               LPC_checkpoint cp = (LPC_checkpoint)I3DCAST_USER(frm)->GetData2();
               assert(cp);
               if(FallCheckpoint(cp)){
                  sucess_num++;
               }
            }
            C_string s1 = C_fstring("sucess fall %i cp", sucess_num);
            int fail_num(sel_list.size()-sucess_num);
            if(!fail_num)
               ed->SetModified();
            else
               s1 += C_fstring(", failed : %i.", fail_num);
            ed->Message(s1);               
         }
         break;

      case E_CHKPT_CHANGE_POS:
         {
            if(!ed->CanModify()) break;
            S_cp_pos_undo *ui = (S_cp_pos_undo*)context;

                              //find cp
            for(map<LPC_checkpoint, S_cp_info>::const_iterator it=cp_info.begin(); it!=cp_info.end(); it++)
               if((*it).second.id == ui->cp_id)
                  break;
            assert(it!=cp_info.end());
            LPC_checkpoint cp = (*it).first;

                              //save undo
            {
               S_cp_pos_undo ui;
               ui.cp_id = (*it).second.id;
               ui.pos = cp->GetPos();
               S_edit_Undo_2 eu(GetName(), E_CHKPT_CHANGE_POS, &ui, sizeof(S_cp_pos_undo));
               e_undo->Action(E_UNDO_SAVE, &eu);
            }

            cp->SetPos(ui->pos);
            (*it).second.frm->SetPos(ui->pos);
            (*it).second.frm->Update();

            ed->SetModified();
         }
         break;

      case E_CHKPT_UNDO_TYPE:
         {
            S_cp_type_undo *ui = (S_cp_type_undo*)context;

            for(map<LPC_checkpoint, S_cp_info>::const_iterator it=cp_info.begin(); it!=cp_info.end(); it++)
               if((*it).second.id == ui->cp_id)
                  break;
            assert(it!=cp_info.end());
            LPC_checkpoint cp = (*it).first;

            RecursiveSetType(cp, ui->type);
         }
         break;

      case E_CHKPT_UNDO_NAME:
         {
            int id = *(int*)context;
            const char *name = ((const char*)context) + sizeof(int);

            for(map<LPC_checkpoint, S_cp_info>::const_iterator it=cp_info.begin(); it!=cp_info.end(); it++)
               if((*it).second.id == id)
                  break;
            assert(it!=cp_info.end());
            LPC_checkpoint cp = (*it).first;
            RenameCheckpoint(cp, name);
         }
         break;

      case EDIT_ACTION_VALIDATE:
         {
            LPC_editor_item e_log = ed->FindPlugin("Log");
            if(!e_log)
               break;
            ed->Message("Checking checkpoints...", 0, EM_MESSAGE, true);

            vector<C_smart_ptr<C_checkpoint> > cps;
                              //get PATH checkpoints only
            {
               const C_smart_ptr<C_checkpoint> *cps1 = mission.GetCheckpoints();
               cps.reserve(mission.NumCheckpoints());
               for(int i=mission.NumCheckpoints(); i--; ){
                  LPC_checkpoint cp = cps1[i];
                  if(cp->GetType()==CP_PATH)
                     cps.push_back(cp);
               }
            }
            if(0)
            {
                                       //check checkpoints duplication
               LPC_checkpoint *cpsp = (LPC_checkpoint*)cps.begin();

               for(int i=cps.size(); i-- ; ){
                  LPC_checkpoint cp = cpsp[i];
                  const S_vector &pos = cp->GetPos();
                  for(int j=i; j-- ; ){
                     LPC_checkpoint cp1 = cpsp[j];
                     const S_vector &pos1 = cp1->GetPos();
                     if(pos==pos1){
                        ShowCheckpoints(true);
                        e_slct->Action(E_SELECTION_ADD_FRAME, cp_info[cp].frm);

                        e_log->Action(E_LOG_ADD_TEXT, (void*)(const char*)
                           C_fstring("Checkpoint duplication on [%.3f, %.3f, %.3f]",
                           pos.x, pos.y, pos.z));
                        return 1;
                     }
                  }
               }
            }

                              //check checkpoints grid consistency
            if(cps.size()){
               set<LPC_checkpoint> con_cps;
               struct S_hlp{
                  static void RecFunc(set<LPC_checkpoint> &con_cps, LPC_checkpoint cp){

                     int num_cons = cp->NumConnections();
                     vector<LPC_checkpoint> cp_un;
                     cp_un.reserve(num_cons);
                              //phase 1 - mark uninserted and add them to set
                     for(int i=num_cons; i--; ){
                        LPC_checkpoint cp1 = cp->GetCPoint(i);
                        set<LPC_checkpoint>::const_iterator it = con_cps.find(cp1);
                        if(it==con_cps.end()){
                           cp_un.push_back(cp1);
                           con_cps.insert(cp1);
                        }
                     }
                              //phase 2 - recursive call on uninserted
                     for(i=cp_un.size(); i--; )
                        RecFunc(con_cps, cp_un[i]);
                  }
               };
               LPC_checkpoint cp_first = cps.front();
               con_cps.insert(cp_first);
               S_hlp::RecFunc(con_cps, cp_first);

               if(con_cps.size() != cps.size()){
                  ShowCheckpoints(true);
                  e_log->Action(E_LOG_ADD_TEXT, "Checkpoint grid not consistent");
                              //select all unconnected checpoints
                  for(int i=cps.size(); i-- ; ){
                     LPC_checkpoint cp = cps[i];
                     set<LPC_checkpoint>::const_iterator it = con_cps.find(cp);
                     if(it==con_cps.end())
                        e_slct->Action(E_SELECTION_ADD_FRAME, cp_info[cp].frm);
                  }
                  return 1;
               }
            }
         }
         break;
      }
      return ret;

   }

//----------------------------

   virtual void Render(){

      assert(visible);
      const vector<PI3D_frame> &sel_list = *(vector<PI3D_frame>*)e_slct->Action(E_SELECTION_GETVECTOR);

      ed->GetScene()->SetRenderMatrix(GetIdentityMatrix());
      float opacity = config_tab->ItemI(TAB_I_CFG_ALPHA);
      byte alpha = 255 - (opacity * 255 / 100);
      //byte half_alpha = 255 - (opacity * 100 / 100);
      map<LPC_checkpoint, S_cp_info>::iterator it;

                              //preprocess - generate visibility info
      MakeVisibilityInfo();
      static const S_vector render_colors[] = { S_vector(1, 1, 0), S_vector(0, 1, 0), S_vector(0, 0, 1) };

      const float max_vis_dist = config_tab->ItemI(TAB_I_MAX_VISIBILITY);
      const float icon_scale = config_tab->ItemF(TAB_F_CFG_SCALE);
      for(it=cp_info.begin(); it!=cp_info.end(); it++){
         LPC_checkpoint cp = (*it).first;
         S_cp_info &cpi = (*it).second;
         float scale = icon_scale;
         if(cp->help_visited)
            scale *= .33f;
                              //render sprite on position of checkpoint
         if(cpi.visible){
            PI3D_frame frm = (*it).second.frm;
                              //if the user frame is selected, draw opaque, otherwise draw ...
            const vector<PI3D_frame>::const_iterator it = find(sel_list.begin(), sel_list.end(), frm);
            bool selected = (it!=sel_list.end());

            ed->GetScene()->DrawSprite(cp->GetPos(), GetIcon(cp->GetType()),
               selected ? 0 : alpha, scale);
            {
                              //draw connections
               for(int j=cp->NumConnections(); j--; ){
                  const C_checkpoint::S_connection &con = cp->GetConnection(j);
                  LPC_checkpoint cp1 = con.cp;
                              //always draw only one line per cross-connection
                  bool draw = (cp<cp1 || !cp_info[cp1].visible);
                  if(draw){
                     ed->GetScene()->DrawLine(cp->GetPos(), cp1->GetPos(),
                        !con.flags ? render_colors[cp->GetType()] : S_vector(1, 0, 0),
                        //type==CPT_DEFAULT ? alpha : half_alpha);
                        alpha);

                     if(con.flags){
                        C_string str;
                        /*
                        if(con.flags&CP_CON_ONEWAY)
                           str += "OneWay ";
                        if(con.flags&CP_CON_ONEWAYTO)
                           str += "OneWayTo ";
                           */
                        if(con.flags&CP_CON_USE_LADDER)
                           str += "Ladder ";
                        if(con.flags&CP_CON_USE_DOOR)
                           str += "Door ";
                        DrawConnectionText((cp->GetPos() + cp1->GetPos()) * .5f, str);
                     }
                  }
               }
            }
                              //draw name
            const C_string &name = cp->GetName();
            if(name.Size()){
               if(!cpi.name_texture){
                  cpi.name_texture = CreateStringTexture(name, cpi.txt_size, driver, GetNameFont());
                  cpi.name_texture->Release();
               }
               DrawStringTexture(frm, 0.0f, mission.GetScene(), cpi.name_texture, cpi.txt_size,
                  S_vector(1, 1, 1),
                  max_vis_dist*.8f, max_vis_dist, opacity, scale * .5f);
            }else{
               cpi.name_texture = NULL;
            }
         }
      }
      if(visible && (LPC_editor_item)e_mouseedit->Action(E_MOUSE_GET_USER_PICK)==this){
         S_vector pos, dir;
         float closest_hit;
         LPC_checkpoint cp1, cp2;
         E_HIT_RESULT hr = GetHit(pos, dir, &cp1, &cp2, closest_hit);
         if(drag_cp){
            if(hr==HIT_CHECKPOINT && drag_cp->GetType()==cp1->GetType()){
               ed->GetScene()->DrawSprite(cp1->GetPos(), GetIcon(2),
                  0, config_tab->ItemF(TAB_F_CFG_SCALE));
               ed->GetScene()->DrawLine(drag_cp->GetPos(), cp1->GetPos(), S_vector(1, 1, 0), 0);
            }else{
               ed->GetScene()->DrawLine(drag_cp->GetPos(), pos+dir, S_vector(1, 1, 0), 0);
            }
         }else{
            if(hr==HIT_LINE){
               ed->GetScene()->DrawLine(cp1->GetPos(), cp2->GetPos(), S_vector(1, 0, .4f), 0);
            }
         }
      }else{
         drag_cp = NULL;
      }
   }

//----------------------------

   virtual bool LoadState(class C_chunk *ck){
      
      ck->Read(&show_on, sizeof(byte));
                              //read table
      config_tab->Open((dword)ck->GetHandle(), TABOPEN_FILEHANDLE | TABOPEN_UPDATE);

      ed->CheckMenu(this, E_CHKPT_TOGGLE_SHOW, show_on);

                              //don't call ShowCheckpoints(), it's done after scene is loaded
      return true; 
   }

   virtual bool SaveState(class C_chunk *ck) const{

      ck->Write(&show_on, sizeof(byte));
                              //write table
      config_tab->Save((dword)ck->GetHandle(), TABOPEN_FILEHANDLE);

      return true; 
   }
};

//----------------------------

void InitCheckpointPlugin(C_game_mission *gm, LPC_editor editor){
   C_edit_checkpoint *em = new C_edit_checkpoint(*gm); editor->InstallPlugin(em); em->Release();
}

//----------------------------
