#include "all.h"


//----------------------------

C_checkpoint::C_checkpoint():
   type(CP_PATH),
   recurse(false),
#ifdef EDITOR
   help_visited(false),
#endif
   debug_flag(0)
{
   pos.Zero();
}

//----------------------------

C_checkpoint::~C_checkpoint(){
   //Show(false);
   while(cnts.size())
      Disconnect(cnts[0].cp);
}

//----------------------------

void C_checkpoint::Reset1(){

   while(cnts.size())
      Disconnect(cnts[0].cp);
}

//----------------------------

void C_checkpoint::Connect(LPC_checkpoint cd){

   cnts.push_back(S_connection());
   cnts.back().cp=cd;
   cnts.back().flags=0;

   cd->cnts.push_back(S_connection());
   cd->cnts.back().cp=this;
   cd->cnts.back().flags=0;
}

//----------------------------

void C_checkpoint::Disconnect(LPC_checkpoint cd){

   int i;
   for(i=0; i<cnts.size(); i++)
   if(cnts[i].cp==cd){
      //cnts.fast_erase(i);
      cnts[i] = cnts.back(); cnts.pop_back();
      break;
   }
   for(i=0; i<cd->cnts.size(); i++)
   if(cd->cnts[i].cp==this){
      //cd->cnts.fast_erase(i);
      cd->cnts[i] = cd->cnts.back(); cd->cnts.pop_back();
      break;
   }
   //mission.InvalidateCPGrid();
}

//----------------------------

void C_checkpoint::SetConnectionData(int i, dword d){

   cnts[i].flags = d;
   //cnts[i].cp->cnts[cnts[i].cp->GetConnectionIndex(this)].flags = d & ~CP_CON_ONEWAYTO;
   cnts[i].cp->cnts[cnts[i].cp->GetConnectionIndex(this)].flags = d;
}

//----------------------------

void C_checkpoint::SetConExpence1(int i, float f){

   cnts[i].expence = f;
   cnts[i].cp->cnts[cnts[i].cp->GetConnectionIndex(this)].expence = f;
   //mission.InvalidateCPGrid();
}

//----------------------------

int C_checkpoint::GetConnectionIndex(LPC_checkpoint cd) const{

   for(int i=cnts.size(); i--; )
      if(cnts[i].cp==cd) break;
   return i;
}

//----------------------------

bool C_checkpoint::IsConnected(LPC_checkpoint cd) const{
   return (GetConnectionIndex(cd) != -1);
}

//----------------------------
//----------------------------

