#include <math\ease.hpp>

template<class T>
class C_fade{
   dword curr_time, end_time;
   T t_end, t_delta;
   C_ease_interpolator ease;
public:
   C_fade(): curr_time(0), end_time(0)
   {}
   void Setup(dword time, const T &beg, const T end){
      curr_time=0;
      end_time=time;
      t_delta=beg-(t_end=end);
   }
   T Tick(dword time){
      curr_time=Min(end_time, curr_time+time);
      float f = 1.0 - ease[(float)curr_time / (float)end_time];
      return t_end + t_delta*f;
   }
   bool IsEnd() const{
      return curr_time==end_time;
   }
   void Stop(){
      curr_time=end_time;
   }
};

struct S_fade_color{
   int color[4];

   S_fade_color(){}
   S_fade_color(dword c)
   {
      for(int i=0; i<4; i++) color[i]=(c>>(i*8))&255;
   }
   operator dword() const{
      dword ret=0;
      for(int i=0; i<4; i++) ret |= color[i]<<(i*8);
      return ret;
   }
   S_fade_color operator +(const S_fade_color &c) const{
      S_fade_color ret;
      for(int i=0; i<4; i++) ret.color[i] = color[i] + c.color[i];
      return ret;
   }
   S_fade_color operator -(const S_fade_color &c) const{
      S_fade_color ret;
      for(int i=0; i<4; i++) ret.color[i] = color[i] - c.color[i];
      return ret;
   }
   S_fade_color operator*(float f) const{
      S_fade_color ret;
      for(int i=0; i<4; i++) ret.color[i] = color[i] * f;
      return ret;
   }
};

//----------------------------