#include "all.h"
#include "net.h"


//----------------------------
#define HOLE_TIME 7000
#define FADE_TIME 6000

//----------------------------

class C_gun_hole: public C_actor{
   float optacity;
   int count_down;
   PI3D_material mat;
   PI3D_object obj;
public:
   C_gun_hole(C_game_mission &m):
      C_actor(m, ACTOR_NULL),
      count_down(HOLE_TIME), mat(NULL), obj(NULL),
      optacity(1.0f)
   {}

//----------------------------

   virtual void SetFrame(PI3D_frame frm1){

      C_actor::SetFrame(frm1);
      mission.SetFrameSector(frame);
      PI3D_frame frm = frame->FindChildFrame(NULL, ENUMF_VISUAL);
      if(frm){
         assert(I3DCAST_VISUAL(frm)->GetVisualType()==I3D_VISUAL_OBJECT);
         obj = I3DCAST_OBJECT(frm);
         PI3D_mesh_object mo = obj->GetMeshObject();
         if(mo){
                              //dup mesh
            PI3D_mesh_object mo1 = driver->CreateMesh();
            mo1->Duplicate(mo);

            PI3D_mesh_level ml = mo1->GetLOD(0);
            if(ml){
                              //dup level
               PI3D_mesh_level ml1 = driver->CreateMeshLevel();
               ml1->Duplicate2(ml);

               PI3D_face_group fg = ml1->GetFGroup(0);
               mat = driver->CreateMaterial();
               mat->Duplicate(fg->GetMaterial());
               mat->SetAlpha(optacity);
               mat->Update();
               fg->SetMaterial(mat);
               mat->Release();

               mo1->SetLOD(ml1, 0.0);
               ml1->Release();
            }
            obj->SetMeshObject(mo1);
            mo1->Release();
         }
      }
   }

//----------------------------

   dword cbProc(dword msg, dword prm1, dword prm2){
      switch(msg){

      case CB_SETPARAM:
         switch(prm1){
         case 0:
            if(mat){
               optacity = *(float*)&prm2;
               mat->SetAlpha(optacity);
               mat->Update();
            }
            return true;
         }
      }
      return C_actor::cbProc(msg, prm1, prm2);
   }

//----------------------------

   dword Tick(const S_tick_context &tc){

      if((count_down -= tc.time)<=0) mission.DestroyActor(this);
      else
      if(count_down<FADE_TIME && mat){
         mat->AddRef();
         if(mat->Release()!=1) assert(0);
         mat->SetAlpha(optacity * (float)count_down/FADE_TIME);
         mat->Update();
         obj->SetUpdate();
      }
      return 0;
   }

//----------------------------

   virtual bool MaySaveGame() const{ return false; }
};

//----------------------------

LPC_actor CreateGunGole(C_game_mission &gm){

   return new C_gun_hole(gm);
}

//----------------------------
