#include "all.h"

//----------------------------

                              //hint class
#define HINT_TIME 3000
#define HINT_FADE_TIME 300

class C_hint: public C_hint_base{
   LPC_text text;

   int count;
   C_fade<S_fade_color> fade;
   bool flt_up;
   dword color;
public:
   C_hint(const char *t1, bool wide, C_poly_text *texts, float x, float y, float size, bool flt_up1, int count1,
      dword color1, dword text_flags):
      color(color1),
      text(NULL),
      count(count1 ? count1 : HINT_TIME),
      flt_up(flt_up1)
   {
      if(!t1)
         return;
      text = texts->CreateText(t1, 0, x, y, size, text_flags, wide,
         NULL, NULL, NULL, NULL, 0,
         PI*.08f);
      fade.Setup(HINT_FADE_TIME, color&0x00ffffff, color);
   }

   ~C_hint(){
      text->Release();
   }

//----------------------------

   virtual bool Tick(int time){

      if(!text)
         return false;
      if(flt_up){
                           //fly up
         S_vector2 pos;
         text->GetPos(pos.x, pos.y);

         pos.y -= (float)time*.04f*.001f;
         text->SetPos(pos.x, pos.y);
      }
      if(!fade.IsEnd()){
                              //fade on or off
         text->SetColor(fade.Tick(time));
         if(fade.IsEnd() && !count)
            return false;
      }else{
                              //fade off
         if((count -= time) <= 0){
            count = 0;
            fade.Setup(HINT_FADE_TIME, color, color&0x00ffffff);
         }
      }
      return true;
   }

//----------------------------

   virtual void FadeOff(){ count = Min(count, 10); }

//----------------------------

   virtual void SetPos(const S_vector2 &p){

      //pos = p;
      text->SetPos(p.x, p.y);
   }

//----------------------------

   virtual void SetOn(bool b){
      text->SetOn(b);
   }

};

//----------------------------

C_hint_base *CreateHint(const char *t1, bool wide, C_poly_text *texts, float x, float y, float size, dword color,
   bool flt_up, int count, dword text_flags){

   assert(texts);
   return new C_hint(t1, wide, texts, x, y, size, flt_up, count, color, text_flags);
}

//----------------------------