#include "all.h"

//----------------------------

#define SIZE .04125f

//----------------------------

C_icon_info::C_icon_info(C_poly_text &tx, int sm):
   texts(tx),
   text_size(.0225f),
   sprite_mask(sm),
   text(NULL)
{
   pos[0] = 0.0f;
   pos[1] = 0.0f;
   spr = new C_poly_sprite(0.0f, 0.0f, SIZE, &icons_img, sprite_mask);
   spr->Release();
}

//----------------------------

void C_icon_info::ResetScreen(){

   spr = new C_poly_sprite(pos[0], pos[1], SIZE, &icons_img, sprite_mask);
   spr->Release();
   SetText(str_text);
}

//----------------------------

void C_icon_info::GetPos(float &x, float &y) const{

   x = pos[0];
   y = pos[1];
}

//----------------------------

void C_icon_info::SetPos(float x, float y){

   pos[0] = x;
   pos[1] = y;
   if(spr) spr->SetPos(pos[0], pos[1]);
   if(text){
      float x1, y1;
      text->GetPos(x1, y1);
      text->SetPos(x1, pos[1]);
   }
}

//----------------------------

void C_icon_info::SetText(const char *cp){

   text = NULL;
   str_text = cp;
   if(cp){
      text = texts.CreateText(cp, -1, pos[0], pos[1], text_size, TEXT_JUSTIFY_CENTER);
      text->Release();
   }
}

//----------------------------

void C_icon_info::Render(){

   spr->Render();
}

//----------------------------
