#ifndef __C_UNKNWN_H
#define __C_UNKNWN_H

// Unknown interface - keeping object reference count
#include <assert.h>


//----------------------------

class C_unknown{
   unsigned long ref;
protected:
   virtual ~C_unknown(){};
public:
   inline C_unknown(): ref(1) {}
   inline unsigned long AddRef(){
                              //make sure we're not operating on released pointer (zero ref)
      assert(ref);
      return ++ref;
   }
   inline unsigned long Release(){
      if(--ref) return ref;
      delete this;
      return 0;
   }
};
typedef C_unknown *LPC_unknown;

//----------------------------

#endif
