#ifndef __DTA_READ_H
#define __DTA_READ_H

//----------------------------
// Copyright (c) 2002 Lonely Cat Games  All rights reserved.
// Data reader - read-only access to data packages.
// Contents:
//    - data initalizer class
//    - I/O functions simulating standard open, close, read and seek
//----------------------------

#ifdef DTA_READ_STATIC

# define DTAAPI __stdcall
# pragma comment(lib, "dta_read_static")

#else

# define DTAAPI __declspec(dllexport) __stdcall
# pragma comment(lib, "icom_rd")

#endif

#include <rules.h>

#ifndef DTA_FULL

class C_dta_read{
public:
   virtual unsigned long DTAAPI AddRef() = 0;
   virtual unsigned long DTAAPI Release() = 0;
};
#endif

typedef class C_dta_read *LPC_dta_read;

#define DTA_SEEK_SET 0
#define DTA_SEEK_CUR 1
#define DTA_SEEK_END 2

#define DTACREATE_SHOWINFO 1  //show dta file scanning during content creation

void DTAAPI dtaDumpMemoryLeaks(bool);
LPC_dta_read DTAAPI dtaCreate(const char *fname, dword flags = 0, const char *info_title = NULL);
int DTAAPI dtaOpen(const char *name);
bool DTAAPI dtaClose(int handle);
int DTAAPI dtaRead(int handle, void *buffer, dword len);
int DTAAPI dtaSeek(int handle, int pos, int whence);
int DTAAPI dtaBin2Text(void *mem, dword len);
bool DTAAPI dtaGetTime(int handle, dword time[2]);
int DTAAPI dtaOpenWrite(const char *name);
int DTAAPI dtaWrite(int handle, const void *buffer, dword len);
LPC_dta_read DTAAPI dtaGetDtaPack(int handle);

//----------------------------
#endif
