#ifndef __IEXCEPT_H
#define __IEXCEPT_H

//----------------------------
// Copyright (c) 2002 Lonely Cat Games,  All rights reserved.
// Exception handling for Win32 API
//    - catching standard and FPU hardware exceptions
//----------------------------

#include <rules.h>

#pragma comment(lib, "iexcpt")

//----------------------------
// Initialize exception handler, and setup FPU control word (used to
// enable required FPU exceptions - see _ctrlfp() for details).
void __declspec(dllexport) __stdcall InitializeExceptions(dword fpu_cw = -1);

//----------------------------
// Setup function, which will be called with error string,
// when user hits 'Send' button.
// The user function should return true, if sending succeeded.
void __declspec(dllexport) __stdcall SetExceptionSendFunc(bool (__stdcall *)(const char*));

//----------------------------
// Setup function, which will be called once when crash occurs.
void __declspec(dllexport) __stdcall SetExceptionCallback(void (__stdcall *)());

//----------------------------
#endif
