#include "frame.h"

//----------------------------

class I3D_target: public I3D_frame{
   C_smart_ptr<I3D_frame> frame;

   friend I3D_driver;        //creation
   I3D_target(PI3D_driver);
   ~I3D_target();
public:
   I3D_target &operator =(const I3D_target&);
   void Draw1(PI3D_scene, bool strong) const;
public:
   I3DMETHOD_(void,Update)();
   I3DMETHOD(Duplicate)(CPI3D_frame);
   I3DMETHOD(DebugDraw)(PI3D_scene) const;
   virtual void SetMatrixDirty(){
      Update();
      I3D_frame::SetMatrixDirty();
   }
public:
   I3DMETHOD_(dword,Release)(){ if(--ref) return ref; delete this; return 0; }

   I3DMETHOD_(void,SetFrame)(PI3D_frame frm){ frame = frm; }
   I3DMETHOD_(PI3D_frame,GetFrame)() const{ return frame; }
};

//----------------------------