#include "all.h"
#include "common.h"

//----------------------------

class C_edit_Help: public C_editor_item{
   virtual const char *GetName() const{ return "Help"; }

   static BOOL CALLBACK dlgAbout(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam){

      switch(uMsg){
      case WM_INITDIALOG:
         {
            C_edit_Help *eh = (C_edit_Help*)lParam;
            InitDlg(eh->ed->GetIGraph(), hwnd);
            ShowWindow(hwnd, SW_SHOW);
            SetWindowLong(hwnd, GWL_USERDATA, lParam);
         }
         break;

      case WM_COMMAND:
         switch(LOWORD(wParam)){
         case IDCANCEL:
            {
               EndDialog(hwnd, 0);
            }
            break;
         }
         break;
      }
      return 0;
   }
public:

   C_edit_Help()
   {}

   virtual bool Init(){
      LPIGraph igraph = ed->GetIGraph();
      if(!igraph->GetMenu()){
         igraph->UpdateParams(0, 0, 0, IG_LOADMENU, IG_LOADMENU);
         igraph->ProcessWinMessages();
      }
                              //add menu items (and keyboard short-cuts)
      ed->AddShortcut(this, 1001, "%100 %i &Help\\%100 %i &Help\tF1", K_F1, 0);
      ed->AddShortcut(this, 1000, "%100 %i &Help\\%100 %i &About", 0, 0);
      return true;
   }
   //virtual void Close(){ }
   //virtual void Tick(byte skeys, int time, int mouse_rx, int mouse_ry, int mouse_rz, byte mouse_butt){}

//----------------------------

   virtual dword Action(int id, void *context){
      switch(id){
      case 1000:
         {
            DialogBoxParam(GetHInstance(), "IDD_ABOUT", (HWND)ed->GetIGraph()->GetHWND(),
               dlgAbout, (LPARAM)this);
         }
         break;
      case 1001:
         {
            SHELLEXECUTEINFO se;
            memset(&se, 0, sizeof(se));
            se.cbSize = sizeof(se);
            //se.fMask = SEE_MASK_FLAG_DDEWAIT | SEE_MASK_ICON | SEE_MASK_NOCLOSEPROCESS;
            se.hwnd = (HWND)ed->GetIGraph()->GetHWND();
            //se.lpFile = "Editor\\Help\\main.htm";
            se.lpFile = "Editor\\Help\\IEditor.chm";
            se.nShow = SW_SHOWDEFAULT;
            //se.hIcon = LoadIcon(GetHInstance(), "IDI_HELP");
                              //let system show error message
            ShellExecuteEx(&se);
         }
         break;
      }
      return 0;
   }

//----------------------------

   //virtual void Render(){}
   //virtual bool LoadState(class C_chunk*){ return false; }
   //virtual bool SaveState(class C_chunk*) const{ return false; }
};

//----------------------------

void CreateHelp(LPC_editor ed){
   LPC_editor_item ei = new C_edit_Help;
   ed->InstallPlugin(ei);
   ei->Release();
}

//----------------------------
