#include "all.h"


//----------------------------

class C_edit_VideoGrab: public C_editor_item{
   virtual const char *GetName() const{ return "VideoGrab"; }

   bool in_grab;
   vector<C_smart_ptr<IImage> > images;
public:
   C_edit_VideoGrab():
      in_grab(false)
   {}

   virtual bool Init(){
#define DS "&View\\&Video\\"
      ed->AddShortcut(this, 1000, DS"&Grab being/end\tScrollLock", K_SCROLLLOCK, 0);
      return true;
   }

   virtual dword Action(int id, void *context){

      switch(id){
      case 1000:
         if(!in_grab){
            in_grab = true;
            ed->Message("Video grab begin.");
         }else{
            in_grab = false;
            ed->Message("Video grab finished.", 0, EM_MESSAGE, true);
            if(!images.size())
               break;

            char buf[MAX_PATH];

            OPENFILENAME on;
            memset(&on, 0, sizeof(on));
            on.lStructSize = sizeof(on);
            on.hwndOwner = (HWND)ed->GetIGraph()->GetHWND();
            on.lpstrFilter = "Image (*.bmp, *.png)\0*.bmp;*.png\0All files\0*.*\0";
            on.nFilterIndex = 0;
            on.lpstrFile = buf;
            buf[0] = 0;
            on.nMaxFile = MAX_PATH;
            //on.lpstrInitialDir =
            on.lpstrTitle = "Save image sequence as (enter name base)";
            on.Flags |= OFN_HIDEREADONLY | OFN_NOCHANGEDIR | OFN_NOTESTFILECREATE | OFN_EXPLORER;
            //on.lpstrDefExt = def_ext;

#define EXTENSION "png"

            bool b = GetSaveFileName(&on);
            if(b){
               ed->GetIGraph()->UpdateParams(0, 0, 0, 0, IG_SUSPENDINACTIVE);
               const char *base = on.lpstrFile;
               int num = images.size();
               for(int i=0; i<num; i++){
                  C_fstring fname_full("%s_%.4i."EXTENSION, base, i);
                  ed->Message(C_fstring("Saving image %i/%i", i+1, num), 0, EM_MESSAGE, true);
                  LPIImage img = images[i];
                  img->Draw();
                  ed->GetIGraph()->UpdateScreen();
                  C_cache ck;
                  ck.open(fname_full, CACHE_WRITE);
                  img->SaveShot(&ck, EXTENSION);
                  ck.close();
                  images[i] = NULL;
                  if(ed->GetIGraph()->ReadKey(true)==K_ESC)
                     break;
               }
               ed->GetIGraph()->UpdateParams(0, 0, 0, IG_SUSPENDINACTIVE, IG_SUSPENDINACTIVE);
            }
            images.clear();
            ed->Message("Video grab finished.");
         }
         break;
      }
      return 0;
   }

   virtual void Tick(byte skeys, int time, int mouse_rx, int mouse_ry, int mouse_rz, byte mouse_butt){

      if(in_grab){
         IImage *img = ed->GetIGraph()->CreateBackbufferCopy(true);
         if(img){
            images.push_back(img);
            ed->Message(C_fstring("Grab frame: %i", images.size()));
            img->Release();
         }
      }
   }
};

//----------------------------

void CreateVideoGrab(LPC_editor ed){
   LPC_editor_item ei = new C_edit_VideoGrab;
   ed->InstallPlugin(ei);
   ei->Release();
}

//----------------------------
