#include "all.h"
#include "loader.h"


//----------------------------

bool ReadJPGHeader(const char *file_name, dword &size_x,
   dword &size_y, byte &bpp);

bool LoadJPG(const char *file_name, dword size_x, dword size_y,
   void *area, byte *pal, byte bpp);

//----------------------------

class C_jpg_loader: public C_image_loader{
public:
   C_jpg_loader(){
      RegisterImageLoader(this);
   }

//----------------------------

   virtual bool GetImageInfo(int h, const char *file_name, void *header, dword hdr_size,
      dword *size_x, dword *size_y, S_pixelformat *pf){

      if(hdr_size<4)
         return false;
      if((*(dword*)header) != 0xe0ffd8ff)
         return false;

      byte bpp;
      bool b = ReadJPGHeader(file_name, *size_x, *size_y, bpp);
      if(!b || bpp!=3)
         return false;
      memset(pf, 0, sizeof(S_pixelformat));
      pf->r_mask = 0x00ff0000;
      pf->g_mask = 0x0000ff00;
      pf->b_mask = 0x000000ff;
      pf->bytes_per_pixel = bpp;

      return true;
   }

//----------------------------

   virtual bool Load(int h, const char *file_name, void *header, dword hdr_size,
      void **mem1, void **pal1, dword *size_x, dword *size_y, S_pixelformat *pf){

      if(!GetImageInfo(h, file_name, header, hdr_size, size_x, size_y, pf))
         return false;

                              //alloc buffer
      *mem1 = MemAlloc((*size_x) * (*size_y) * pf->bytes_per_pixel);
      if(!*mem1)
         return false;
      *pal1 = NULL;
      bool b = LoadJPG(file_name, *size_x, *size_y, *mem1, NULL, (byte)pf->bytes_per_pixel);
      if(b)
         return true;
      MemFree(*mem1);
      *mem1 = NULL;

      return false;
   }
} jpg_loader;

//----------------------------
//----------------------------
