/*--------------------------------------------------------
   Copyright (c) 1999 - 2001 Lonely Cat Games

   File: Main.cpp
   Content: Insanity 3D DLL load/unload processing.
--------------------------------------------------------*/

#include "all.h"
#include <rules.h>
#include <malloc.h>
#include <C_string.hpp>
#if defined _DEBUG
#include <crtdbg.h>
#endif

#define DEBUG_NO_LEAK_WARNING //no warning about unreleased memory

//----------------------------

BOOL WINAPI DllMain(HINSTANCE hinstDLL, dword fdwReason, void *lpvReserved){

   switch(fdwReason){
   case DLL_THREAD_ATTACH:
      break;

   case DLL_THREAD_DETACH:
      break;

   case DLL_PROCESS_ATTACH:
      {
                              //this func switches to MSVC mem allocation, instead of system allocation
         _set_sbh_threshold(1016);
#if defined _MSC_VER && defined _DEBUG && !defined DEBUG_NO_LEAK_WARNING
                              //report memory leaks at exit
         _CrtSetDbgFlag(_CrtSetDbgFlag(_CRTDBG_REPORT_FLAG) | _CRTDBG_LEAK_CHECK_DF);

                              //report mode
         _CrtSetReportMode(_CRT_ERROR, _CRTDBG_MODE_WNDW);
         _CrtSetReportMode(_CRT_WARN, _CRTDBG_MODE_WNDW);
         _CrtSetReportMode(_CRT_ASSERT, _CRTDBG_MODE_WNDW);
         struct S_hlp{
            static int __cdecl CrtDumpClient(int report_type, char *msg, int *ret_val){

               static bool called;
               if(!called){
                  _CrtSetDbgFlag(_CrtSetDbgFlag(_CRTDBG_REPORT_FLAG) & ~_CRTDBG_LEAK_CHECK_DF);
                  called = true;
               }
               if(report_type==_CRT_WARN){
                  _CrtMemState ms;
                  _CrtMemCheckpoint(&ms);
                  int num = ms.lCounts[_NORMAL_BLOCK];
                  int sz = ms.lSizes[_NORMAL_BLOCK];

                              //display message that some errors occured
                  int i = MessageBox(NULL,
                     msg,
                     C_fstring("ISND2.dll (%i bytes in %i blocks)", sz, num), MB_ABORTRETRYIGNORE);

                  switch(i){
                  case IDABORT:
                     abort();
                     break;
                  case IDRETRY:
                     *ret_val = 1;
                     break;
                  default:
                     *ret_val = 0;
                  }
               }
               return true;
            }
         };
         _CrtSetReportHook(S_hlp::CrtDumpClient);
         //_CrtSetBreakAlloc(2952);
#endif
      }
      break;

   case DLL_PROCESS_DETACH:
      break;
   }
   return true;
}

//----------------------------

