#include <insanity\SourceControl.h>
#include <windows.h>
#include <win_reg.h>

//----------------------------

bool SCGetPath(C_string &vss_exe, C_string &vss_database){

   char name[256];
                           //get path to source safe
   int hk = RegkeyOpen("Software\\Microsoft\\SourceSafe");
   if(hk==-1)
      return false;
   int len = RegkeyRdata(hk, "SCCServerPath", name, sizeof(name));
   if(len==-1){
      RegkeyClose(hk);
      return false;
   }
   while(len && name[len-1]!='\\') --len;
   strcpy(&name[len], "ss.exe");
   vss_exe = name;

   len = RegkeyRdata(hk, "Current Database", name, sizeof(name));
   RegkeyClose(hk);
   if(len==-1)
      return false;
   vss_database = name;

   return true;
}

//----------------------------

static bool SCCommand(const char *in_cmdline){

   C_string vss_exe, vss_data;
   if(!SCGetPath(vss_exe, vss_data))
      return false;

   C_fstring cmdline("\"%s\" %s", (const char*)vss_exe, (const char*)in_cmdline);

   PROCESS_INFORMATION pi;
   memset(&pi, 0, sizeof(pi));

   STARTUPINFO si;
   memset(&si, 0, sizeof(si));
   si.cb = sizeof(si);
   si.dwFlags = STARTF_USESHOWWINDOW;// | STARTF_USESTDHANDLES;
   si.wShowWindow = SW_HIDE;

   SECURITY_ATTRIBUTES lsa;
   lsa.nLength = sizeof(lsa);
   lsa.lpSecurityDescriptor = NULL;
   lsa.bInheritHandle = true;

   char env[1024];
   strcpy(env, "SSDIR=");
   strcat(env, vss_data);
   int len = strlen(env);
   env[len] = 0;
   bool ok = CreateProcess(vss_exe,
      (char*)(const char*)cmdline,
      &lsa,                //process security attributes
      &lsa,                //thread security attributes
      true,                //handle inheritance flag
      0,                   //creation flags
      (void*)(const char*)env,
      NULL,                //pointer to current directory name
      &si,
      &pi);
   if(!ok)
      return false;

   dword wr = WaitForSingleObject(pi.hProcess, 30000);
   switch(wr){
   case WAIT_TIMEOUT:
      return false;
   default:
      return false;
   case WAIT_OBJECT_0: break;
   }
   dword cr;
   bool b = GetExitCodeProcess(pi.hProcess, &cr);
   assert(b && cr!=STILL_ACTIVE);
   b = CloseHandle(pi.hProcess);
   assert(b);
   b = CloseHandle(pi.hThread);
   assert(b);
   return (cr==0);
}

//----------------------------

bool SCGetFile(const char *project, const char *filename){

   C_string filepath = filename;
   for(int i=filepath.Size(); i--; ){
      if(filepath[i]=='\\'){
         filepath[i] = 0;
         break;
      }
   }
   C_fstring cmdline("Get $\\%s\\%s -GKA -GL%s", project, filename, (const char*)filepath);
   return SCCommand(cmdline);
}

//----------------------------

bool SCCheckOutFile(const char *project, const char *filename){

   C_string filepath = filename;
   for(int i=filepath.Size(); i--; ){
      if(filepath[i]=='\\'){
         filepath[i] = 0;
         break;
      }
   }
   C_fstring cmdline("Checkout $\\%s\\%s -GKA -C- -GL%s", project, filename, (const char*)filepath);
   return SCCommand(cmdline);
}

//----------------------------

bool SCCheckInFile(const char *project, const char *filename, bool keep_checked_out){

   C_string filepath = filename;
   for(int i=filepath.Size(); i--; ){
      if(filepath[i]=='\\'){
         filepath[i] = 0;
         break;
      }
   }
   C_fstring cmdline("Checkin $\\%s\\%s -GKA -C- -%s -GL%s",
      project, filename,
      keep_checked_out ? "K" : "K-",
      (const char*)filepath);
   return SCCommand(cmdline);
}

//----------------------------
//----------------------------
