#include "Max.h"
#include <stdio.h>
#include <direct.h>
#include <commdlg.h>
#include "splshape.h"
#include "imtl.h"
#include "dummy.h"
#include "i3dimp.h"
#include "..\common\mtldef.h"
#include "gamma.h"

#include "dummy.h"

SMtl *loadmtl,inmtl;

extern UWORD file_in_degamtab[];

//----------------------------

/*
int load_app_data(FILE *stream,void **pdata, int size) {
   ULONG *plong;
   if (*pdata!=NULL) 
      XMFreeAndZero(pdata);
   *pdata = (void *)XMAlloc(size+4);
   if (*pdata==NULL) {
      MtlError();
      return(0);  
      }     
   plong = (ULONG *)(*pdata);
   plong[0] = size;
   RDERR((void *)&plong[1],size);
   return(1);
   }
   */

int strlimit;

/* Percentage work areas */

short ipct;
float fpct;

/* Incoming color work areas */

Color_24 C24, LC24;
Color_f Cf, LCf;

/* Error codes */

#define INVALID_FILE 1
#define PARTIAL_READ 2
#define EXCEEDS_SETUP 3

//----------------------------
// Get chunk and Descend.
int get_mapdata_chunk(C_chunk *ck, int tag, MapData *md){

   switch(tag){
   case MAT_MAPNAME:
      //strlimit=13;
      strlimit = MAX_MAP_NAME;
      if(!get_mtlchunk(ck, tag, md->map_name)){
         return false;
      }
      break;
   case MAT_MAP_TILING: 
      return(get_mtlchunk(ck, tag, &md->p.tex.texflags));

   case MAT_MAP_TILINGOLD: 
      if(!get_mtlchunk(ck, tag, &md->p.tex.texflags)){
         return(0);
      }
      if(md->p.tex.texflags&TEX_DECAL)
         md->p.tex.texflags|=TEX_NOWRAP;           
      return(1);
   case MAT_MAP_TEXBLUR: 
      return(get_mtlchunk(ck, tag, &md->p.tex.texblur));
   case MAT_MAP_TEXBLUR_OLD: 
      return(get_mtlchunk(ck, tag, &md->p.tex.texblur));
   case MAT_MAP_USCALE: 
      return(get_mtlchunk(ck, tag, &md->p.tex.uscale));
   case MAT_MAP_VSCALE: 
      return(get_mtlchunk(ck, tag, &md->p.tex.vscale));
   case MAT_MAP_UOFFSET: 
      return(get_mtlchunk(ck, tag, &md->p.tex.uoffset));
   case MAT_MAP_VOFFSET: 
      return(get_mtlchunk(ck, tag, &md->p.tex.voffset));
   case MAT_MAP_ANG: 
      return(get_mtlchunk(ck, tag, &md->p.tex));
   case MAT_MAP_COL1: 
      return(get_mtlchunk(ck, tag, &md->p.tex.col1));
   case MAT_MAP_COL2: 
      return(get_mtlchunk(ck, tag, &md->p.tex.col2));
   case MAT_MAP_RCOL: 
      return(get_mtlchunk(ck, tag, &md->p.tex.rcol));
   case MAT_MAP_GCOL: 
      return(get_mtlchunk(ck, tag, &md->p.tex.gcol));
   case MAT_MAP_BCOL: 
      return(get_mtlchunk(ck, tag, &md->p.tex.bcol));
   default:
      ck->Descend();
   }
   return true;
}

//----------------------------

int get_map(C_chunk *ck, int n){

   Mapping *m = loadmtl->map[n];
   if(m==NULL){
      m = NewMapping(n, 0);
      if(!m)
         return false;
      loadmtl->map[n] = m;
   }
   m->use = 1;

   word tag;
   while(ck->Size()){
      if(!ck->RAscend(tag))
         return false;
      switch(tag){
      case INT_PERCENTAGE:
      case FLOAT_PERCENTAGE:
         if(get_mtlchunk(ck, tag, NULL)==0)
            return false;
         m->amt.pct = ipct; 
         if(n==Nbump) 
            m->amt.pct = (float)ipct * .1f;
         break;
            /*
         case MAT_BUMP_PERCENT:
            if(get_mtlchunk(ck, stream,NULL)==0)
               return(0);
            m->amt.pct = ipct; //for version 3+ files
            break;
            */
      default:
         if(!get_mapdata_chunk(ck, tag, &m->map))
            return false;
      }
   }
   return true;
}

//----------------------------

int get_mask(C_chunk *ck, int n){

   Mapping *m = loadmtl->map[n];
   if(m==NULL){
      m = NewMapping(n,0);
      if(!m)
         return false;
      loadmtl->map[n] = m;
   }
   m->use = 1;
   word tag;
   while(ck->Size()){
      if(!ck->RAscend(tag))
         return false;
      if(!get_mapdata_chunk(ck, tag, &m->mask))
         return 0;
   }
   return true;
}

//----------------------------

bool get_sxp_data(C_chunk *ck, int n, int isMask){

   ULONG **pp,*ptr;
   Mapping *m = loadmtl->map[n];
   int size = ck->Size();
   if(size==0) return(1);
   if (m==NULL) {
      m = NewMapping(n,0);
      if(!m)
         return false;
      loadmtl->map[n] = m;
   }
   if(isMask)
      pp = (ULONG **)&m->mask.p.tex.sxp_data;
   else 
      pp = (ULONG **)&m->map.p.tex.sxp_data;
   if(*pp!=NULL)
      XMFreeAndZero((void **)pp);
   ptr = (ULONG *)XMAlloc(size+4);
   if(!ptr)
      return false;
   ptr[0] = size;

   ck->Read(&ptr[1], size);
   *pp = ptr;
   return true;
}       

//----------------------------

bool get_int_float_chunk(C_chunk *ck, short &ret){

   ret = 0;
   while(ck->Size()){
      word tag;
      if(!ck->RAscend(tag))
         return false;
      switch(tag){
      case INT_PERCENTAGE:
      case FLOAT_PERCENTAGE:
         if(get_mtlchunk(ck, tag, NULL)==0)
            return false;
         ret = ipct;
         break;
      default:
         ck->Descend();
      }
   }
   ck->Descend();
   return true;
}

//----------------------------

#define GET_SXP(num,type) if (!get_sxp_data(ck, num, type)) return(0); ck->Descend();
#define GET_MAP(num) if (!get_map(ck, num)) return(0); ck->Descend();
#define GET_MASK(num) if (!get_mask(ck, num)) return(0); ck->Descend();

//----------------------------

int get_mtlchunk(C_chunk *ck, word tag, void *data){

   switch(tag){
   case MAT_ENTRY:
      {
         while(ck->Size()){
            if(!ck->RAscend(tag))
               return false;
            switch(tag){
            case MAT_NAME:
               strlimit = 17;
               if(get_mtlchunk(ck, tag, loadmtl->name)==0)
                  return false;
               break;     
            case MAT_AMBIENT:
               if(get_mtlchunk(ck, tag, &loadmtl->amb)==0)
                  return false;
               break;     
            case MAT_DIFFUSE:
               if(get_mtlchunk(ck, tag, &loadmtl->diff)==0)
                  return false;
               break;     
            case MAT_SPECULAR:
               if(get_mtlchunk(ck, tag, &loadmtl->spec)==0)
                  return false;
               break;     
            case MAT_ACUBIC:
               {
                  Mapping *m = loadmtl->map[Nrefl];
                  if(m==NULL){
                     ck->Descend();
                     break;
                  }
                  if(!get_mtlchunk(ck, tag, &m->map.p.ref.acb))
                     return false;
               }
               break;     

            case MAT_SXP_TEXT_DATA:       
            case MAT_SXP_TEXT2_DATA: 
            case MAT_SXP_OPAC_DATA:  
            case MAT_SXP_BUMP_DATA:  
            case MAT_SXP_SPEC_DATA:  
            case MAT_SXP_SELFI_DATA: 
            case MAT_SXP_SHIN_DATA:  
         
            case MAT_SXP_TEXT_MASKDATA:  
            case MAT_SXP_TEXT2_MASKDATA: 
            case MAT_SXP_OPAC_MASKDATA:  
            case MAT_SXP_BUMP_MASKDATA:  
            case MAT_SXP_SPEC_MASKDATA:  
            case MAT_SXP_SELFI_MASKDATA: 
            case MAT_SXP_SHIN_MASKDATA:  
            case MAT_SXP_REFL_MASKDATA:  
               if(!get_mtlchunk(ck, tag, NULL))
                  return false;
               break;
         
            case MAT_TEXMAP:   
            case MAT_TEX2MAP:  
            case MAT_OPACMAP:  
            case MAT_BUMPMAP:  
            case MAT_SPECMAP:  
            case MAT_SHINMAP:  
            case MAT_SELFIMAP: 
            case MAT_REFLMAP:  

            case MAT_TEXMASK:   
            case MAT_TEX2MASK:  
            case MAT_OPACMASK:  
            case MAT_BUMPMASK:  
            case MAT_SPECMASK:  
            case MAT_SHINMASK:  
            case MAT_SELFIMASK: 
            case MAT_REFLMASK:  
               if(!get_mtlchunk(ck, tag, NULL))
                  return false;
               break;

            case MAT_SHININESS:
            case MAT_SHIN2PCT:
            case MAT_TRANSPARENCY:
            case MAT_XPFALL:
            case MAT_REFBLUR:
            case MAT_SELF_ILPCT:
            case MAT_SHADING:
            case MAT_TWO_SIDE:
            case MAT_SUPERSMP:
            case MAT_SELF_ILLUM:
            //case MAT_DECAL:
            //case MAT_ADDITIVE:
            case MAT_WIRE:
            case MAT_FACEMAP:
            case MAT_XPFALLIN:
            case MAT_PHONGSOFT:
            case MAT_WIREABS:
            case MAT_USE_XPFALL:
            case MAT_USE_REFBLUR:
            case MAT_WIRESIZE:
               if(!get_mtlchunk(ck, tag, NULL))
                  return false;
               break;
            case APP_DATA:
               if(!get_mtlchunk(ck, tag, &loadmtl->appdata))
                  return(0);
               break;
            default:
               ck->Descend();
            }
         }
                  
                              //convert old data formats to new
         if(loadmtl->shading==REND_WIRE){
            loadmtl->shading = REND_FLAT;
            loadmtl->flags |= MF_WIRE;
            loadmtl->flags |= MF_TWOSIDE;
            loadmtl->shininess=0;
            loadmtl->shin2pct=0;
            loadmtl->transparency=0;
         }

         if(loadmtl->xpfall<0.0f){
            loadmtl->flags|= MF_XPFALLIN;
            loadmtl->xpfall = -loadmtl->xpfall;
         }
         if(loadmtl->flags&MF_DECAL){
            set_mtl_decal(loadmtl);
            loadmtl->flags &= ~MF_DECAL;
         }
         if(loadmtl->shin2pct==255){
            float shin = (((float)(loadmtl->shininess))/100.0f);
            float atten = (float)sin(1.5707*shin);
            loadmtl->shin2pct = (int)((atten)*100.0f+0.5f);
         }
         ck->Descend();
      }
      break;

   case MAT_SXP_TEXT_DATA: GET_SXP(Ntex,0); break;     
   case MAT_SXP_TEXT2_DATA: GET_SXP(Ntex2,0);  break;     
   case MAT_SXP_OPAC_DATA:  GET_SXP(Nopac,0);  break;
   case MAT_SXP_BUMP_DATA:  GET_SXP(Nbump,0);  break; 
   case MAT_SXP_SPEC_DATA:  GET_SXP(Nspec,0);  break;
   case MAT_SXP_SELFI_DATA: GET_SXP(Nselfi,0);  break;
   case MAT_SXP_SHIN_DATA:  GET_SXP(Nshin,0);  break;

   case MAT_SXP_TEXT_MASKDATA:  GET_SXP(Ntex,1);  break;     
   case MAT_SXP_TEXT2_MASKDATA: GET_SXP(Ntex2,1);  break;     
   case MAT_SXP_OPAC_MASKDATA:  GET_SXP(Nopac,1);  break;
   case MAT_SXP_BUMP_MASKDATA:  GET_SXP(Nbump,1);  break; 
   case MAT_SXP_SPEC_MASKDATA:  GET_SXP(Nspec,1);  break;
   case MAT_SXP_SELFI_MASKDATA: GET_SXP(Nselfi,1);  break;
   case MAT_SXP_SHIN_MASKDATA:  GET_SXP(Nshin,1);  break;
   case MAT_SXP_REFL_MASKDATA:  GET_SXP(Nrefl,1);  break;

   case MAT_TEXMAP:   GET_MAP(Ntex);  break;     
   case MAT_TEX2MAP:  GET_MAP(Ntex2);  break;     
   case MAT_OPACMAP:  GET_MAP(Nopac);  break;     
   case MAT_BUMPMAP:  GET_MAP(Nbump);  break;     
   case MAT_SPECMAP:  GET_MAP(Nspec);  break;     
   case MAT_SHINMAP:  GET_MAP(Nshin);  break;     
   case MAT_SELFIMAP: GET_MAP(Nselfi);  break;     
   case MAT_REFLMAP:  GET_MAP(Nrefl);  break;     

   case MAT_TEXMASK:   GET_MASK(Ntex);  break;     
   case MAT_TEX2MASK:  GET_MASK(Ntex2);  break;     
   case MAT_OPACMASK:  GET_MASK(Nopac);  break;     
   case MAT_BUMPMASK:  GET_MASK(Nbump);  break;     
   case MAT_SPECMASK:  GET_MASK(Nspec);  break;     
   case MAT_SHINMASK:  GET_MASK(Nshin);  break;     
   case MAT_SELFIMASK: GET_MASK(Nselfi);  break;     
   case MAT_REFLMASK:  GET_MASK(Nrefl);  break;     

   case MAT_AMBIENT:
   case MAT_DIFFUSE:
   case MAT_SPECULAR:
      {
         int got_lin,got_gam;
         got_lin = got_gam = 0;
         while(ck->Size()){
            if(!ck->RAscend(tag))
               return false;
            switch(tag){
            case COLOR_F:
            case COLOR_24:
               got_gam = 1;
               if(get_mtlchunk(ck, tag, NULL)==0) return(0);
               break;     
            case LIN_COLOR_24:
               got_lin = 1;
               if(get_mtlchunk(ck, tag, NULL)==0) return(0);
               break;     
            default:
               ck->Descend();
            }
         }
         if(got_lin){
            memcpy((char *)data,(char *)&LC24,sizeof(Color_24));
         }else{
            if(!got_gam)
               return false;
            if(gammaMgr.enable){
               Color_24 gc;
               gc.r = gammaMgr.file_in_degamtab[C24.r]>>8;
               gc.g = gammaMgr.file_in_degamtab[C24.g]>>8;
               gc.b = gammaMgr.file_in_degamtab[C24.b]>>8;
               memcpy((char *)data,(char *)&gc,sizeof(Color_24));
            }else{
               memcpy((char *)data,(char *)&C24,sizeof(Color_24));
            }
         }
         ck->Descend();
      }
      break;

   case MAT_SELF_ILLUM: 
      loadmtl->flags |= MF_SELF;   
      loadmtl->selfipct = 100;            
      ck->Descend();
      break;

   case MAT_TWO_SIDE:   loadmtl->flags |= MF_TWOSIDE; ck->Descend(); break;
   case MAT_SUPERSMP:   loadmtl->flags |= MF_SUPERSMP; ck->Descend(); break;
   case MAT_ADDITIVE:   loadmtl->flags |= MF_ADDITIVE; ck->Descend(); break;
   case MAT_DECAL:   loadmtl->flags |= MF_DECAL; ck->Descend(); break;
   case MAT_WIRE: loadmtl->flags |= MF_WIRE; ck->Descend(); break;
   case MAT_FACEMAP: loadmtl->flags |= MF_FACEMAP; ck->Descend(); break;
   case MAT_XPFALLIN:   loadmtl->flags |= MF_XPFALLIN; ck->Descend(); break;
   case MAT_PHONGSOFT:  loadmtl->flags |= MF_PHONGSOFT; ck->Descend(); break;
   case MAT_WIREABS: loadmtl->flags |= MF_WIREABS; ck->Descend(); break;
   case MAT_USE_XPFALL: loadmtl->use |= MATUSE_XPFALL; ck->Descend(); break;
   case MAT_USE_REFBLUR:   loadmtl->use |= MATUSE_REFBLUR; ck->Descend(); break;

   case MAT_SHININESS:
      if(!get_int_float_chunk(ck, loadmtl->shininess))
         return false;
      break;
   
   case MAT_SHIN2PCT:
      if(!get_int_float_chunk(ck, loadmtl->shin2pct))
         return false;
      break;
   
   case MAT_TRANSPARENCY:
      if(!get_int_float_chunk(ck, loadmtl->transparency))
         return false;
      break;
   
   case MAT_XPFALL:
      if(!get_int_float_chunk(ck, loadmtl->xpfall))
         return false;
      break;

   case MAT_REFBLUR:
      if(!get_int_float_chunk(ck, loadmtl->refblur))
         return false;
      break;
   
   case MAT_SELF_ILPCT:
      if(!get_int_float_chunk(ck, loadmtl->selfipct))
         return false;
      break;
   
   case MAT_SHADING:
      ck->Read(&loadmtl->shading, 2);
      ck->Descend();
      break;

   case MAT_MAP_TILING: 
   case MAT_MAP_TILINGOLD: 
      ck->Read(data, 2);
      ck->Descend();
      break;

   case MAT_MAP_TEXBLUR_OLD:
      {
         float foo;
         ck->Read(&foo, sizeof(float));
         ck->Descend();
         foo = (foo-1.0f)/7.0f;
         if (foo<0.0f) foo = 0.0f;
         if (foo>1.0f) foo = 1.0f;
         memmove(data, &foo, 4);
      }
      break;

   case MAT_MAP_TEXBLUR: 
   case MAT_MAP_USCALE: 
   case MAT_MAP_VSCALE: 
   case MAT_MAP_UOFFSET: 
   case MAT_MAP_VOFFSET: 
      ck->Read(data, sizeof(float));
      ck->Descend();
      break;

   case MAT_MAP_ANG:
      {
         MapParams *mp = (MapParams *)data;
         float ang;
         ck->Read(&ang, sizeof(float));
         ck->Descend();
         ang = DegToRad(ang);
         mp->ang_sin = (float)sin(ang);
         mp->ang_cos = (float)cos(ang);
      }
      break;

   case MAT_MAP_COL1: 
   case MAT_MAP_COL2: 
   case MAT_MAP_RCOL: 
   case MAT_MAP_GCOL: 
   case MAT_MAP_BCOL: 
      {
         Color_24 *pcol = (Color_24*)data;
         ck->Read(pcol, 3);
         ck->Descend();
      }
      break;

   case COLOR_F:
      ck->Read(&Cf, 12);
      ck->Descend();
      C24.r = (uchar)(Cf.r*255.0f);
      C24.g = (uchar)(Cf.g*255.0f);
      C24.b = (uchar)(Cf.b*255.0f);
      break;

   case COLOR_24:
      ck->Read(&C24, 3);
      ck->Descend();
      Cf.r = (float)C24.r/255.0f;
      Cf.g = (float)C24.g/255.0f;
      Cf.b = (float)C24.b/255.0f;
      break;

   case LIN_COLOR_24:
      ck->Read(&LC24, 3);
      ck->Descend();
      LCf.r = (float)LC24.r/255.0f;
      LCf.g = (float)LC24.g/255.0f;
      LCf.b = (float)LC24.b/255.0f;
      break;

   case MAT_NAME:
   case MAT_MAPNAME:
      {
                              //simple strings
         char *string = (char*)data;
         if(!read_string(ck, string, strlimit))
            return false;
         ck->Descend();
      }
      break;

   case MAT_ACUBIC: 
      {
         AutoCubicParams *ac = (AutoCubicParams *)data;
         ck->Read(&ac->shade, 1);
         ck->Read(&ac->aalevel, 1);
         ck->Read(&ac->flags, 2);
         ck->Read(&ac->size, 4);
         ck->Read(&ac->nth, 4);
         ck->Descend();
      }
      break;

   case INT_PERCENTAGE:
      ck->Read(&ipct, 2);
      ck->Descend();
      fpct = (float)ipct/100.0f;
      break;

   case MAT_WIRESIZE:
      ck->Read(&loadmtl->wiresize, 4);
      ck->Descend();
      break;

      /*
   case MAT_BUMP_PERCENT:
      RDERR(&ipct,2);
      fpct=(float)ipct/100.0f;
      chunk.size-=2L;
      goto skiprest;
      */

   case FLOAT_PERCENTAGE:
      ck->Read(&fpct, 4);
      ck->Descend();
      ipct = (short)(fpct*100.0f);
      break;

   case APP_DATA:
//       if (!load_app_data(stream, (void **)data, chunk.size))
//          return(0);
//       chunk.size = 0;
      //goto skiprest;
      ck->Descend();
      break;
      
   default:
      ck->Descend();
   }
   return true;
}

//----------------------------
