#include "all.h"
#include "actors.h"



//----------------------------

class C_ladder: public C_actor{
   bool up;
public:
   C_ladder(C_game_mission &m):
      C_actor(m, ACTOR_LADDER)
   {
   }

//----------------------------

   virtual void SetFrame(PI3D_frame frm){

      C_actor::SetFrame(frm);
      if(frm->GetType()==FRAME_MODEL){
         PI3D_model mp = I3DCAST_MODEL(frm);
         const char *cp = mp->GetFileName();
         //if(strlen(cp)>=5) up = (tolower(cp[strlen(cp)-5])=='p');
                        //bug fixed:different filename size due extension stripping
         if(strlen(cp)>=1)
            up = (tolower(cp[strlen(cp)-1])=='p');
      }
   }

//----------------------------

   virtual int NumUsePositions(C_actor *asker = NULL) const{ return 1; }

//----------------------------

   virtual int Use(LPC_actor user, dword prm2, bool force_use_off){

      return user->cbProc(CB_USE_LADDER, 0, prm2 ? (dword)this : NULL);
   }

//----------------------------

   virtual void SaveGame(C_chunk *ck) const{
                           //write data
      ck->Write(&up, sizeof(up));
   }

//----------------------------

   virtual bool LoadGame(C_chunk *ck){
                           //read data
      ck->Read(&up, sizeof(up));
      return true;
   }

//----------------------------

   virtual bool GetUseDir(S_vector &ret, int indx, bool abs_index_mode = false) const{

      ret = frame->GetWorldDir();
      return true;
   }

//----------------------------

   virtual dword CheckUseStay(dword suggest_stay_mode, int indx) const{

      return SM_STAY;
   }
   virtual float GetUsePosThresh() const{

      return .32f;
   }

//----------------------------

   dword cbProc(dword msg, dword prm1=0, dword prm2=0){

      switch(msg){

      case CB_USE_LADDER:
         switch(prm1){
         case 1: return up;
         }
         break;
      }
      return C_actor::cbProc(msg, prm1, prm2);
   }
};

//----------------------------

LPC_actor CreateLadder(C_game_mission &gm){

   return new C_ladder(gm);
}

//----------------------------
