#include "all.h"
#include <float.h>
#include <process.h>
#include <iexcpt.h>
#include "tables.h"
#include "mainmenu.h"
#include "net.h"
#include "winstuff.h"
#include "commandline.h"
#include <insanity\controller.h>
#include <malloc.h>
#if defined _DEBUG && 1
#include <crtdbg.h>
#endif

#define NEW_MENU              //use new menu interface

//----------------------------

#if defined _DEBUG && 0
#define MIN_FPS 20
#define MAX_FPS 20
#else
#define MIN_FPS 10            //we don't accept less than this
#define MAX_FPS 200           //we don't accept more than this (the rest of time we're Sleeping)
#endif

//----------------------------

//#define NET_DEMO
//#define FINAL

//----------------------------
                              //constants

const char APP_NAME[] = "Hidden & Dangerous Deluxe";

extern const char *lang_names[];
const char *lang_names[] = {
   "english",                 //0
   "german",                  //1
   "french",                  //2
   "spanish",                 //3
   "italian",                 //4
   "japan",                   //5
   "portugal",                //6
   "czech",                   //7
   "polish",                  //8
   "slovak",                  //9
   NULL
};

//----------------------------
                              //globals

LPIGraph igraph;
PI_net net;
PC_net_out_msg net_msg;

#ifdef EDITOR                 //main console in game mode is more up with greater font size
C_console console_main(.007f, .09f, .025f, .026f);
#else
C_console console_main(.007f, .0225f, .033f, .034f);
#endif
C_console console_debug(.007f, .2f, .0225f, .023f);
C_smart_ptr<C_class_to_be_ticked_hd> tick_class;

PI3D_driver driver;
PISND_driver isound;
bool allow_stream_snd;

#ifdef JOYSTICK
LPC_JoyBase joy_base;
LPC_Joy joy;
LPC_FF_effect ff_effect;
#endif //JOYSTICK

float screen_aspect_ratio;
C_sprite_image font_img, icons_img;
LPC_table tab_game_cfg;
LPC_table tab_inv[2], tab_human_anim, mat_table, tab_sound_envs;
LPC_table tab_resistance;
LPC_table tab_campaigns;
S_game_configuration game_configuration;
C_all_texts all_txt;

C_game_music game_music;
extern LPC_controller controller;

S_game_profile game_profile(0, 0, 0, 0);
//S_game_profile game_profile(8, 3, 1, 3);

//----------------------------
                              //I3D caches
C_I3D_model_cache_special model_cache;
C_I3D_sound_cache sound_cache;

#ifdef EDITOR
LPC_editor editor;
#endif   //EDITOR

//----------------------------
void SaveScreenShot(bool photo_name, C_string *out_name = NULL);

/*

#ifndef NEW_MENU

static void GetControllerName(int i, C_string &str){

   for(int j=0; j<2; j++){
      C_controller::E_VALUE_MODE vm;
      C_controller::E_INPUT_DEVICE id;
      dword data;
      //static const char *pos_neg[] = {"+", "-"};
      bool b = controller->GetSlotSetting(setup_key_2_game_ctrl[i], j, vm, id, data);
      if(!b) break;
      if(id != C_controller::ID_NULL){
         if(str.Size()){
            if(local_info.hd_language!=5)
               str += ", ";
            else{
               wchar_t buf[256];
               _snwprintf(buf, 256, (wchar_t*)"%\0s\0,\0 \0\0", (wchar_t*)(const char*)str);
               str.Assign((const char*)buf, wcslen(buf)*2+2);
            }
         }
         switch(id){
         case C_controller::ID_KEYBOARD:
            {
               const C_string &kn = all_txt.IsDefined(GT_KEY_NAME+data) ?
                     all_txt[GT_KEY_NAME+data] : all_txt[GT_KEY_NAME+256];
               if(local_info.hd_language!=5)
                  str += kn;
               else{
                  wchar_t buf[256];
                  _snwprintf(buf, 256, (wchar_t*)"%\0s\0%\0s\0\0", (wchar_t*)(const char*)str, (wchar_t*)(const char*)kn);
                  str.Assign((const char*)buf, wcslen(buf)*2+2);
               }
               //const char *key_name = all_txt.IsDefined(GT_KEY_NAME+data) ?
                  //all_txt[GT_KEY_NAME+data] : all_txt[GT_KEY_NAME+256];

               const char *key_name = key_names[data];
               if(!key_name) key_name = "unknown";
               //str += key_name;
            }
            break;
         case C_controller::ID_MOUSE_BUTTON:
            //str += C_fstring("Mouse button %i", data);
            if(local_info.hd_language!=5)
               str += C_fstring("%s %i", (const char*)all_txt[10257], data);
            else{
               wchar_t buf[256];
               _snwprintf(buf, 256, (wchar_t*)"%\0s\0%\0s\0 \0%\0i\0\0", (wchar_t*)(const char*)str, (wchar_t*)(const char*)all_txt[10257], data);
               str.Assign((const char*)buf, wcslen(buf)*2+2);
            }
            break;
         case C_controller::ID_JOY_BUTTON:
            {
               const char *cp = NULL;
#ifdef JOYSTICK
               if(joy) cp = joy->GetButtonName(data);
#endif

               if(local_info.hd_language!=5){
                  //if(!cp) str += C_fstring("Joystick button %i", data);
                  if(!cp) str += C_fstring("%s %i", (const char*)all_txt[10259], data);
                  //else str += C_fstring("Joystick %s", cp);
                  else str += C_fstring("%s %s", (const char*)all_txt[10260], cp);
               }else{
                  wchar_t buf[256];
                  if(!cp)
                     _snwprintf(buf, 256, (wchar_t*)"%\0s\0%\0s\0 \0%\0i\0\0", (wchar_t*)(const char*)str, (wchar_t*)(const char*)all_txt[10259], data);
                  else
                     _snwprintf(buf, 256, (wchar_t*)"%\0s\0%\0s\0 \0%\0s\0\0", (wchar_t*)(const char*)str, (wchar_t*)(const char*)all_txt[10260], (const char*)MakeGameText(cp));
                  str.Assign((const char*)buf, wcslen(buf)*2+2);
               }
            }
            break;
         case C_controller::ID_MOUSE_AXIS:
            //str += C_fstring("Mouse %c", 'X' + (data&0x7fffffff));
            if(local_info.hd_language!=5){
               str += C_fstring("%s %c", (const char*)all_txt[10258], 'X' + (data&0x7fffffff));
               str += (data&0x80000000) ? "+" : "-";
            }else{
               wchar_t buf[256];
               _snwprintf(buf, 256, (wchar_t*)"%\0s\0%\0s\0 \0%\0s\0%\0c\0\0",
                  (wchar_t*)(const char*)str, (wchar_t*)(const char*)all_txt[10258],
                  (const char*)MakeGameText(C_fstring("%c", 'X' +(data&0x7fffffff))),
                  (dword)((data&0x80000000) ? '+' : '-'));
               str.Assign((const char*)buf, wcslen(buf)*2+2);
            }
            break;

#ifdef JOYSTICK
         case C_controller::ID_JOY_AXIS:
            {
               const char *cp = NULL;
               if(joy) cp = joy->GetAxisName(data&0x7fffffff);
               if(local_info.hd_language!=5){
                  //if(!cp) str += C_fstring("Joystick %c", 'X' +(data&0x7fffffff));
                  if(!cp) str += C_fstring("%s %c", (const char*)all_txt[10260], 'X' +(data&0x7fffffff));
                  //else str += C_fstring("Joystick %s", cp);
                  else str += C_fstring("%s %s", (const char*)all_txt[10260], cp);
                  str += (data&0x80000000) ? "+" : "-";
               }else{
                  wchar_t buf[256];
                  if(!cp)
                     _snwprintf(buf, 256, (wchar_t*)"%\0s\0%\0s\0 \0%\0s\0%\0c\0\0",
                        (wchar_t*)(const char*)str, (wchar_t*)(const char*)all_txt[10260],
                        (const char*)MakeGameText(C_fstring("%c", 'X' +(data&0x7fffffff))),
                        (dword)((data&0x80000000) ? '+' : '-'));
                  else
                     _snwprintf(buf, 256, (wchar_t*)"%\0s\0%\0s\0 \0%\0s\0%\0c\0\0",
                        (wchar_t*)(const char*)str, (wchar_t*)(const char*)all_txt[10260],
                        (const char*)MakeGameText(cp),
                        (dword)((data&0x80000000) ? '+' : '-'));
                  str.Assign((const char*)buf, wcslen(buf)*2+2);
               }
            }
            break;

         case C_controller::ID_JOY_POV:
            {
               const char *cp = NULL;
               if(joy) cp = joy->GetPOVName(data&0xffff);
               if(local_info.hd_language!=5){
                  //if(!cp) str += C_fstring("Joystick POV %i", (data&0xffff));
                  if(!cp) str += C_fstring("%s %i", (const char*)all_txt[10261], (data&0xffff));
                  //else str += C_fstring("Joystick %s", cp);
                  else str += C_fstring("%s %s", (const char*)all_txt[10260], cp);
                  str += C_fstring(" (%i)", (data>>16)*45);
               }else{
                  wchar_t buf[256];
                  if(!cp)
                     _snwprintf(buf, 256, (wchar_t*)"%\0s\0%\0s\0 \0%\0i\0%\0s\0\0",
                        (wchar_t*)(const char*)str, (wchar_t*)(const char*)all_txt[10261],
                        (data&0xffff),
                        (const char*)MakeGameText(C_fstring(" (%i)", (data>>16)*45)));
                  else
                     _snwprintf(buf, 256, (wchar_t*)"%\0s\0%\0s\0 \0%\0s\0%\0s\0\0",
                        (wchar_t*)(const char*)str, (wchar_t*)(const char*)all_txt[10260],
                        (const char*)MakeGameText(cp),
                        (const char*)MakeGameText(C_fstring(" (%i)", (data>>16)*45)));
                  str.Assign((const char*)buf, wcslen(buf)*2+2);
               }
               //str += MakeGameText(C_fstring(" (%i)", (data>>16)*45));
            }
            break;
#endif
         }
      }
   }
   if(!str.Size()) str = all_txt[GT_MENU_UNDEF_KEY];
   //else str = MakeGameText(str);
}

//----------------------------

static void ModifyController(int indx, C_controller::E_INPUT_DEVICE new_id, dword new_data){

   int slot = setup_key_2_game_ctrl[indx];
   int sub_indx;
                              //check if it contains 2 valid assignments
   C_controller::E_VALUE_MODE vm;
   C_controller::E_INPUT_DEVICE id;
   dword data;
   controller->GetSlotSetting(slot, 1, vm, id, data);
   if(id != C_controller::ID_NULL){
      sub_indx = 0;
      controller->SetupSlotInput(slot, 1, C_controller::VM_NULL, C_controller::ID_NULL, 0);
   }else{
      controller->GetSlotSetting(slot, 0, vm, id, data);
                              //already assigned?
      if(id==new_id && data==new_data) return;
      sub_indx = 1;
   }
                              //assign new controller
   controller->SetupSlotInput(slot, sub_indx, C_controller::VM_NULL, new_id, new_data);
   controller->IgnoreValue(slot);

                              //remove this controller from other type
   for(int i=0; i<sizeof(setup_key_2_game_ctrl); i++)
   if(i != indx){
      int slot = setup_key_2_game_ctrl[i];
      bool modify = false;
      for(int j=0; j<2; j++){
         controller->GetSlotSetting(slot, j, vm, id, data);
         if(id==new_id && data==new_data){
            if(!j){
                              //move sub-controller 1 down
               controller->GetSlotSetting(slot, 1, vm, id, data);
               controller->SetupSlotInput(slot, 0, C_controller::VM_NULL, id, data);
               controller->SetupSlotInput(slot, 1, C_controller::VM_NULL, C_controller::ID_NULL, 0);
            }else
               controller->SetupSlotInput(slot, j, C_controller::VM_NULL, C_controller::ID_NULL, 0);
            modify = true;
         }
      }
      if(modify){
         C_string str;
         GetControllerName(i, str);
         menu_main_old->ModifyItem(i+1, 1, str);
      }
   }
}

*/

//----------------------------
//----------------------------

void RenderScreen(){

   driver->BeginScene();
   tick_class->Render();

   console_debug.texts.Render();
   console_main.texts.Render();

   driver->EndScene();
}

//----------------------------

void RenderAllBackbuffers(){

   for(int i=igraph->GetBackbufferCount(); i--; )
      RenderScreen();
}

//----------------------------

bool DtaOpenAll();
void DtaCloseAll();

//----------------------------
//----------------------------

#ifdef EDITOR

class C_tick_class_begin: public C_class_to_be_ticked_hd{
   C_smart_ptr<C_game_mission> mission;
   const C_command_line &cmd_line;
public:
   C_tick_class_begin(const C_command_line &cmd_line1):
      cmd_line(cmd_line1)
   {
#ifdef EDITOR
      if(editor){
         mission = (C_game_mission*)editor->FindPlugin("Mission")->Action(E_MISSION_GET_MISSION);
      }
#endif
      if(!mission){
         mission = CreateGameMission(); mission->Release();
      }
   }

   virtual dword GetID() const{ return 'TBEG'; }
   virtual void Render(){}

//----------------------------

   virtual void Tick(const S_tick_context &tc){

                                    //force single precission (BSP checks problem)
      _control87(_PC_24, _MCW_PC);

                              //load default mission and switch to game mode
#ifdef EDITOR
      LPC_editor_item e_miss = editor ? editor->FindPlugin("Mission") : NULL;
      if(e_miss){
         if(cmd_line.cmdline_model.Size()){
            e_miss->Action(E_MISSION_SET_MODEL, (void*)(const char*)cmd_line.cmdline_model);
         }else{
            if(cmd_line.cmdline_mission.Size()){
               e_miss->Action(E_MISSION_SET_MISSION, (void*)(const char*)cmd_line.cmdline_mission);
            }
            e_miss->Action(E_MISSION_RELOAD);
         }
      }
#else //EDITOR
      {
         E_MISSION_IO mio;
         if(cmd_line.cmdline_mission.Size())
            mio = mission->Open(cmd_line.cmdline_mission, 0);
         else
            mio = mission->Open("!test", OPEN_NO_EDITOR);
         if(mio!=MIO_OK){
            tick_class = NULL;
            return;
         }
      }
#endif   //!EDITOR

      tick_class = mission;
                              //since we process this in Tick, update the loaded mission
      tick_class->Tick(tc);

#if defined DEBUG_MENU && defined EDITOR
      //extern const S_menu_template controller_menu_templ;
      //tick_class = CreateMenu(controller_menu_templ, tick_class);
      //extern const S_menu_template sounds_menu_templ;
      //tick_class = CreateMenu(sounds_menu_templ, tick_class);
      extern const S_menu_template video_menu_templ;
      tick_class = CreateMenu(video_menu_templ, tick_class);
      if(tick_class)
         tick_class->Release();
#endif
#ifdef DEBUG_MUSIC
      if(music){
         music->Open("music\\test1.xm");
         music->Play();
      }
#endif
   }
};

#endif

//----------------------------

void GameLoop(const C_command_line &cmd_line){

   int i;

#ifdef EDITOR
   LPC_editor_item e_exit = editor ? editor->FindPlugin("Exit") : NULL;
#endif//EDITOR

   S_tick_context tc;
   tc.ClearInput();
   tc.p_ctrl = controller;

   /*
#ifdef _DEBUG
   console_main.texts.Init();
   float fmt_rect[4] = {.2f, 0, .8f, 0};
   C_smart_ptr<C_text> txt = console_main.texts.CreateText(all_txt[1000], -1, .5f, .07f, .06f, TEXT_JUSTIFY_CENTER,
      false, fmt_rect, NULL, NULL, NULL, 0, .0f);
   txt->Release();
#endif
   /**/

   //sync_menu = CreateSyncMenu(20300);
   //dword pids[] = {1, 2};
   //sync_menu->CheckSyncMarks(pids, 2);

   igraph->NullTimer();
//----------------------------
   while(true){
      tc.key = igraph->ReadKey(true);
      tc.modify_keys = igraph->GetShiftKeys();

      igraph->MouseUpdate();
      tc.mouse_rel[0] = igraph->Mouse_rx();
      tc.mouse_rel[1] = igraph->Mouse_ry();
      tc.mouse_rel[2] = igraph->Mouse_rz();
      tc.mouse_buttons = igraph->GetMouseButtons();

#ifdef MIN_FPS
      tc.time = igraph->GetTimer(1000/MAX_FPS, 1000/MIN_FPS);
#else
      tc.time = igraph->GetTimer(1, 0);
#endif

#if defined EDITOR || defined _DEBUG
                              //let other network apps live
      if(game_configuration.net_debug_schedule_cpu && net && net->GetStatus()==INET_ST_CONNECTED){
         dword num_pl = 0;
         net->GetPlayers(NULL, &num_pl);
         if(num_pl)
            tc.time += igraph->GetTimer((int)(tc.time * num_pl), 0);
      }
#endif

      controller->Update(tc);

      bool want_close = (igraph && igraph->GetWindowCloseStatus());
      //if(tc.key==K_CLOSE) 
      if(want_close)
         break;

                              //smooth timer
      //if(0)
      {
         const int TIME_CACHE_SIZE = 8;
         static int time_cache[TIME_CACHE_SIZE], time_cache_i;
         time_cache[time_cache_i] = tc.time;
         ++time_cache_i %= TIME_CACHE_SIZE;
         tc.time = 0;
         for(i=0; i<TIME_CACHE_SIZE; i++) tc.time += time_cache[i];
         tc.time /= TIME_CACHE_SIZE;
      }

#ifdef EDITOR
      if(editor){
                              //scale time
         LPC_editor_item e_miss = editor->FindPlugin("Mission");
         if(editor->IsActive() || !((C_game_mission*)e_miss->Action(E_MISSION_GCAM_IS_ACQUIRED))){
            editor->Tick(tc.modify_keys, tc.time,
               tc.mouse_rel[0], tc.mouse_rel[1], tc.mouse_rel[2], tc.mouse_buttons);
                           //clear mouse imput in tc - not to be passed further
            memset(tc.mouse_rel, 0, sizeof(tc.mouse_rel));
            tc.mouse_buttons = 0;

            for(int i=0; i<3; i++){
               int slot, input_index;
               if(controller->FindSlot(C_controller::ID_MOUSE_BUTTON, i, slot, input_index))
                  controller->IgnoreValue(slot, input_index);
            }
            for(i=0; i<2; i++){
               int slot, input_index;
               if(controller->FindSlot(C_controller::ID_MOUSE_AXIS, (!i ? 0 : 0x80000000) | 2, slot, input_index))
                  controller->IgnoreValue(slot, input_index);
            }
         }
         if(editor->IsActive()){
            if(tc.key!=K_NOKEY)
               editor->MenuHit(0, tc.key, tc.modify_keys);
         }else{
                              //check key for switching back to edit mode
            switch(tc.key){
            case K_F5:        //edit mode
            case K_F8:        //cam acq
            case K_NUM0: case K_NUM1: case K_NUM2: case K_NUM3: case K_NUM4: case K_NUM5: case K_NUM6: case K_NUM7: case K_NUM8: case K_NUM9:
               editor->MenuHit(0, tc.key, 0);
               break;
            }
            if((e_miss->Action(E_MISSION_GCAM_IS_ACQUIRED)))
               editor->Tick(0, tc.time, 0, 0, 0, 0);
         }
                              //scale time
         if(e_miss){
            float f = IntAsFloat(e_miss->Action(E_MISSION_TIME_GET));
            static float time_rest;
            float time = (float)tc.time * f + time_rest;
            time_rest = fmod(time, 1.0f);
            tc.time = floor(time);
         }
      }
                              //check exit request
      if(want_close || (e_exit && e_exit->Action(E_EXIT_GET_STATE)) ||
         //debug_net_quit ||
         (tc.key==(char)K_ESC && tc.modify_keys==SKEY_SHIFT)){

         LPC_editor_item e_miss = editor ? editor->FindPlugin("Mission") : NULL;
         if(!e_miss)
            break;
         if(e_miss->Action(E_MISSION_SAVE, (void*)true))
            break;
         if(e_exit)
            e_exit->Action(E_EXIT_SET_STATE, (void*)false);
      }
      NetStatUpdate();
#endif   //EDITOR

                              //receive and send
      if(net)
         NetProcessMessages();

                              //tick all
      tick_class->Tick(tc);
      if(!tick_class)         //tick class destroyed => end of game
         break;
      game_music.Tick(tc.time);

      switch(tc.key){
#ifndef EDITOR
      case K_F11:
         if(tick_class->GetID()=='GMIS')
            SaveScreenShot(true);
         else
            SaveScreenShot(false);
         break;
#endif
#if defined BETAVERSION || defined EDITOR
      case K_GREYMULT:
         C_class_to_be_ticked_hd *CreateBugReport(C_class_to_be_ticked_hd*);
         if(tick_class->GetID()!='BUGR'){
            tick_class = CreateBugReport(tick_class);
            if(tick_class)
               tick_class->Release();
         }
         break;
#endif
      }

#ifdef _DEBUG
      {
         float profile_time = PR_GET;
         if(profile_time!=0.0f)
            DEBUG(profile_time);
      }
#endif
      RenderScreen();

      igraph->UpdateScreen(IGUPDATE_ENTIRE_AREA);

      console_main.Tick(tc.time);
                              //force single precission
      _control87(_PC_24, _MCW_PC);
#ifdef _DEBUG                 //clear console before tick editor - get output texts from editor
      console_debug.Clear();
#endif
   };

   if(net){
#if defined _DEBUG && 0
      if(net_debug){
                              //quit connection
         net_msg->AddID(NM_DEBUG_QUIT, true);
         net->Send(net_msg);
      }
#endif
                              //too slow and wasteful network closing (release version only)
#if !defined _DEBUG || 1
      NetCloseAll();
#endif
   }

   igraph->ClearViewport();
   igraph->UpdateScreen();

   //sync_menu->Release();
}

//----------------------------

bool InitSystem(void *hi, const C_command_line &cmd_line);
void CloseSystem();
bool OpenAllTexts(int lang_id);
extern const char DATABASE_FILENAME[];

//----------------------------
// Function called when crash encountered. It flushes database and lets user
// save current work.
static void __stdcall CrashCallback(){

#if defined _MSC_VER && defined _DEBUG && defined DEBUG_NEW_ALLOC
                              //crashed, disable leak warning
   _CrtSetDbgFlag(_CrtSetDbgFlag(_CRTDBG_REPORT_FLAG) & ~_CRTDBG_LEAK_CHECK_DF);
#endif
                              //reset FPU so that we may do some tasks
   _fpreset();

#ifndef _DEBUG
                              //hide window, so that user sees the crash also in fullscreen
   if(igraph){
      //igraph->UpdateParams(0, 0, 0, 0, IG_SUSPENDINACTIVE);
      igraph->FlipToGDI();
      OsShowWindow(igraph->GetHWND(), false);
      igraph->UpdateParams(0, 0, 0, 0, IG_SUSPENDINACTIVE);
      igraph->ProcessWinMessages();
   }
#endif

   if(driver){
                              //save what's possible
#ifdef EDITOR
      LPC_editor_item e_mission = editor ? editor->FindPlugin("Mission") : NULL;
      if(e_mission){
         if(editor->IsModified()){
            int i = OsMessageBox("The program crashed.\nDo you want to save mission before quitting?",
               "Program crash", MBOX_YESNO);
            if(i==MBOX_RETURN_YES)
               e_mission->Action(E_MISSION_SAVE, (void*)false);
         }
      }
#endif
      //driver->FlushDataBase();
      driver->SetDataBase(NULL, 0);
      OsDeleteFile(DATABASE_FILENAME);
   }
   //NetCloseAll();
   TablesCloseAll();
}

//----------------------------
#ifdef EDITOR
// Special debug mode - check if non-english texts match english version.
void CheckGameTexts(){

   assert(game_configuration.language!=0);
   OpenAllTexts(0);
   C_all_texts all_txt_eng = all_txt;
   OpenAllTexts(game_configuration.language);
   ErrReport(C_fstring("Testing %s texts...", lang_names[game_configuration.language]), editor);
   struct S_hlp{
      static void cbEnum(int id, const C_string&, void *c){
         const C_all_texts &txts = *(C_all_texts*)c;
         if(!txts.IsDefined(id)){
            ErrReport(C_fstring("%i text undefined!", id), editor);
         }
      }
   };
   all_txt_eng.EnumTexts(S_hlp::cbEnum, &all_txt);
   ErrReport("Phase2...", editor);
   all_txt.EnumTexts(S_hlp::cbEnum, &all_txt_eng);
}
#endif

//----------------------------
void SetBreakAlloc(dword id);

int Main(void *hi, const char *cp_cmd_line){

   //SetBreakAlloc(985);

#ifdef _MSC_VER
                              //executables reside in .\BIN directory, so set working path
                              // one level down
   _chdir("..");
#endif

                              //this func switches to MSVC mem allocation, instead of system allocation
   _set_sbh_threshold(1016);

#if defined _MSC_VER && defined _DEBUG && 1
   {
                              //don't bother non-programmers with our problems
      //if(IsProgrammersPC())
#ifdef DEBUG_NEW_ALLOC
      {

                              //report memory leaks at exit
         _CrtSetDbgFlag(_CrtSetDbgFlag(_CRTDBG_REPORT_FLAG) | _CRTDBG_LEAK_CHECK_DF);
#if 0
                              //aggressive memory checking:
         _CrtSetDbgFlag(_CrtSetDbgFlag(_CRTDBG_REPORT_FLAG) | _CRTDBG_CHECK_ALWAYS_DF);
#endif
         //_CrtSetDbgFlag(_CrtSetDbgFlag(_CRTDBG_REPORT_FLAG) | _CRTDBG_DELAY_FREE_MEM_DF);
         _CrtSetReportMode(_CRT_ERROR, _CRTDBG_MODE_WNDW);
         _CrtSetReportMode(_CRT_WARN, _CRTDBG_MODE_WNDW);
         _CrtSetReportMode(_CRT_ASSERT, _CRTDBG_MODE_WNDW);
         //_CrtSetBreakAlloc(2952);
      }
#endif
                              //catch hardware exceptions
      SetExceptionSendFunc(WinSendCrashReport);
      SetExceptionCallback(CrashCallback);
      dword flags = ~(_EM_INVALID | _EM_OVERFLOW | _EM_ZERODIVIDE);
      InitializeExceptions(flags);
   }
#else
# ifdef _DEBUG
   _CrtSetDbgFlag(0);
# endif
   SetExceptionSendFunc(WinSendCrashReport);
   SetExceptionCallback(CrashCallback);
   InitializeExceptions();
#endif

   while(true){
                              //read info from Windows registry
      bool cfg_read = 
         game_configuration.ReadSysConfig();
      if(cfg_read)
         break;
                              //failed to read initialization config...
                              // run hardware config
      int rtn = spawnl(P_WAIT, "bin\\iconfig.exe", "iconfig.exe", NULL);
      switch(rtn){
      case -1:                //failed to run program
         OsMessageBox("Cannot run IConfig.exe.", APP_NAME, MBOX_OK);
                              //flow...
      case 1:                 //canceled
         return 3;
      }
   }
   if(!game_configuration.ReadInstallationInfo())
      return 1;


   C_command_line cmd_line;
                              //process command-line, exit if some errors encountered
   if(!cmd_line.Scan(cp_cmd_line, APP_NAME))
      return 1;


   if(!DtaOpenAll())
      return 1;

   /* //removed - no censoring for all versions
                              //some languages are automatically censored
   switch(game_configuration.language){
   case 1:                    //german
      game_configuration.censored = true;
      break;
   }
   */

   int i;

   i = TablesOpenAll();
   if(!i){
      DtaCloseAll();
      return 0;
   }

   i = InitSystem(hi, cmd_line);
   if(!i){
      TablesCloseAll();
      DtaCloseAll();
      return 0;
   }

#if 0
   CheckGameTexts();
#endif

                              //init texts
   if(!OpenAllTexts(game_configuration.language)){
      CloseSystem();
      OsMessageBox("Internal error (cannot find game text files).", APP_NAME, MBOX_OK);
      return 1;
   }


#ifdef EDITOR
   game_profile.Open("_tmp\\testgame.bin");
#endif

#ifndef EDITOR
#if defined BETAVERSION || 0
   OUTTEXT("Version: Release Candidate 1");
#else
   OUTTEXT("Version 1.50 Deluxe");
#endif
#endif

#ifdef EDITOR
   tick_class = new C_tick_class_begin(cmd_line); tick_class->Release();
#else

   if(game_configuration.net_join){
                              //choose last opened profil (for case connecting fails)
      vector<S_logon_account> accounts;
      SearchAccounts(accounts);
      if(accounts.size())
         game_profile.Open(accounts.front().file_name);
      tick_class = CreateMainMenu();
   }else
   if(cmd_line.profile_name.Size()){
      vector<S_logon_account> accounts;
      SearchAccounts(accounts);
      for(int i=accounts.size(); i--; ){
         if(accounts[i].user_name==cmd_line.profile_name){
            bool b = game_profile.Open(accounts[i].file_name);
            if(b)
               tick_class = CreateMainMenu();
            break;
         }
      }
   }
   if(!tick_class){
      tick_class = CreateLogonMenu();
   }
   /**/
   //tick_class = CreateBriefing(cmd_line.cmdline_mission);
   //tick_class = CreateCampAnim(cmd_line.cmdline_mission);
   //tick_class = new C_tick_class_begin(cmd_line);
   //tick_class = CreateTheEnd();
   /*
   {
      C_game_mission *miss = CreateGameMission();
      C_fstring mname("%s\\game", game_profile.GetCurrMissionName());
      miss->Open(mname, 0);
      miss->GameBegin(true); miss->DisplayObjectives();
      tick_class = miss;
   }
   /**/
   //tick_class = new C_tick_class_begin(cmd_line);
   /*
   {
      E_GAME_MENU id =
         //GAME_MENU_CAMPAIGN_SELECT;
         //GAME_MENU_MISSION_SELECT;
         //GAME_MENU_DEBRIEF;
         //GAME_MENU_SOLDIER_INFO;
         //GAME_MENU_8_OF_40;
         //GAME_MENU_CAMPAIGN_LOAD;
         GAME_MENU_4_OF_8;
      //S_menu_debriefing_info di;
      //di.status = S_menu_debriefing_info::DEBRIEF_SUCCESS_GAME_DONE;
      //tick_class = CreateMenu(id, (dword)&di);
      //S_menu_soldier_info si; si.soldier_id = 14; si.save_tc = NULL;
      //tick_class = CreateMenu(id, (dword)&si);
      tick_class = CreateMenu(id);
   }
   /**/
   if(tick_class) tick_class->Release();
#endif

   if(tick_class){
      GameLoop(cmd_line);
      tick_class = NULL;
   }

#ifdef EDITOR
   if(!strcmp(game_profile.file_name, "_tmp\\testgame.bin"))
      game_profile.Save();
#endif

   CloseSystem();

   if(!cmd_line.res_x && !cmd_line.res_y)
      game_configuration.WriteSysConfig();

   all_txt.Close();
   TablesCloseAll();
   DtaCloseAll();

   game_profile.Reset();

   return 0;
}

//----------------------------
