#include "all.h"


//----------------------------

enum{
   TAB_I_RND_PAUSE_BASE,
   TAB_I_RND_PAUSE_THRESH,
   TAB_B_RND_ONOFF,
   TAB_B_RND_ANIMRESET,
};

C_table_template templ_rnd_table = {
   // {32439A20-89DB-11d2-9B9E-004F4905FF1A}
   { 0x32439a20, 0x89db, 0x11d2, { 0x9b, 0x9e, 0x0, 0x4f, 0x49, 0x5, 0xff, 0x1a } },
   "Random generator setup",
   NULL,
   {
      {TE_INT, TAB_I_RND_PAUSE_BASE, "Base delay", 0, 0, 1000},
      {TE_INT, TAB_I_RND_PAUSE_THRESH, "Random delay"},
      {TE_BOOL, TAB_B_RND_ONOFF, "On/Off switch", 0, 0, true},
      {TE_BOOL, TAB_B_RND_ANIMRESET, "Model anim. reset"},

      {TE_NULL}
   }
};

//----------------------------

class C_random_gen: public C_actor{

   LPC_table tab;
   int counter;

   void SetCounter(){
      counter =
         tab->ItemI(TAB_I_RND_PAUSE_BASE) +
         S_int_random(tab->ItemI(TAB_I_RND_PAUSE_THRESH));
   }
public:
   C_random_gen(C_game_mission &m):
      counter(0),
      C_actor(m, ACTOR_RANDOM_GEN)
   {
      tab=CreateTable();
      tab->Open((dword)&templ_rnd_table, TABOPEN_TEMPLATE);
   }

   ~C_random_gen(){
      if(tab) tab->Release();
   }

//----------------------------

   virtual void SetFrame(PI3D_frame frm){

      C_actor::SetFrame(frm);
      if(frm && frm->GetType()==FRAME_MODEL)
         I3DCAST_MODEL(frm)->StopAnimation(0);
   }

//----------------------------

   virtual LPC_table GetTable(int index) const{
      if(index==0)
         return tab;
      return C_actor::GetTable(index);
   }

//----------------------------

   virtual class C_table_template *GetTemplate(int) const{ return &templ_rnd_table; }

   virtual void MissionSave(C_chunk *ck) const{ SaveTable(ck, tab); }
   virtual bool MissionLoad(C_chunk *ck, int table_id){ return LoadTable(ck, tab); }

//----------------------------

   dword Tick(const S_tick_context &tc){

      if((counter -= tc.time) <= 0){
         SetCounter();
         if(tab->ItemB(TAB_B_RND_ONOFF)){
            struct S_hlp{
               static I3DENUMRET I3DAPI cbEnum(PI3D_frame frm, dword){
                  if(frm->GetType()==FRAME_VISUAL && I3DCAST_VISUAL(frm)->GetVisualType()!=I3D_VISUAL_PARTICLE)
                     return I3DENUMRET_OK;
                  frm->SetOn(false);
                  frm->SetOn(true);
                  return I3DENUMRET_OK;
               }
            };
            S_hlp::cbEnum(frame, 0);
            frame->EnumFrames(S_hlp::cbEnum, 0, ENUMF_LIGHT | ENUMF_VISUAL | ENUMF_SOUND);
         }
         if(tab->ItemB(TAB_B_RND_ANIMRESET)){
            if(model)
               model->SetAnimation(0, NULL);
         }
      }
      return 0;
   }
};

//----------------------------

LPC_actor CreateRandomGen(C_game_mission &gm){

   return new C_random_gen(gm);
}

//----------------------------
