#include <rules.h>

//----------------------------
// C_smoke_ray
//----------------------------
                              //init structure for ray smoke
struct S_smoke_ray_init{
   PI3D_scene scene;          //scene in which we fly
   S_vector start_pos;        //initial position and direction
   S_vector start_dir;

   int tail_fade_time;
   float tile_tile;
   float dest_scale;
   const char *tail_name;
};

//----------------------------

class C_smoke_ray{
public:
   virtual ~C_smoke_ray(){}

//----------------------------
// <comment>
   virtual void Finish() = 0;

//----------------------------
// <comment>
   virtual bool IsFinishing() const = 0;

//----------------------------
// <comment>
   virtual void UpdateTrajectory(const S_vector &new_pos, const S_vector &new_dir) = 0;

//----------------------------
// <comment>
   virtual void UpdateFade(int time) = 0;

//----------------------------
// <comment>
   virtual bool IsOver() const = 0;
};

C_smoke_ray *GreateSmokeRay(const S_smoke_ray_init &is);

//----------------------------
