/*
   H&D tables declaration / definition



*/

#include <tabler2.h>


//----------------------------
                              //particle params
enum{
   TAB_B_PRT_ON = 24,
};

extern const C_table_template tab_particle_params;

//----------------------------
                              //sound - only compatibility import
enum{
   TAB_B_SOUND_ON,
   TAB_F_SOUND_RANGE_N,       //m
   TAB_F_SOUND_RANGE_F,       //m
   TAB_I_SOUND_CONE_IN,       //degrees
   TAB_I_SOUND_CONE_OUT,      //degrees
   TAB_I_SOUND_OUTVOL,        //0 - 100
   TAB_I_SOUND_VOLUME,        //0 - 100
   TAB_S_SOUND_FILENAME,      //string[16]
   TAB_B_SOUND_LOOP,
   TAB_B_SOUND_STREAM,
   TAB_B_SOUND_NO3D,
   TAB_S12_SOUND_SCTNAME,
};
//----------------------------
                              //AI - used in templ_ game_cfg, tab_scene_property and templ_hum_prop
                              //reserved entries 96 - 127
enum{
   TAB_E_AI_HUNT = 96,
   TAB_F_AI_HUNT_MAX_DIST,

   TAB_F_AI_WATCH_MAX_DIST,
   TAB_F_AI_MIN_SHOOT_DIST,
   TAB_I_AI_SHOOT_QUALITY,
   TAB_I_AI_REACTION,
   TAB_E_AI_ENABLED,
   TAB_I_AI_ENDURANCE,
   TAB_E_AI_SEARCH_DEAD,
   TAB_E_AI_SEARCH_HEARD,

   TAB_E_AI_LISTEN = 127,
};

static char ENUM_AI_NOYES[] = "<default>\0No\0Yes\0";

//----------------------------

                              //human properties - common to all human
enum{
   TAB_E_HUM_PRG_ITEM,
   TAB_S18_HUM_PRG_CP0,
   TAB_S18_HUM_PRG_SUBJ_NAME=TAB_S18_HUM_PRG_CP0,
   //TAB_S18_HUM_PRG_SIGMASK=TAB_S18_HUM_PRG_CP0,   //name of waited signal
   TAB_B_HUM_PRG_SHOWON,      //true = appear, false = disappear
   TAB_S18_HUM_PRG_CP1,
   TAB_I_HUM_PRG_INV_ID,
                              //inventory (debug)
   TAB_I_HUM_INV_LIST = 8,
   TAB_I_HUM_INV_AMOUNT,

   TAB_I_HUM_AI_WATCH_DIST=16,
   TAB_I_HUM_AI_FORCE_DELAY,

   TAB_S_HUM_NAME = 64,
   TAB_I_HUM_FACE,
   TAB_I_HUM_VOICE,
   /*
   TAB_I_HUM_SHOOT_NORM_HIT,
   TAB_F_HUM_SHOOT_NORM_SPREAD,
   TAB_F_HUM_SHOOT_NORM_MAGNET,
   TAB_I_HUM_SHOOT_AIM_HIT,
   TAB_F_HUM_SHOOT_AIM_SPREAD,
   TAB_F_HUM_SHOOT_AIM_MAGNET,
   */
   TAB_B_HUM_FACEMASK = TAB_I_HUM_VOICE + 7,
                              //enemy-only
   TAB_I_ENM_GROUP,

   TAB_I_HUM_CARRIAGE,
                              //percentage to be shown in menu
   TAB_I_HUM_BAR1_SHOOTING,
   TAB_I_HUM_BAR2_REACTION,
   TAB_I_HUM_BAR3_STEALTH,
   TAB_I_HUM_BAR4_STRENGTH,
   TAB_I_HUM_BAR5_ENDURANCE,
   TAB_I_HUM_AUTO_ITM_ID,
   TAB_I_HUM_AUTO_ITM_AMNT,
   //TAB_E_HUM_UNIFORM_ID,

                              //96 - 127 - reserved for AI
};

//----------------------------
                              //game config

enum{
                              //0
   //TAB_B_GAME_ANIMS,
   //TAB_B_GAME_COLLISIONS = 1,
   TAB_B_GAME_TEXTS = 2,
   //TAB_B_GAME_CPOINTS = 3,
   //TAB_B_GAME_DRAWVOLS,
   /*
   TAB_S32_GAME_MAPS_DIRS = 5,
   TAB_S32_GAME_SOUNDS_DIRS,
   TAB_S32_GAME_MODELS_DIRS,
   TAB_S32_GAME_ANIMS_DIRS,
   */
                              //8
   TAB_I_DEBUG = 8,
   TAB_F_DEBUG = 9,
   //TAB_S32_GAME_MISSIONNAME,
   //TAB_B_GAME_PRELOAD_MODELS,
   //TAB_S12_GAME_PRELOAD_MODEL,
   TAB_I_GAME_FOV = 12,
   //TAB_F_GAME_GAMMA,
   TAB_I_GAME_SHOOT_SPEED = 14,
   TAB_F_GAME_MIN_AIM_ZOOM,
   TAB_F_GAME_DIE_FALL_DIST,
                              //16
   TAB_F_GAME_CAMERA_SHAKE_RANGE,
   TAB_I_GAME_CAMP_ITEMS_ID,
   TAB_I_GAME_CAMP_ITEMS_AMOUNT,
   TAB_F_GAME_WALL_Y_THRESH,
   TAB_F_GAME_GRENADE_JUMP,
   TAB_I_GAME_EXPL_DELAY,
   //TAB_I_GAME_CAMP_AUTO_ITEM_AMN,
   TAB_B_GAME_DRAW_PATH = TAB_I_GAME_EXPL_DELAY + 2,
                              //24
   TAB_F_GAME_BARRIER_LOW,
   TAB_F_GAME_BARRIER_HI,
   TAB_F_GAME_SHOOT_ERR_MIN,
   TAB_F_GAME_SHOOT_ERR_MAX,
   TAB_F_GAME_SHOOT_MAG_MIN,
   TAB_F_GAME_SHOOT_MAG_MAX,
   TAB_F_GAME_REACTION_MIN,
   TAB_F_GAME_REACTION_MAX,
                              //32
   TAB_I_GAME_AUTO_START_DELAY,
   TAB_I_GAME_HUM_CRASH_RESIST,
   TAB_F_GAME_MOUSE_2_TURN,
   TAB_F_GAME_MOUSE_TURN_CACHE,
   TAB_F_GAME_BARR_CLIMB_COUNT,
   TAB_F_GAME_SNDR_GUN_MIN,
   TAB_F_GAME_SNDR_GUN_MAX,
   TAB_F_GAME_SNDR_GUNWHEEZ_MIN,
                              //40
   TAB_F_GAME_SNDR_GUNWHEEZ_MAX,
   TAB_F_GAME_SNDR_EXPL_MIN,
   TAB_F_GAME_SNDR_EXPL_MAX,
   TAB_F_GAME_SNDR_HUM_MIN,
   TAB_F_GAME_SNDR_HUM_MAX,
   TAB_F_GAME_SNDR_ROCKET_MIN,
   TAB_F_GAME_SNDR_ROCKET_MAX,
   TAB_F_GAME_SNDR_CANNON_MIN,
                              //48
   TAB_F_GAME_SNDR_CANNON_MAX,
   TAB_F_GAME_SNDR_AUTO_MIN,
   TAB_F_GAME_SNDR_AUTO_MAX,
   TAB_B_GAME_DEBUG_SHOW_LISTEN,
   TAB_B_GAME_DEBUG_SHOW_WATCH,
   TAB_F_GAME_WATCH_STAY_FACTOR, //[4] for stay/bench/lay/other
   TAB_F_GAME_WATCH_LIGHT_MULT,
   TAB_I_GAME_WATCH_ENUM_COUNT,
                              //56
   TAB_I_GAME_WATCH_CHECK_COUNT,
   TAB_B_GAME_DEBUG_EXPL_LINES,
   TAB_F_GAME_GUNHOLE_DIST,
   TAB_I_GAME_AI_ATTACK_KILL_COUNT,
   TAB_I_GAME_AI_ATTACK_LOST_COUNT,
   TAB_F_GAME_AIM_MODEL_DIST,
   TAB_F_GAME_WATCH_CARE_WALK,
   TAB_F_GAME_WATCH_CARE_RUN,
                              //64
   TAB_F_GAME_WATCH_CARE_WATCH,
   TAB_F_GAME_WATCH_CARE_GUARD,
   TAB_I_GAME_AI_MOVE_HUNT_COUNT,
   TAB_B_GAME_DEBUG_DETECTOR,
      TAB_I_GAME_DETECTOR_COUNT,
   TAB_F_GAME_SNIPER_ERR_FACTOR,
   TAB_F_GAME_SNIPER_MAGNET_FACTOR,
   TAB_F_GAME_WATCH_CARE_FOLLOW,
                              //72
   TAB_F_GAME_AI_FOLLOW_CIRCLE_RAD,
   TAB_B_GAME_DEBUG_SHOW_SHOTS,
   TAB_F_GAME_WATCH_CARE_ATTACK,
   TAB_F_GAME_WATCH_UNIF_GERMAN,
   TAB_F_GAME_WATCH_UNIF_CIVIL,
   TAB_F_GAME_WATCH_UNIF_CIVIL_W,
   TAB_B_GAME_DEBUG_NET,
   TAB_F_GAME_AIMLINE_COLOR,  //[3]
                              //80
   TAB_I_GAME_AIMLINE_ALPHA,
   TAB_I64_GAME_MIS_ITEM_AMOUNT,

                              //96 - 127 - reserved for AI
};

extern const C_table_template templ_game_cfg;

//----------------------------

                              //scene properties
enum{
   TAB_CV_SCN_BGND,           //bgnd color
   TAB_CV_SCN_AMBIENT,        //ambient color
   TAB_CV_SCN_FOG,            //fog color
   TAB_B_SCN_FOG_ON,          //fog on
   TAB_S_SCN_BACKDROPNAME,    //backdrop
   TAB_F_SCN_FOG_NEAR,        //fog near (0..1)
   TAB_I_SCN_CAM_FOV,         //camera FOV
   TAB_CV_SCN_BACK_AMB,       //backdrop ambient color
   TAB_F_SCN_CAM_RANGE,       //camera far range
                              //time config
   TAB_E_SCN_TIME_UNIT,       //time units: msec / anim notification
   TAB_I_SCN_TIME_VAL,        //value (time / notify key)
   TAB_S24_SCN_TIME_OBJ,      //triggered frame (name)
   TAB_B_SCN_TIME_STATUS,     //trigger status
   TAB_F_SCN_CGLOBAL,         //global color multiplier
   TAB_I_SCN_TIME_SIGNUM,     //broadcast signal (0 = disabled)
   TAB_B_SCN_BGND_FORCE,      //force backdrop drawing
                              //Optimization
   TAB_B_SCN_DISABLE_SHDWS,   //disable shadows for all enemies
   TAB_B_SCN_OPTIM_DEAD_BODY, //make bag instead dead enemy bodies
   TAB_B_SCN_OPTIM_GUNFLR,    //optimize gun-flares (not applied when outside)


                              //96 - 127 - reserved for AI
};

extern const C_table_template tab_scene_property;

//----------------------------
                              //inventory table
enum{
   TAB_S32_INV_NAME,
   TAB_S16_INV_MODEL_S,
   TAB_S16_INV_MODEL_I,
   TAB_I_INV_ID,
   TAB_S16_INV_USESOUND,
   TAB_S16_INV_SMKNAME,
   TAB_S16_INV_SMKTABNAME,
   TAB_I_INV_WPN_POWER,
   TAB_I_INV_WPN_DELAY,
   TAB_E_INV_USEPOSE,
   TAB_E_INV_CARRYPOSE,
   TAB_B_INV_ZOOM,
   TAB_E_INV_FIREMODE,
   TAB_I_INV_STACKSIZE,
   TAB_B_INV_MULTIPLE,
   TAB_E_INV_POSEMODE,        //Normal/Gun/Bazooka
   TAB_E_INV_GRN_TYPE,        //time/expl
   TAB_F_INV_GRN_RANGE,
   TAB_S16_INV_MODEL_AIM,
   TAB_I_INV_PRIORITY,        //at which AI chooses weapon (0=best)
   TAB_S16_INV_MODEL_RES,
   TAB_I_INV_NUM_BULLETS,
   TAB_F_INV_WEIGTH,
   TAB_F_INV_AMMO_WEIGTH,
   TAB_I_INV_DEFAULT_AMMO,
   TAB_F_INV_WPN_SHOT_Z,
   TAB_I_INV_MENU_AMMO_TRANSFER,
   TAB_I_INV_MINE_EXPL,
   TAB_I_INV_AUTO_GROUP,
   TAB_B_INV_TO_NEXT_MISS,
};

extern const C_table_template templ_inv_table;

//----------------------------
                              //human animation table
enum{
   TAB_S16_ANI_FILENAME,
   TAB_F_ANI_SPEEDX,
   TAB_F_ANI_SPEEDY,
   TAB_F_ANI_SPEEDZ,
   TAB_E_ANI_TYPE,
   TAB_I_ANI_BLENDTIME,
   TAB_B_ANI_TURNENABLE,
   TAB_B_ANI_MOUSE_TURN_X,
};

extern const C_table_template templ_anim_table;

//----------------------------
                              //volumes, materials, sounds
enum{
   TAB_S12_SND_SNDNAME,
   TAB_I_SND_VOLUME,
   TAB_S12_SND_GUNSHOOT,
   TAB_S12_EXPL_SOUND,
   TAB_I_EXPL_RANGE,
   TAB_I_EXPL_POWER,
   TAB_S16_MAT_NAME,
   TAB_B_MAT_STAIRS,
   TAB_B_MAT_BORDER,
   TAB_B_MAT_AI_SEE_THROUGH,
   TAB_B_MAT_CAM_SEE_THROUGH,
   TAB_B_MAT_WATER,
   TAB_E_MAT_KILL,
};

#define MAX_MATERIALS 50
#define MAX_ACTIONS 32

extern const C_table_template templ_mat_table;

//----------------------------
                              //C_resource actor:
enum{
   TAB_I_RES_INVTYPE,
   TAB_I_RES_AMOUNT,
   TAB_S8_RES_RND_CP,
};

//----------------------------
                              //C_door actor:
enum{
   TAB_I_DOR_ANGLE_CLOSE,
   TAB_I_DOR_ANGLE_OPEN,
   TAB_I_DOR_AUTO_CLOSE_TIME,
   TAB_B_DOR_LOCK,
   TAB_S12_DOR_SOUND,
};

//----------------------------

enum{
   TAB_E_COND,
   TAB_I_COND_DATA,
   TAB_E_DET_ACTION,
   TAB_S32_DET_ACTION_DATA,
   TAB_I_DET_ACTION_DATA,
   TAB_I_DET_RESET_TIME,
   TAB_I_DET_FREQ,
   TAB_I_COND_DATA2,
   TAB_S32_COND_DATA_S,
   TAB_B_DET_COND_INVERSE,
};

//----------------------------
                              //resistance sets
enum{
   TAB_I_RSET_VALUE,
   //TAB_S12_RSET_EXPL_MODEL,
   TAB_I_RSET_EXPLOSION,
   TAB_S12_RSET_SET_NAME,
   TAB_I_RSET_THRESH,
};

extern const C_table_template templ_resset;

//----------------------------

enum{
   TAB_I_AUTO_MAX_SPEED,      //km/h
   TAB_I_AUTO_NUM_TRANSL,
   TAB_F_AUTO_ACCEL,          //ratio/sec
   TAB_F_AUTO_BRAKE,          // ''
                              //advanced
   TAB_I_AUTO_MAX_WHEEL_TURN, //degrees
   TAB_I_AUTO_MAX_MOTOR_TURN, //turns/min
   TAB_I_AUTO_TRANS_UP,       //turns/min
   TAB_I_AUTO_TRANS_DOWN,     //turns/min
   TAB_S12_AUTO_SOUND,
   TAB_F_AUTO_FUEL,           //litres
   TAB_F_AUTO_CONSUM,         //multiplier

   TAB_B_WHEEL_ON,            //switch off collision check

   TAB_E_AUTO_SEAT_STAY,      //stay/sit/bike
   TAB_B_AUTO_SEAT_WEAPON,    //may hold weapon
   TAB_B_AUTO_SEAT_CANNON,    //controll cannon

   TAB_S12_AUTO_SOUND_ON,
   TAB_S12_AUTO_SOUND_OFF,
   TAB_S16_AUTO_TXT_SHIFT,    //name of material to shift texture
   TAB_I_AUTO_TXS_ANGLE,
   TAB_F_AUTO_TXS_SPEED,
   TAB_E_AUTO_TYPE,           //auto or boat
   TAB_F_AUTO_TURN_RATIO,     //ratio of turn:speed, default = 1.0

   TAB_I_AUTO_EXPL_THRESH,
   TAB_I_AUTO_DESTROY_THRESH,
};

//----------------------------
                              //campaign/mission setup
enum{
   //TAB_I_CM_NUM_CAMPAIGNS = 1,
   TAB_I_CM_NUM_MISSIONS = 2,
   TAB_S12_CM_IMAGE_NAME,
   TAB_S12_CM_MISS_IMG_BASE,
   TAB_S12_CM_MISS_DIR,
   TAB_I_CM_NUM_SOLDIERS,
};

extern const C_table_template templ_campaigns;

//----------------------------

bool TablesOpenAll();
void TablesCloseAll();

//----------------------------
