#include "all.h"
#include "mainmenu.h"


//----------------------------

static S_scrolltext_style the_end_styles[]={
   {.0375f, 0xffffffff,    PI*.1f,  TEXT_JUSTIFY_CENTER,    1300},
   {.06f,   0xffffff80,    PI*.1f,  TEXT_JUSTIFY_CENTER,    2000},
   {.0525f, 0xffffffff,    PI*.1f,  TEXT_JUSTIFY_CENTER,    1300},
};

//----------------------------

                              //the end implementation
class C_the_end: public C_mission{

   C_smart_ptr<C_scrolltext> scrolltext;

   C_string the_end_text;
   byte text_phase;           //0=end_texts, 1=credits
   C_poly_text texts;

//----------------------------

   void Finish(){

      game_music.Stop();
      tick_class = CreateMainMenu();
      if(tick_class) tick_class->Release();
   }

//----------------------------
public:
   C_the_end():
      text_phase(0)
   {
   }

   bool Init(){

      E_MISSION_IO mio = Open("the_end", OPEN_USE_SCENE_CAMERA);
      if(mio!=MIO_OK)
         return false;

                              //build the end text
      for(int i=0; ; i++){
         const C_string &str = all_txt[GT_THE_END+i];
         if(game_configuration.language!=5){
            the_end_text += str;
            the_end_text += "\n";
         }else{
            int sum = the_end_text.Size() + str.Size();
            char *cp = new char[sum];
            if(the_end_text.Size()) memcpy(cp, &the_end_text[0], the_end_text.Size());
            memcpy(cp+the_end_text.Size(), &str[0], str.Size());
            the_end_text.Assign(cp, sum);
            delete[] cp;
         }
         if(!str[0])
            break;
      }

      scrolltext = CreateScrolltext(texts, the_end_styles, &the_end_text, (game_configuration.language==5));
      scrolltext->Release();

      game_music.Play("the_end", true);

      texts.Init();
      return true;
   }

//----------------------------

   void Tick(const S_tick_context &tc){

      switch(tc.key){
      case K_ESC:
         Finish();
         return;
      }
      C_mission::Tick(tc);
      scrolltext->Tick(tc);

      if(scrolltext->IsEnd()){
         text_phase ^= 1;
         scrolltext = CreateScrolltext(texts, !text_phase ? the_end_styles : NULL,
            !text_phase ? &the_end_text : NULL, !text_phase ? (game_configuration.language==5) : false);
         scrolltext->Release();
      }
   }

//----------------------------

   virtual void Render(){

      driver->BeginScene();
      C_mission::Render();
      texts.Render();
      driver->EndScene();
   }

//----------------------------

   virtual dword GetID() const{ return 'TEND'; }
};

//----------------------------

C_class_to_be_ticked_hd *CreateTheEnd(){

   C_the_end *te = new C_the_end;
   if(!te->Init()){
      te->Release();
      te = NULL;
   }
   return te;
}

//----------------------------
