#ifndef __WIDETEXT_H
#define __WIDETEXT_H



class C_wide_text: public C_unknown{
   void *rep;                 //internal hidden implementation
public:
//----------------------------
// Construct wide text. Input parameters are: color, screen-relative position and size,
// justify and optional formatting rectangle.
// Output values are (optional): real position (after clipping to screen),
// number of lines of text.
   C_wide_text(const wchar_t *wcp, dword color, float x, float y, float size,
      dword justify, PI3D_driver, float fmt_rect[4] = NULL,
      float *xret = NULL, float *yret = NULL,
      int *num_lines = NULL);

   ~C_wide_text();

//----------------------------
// Draw wide text image - in 2D.
   void Render() const;

//----------------------------
// Adjust text position (reference point).
   void SetPos(float new_x, float new_y);

//----------------------------
// Read text position (reference point).
   void GetPos(float &x, float &y) const;

//----------------------------
// Set color of text.
   void SetColor(dword);

//----------------------------
// Get text extent, in normalized screen coordinates.
   void GetExtent(float &l, float &t, float &r, float &b);
};

//----------------------------

#endif
