#ifndef __WINSTUFF_H_
#define __WINSTUFF_H_

#include <c_string.hpp>


bool __stdcall WinSendCrashReport(const char*);

//----------------------------
// Create small texture containing string. Since real texture size is dependent on
// hardware (power of 2), initialized part of texture is returned in 'size' param.
// winHFONT is a valid Windows' HFONT handle.
PI3D_texture CreateStringTexture(const char *cp, int size[2], PI3D_driver drv, void *winHFONT);

//----------------------------
// Draw string texture above specified frame. The size is size of valid rectangle
// within the texture. Distances specifies visibility, range between them fades
// opacity.
void DrawStringTexture(PI3D_frame frm, float y_displace,
   PI3D_scene scene, PI3D_texture, const int size[2], 
   const S_vector &color, float dist_near, float dist_far,
   float opacity, float y_world_displace = .2f, const S_vector *pos = NULL);

//----------------------------
                              //multi-thread safe logging
class C_log_mt_safe{
   void *critical_section;
public:
   FILE *f_log;
   C_string log_name;

   C_log_mt_safe();
   ~C_log_mt_safe();

//----------------------------
// Add string to queue.
   void WriteString(const char*);
};

//----------------------------
// Initialize dialog box.
void WinInitDialog(void *hwnd);

//----------------------------
// Let user visually select one item from a list of items. The returned value is
// index of item, or -1 if selection is cancelled.
// The input parameter points to list of strings to choose from.
int WinSelectItem(const char *title, const char *item_list, int curr_sel = -1);

//----------------------------
// Let user re-type name. The provided string on input fills in default name, on output, if successfull,
// contains new name.
bool WinGetName(const char *title, C_string&);

//----------------------------
#endif