#include <fstream.h>
#include <stdio.h>
#include <rules.h>

//----------------------------

bool LockRar(FILE *fp, bool lock){

                              //get # of files
#pragma pack(push, 1)
                              //RAR file system
   struct S_dta_header{
      dword id;
      dword res[4];
   } dta_header;

   struct S_file_header{
      byte res[7];
      dword file_len_packed;
      dword file_len_unpacked;
      byte res1[11];
      word fname_len;
      dword res2;
   } file_header;
#pragma pack(pop)

   fread(&dta_header, sizeof(dta_header), 1, fp);
   switch(dta_header.id){
   case 0x5f415444:           //DTA_
      if(lock) return false;
      break;
   case 0x21726152:           //Rar!
      if(!lock) return false;
      break;
   }
   dta_header.id = lock ?
      0x5f415444 :            //DTA_
      0x21726152;             //Rar!
   fseek(fp, 0, SEEK_SET);
   fwrite(&dta_header, sizeof(dta_header), 1, fp);
   int curr_pos = sizeof(dta_header);

   while(true){
      fseek(fp, curr_pos, SEEK_SET);
                              //read
      int i = fread(&file_header, sizeof(file_header), 1, fp);
      if(!i) break;
                              //modify
      for(i=0; i<sizeof(file_header.res); i++) file_header.res[i] ^= 255-i;
      for(i=0; i<sizeof(file_header.res1); i++) file_header.res1[i] ^= 128-i;
      file_header.res2 ^= 0x2465fe9a;

      fseek(fp, curr_pos, SEEK_SET);
                              //write back
      fwrite(&file_header, sizeof(file_header), 1, fp);

      curr_pos += sizeof(file_header);
                              //skip file data
      curr_pos += file_header.file_len_packed + file_header.fname_len;
   }
   return true;
}

//----------------------------

int main(int argc, char *argv[]){

   if(argc<2){
      cout<<"Data file lock utility" <<endl;
      cout<<"Usage: dta_lock.exe filename [-u]" <<endl;
      cout<<"   -u ... unlock" <<endl;
      return 0;
   }
   const char *fname = argv[1];
   bool lock = true;

   FILE *fp = fopen(fname, "r+b");
   if(!fp){
      cout<<"unable to open file: " <<fname <<endl;
      return 0;
   }
   if(argc>=3){
      if(argv[2][0]=='/' || argv[2][0]=='-')
      switch(argv[2][1]){
      case 'u':
         lock = false;
         break;
      }
   }
   cout<<"processing file " <<fname <<"... ";
   bool st = LockRar(fp, lock);

   fclose(fp);

   if(st)
      cout<<(lock ? "locked" : "unlocked") <<endl;
   else
      cout<<" failed to " <<(lock ? "lock" : "unlock") <<endl;

   return 0;
}

//----------------------------
