#include "all.h"
#include <math\ease.hpp>
#include <sortlist.hpp>
#include <advanced.h>
#include "tables.h"
#include "loader.h"
#include <insanity\controller.h>
#include "actors.h"
#include "net.h"
#include "winstuff.h"

//#define FINAL

//#define JOYSTICK

                              
/*
#ifdef JOYSTICK
 #include <ijoy.h>
#endif
*/

//#define EXPIRED_ENEMY_OUT     //if enemy's program expired, go out of game

//#define ENEMY_NET_SYNC_INV    //enables enemy inventory use sync accross net, when enabled, all shadow enemies have same inventory, otherwise only at death the inventory is update, if disabled, some out-of-sync errors may arise (save-game)
//#define ENEMY_NET_SYNC_PRG    //enables enemy program sync accross net, when enabled, all shadow enemies have same program - useful only for savegame, when disabled, program is kept only locally

//#define MAIN_ANIM_STAGE 4
#define GUN_LIGHT_MIN_FPS 15  //fps under which we disable gun lights

                              //number of maximum stage which human can use fo animation blending.
                              //obviously this is also number of stage when main anim is running(except enemies, where dynamic move of main stage can be applied for optimalization)
#define MAX_ANIM_STAGE 4
                              //reduce enemy anim to 1 stage when not rendered
#define REDUCE_ENEMY_ANIMS

#define INVENTORY_COUNT 6000

#define WALL_ALIGN_RATIO .8f
#define WALL_ALIGN_SPEED (PI*.5f)    //angle per second

#define DEFAULT_SOUND_SIGNAL_DIST 40   //in meters

                              //fieldglass looking
#define FGLASS_FOV_INIT (PI*.15f)
#define FGLASS_FOV_MIN (PI*.05f)
#define FGLASS_FOV_MAX (PI*.3f)
#define FGLASS_FOV_ACCEL (PI*.2f)
#define GET_LOOK_SPEED(fov) ((PI/500.0f) * (.25f + .75f*(fov/(PI*.15f))))

#define AIMGUN_DELAY    1000
#define AIMGUN_POWER    220

                              //number of voice types
#define NUM_VOICE_TYPES 3

                              //player's free aiming
#define AIM_COUNT 2500        //time after which aiming is reset
#define AIM_FADE_TIME   1000  //time at which aim reset fades

#define SIGNAL_HEAR_DIST   35.0

#define GRENADE_THROW_DISTANCE 30.0f
#define KNIFE_HIT_DISTANCE 1.0f

#define KEEP_HUMAN_OUT_OF_WALL                 

                              //debug:
#ifdef _DEBUG
                              //show barrier climb colision lines
//#define DEBUG_DRAW_BARRIER_CLIMB
                              //show repulse collision lines
//#define DEBUG_DRAW_REPULSE
//#define DEBUG_ANIMS
# define NET_DEBUG(n)
//# define NET_DEBUG(n) OUTTEXT(n)
#else
# define NET_DEBUG(n)
#endif

#ifdef JOYSTICK
extern LPC_Joy joy;
#endif

enum E_UNIFORM_ID{
   UID_NULL,
   UID_SAS,
   UID_CIVIL,
   UID_GERMAN,
};

//----------------------------

float CountManCarriage(LPC_table tab){

   int strength = tab->ItemI(TAB_I_HUM_BAR4_STRENGTH);
   if(strength<=40) return 20;
   return 20.0f + 30.0f*(strength-40.0f)/60.0f;
}

//----------------------------

C_string MakeGameText(const C_string &str);
C_string AddGameText(const C_string&, const C_string&);

                              //convert float angle value into 8-bit value
inline byte Angle_8bit(float angle){
   return (angle*256.0f/GetPI2());
}

//----------------------------

void SaveScreenShot(bool photo_name, C_string *out_name = NULL){

                              //no photo name for japans
   if(game_configuration.language==5)
      photo_name = false;
                              //add mission name
   C_string name;
   if(photo_name){
      int tid = game_profile.MissionIndex();
      if(!game_profile.IsAddOn()){
         if(game_profile.IsDatadisk())
            tid += 1e6 - game_profile.MissionIndex(6, 0);
         tid += GT_MISSION_NAMES;
      }else
         tid += 100000 - NUM_MISSIONS;
      C_string mission_name = all_txt[tid];
      for(int i=0; i<mission_name.Size(); i++){
         switch(mission_name[i]){
         case '\\':
         case '/':
         case '$':
         case '%':
         case ':':
            mission_name[i] = ' ';
            break;
         }
      }
      name = C_fstring("Picture from %s #", (const char*)mission_name);
   }else
      name = "Shot ";

                              //make unique number
   {
      for(int i=1; i<1000; i++){
         C_fstring s("%s%i.png", (const char*)name, i);
         if(Load(s, NULL, 0)){
            name = s;
            break;
         }
      }
   }
   C_cache ck;
   ck.open(name, CACHE_WRITE);
   bool ok = false;
   if(ck.good()){
      LPIImage img = igraph->CreateBackbufferCopy(true);
      ok = img->SaveShot(&ck, "png");
      img->Release();
      ck.close();
   }
   C_string msg;
   bool wide;
   if(ok){
      wide = all_txt.IsWide(20400);
      if(!wide)
         msg = C_fstring("%s \"%s\"", (const char*)all_txt[20400], (const char*)name);
      else{
         msg = AddGameText(all_txt[20400], MakeGameText(C_fstring("\"%s\"", (const char*)name)));
      }
   }else{
      wide = all_txt.IsWide(20401);
      msg = all_txt[20401];
   }
   console_main.OutText(msg, -1, wide);

   if(out_name) *out_name = name;
}

//----------------------------
//----------------------------
#define ANIM_SIMPLE  1
#define ANIM_FULL    2

//----------------------------
//----------------------------
                              //help functions

inline int F2I(float f){ return *(dword*)&f; }
inline float I2F(int i){ return *(float*)&i; }

float Angle2D(const S_vector2 &v1);
float Angle2D(const S_vector2 &v1, const S_vector2 &v2);
float GetAngle(float x, float y);
float SubAngle(float src, float sub);
bool FreeCameraMove(S_vector &dir, const S_vector &limit_dir, int rx, int ry,
   float limit_angle, float look_speed=PI/500.0f);

/*--------------------------------------------------------
   Apply random error to direction.
   In: err = max error in degrees
--------------------------------------------------------*/

void ApplyShootErr(S_vector &dir, float err){

   //err = Random(err);
   err *= S_float_random();

                        //choose rotation axis in local x/z plane and
                        //rotate to dir's coords
   S_matrix m;
   m.SetDir(dir,
      //Random(GetPI2()));
      S_float_random() * GetPI2());
   S_vector axis(S_vector(1.0f, 0.0f, 0.0f).RotateByMatrix(m));
   S_quat q;
   q.Make(axis, err);
   //m = q.RotationMatrix();
   m = S_matrix(q);
   dir = dir.RotateByMatrix(m);
}

//----------------------------

#define SHOOT_MAGNET_CONE_FULL .5f  //range of shoot cone which produces 100% magnet

static bool CheckHitRange(const S_vector &from, const S_vector &dir, S_vector &ret, float &ratio,
   PI3D_model model, float angle_thresh, const S_vector &target_pos){

                              //check if we have any chance to hit target
   float pol = target_pos.PositionOnLine(from, dir);
                              //if target is behind us, reject
   if(pol <= 0.0f)
      return false;
                              //check how far is target from the shoot line
   float dist = ((from+dir*pol) - target_pos).Magnitude();
   if(dist > 2.0f)
      return false;

   int num_test_frames = model->NumFrames();
   const PI3D_frame *frmp = model->GetFrames();
   float a;

   for(int i=0; i<num_test_frames; i++){
      PI3D_frame tf = frmp[i];
      const S_vector &pos = tf->GetWorldPos();

      S_vector ret1 = pos - from;
      float a1 = dir.AngleTo(ret1);
      if(!i || a>a1){
         a = a1;
         ret = ret1;
      }
   }
                              //return true if in range
   if(a>=angle_thresh)
      return false;
   float in_thresh = angle_thresh * SHOOT_MAGNET_CONE_FULL;

   if(a<in_thresh){
      ratio = 1.0f;
   }else{
      ratio = (angle_thresh - a) / (angle_thresh - in_thresh);
      ret.Normalize();
      ret = ret * ratio + dir * (1.0f - ratio);
   }
   return true;
}

//----------------------------
//----------------------------
static bool can_see_through_car;

bool I3DAPI WatchColResp2(I3D_collision_data &cd){

   assert(cd.GetHitFrm());
   int mat_id = 0;
   switch(cd.GetHitFrm()->GetType()){
   case FRAME_VOLUME:
      mat_id = I3DCAST_VOLUME(cd.GetHitFrm())->GetCollisionMaterial();
      break;
   case FRAME_VISUAL:
      mat_id = I3DCAST_VISUAL(cd.GetHitFrm())->GetCollisionMaterial();
      break;
   }
   if(mat_id){
      if(mat_table->ItemB(TAB_B_MAT_AI_SEE_THROUGH, mat_id) ||
         mat_table->ItemB(TAB_B_MAT_WATER, mat_id))
         return false;
      if(can_see_through_car &&
         mat_table->ItemB(TAB_B_MAT_CAM_SEE_THROUGH, mat_id))
         return false;
   }
   return true;
}

/*--------------------------------------------------------
   Watch - test collision between 2 3D points.
   If a collision with actor is detected and the actor is friend of us,
   he's asked to move out of way - in that case the func returns false (no obstacle in way).

   move_necessity is a value in range 0.0 - 1.0
--------------------------------------------------------*/

static PI3D_frame WatchObstacle(C_game_mission &mission, LPC_actor actor, PI3D_frame root,
   const S_vector &from, S_vector &to, float move_necessity = 1.0, S_vector *ret_norm = NULL){

   S_vector to1 = to;
   S_vector dir(to-from);

   I3D_collision_data cd(from, dir, 0, root, WatchColResp2);
   bool b = mission.GetScene()->TestCollision(cd);
   PI3D_frame obstacle = b ? cd.GetHitFrm() : NULL;
   if(b && ret_norm)
      *ret_norm = cd.GetHitNormal();

   if(obstacle){
      //OUTTEXT(obstacle->GetName());
                           //check what's in the way (find actor)
      PI3D_volume vol = (obstacle->GetType()==FRAME_VOLUME) ? I3DCAST_VOLUME(obstacle) : NULL;
      PI3D_frame owner =  vol ? vol->GetOwner() : NULL;

      if(owner){
         obstacle = owner;
         LPC_actor a = (LPC_actor)owner->GetData();
         if(a && a->GetType() == actor->GetType()){
                           //ask the actor nicely to move a bit...

            S_obstacle_move om(from, to1, move_necessity);
            bool moving = a->ObstacleMove(om);
            if(moving)
               return NULL;
         }
      }
   }
   return obstacle;
}

//----------------------------
//----------------------------
                              //C_actor class

                              //actors over network:
                              // - bits:NET_ACTOR_CODE_BITS code
                              //(before each item marked by '?' is a bits:1 value specifying if item is present)

                              //network codes
enum{
   NM_HUMAN_STAY_MODE = 0,    //set stay mode; (bits:2 new stay mode <stay/bench/lay>)
   NM_HUMAN_PLAY_ANIM = 1,    //(bits:9 anim)

   NM_HUMAN_ABS_TURN = 3,     //(bits:NET_HUMAN_ABS_DIR_BITS abs_angle)
   NM_HUMAN_POS = 4,          //(S_vector pos)
   NM_HUMAN_DIE = 5,          //(bits:9 die_pose)
   NM_HUMAN_THROW_OUT = 6,    //(word caller_id [= 0])
   NM_HUMAN_KILLER = 7,       //(word killer_id)
   NM_HUMAN_HIT = 8,          //(bits:5 body_part_indx, bits:14 resistance,
   NM_HUMAN_INVENTORY = 9,    //(bits:6 itm_index/inv_index, bits:3 sub_command)
                              // sub_command:
                              //    0 = set amount (bits:12 amount)
                              //    1 = set bullets (bits:7 amount)
                              //    2 = set active item
                              //    3 = add item (bits:12 amount)
                              //    4 = delete item
                              //    5 = reload ammo (bits:1 play_sound)
                              //    6 = set selected_inv_item
                              //    7 = clear all
   NM_HUMAN_AIM_DIR = 0xa,    //bits:1 = sub_command:
                              //    0 = set vector (S_vector)
                              //    1 = begin fade
                              //       - ? float fade_factor [= 1.0f]
   NM_HUMAN_SET_VISIBLE = 0xb,//(bits:1 visibility, bits:1 volume_only)
   NM_HUMAN_SWITCH_SYNC = 0xc,//<C_net_sync>
   NM_HUMAN_PROGRAM = 0xd,    //(? byte insert_pos, bits:5 prg_item)
                              //prg dependent:
                              //    PRG_MOVE: ? S_vector dest, bits:1 run, ? byte move_reason, bits:1 force_smart
                              //    PRG_GUARD: ? S_vector dest, ? word cp_aim_dest, ? word countdown, ? S_vector guard_aim_dest, ? word subject_net_id
                              //    PRG_FOLLOW: word subj_net_id
                              //    PRG_ATTACK: word subject_net_id, ? bits:5 attack_body_part_index, bits:2 E_ATTACK_MODE
                              //    PRG_USE_INV: bits:6 inv_itm_id
                              //    PRG_WAIT_SIGNAL: word int signal_id
                              //    PRG_STEP: ? S_vector dest, ? float goto_min_dist, ? S_vector turn_dir, bits:1 run
                              //    PRG_SUSPEND: word time
                              //    PRG_WATCH: ? S_vector dest, ? bits:4 phase_count
                              //    PRG_USE: word subj_net_id, ? schar use_indx
                              //    PRG_WALK_CP: word start_CP_indx, ? word next_CP_indx, bits:1 run
                              //    PRG_SETVISIBLE: bits:1 on
                              //    PRG_LADDER_CLIMB: bool climb_up
                              //    PRG_SEND_SIGNAL: ? word subj_net_id, word signal_id
                              //    PRG_DRIVE: S_vector dest, ? word ideal_speed
   NM_HUMAN_DEL_PRG = 0xe,    //(byte del_pos)
   NM_HUMAN_DEL_PRG_0 = 0xf,  //delete prg on position 0 (quite common)
   NM_HUMAN_CLR_PRG = 0x10,
   NM_ACTOR_LISTEN_SRC = 0x11,//(bits:2 E_listen_type, S_vector pos, float power)
   NM_HUMAN_SET_USING_ITEM = 0x12,//(word item_net_id)
   NM_HUMAN_VOICE_COMMAND = 0x13,//(word caller_net_id, bits:3 sub_code)
   NM_HUMAN_PLAY_VOICE = 0x14,//(bits:24 voice_base, ? bits:1 power [=1.0f], bits:1 stop_old)
   NM_HUMAN_GUN_ANIM = 0x15,
   NM_HUMAN_RELAXED_STAY = 0x16,//(bits:1 relaxed_weapon_hold)
   NM_HUMAN_GRAB_SYNC = 0x17, //C_net_sync messages
   NM_HUMAN_GRAB_SYNC_USER = 0x18, //word grabber_id
   NM_HUMAN_USE_INV_ITEM = 0x19,
   NM_HUMAN_PLR_SET_ACTIVE = 0x1a, //(bits:1 active_mode)
   NM_HUMAN_ZOOM = 0x1b,      //(float)
   NM_HUMAN_CAM_FLASH = 0x1c, //(S_vector pos, dir)
   NM_HUMAN_DEAD_POS = 0x1d,  //(S_vector pos); final position after death
};

#ifndef _DEBUG
#define NET_ACTOR_CODE_BITS 5 //must cover all NM_???_ codes
#else
#define NET_ACTOR_CODE_BITS 5 //debug - may set wider in order to catch errors more easy
#endif

                              //how many bits are used for sending human absolute direction angle
#define NET_HUMAN_ABS_DIR_BITS 8

C_actor::C_actor(C_game_mission &m, E_ACTOR_TYPE at):
   mission(m),
   model(NULL),
   frame(NULL),
   type(at),
   resistance(1000),
   small_climb(0),
   init_ok(true),
   center_comp(false),
   net_id(0),
   network_actor(0),
   last_mat_id(-1), last_mat_id_count(0)
{
}

//----------------------------

C_actor::~C_actor(){

   Close();
   SetFrame(NULL);
}

//----------------------------

void C_actor::SaveTable(C_chunk *ck, LPC_table tab) const{

   ck->WAscend(CT_TABLE);
   tab->Save((dword)ck->GetHandle(), TABOPEN_FILEHANDLE);
   ck->Descend();
}

//----------------------------

void C_actor::SaveTableEx(C_chunk *ck, int tab_id) const{

   LPC_table tab = GetTable(tab_id);
   ck->WAscend(CT_TABLE_EX);
   ck->Write(&tab_id, sizeof(short));
   tab->Save((dword)ck->GetHandle(), TABOPEN_FILEHANDLE);
   ck->Descend();
}

//----------------------------

void C_actor::Close(){

   if(init_ok){
      /*
      if(model)
         model->LinkTo(NULL);
         */
      init_ok = false;
   }
}

//----------------------------

void C_actor::SetFrame(PI3D_frame frm){

   if(frame){
      //assert(frame->GetData());
      frame->SetData(NULL);

      struct S_hlp{
         static I3DENUMRET I3DAPI cbVol(PI3D_frame frm, dword){
            PI3D_volume vol = I3DCAST_VOLUME(frm);
            vol->SetOn(false);
            vol->SetScene(NULL);
            //assert(frm->GetData());
            frm->SetData(NULL);
            return I3DENUMRET_OK;
         }
      };
      frame->EnumFrames(S_hlp::cbVol, 0, ENUMF_VOLUME);
      if(model){
         model->LinkTo(NULL);
         model->StopAnimation(0);
      }
      //frame->SetOn(false);
      frame->Release();
   }

   if(frm){
      frm->AddRef();
                        //be sensible on sound n_otifications
                        /*
      new_frame->EnumFrames(cbSetAllCallback, FRMCALLBACK_ANIMNOTIFY,
         ENUMF_OBJECT | ENUMF_DUMMY, NULL);
         */
      struct S_hlp{
         dword type;
         PI3D_frame owner;
         LPC_actor act;
         C_game_mission *mission;
         static I3DENUMRET I3DAPI cbVol(PI3D_frame frm, dword c){
            PI3D_volume vol = I3DCAST_VOLUME(frm);
            S_hlp *hp = (S_hlp*)c;
                        //for certain (moving) actors don't put into hierarchy

            static const bool actor_moving[ACTOR_LAST] = {
               false, true, true, true,
               true, false, false, false,
               true, true, false, false,
               true, true, false, true,
               true, false, false, true,  //0x10
               false, false, true,

            };
            //vol->SetHierarchical(hp->mission->GetScene());
            //if(actor_moving[hp->type]) vol->SetHierarchical(NULL);
            vol->SetOn(true);
            vol->SetOwner(hp->owner);

            //assert(!vol->GetData());
            vol->SetData((dword)hp->act);
            return I3DENUMRET_OK;
         }
      } hlp;
      hlp.type = type;
      hlp.owner = frm;
      hlp.act = this;
      hlp.mission = &mission;
      frm->EnumFrames(S_hlp::cbVol, (dword)&hlp, ENUMF_VOLUME);
      //assert(!frm->GetData());
      frm->SetData((dword)this);
   }
   frame = frm;
   if(frame && frame->GetType()==FRAME_MODEL){
      model = I3DCAST_MODEL(frame);
   }else
      model = NULL;
}

//----------------------------

void C_actor::NetPlrDisconnect(dword pid){

   if(network_actor==pid)
      network_actor = 0;
}

//----------------------------
extern const char *actor_names[];

void C_actor::ReportActorError(const char *err_msg) const{

   ErrReport(C_fstring("Actor %s (%s): %s",
      frame ? frame->GetName() : model ? model->GetName() : "<unknown>",
      actor_names[type], err_msg), editor);
}

//----------------------------

enum{
   POSE_MOVE_LEFT, POSE_MOVE_FORWARD, POSE_MOVE_RIGHT, POSE_MOVE_BACKWARD,
   POSE_ACCEL=4,
   POSE_RESET=8, POSE_BREATH, POSE_TURN_LEFT, POSE_TURN_RIGHT,
                              //0xc
   POSE_JUMP_FORWARD, POSE_STAY_UP, POSE_STAY_DOWN, POSE_ITEM_PUT,
                              //0x10
   POSE_ITEM_GET, POSE_CREEP, POSE_BARRIER_CLIMB, POSE_CLIMB_UP,
                              //0x14
   POSE_CLIMB_BREATH, POSE_CHANGE, POSE_THROW, POSE_HIT,
                              //0x18
   POSE_HIT_AL, POSE_HIT_AR, POSE_HIT_LL, POSE_HIT_LR,
                              //0x1c
   POSE_LOAD, POSE_FIRE, POSE_FLAREFIRE, POSE_PULL_GUN,

                              //0x60
   POSE_DIE = 0x60,           //+ next 7
   POSE_FALL=0x68, POSE_LAND, POSE_GUN_AIM, POSE_BAZOOKA_AIM,
   POSE_BAZOOKA_BREATH, POSE_PANZER_AIM, POSE_PANZER_BREATH, POSE_ITEM_DROP,
   POSE_DRIVE, POSE_KNIFE_HIT, POSE_BINOC_LOOK, POSE_BINOC_BREATH,
   POSE_DIE_BY_KNIFE = 0x74,  //+next 3
   POSE_DRIVE_BREATH = 0x78, POSE_DRIVE_STRAIGHT, POSE_DRIVE_LEFT, POSE_DRIVE_RIGHT,
   POSE_DRIVE_TRANS, POSE_GRAB_BEGIN, POSE_GRAB, POSE_GRAB_FINISH,

                              //0xc0
   POSE_OPEN_DOOR = 0xc0, POSE_COLT_AIM, POSE_COLT_BREATH, POSE_COLT_FIRE,
   POSE_COLT_LOAD, POSE_DIE_DROWN, POSE_THROW_DOWN, POSE_BIKE,
   POSE_BIKE_BREATH, POSE_CLIMB_DOWN, POSE_CLIMB_DOWN1, POSE_DUMMY,
   POSE_MOVE_LF, POSE_MOVE_RF, POSE_MOVE_LB, POSE_MOVE_RB,
   POSE_MOVE_LF_A, POSE_MOVE_RF_A, POSE_MOVE_LB_A, POSE_MOVE_RB_A,
};

#define TURN_SPEED_SLOW (PI*.5f)
#define TURN_SPEED_FAST (PI*1.0f)

static const byte stay_base[]={0, 0, 0x20, 0x40, 0, 0};

//----------------------------
                              //actor collision response
#define INIT_FALL_SPEED .01f
#define FALL_ACCEL   40.0f    //meter/sec

static const S_vector axis_y(0.0f, 1.0f, 0.0f);

//----------------------------
#define MAX_TURN_ACCEL 100    //in msec

//----------------------------

void C_actor::SetVisible(bool on, bool vol_only, bool net_send){

   if(!vol_only) model->SetOn(on);
   struct S_hlp{
      static I3DENUMRET I3DAPI cbP(PI3D_frame frm, dword on){
         frm->SetOn(on);
         return I3DENUMRET_OK;
      }
   };
   frame->EnumFrames(S_hlp::cbP, on, ENUMF_VOLUME, NULL);
}

//----------------------------

void C_actor::ReceiveListen(S_listen_source &ls, bool net_send){

   if(net && net_send && network_actor){
                              //don't process it directly, rather send it to network owner
      const bool g = false;
      net_msg->Ascend(net_id);
      net_msg->AddBits(NM_ACTOR_LISTEN_SRC, NET_ACTOR_CODE_BITS, g);
      net_msg->AddBits(ls.type, 2, g);
      net_msg->AddVector(ls.pos, g);
      net_msg->AddFloat(ls.power, g);
      net_msg->Descend();
      return;
   }

   int i;
                              //try to concanetate with closest of the same type
   for(i=listen_list.size(); i--; )
   if(listen_list[i].type==ls.type){
      float dist = (listen_list[i].pos-ls.pos).Magnitude();
      if(dist<3.0f) break;
   }
   if(i==-1){
      listen_list.push_back(ls);
      //LISTEN_DEBUG("new listen source added");
   }else{
                              //migrate position to logical center
      listen_list[i].pos += (ls.pos-listen_list[i].pos) * (listen_list[i].power/(listen_list[i].power+ls.power));
      listen_list[i].power = Min(5.0f, listen_list[i].power+ls.power);
      //LISTEN_DEBUG("listen source concanetated");
   }
}

//----------------------------

bool C_actor::SG_SaveModelInfo(C_chunk *ck, bool save_name) const{
                              //write model info
   ck->WAscend(CT_SG_MODEL);

   {
      if(save_name){
                              //write pure filename
         C_string cp(model->GetFileName());
         int j = cp.Size();
         if(j>=4 && cp[j-4]=='.') cp[j-=4]=0;
         while(j && cp[j-1]!='\\') --j;
         //ck->WriteText(CT_MODELFILENAME, &cp[j]);
         ck->WStringChunk(CT_MODELFILENAME, &cp[j]);
      }
                              //write pos/rot
      ck->WVectorChunk(CT_POSITION, frame->GetPos());
      ck->WRotChunk(CT_QUATERNION, frame->GetRot());
      //ck->WFloatChunk(CT_USCALE, frame->GetWorldScale());
      ck->WFloatChunk(CT_USCALE, frame->GetScale());

      {
         PI3D_frame link_to = frame->GetParent();
         if(link_to && link_to->GetType()!=FRAME_SECTOR)
            ck->WStringChunk(CT_SG_LINK, link_to->GetName());
      }
   }
   ck->Descend();
   return true;
}

//----------------------------

bool C_actor::SG_LoadModelInfo(C_chunk *ck, bool ascend){

   CK_TYPE t;
   ck->RAscend(t);

   bool model_loaded = false;
   C_smart_ptr<I3D_model> mp = I3DCAST_MODEL(frame);

   PI3D_frame link_to = NULL;
   bool set_frame_sector = false;
   C_string str;
   while(ck->Size()){
      CK_TYPE t;
      ck->RAscend(t);
      switch(t){
      case CT_MODELFILENAME:
         {
            SetFrame(NULL);
            if(!mp){
               mp = driver->CreateModel();
               mp->Release();
            }
            set_frame_sector = true;

            str = ck->RStringChunk();
            I3D_RESULT ir;
            ir = model_cache.Open(mp, str, mission.GetScene(), 0, ErrReport, editor);
            assert(I3D_SUCCESS(ir));
                              //init volumes
            //S_model_load s = {mp, &mission};
            //mp->EnumFrames(cbModelLoad, (dword)&s, ENUMF_DUMMY | ENUMF_USEMASK, "~0*");
            mp->EnumFrames(cbSetAllCallback, FRMCALLBACK_ANIMNOTE, ENUMF_VISUAL | ENUMF_DUMMY | ENUMF_JOINT, NULL);
            mp->EnumFrames(cbAddVolumeToScene, (dword)mission.GetScene(), ENUMF_VOLUME);

            model_loaded = true;
         }
         break;

      case CT_POSITION:
         mp->SetPos(ck->RVectorChunk());
         break;

      case CT_QUATERNION:
         mp->SetRot(ck->RQuaternionChunk());
         break;

      case CT_USCALE:
         mp->SetScale(ck->RFloatChunk());
         break;

      case CT_SG_LINK:
         str = ck->RStringChunk();
         link_to = mission.GetScene()->FindFrame(str);
         break;

      default:
         ck->Descend();
      }
   }
   mp->Update();
   if(model_loaded){
      SetFrame(mp);
   }
   if(link_to)
      frame->LinkTo(link_to);
   else
   if(set_frame_sector){
      S_vector pos;
      GetCenterPos(pos);
      mission.GetScene()->SetFrameSectorPos(frame, pos);
   }

   ck->Descend();

   return true;
}

//----------------------------

void C_actor::SetNetID(word w){ net_id = w; }

//----------------------------

void C_actor::NetIn(PC_net_in_msg in_msg){

   assert(0);
}

//----------------------------

                              //network support for C_actor
void C_actor::NetCodeIn(byte msg_code, PC_net_in_msg in_msg){

   switch(msg_code){
   case NM_ACTOR_LISTEN_SRC:
      {
         S_listen_source ls;
         ls.type = (E_listen_type)in_msg->GetBits(2);
         ls.pos = in_msg->GetVector();
         ls.power = in_msg->GetFloat();
         if(!network_actor)   //for network_actor this information is useless
            ReceiveListen(ls, false);
      }
      break;

   default:
      assert(0);
   }
}

//----------------------------

bool I3DAPI FlyColResp(I3D_collision_data &cd);

//----------------------------
#define ACTOR_HIT_RANGE_ANGLE (PI*.05f)

#ifdef _DEBUG
 #define LISTEN_DEBUG(n)
 //#define LISTEN_DEBUG(n) OUTTEXT(n)

 #define LISTEN_LOG(n)
 //#define LISTEN_LOG(n) DEBUG(n)
#else
 #define LISTEN_DEBUG(n)
 #define LISTEN_LOG(n)
#endif

dword C_actor::cbProc(dword msg, dword prm1, dword prm2){

   switch(msg){

      /*
   case CB_NET_PLAYER_LOST:
      assert(net);
      if(net){
                              //player disconnected, all his duties come to host
         if(network_actor==prm1)
            network_actor = net->IsHost() ? 0 : net->GetHostPID();
      }
      break;
      */

   case CB_SET_NETWORK_ACTOR:
      network_actor = prm1;
      break;

   case CB_IS_NETWORK_ACTOR:
      return (bool)network_actor;

      /*
   case CB_LISTEN_RESET:
      listen_list.clear();
      break;

   case CB_EMIT_LISTEN:
      ReceiveListen(*(S_listen_source*)prm1);
      break;
      */

   case CB_GET_EXPLODE_RATIO:
      {                       //get line collision from explosion center to our center
         const S_vector &from = *(const S_vector*)prm2;
         S_vector to;
         GetCenterPos(to);
         I3D_collision_data cd(from, to-from, 0, frame, FlyColResp);
         bool vol = mission.GetScene()->TestCollision(cd);
#ifdef EDITOR
         if(tab_game_cfg->ItemB(TAB_B_GAME_DEBUG_EXPL_LINES))
            DebugLine(from, vol ? cd.GetHitPosition() : to, 0, -1, 5000);
#endif
         return F2I(vol ? 0.0f : 1.0f);
      }
      break;

      /*
   case CB_DUPLICATE:
      {
         LPC_actor orig=(LPC_actor)prm1;
         LPC_table tab = GetTable(0);
         LPC_table otab = orig->GetTable(0);
         if(tab && otab){
            tab->Open((dword)otab, TABOPEN_DUPLICATE);
            TableUpdate(-1, true);
         }
      }
      break;

   case CB_SOUND:             //make sound
      if(last_mat_id != -1 || snd_vol != -1){
                              //prm1 = frame, prm2 = sound ID
                              //let mission play required sound
         PI3D_frame frm = (PI3D_frame)prm1;
                              //check how far is the source of camera,
                              // to see if it's worth to play the sound
         float dist = (frm->GetWorldPos() - cam->GetWorldPos()).Magnitude();
         if(dist >= 18.0f)
            break;

         PI3D_sound snd = mission.GetActionSound(snd_vol!=-1 ? snd_vol : last_mat_id, prm2);
         if(frm && snd){
            //snd->LinkTo(frm);
            snd->LinkTo(scene->GetPrimarySector());
            snd->SetPos(frm->GetWorldPos());
            snd->Update();
            snd->SetRange(2.0f, 20.0f);
            snd->SetLoop(false);
            snd->SetOn(true);
            mission.AddPlaySound(snd);
            snd->Release();
         }
      }
      break;
      */
   }
   return 0;
}

//----------------------------

void C_actor::SoundNotify(PI3D_frame frm, dword notify_id, dword stage){

   if(last_mat_id != -1){
                           //prm1 = frame, prm2 = sound ID
                           //let mission play required sound
                           //check how far is the source of camera,
                           // to see if it's worth to play the sound
      PI3D_frame cam = mission.game_cam.GetCamera();
      if(!cam) 
         return;
      float dist = (frm->GetWorldPos() - cam->GetWorldPos()).Magnitude();
      if(dist >= 18.0f)
         return;

      PI3D_sound snd = mission.GetActionSound(last_mat_id, notify_id);
      if(frm && snd){
         //snd->LinkTo(frm);
         snd->LinkTo(mission.GetScene()->GetPrimarySector());
         snd->SetPos(frm->GetWorldPos());
         snd->Update();
         snd->SetRange(2.0f, 20.0f);
         snd->SetLoop(false);
         snd->SetOn(true);
         mission.AddPlaySound(snd);
         snd->Release();
      }
   }
}

//----------------------------

void C_actor::ListenTick(int time, float villigance){
                           //process all sources
   int i;
   float tsec = (float)time*.001f;
   for(i=listen_list.size(); i--; ){
      S_listen_source &ls = listen_list[i];
      LISTEN_LOG(C_fstring("Listen source type: %i, power: %.2f", ls.type, ls.power));
                           //count ignorance
      //ls.ignore_count = Max(0, ls.ignore_count-time);
                           //lower sound source
      if((ls.power -= tsec*1.0f) <= 0.0f){
         //listen_list.fast_erase(i);
         listen_list[i] = listen_list.back(); listen_list.pop_back();
      }
   }
}

//----------------------------
//----------------------------

#ifdef _DEBUG
# define CM_DEBUG(n)
//# define CM_DEBUG(n) OUTTEXT(n)
#else
 #define CM_DEBUG(n)
#endif

                              //movement class:
                              // responsible for finding path,
                              // keeping path,
                              // keeping failed checkpoints during path moving

class C_movement{

   C_game_mission &mission;
   E_CHECKPOINT_TYPE cp_type;
                              //copy of cp_grid used if path failed - bad connections
                              //are removed
   vector<C_cp_grid_element> cp_grid;

                              //internal callback 'wave' function
   void FindPathWave(C_smart_ptr<C_checkpoint> *cpts, vector<short> &wave1,
      const vector<C_cp_grid_element> &cp_grid,
      int cp_to_index, LPC_checkpoint cp_start);

   bool FindPath(C_smart_ptr<C_checkpoint> *cpts, dword num_cpts,
      int cp_from_index, int cp_to_index);

   C_movement &operator=(const C_movement &mv);
   C_movement(const C_movement&);
public:
   C_movement(C_game_mission &m):
      mission(m),
      curr_indx(-1)
   {}
                              //path used in movement
   t_move_path move_path;
   int curr_indx;
   PI3D_frame frm_head;      //frame which is looking

   bool FindPath(const S_vector &from, const S_vector &to, PI3D_frame plr_model, E_CHECKPOINT_TYPE cp_type);
private:
   S_vector next_dst;         //next destination - a position of CP or dest_pos
   S_vector curr_pos;         //current position of moving object
   S_vector dest_pos;         //destination of path

                              //idle testing
   S_vector last_idle_test_pos;     //position when we last checked to see next dest
   int idle_count;            //counter for no progress

                              //next CP watch testing
   S_vector last_ncp_test_pos;      //position when we last looked to the next CP
   int no_next_cp_watch_count;      //counter for not seeing next CP


   //bool done;
   int next_cp_seen_count;    //don't look to next cp every frame
   byte test_cp_phase;        //toggle between tests of shortcut: 0 = head, 1 = feets
   //int no_next_cp_seen_time;
   bool first_run;
                              //shortcut testing
   bool last_skipped;
   int skip_disable_count;
   S_vector last_sc_test_pos; //position when we last checked for shortcut
   //S_vector last_cp_test_pos; //position when we last checked to see next dest
   int last_sc_test_time;     //time since we last time made shortcut test - as this is tied to last_sc_test_pos so we may detect if CP is seen, but unreachable

   const S_vector *NextCPV(){
      if(curr_indx == move_path.size()) return NULL;
      if(curr_indx == move_path.size()-1) return &dest_pos;
      return &mission.GetCheckpoints()[move_path[curr_indx+1]]->GetPos();
   }

//----------------------------

   void IdleReset(){
      last_idle_test_pos = curr_pos;
      idle_count = 0;
   }

//----------------------------

   void NoNextCPReset(){
      last_ncp_test_pos = curr_pos;
      no_next_cp_watch_count = 0;
   }

//----------------------------

   bool NextCP(){

      test_cp_phase = 0;
      if(curr_indx == move_path.size()){
         CM_DEBUG("NextCP: in last CP");
         return true;
      }
      if(++curr_indx == move_path.size()){
         CM_DEBUG("NextCP: last CP, going to dest");
         next_dst = dest_pos;
      }else{
         next_dst = mission.GetCheckpoints()[move_path[curr_indx]]->GetPos();
#ifdef EDITOR
         CM_DEBUG(C_fstring("NextCP (%i left)", move_path.size()-curr_indx));
         mission.GetCheckpoints()[move_path[curr_indx]]->help_visited = true;
#endif
      }
      //first_run = true;
      return false;
   }

//----------------------------
                     //create private copy of CP grid (if not made yet)
   void CopyCPGrid(){
      if(!cp_grid.size()){
         CM_DEBUG("creating private copy of CP grid");
         cp_grid = mission.GetCPGrid();
      }
   }

//----------------------------

   bool Recompute(PI3D_frame root);

//----------------------------

   void UnskipShortcut(){
      assert(last_skipped && curr_indx!=-1);
      CM_DEBUG("unskip shortcut");
                  //oops, unskip point
                  //penaulty
      skip_disable_count = 20000;
      --curr_indx;
      next_dst = mission.GetCheckpoints()[move_path[curr_indx]]->GetPos();
      //S_vector dir = next_dst-curr_pos;
      //dir.Normalize();
      //next_dst += dir*.8;
      idle_count = 0;
      last_skipped=false;
      test_cp_phase = 0;
   }

   static bool CheckFeetCol(float col_y){
      /*
      float angle = asin(col_y);
      bool ok = (angle>PI*.25f);
      //CM_DEBUG(C_fstring("feet collision angle = %.2f, check return = %i", angle, ok));
      return ok;
      */
      return col_y >= tab_game_cfg->ItemF(TAB_F_GAME_WALL_Y_THRESH);
   }

   static void GetFeetPos(PI3D_frame root, S_vector &feet_pos, S_vector &cp_pos){
      feet_pos = root->GetWorldPos();
      feet_pos.y += .1f;
      cp_pos.y -= .8f;
   }

                              //get flags of connection following next CP
   dword GetNextCPConFlags(){
      if(curr_indx<move_path.size()-1){
         C_smart_ptr<C_checkpoint> *cpts = mission.GetCheckpoints();
         LPC_checkpoint cp0 = cpts[move_path[curr_indx]];
         LPC_checkpoint cp1 = cpts[move_path[curr_indx+1]];
         for(int i=cp0->NumConnections(); i--; ) if(cp0->GetCPoint(i)==cp1) break;
         assert(i!=-1);
         if(i==-1) return 0;
         return cp0->GetConnectionData(i);
      }
      return 0;
   }

//----------------------------

public:
#define SHORTCUT_TEST_INTERVAL 2   //distance after which we re-test for shortcut
#define SHORTCUT_TEST_TIME 300      //how often we check for possible shortcuts
//#define NEXT_CP__TEST_INTERVAL 2    //how often we check if next CP is seen
#define IDLE_DIST_INTERVAL .6
#define NO_NEXT_CP_SEEN_TIME 1000   //thresh time for which not seeing next CP is accepted
#define MOVE_TIME_IDLE 2000         //time of no progress in movement after which we make new decissions

   bool GetMovePos(S_vector &ret, S_vector &next_dest, PI3D_frame root, int time,
      LPC_actor actor, int *use_lad_door, bool timeouts = true){

      bool b;
      int i;
                              //go to the next key
                              //get dist
      //float dist = (next_dst - curr_pos).Magnitude();
      float dist_2d;
      {
         S_vector2 dir(next_dst.x-curr_pos.x, next_dst.z-curr_pos.z);
         dist_2d = dir.Magnitude();
      }
      if(dist_2d<1.2f && fabs(next_dst.y-curr_pos.y)<2.0f){
         //const S_vector *next_cp_pos = NextCPV();
         bool next = false;
         const S_vector *next_cp_pos = NextCPV();
         if(next_cp_pos){
            if(dist_2d>=.7f || fabs(next_dst.y-curr_pos.y)>=2.0f){
               if((last_sc_test_time+=time) > SHORTCUT_TEST_TIME){
                  last_sc_test_time = 0;

                  S_vector next_cp = *next_cp_pos;
                  b = WatchObstacle(mission, actor, root, frm_head->GetWorldPos(), next_cp);
                  if(!b){
                     S_vector norm;
                     S_vector feet_pos;
                     GetFeetPos(root, feet_pos, next_cp);

                     b = WatchObstacle(mission, actor, root, feet_pos, next_cp, 1, &norm);
                     if(b) b = !CheckFeetCol(norm.y);
                     if(!b){
                        CM_DEBUG("head & feets ok, going to next");
                        next=true;
                     }
                  }
               }

            }else next=true;
         }else
         if(dist_2d<.7f && fabs(next_dst.y-curr_pos.y)<2.0f){
            CM_DEBUG("done");
            //done=true;
            return true;
         }
         if(next){
                              //check special flags
            dword cflg = GetNextCPConFlags();
            if(cflg&CP_CON_USE_LADDER){
               CM_DEBUG("ladder connection on next CP");
               *use_lad_door = 1;
            }else
            if(cflg&CP_CON_USE_DOOR){
               CM_DEBUG("door connection on next CP");
               *use_lad_door = 2;
            }
            NextCP();
            last_skipped=false;
            skip_disable_count=0;
            goto out1;
         }
      }
                              //simple movement without CPs
      if(!move_path.size()){
         ret = dest_pos;
         next_dest = dest_pos;
         goto out;
      }
                              //check if we see next dest
      {
         b = true;
         bool do_look = false;
                              //always look in 'last' test
         if((no_next_cp_watch_count+time) >= NO_NEXT_CP_SEEN_TIME) do_look = true;
         else{
            float dist = (last_ncp_test_pos - curr_pos).Magnitude();
            if(dist>2.0f){
               last_ncp_test_pos = curr_pos;
               do_look = true;
            }
         }
         if(do_look){
            b = WatchObstacle(mission, actor, root, frm_head->GetWorldPos(), next_dst);
            if(!b){
               S_vector dest = next_dst;
               S_vector norm;
               S_vector feet_pos;
               GetFeetPos(root, feet_pos, dest);
               b = WatchObstacle(mission, actor, root, feet_pos, dest, 1, &norm);
               if(b) b = !CheckFeetCol(norm.y);
            }
         }
         if(b){               //view not clear
            if(timeouts)
            if((no_next_cp_watch_count+=time) >= (last_skipped ? NO_NEXT_CP_SEEN_TIME : NO_NEXT_CP_SEEN_TIME*3)){
               CM_DEBUG("not seeing next CP for long");
                              //locked...?
               if(last_skipped) UnskipShortcut();
               else
               if(!Recompute(root)) return true;
               return GetMovePos(ret, next_dest, root, time, actor, use_lad_door);
            }
         }else no_next_cp_watch_count = 0;
      }

      if(skip_disable_count && (skip_disable_count-=time)<=0){
         skip_disable_count = 0;
         CM_DEBUG("skip penaulty expired");
      }

      if(skip_disable_count){
         float dist = (last_sc_test_pos - curr_pos).Magnitude();
         if(dist >= SHORTCUT_TEST_INTERVAL){
            last_sc_test_pos = curr_pos;
            last_sc_test_time=0;
         }else
         if((last_sc_test_time += time) >= MOVE_TIME_IDLE){
            //if(last_skipped) UnskipShortcut();
            //else
            if(!Recompute(root)) return true;
            return GetMovePos(ret, next_dest, root, time, actor, use_lad_door);
         }
      }else
      if(curr_indx < move_path.size()){
                              //check if it's time to test for shortcut
         float dist_from_last_test = (last_sc_test_pos - curr_pos).Magnitude();
         if(first_run || dist_from_last_test >= SHORTCUT_TEST_INTERVAL){
            last_sc_test_pos = curr_pos;
            last_sc_test_time = 0;  //reset (idle) counter

            bool do_test = true;

            if(last_skipped){
               b = WatchObstacle(mission, actor, root, frm_head->GetWorldPos(), next_dst);
               if(!b){
                  S_vector dest = next_dst;
                  S_vector norm;
                  S_vector feet_pos;
                  GetFeetPos(root, feet_pos, dest);
                  b = WatchObstacle(mission, actor, root, feet_pos, dest, 1, &norm);
                  if(b) b = !CheckFeetCol(norm.y);
               }
                              //check if we still see next key
               if(b){
                  UnskipShortcut();
                  return GetMovePos(ret, next_dest, root, time, actor, use_lad_door);
                  //do_test = false;
               }else{
                              //check distance
                  if(!curr_indx) do_test = false;
                  else{
                     float dist_to_next = (next_dst - curr_pos).Magnitude();
                     float skiped_dist = (next_dst - mission.GetCheckpoints()[move_path[curr_indx-1]]->GetPos()).Magnitude();
                     if(dist_to_next >= skiped_dist)
                        do_test = false;
                     else{
                              //check angle
                        S_vector next_dir(next_dst - curr_pos);
                        S_vector skipped_dir(next_dst - mission.GetCheckpoints()[move_path[curr_indx-1]]->GetPos());
                        float angle = Angle2D(S_vector2(next_dir.x, next_dir.z),
                           S_vector2(skipped_dir.x, skipped_dir.z));
                        if(fabs(angle) > PI*.15f)
                           do_test=false;
                     }
                  }
               }
            }
            if(do_test){
                              //get position of the next CP
               S_vector next_cp_pos = *NextCPV();
               i = first_run;
               do{            //for first time always check both head & feets
                  if(test_cp_phase==0){
                                 //head test
                     b = WatchObstacle(mission, actor, root, frm_head->GetWorldPos(), next_cp_pos);
                  }else{
                                 //feet test
                     S_vector norm;
                     S_vector feet_pos;
                     GetFeetPos(root, feet_pos, next_cp_pos);
                     b = WatchObstacle(mission, actor, root, feet_pos, next_cp_pos, 1, &norm);
                     if(b) b = !CheckFeetCol(norm.y);
                  }

                  if(!b){
                     test_cp_phase ^= 1;
                     if(test_cp_phase==0){
                                 //can't skip special connection type
                        dword cflg = GetNextCPConFlags();
                        if(!(cflg&(CP_CON_USE_LADDER|CP_CON_USE_DOOR))){
                                 //tested both head and feets, everything's ok
                           CM_DEBUG("taking shortcut");
                                 //skip to next CP
                           NextCP();
                           last_skipped=true;
                        }
                     }
                  }else
                     test_cp_phase = 0;
               }while(!b && i--);
            }
            first_run = false;
         }/*else                //check if even moving
         if(dist<IDLE_DIST_INTERVAL && (last_sc_test_time += time) >= MOVE_TIME_IDLE){
            CM_DEBUG("no progress for a long time, making decission");
                              //locked...?
            if(last_skipped) UnskipShortcut();
            else
            if(!Recompute(root)) return true;
            return GetMovePos(ret, next_dest, root, time, actor, use_lad_door);
         }
         */
      }
                              //check for idle
      if(timeouts){
         float dist = (last_idle_test_pos - curr_pos).Magnitude();
         if(dist>IDLE_DIST_INTERVAL){
            last_idle_test_pos = curr_pos;
            idle_count = 0;
         }else
         if((idle_count += time) >= MOVE_TIME_IDLE){
            CM_DEBUG("no progress for a long time, making decission");
                              //locked...?
            if(last_skipped) UnskipShortcut();
            else
            if(!Recompute(root)) return true;
            return GetMovePos(ret, next_dest, root, time, actor, use_lad_door);
         }
      }


   out1:
                              //go to the next computed destination
      ret = next_dst;
      next_dest = (curr_indx+1)>=move_path.size() ? dest_pos :
         mission.GetCheckpoints()[move_path[curr_indx+1]]->GetPos();
   out:
#ifdef EDITOR
      if(tab_game_cfg->ItemB(TAB_B_GAME_DRAW_PATH))
         DebugLine(curr_pos, ret, 1, 0xff0000ff);
#endif
      return false;
   }
//----------------------------

   void SetCurrPos(const S_vector &p){
      curr_pos = p;
   }

//----------------------------

   void DumpPath(vector<S_vector> &path){

      path.push_back(curr_pos);
                              //skip 1st and last CPs
      int psize=move_path.size();
      for(int i=Max(curr_indx, 1); i<psize-1; i++){
         path.push_back(mission.GetCheckpoints()[move_path[i]]->GetPos());
      }
      path.push_back(dest_pos);
   }

/*--------------------------------------------------------
   Compute movement length.
--------------------------------------------------------*/
   float GetLength(){

      C_smart_ptr<C_checkpoint> *cpts = mission.GetCheckpoints();
      float len = (curr_pos-next_dst).Magnitude();

      for(int i=curr_indx; i<move_path.size(); i++){
         if(i==move_path.size()-1)
            len += (cpts[move_path[i]]->GetPos()-dest_pos).Magnitude();
         else
            len += (cpts[move_path[i]]->GetPos()-cpts[move_path[i+1]]->GetPos()).Magnitude();
      }
      return len;
   }
/*--------------------------------------------------------
   Get line of next connection
--------------------------------------------------------*/
   bool GetNextCPConDir(S_vector &cpos, S_vector &cdir){
      if(curr_indx && curr_indx<move_path.size()){
         C_smart_ptr<C_checkpoint> *cpts = mission.GetCheckpoints();
         cpos = cpts[move_path[curr_indx-1]]->GetPos();
         cdir = cpts[move_path[curr_indx]]->GetPos() - cpos;
         return true;
      }
      return false;
   }

   const S_vector &GetDest() const{ return dest_pos; }

   LPC_checkpoint GetPrevCP() const{
      assert(curr_indx);
      C_smart_ptr<C_checkpoint> *cpts = mission.GetCheckpoints();
      return cpts[move_path[curr_indx-1]];
   }

   void SkipCP(){
      if(curr_indx<move_path.size()){
         NextCP();
         last_skipped=false;
         skip_disable_count=0;
      }
   }
};

//----------------------------

void C_movement::FindPathWave(C_smart_ptr<C_checkpoint> *cpts, vector<short> &wave1,
   const vector<C_cp_grid_element> &cp_grid,
   int cp_to_index, LPC_checkpoint cp_start){

   vector<short> new_wave;
   int i, j;

   for(i=wave1.size(); i--; ){
      int indx = wave1[i];
      if(indx == cp_to_index)
         continue;
      LPC_checkpoint cd = cpts[indx];
      const C_cp_grid_element &cg = cp_grid[indx];
                           //process all connected CP's
      //int num = cg.NumConnections();
      //for(j=0; j<num; j++)
      for(j=cg.NumConnections(); j--; ){


                           //check if direction possible
         dword flags = cg.GetConnectionData(j);
         /*
         if((flags&(CP_CON_ONEWAY|CP_CON_ONEWAYTO)) == CP_CON_ONEWAY)
            continue;
            */

         LPC_checkpoint cd1 = cpts[cg.GetCPoint(j)];

         float dist = cd->dist + cg.GetDistance(j);
                           //add cost of opening doors | using ladders
         if(flags&CP_CON_USE_LADDER) dist += 8.0f;
         if(flags&CP_CON_USE_DOOR) dist += 5.0f;

                              //if dist is worse than what we already have found, fast quit
         if(cp_start->prev_index!=-1 && cp_start->dist <= dist) continue;

                              //if dist is worse than this cp has already assigned, fast quit
         if(cd1->prev_index!=-1 && cd1->dist <= dist) continue;
                           //disconnect
         if(cd1->prev_index != -1){
            int k;
            for(k=i+1; k<wave1.size(); k++)
            if(wave1[k] == cd1->index){
               //wave1.fast_erase(k);
               wave1[k] = wave1.back(); wave1.pop_back();
               break;
            }
            for(k=0; k<new_wave.size(); k++)
            if(new_wave[k] == cd1->index){
               //new_wave.fast_erase(k);
               new_wave[k] = new_wave.back(); new_wave.pop_back();
               break;
            }
         }
                           //connect to this
         cd1->prev_index = cd->index;
         cd1->dist = dist;
                           //add to new wave
         new_wave.push_back(cd1->index);
      }
   }
   if(new_wave.size()) FindPathWave(cpts, new_wave, cp_grid, cp_to_index, cp_start);
}

//----------------------------

bool C_movement::FindPath(C_smart_ptr<C_checkpoint> *cpts, dword num_cpts,
   int cp_from_index, int cp_to_index){

   if(cp_from_index==cp_to_index){
      move_path.push_back(cp_to_index);
      return true;
   }

   int i;
   for(i=num_cpts; i--; )
      cpts[i]->PFReset(i);
   vector<short> wave;
                           //search from end to start
   wave.push_back(cp_to_index);
   LPC_checkpoint to = cpts[cp_to_index];
   to->dist = 0.0f;
   to->prev_index = cp_from_index;
   FindPathWave(cpts, wave,
      cp_grid.size() ? cp_grid : mission.GetCPGrid(),
      cp_from_index, cpts[cp_from_index]);

   if(cpts[cp_from_index]->prev_index==-1) return false;
                           //collect path
   int cp_indx = cp_from_index;
   do{
      move_path.push_back(cp_indx);
      if(cp_indx == cp_to_index) break;
      cp_indx = cpts[cp_indx]->prev_index;
   }while(true);

   return true;
}

//----------------------------

bool C_movement::FindPath(const S_vector &from, const S_vector &to, PI3D_frame plr_model, E_CHECKPOINT_TYPE cp_type1){

   cp_type = cp_type1;
   #ifdef EDITOR
   if(tab_game_cfg->ItemB(TAB_B_GAME_DRAW_PATH))
      DebugLineClear();
   #endif
   int i;
   move_path.clear();
                           //find closest visible check points
   dword num_cp = mission.NumCheckpoints();
   if(!num_cp){
      curr_indx=0;
      dest_pos = next_dst = to;
      first_run=true;
      curr_pos = from;
      next_cp_seen_count = 0;
      test_cp_phase = 0;
      return true;
   }
   C_smart_ptr<C_checkpoint> *cpts = mission.GetCheckpoints();
                           //find closest checkpoints to given start/end points
   int from_i=-1, to_i=-1;
   dest_pos = to;
   int j;

   const vector<C_cp_grid_element> &grid = cp_grid.size() ? cp_grid : mission.GetCPGrid();
                           //sort cpts by dist to from/to position
   for(j=0; j<2; j++){
      C_sort_list<int> sl_dist;
      S_vector v(!j ? from : to);
      if(j){
                              //move up
         v.y += 1.0f;
      }

      for(i=num_cp; i--; ){
         if(!grid[i].valid_source) continue;
         LPC_checkpoint cp = cpts[i];
         if(cp->GetType() != cp_type) continue;
         float dist;
         dist = (cp->GetPos() - v).Magnitude();
         sl_dist.Add(i, F2I(dist));
      }
      if(!sl_dist.Count())
         return false;
      sl_dist.Sort(0);
      {
                           //use closest visible checkpoint
         int indx = -1;
         const MAX_CP_SEEN_TEST = 32;
                           //check a few closest CPs, if noone seen, use the closest one
         for(i=0; i<Min(MAX_CP_SEEN_TEST, (int)sl_dist.Count()); i++){
            LPC_checkpoint cp = cpts[sl_dist[i]];
                           //check if CP visible
            S_vector rpos;
            S_vector v1 = v;
            S_vector dir = v-cp->GetPos();
            if(j){
                              //move towards CP
               float dist = dir.Magnitude();
               const float move_dist = .4f;
               if(dist>move_dist){
                  dir /= dist;
                  v1 += dir*move_dist;
                  dir *= (dist-move_dist);
               }
            }
            bool b;
            I3D_collision_data cd(cp->GetPos(), dir, 0, plr_model);
            b = mission.GetScene()->TestCollision(cd);
            if(b){
               rpos = cd.GetHitPosition();
            }
            if(!b){
               indx = i;
               break;
            }
         }
         //if(j && i==Min(MAX_CP_SEEN_TEST, (int)sl_dist.size())) CM_DEBUG(C_fstring("FindPath: (%s) can't see dest, using closest CP", plr_model->GetName()));
         if(indx==-1) indx=0;
         (!j ? from_i : to_i) = sl_dist[indx];
      }
   }

   bool b = false;

   if(from_i!=-1 && to_i!=-1){
      b = FindPath(cpts, num_cp, from_i, to_i);
   }

   if(b){
      CM_DEBUG(C_fstring("Findpath: from [%.2f, %.2f, %.2f], to[%.2f, %.2f, %.2f]",
         from.x, from.y, from.z, to.x, to.y, to.z));
      CM_DEBUG(C_fstring("%i keys", move_path.size()));

      curr_indx=0;
      next_dst = mission.GetCheckpoints()[move_path[0]]->GetPos();
      last_skipped=false;
      skip_disable_count=0;
      last_sc_test_pos = from;
      //last_cp_test_pos = from;

      next_cp_seen_count = 0;
      //no_next_cp_seen_time = 0;
      first_run=true;
      last_sc_test_time=0;
      test_cp_phase = 0;

      curr_pos = from;
      IdleReset();
      NoNextCPReset();
                           //adjust destination point, so that it's reachable
      {
         const S_vector &last_cp = mission.GetCheckpoints()[move_path.back()]->GetPos();
         bool col;
         {
            I3D_collision_data cd(last_cp, dest_pos-last_cp, 0, plr_model, WatchColResp2);
            col = mission.GetScene()->TestCollision(cd);
            if(col)
               dest_pos = cd.GetHitPosition();
         }
         S_vector dir = last_cp - dest_pos;
         if(dir.Magnitude() < .4f){
            CM_DEBUG(C_fstring("Findpath: dest close to CP, using CP"));
            dest_pos = last_cp;
         }else{
            if(col){
               dir.Normalize();
               dest_pos += dir*.4f;
            }
                           //fall it down
            S_vector to1;

            I3D_collision_data cd(dest_pos, S_vector(0, -100, 0), 0, plr_model, WatchColResp2);
            bool col = mission.GetScene()->TestCollision(cd);
            if(col)
               to1 = cd.GetHitPosition();

            if(col){
               dest_pos = to1;
               dest_pos.y += 1.0f;
               CM_DEBUG(C_fstring("Findpath: dest adjusted to dist %.2f from last CP", (dest_pos-last_cp).Magnitude()));
            }else{
               CM_DEBUG(C_fstring("Findpath: dest in air, using CP"));
                           //oops, nothing under feets
               dest_pos = last_cp;
            }
         }
      }

      //done=false;
   #ifdef EDITOR
      if(tab_game_cfg->ItemB(TAB_B_GAME_DRAW_PATH)){
         DebugLine(from, mission.GetCheckpoints()[move_path[0]]->GetPos(), 0, 0xffff0000);
         for(i=0; i<move_path.size()-1; i++){
            DebugLine(mission.GetCheckpoints()[move_path[i]]->GetPos(),
               mission.GetCheckpoints()[move_path[i+1]]->GetPos(), 0, 0xff00ff00);
         }
         DebugLine(mission.GetCheckpoints()[move_path.back()]->GetPos(), dest_pos, 0, 0xff0000ff);
      }
   #endif
   }else
      curr_indx=-1;
   return b;
}

//----------------------------

bool C_movement::Recompute(PI3D_frame root){

   CM_DEBUG("recomputing");
   bool b = false;

   if(curr_indx<0){
   }else
   if(curr_indx <= 0){
      int failed_i=move_path[0];
      move_path.clear();
      CopyCPGrid();
                           //mark failed CP as non-source
      CM_DEBUG("marking CP not to be source");
      cp_grid[failed_i].valid_source=false;

      b = FindPath(curr_pos, dest_pos, root, cp_type);
   }else{
      int fi, ti, failed_i;
      if(curr_indx>=move_path.size()){
         if(move_path.size()<2)
            return false;
         if(curr_indx>move_path.size())   //shouldn't happen, but does :( (no time to find out why)
            return false;

         fi=move_path[curr_indx-2];
         failed_i=move_path[curr_indx-1];
      }else{
         fi=move_path[curr_indx-1];
         failed_i=move_path[curr_indx];
      }
      ti=move_path[move_path.size()-1];

      move_path.clear();

      CopyCPGrid();
                           //remove failed connection
      CM_DEBUG("removing failed connection");
      cp_grid[fi].DisConnect(failed_i);
      cp_grid[failed_i].DisConnect(fi);

      b = FindPath(mission.GetCheckpoints(), mission.NumCheckpoints(), fi, ti);
   }
   if(b){
      curr_indx=0;
      next_dst = mission.GetCheckpoints()[move_path[0]]->GetPos();
      last_skipped=false;
      skip_disable_count=0;
      last_sc_test_pos = curr_pos;
      //last_cp_test_pos = curr_pos;
      next_cp_seen_count = 0;
      //no_next_cp_seen_time = 0;
      last_sc_test_time=0;
      test_cp_phase = 0;
      first_run=true;
      return true;
   }
   CM_DEBUG("can't recompute, quitting");
   //done=true;
   return false;
}

//----------------------------
//----------------------------

class C_follow_formation: public C_unknown{
   dword GetID() const{
      dword id = 0;
      for(int i=followers.size(); i--; ) id = Max(id, followers[i].id+1);
      return id;
   }
   void RotateDir(S_vector &ret, int indx){
      float a = Angle2D(S_vector2(ret.x, ret.z));
      float circle_angle = GetPI2()/(followers.size()+1);   //one part for master
      a += circle_angle*(followers[indx].id+1);
      ret.x = -sin(a);
      ret.z = cos(a);
   }
public:
   enum E_look_mode{
      LM_FORWARD,
      LM_CIRCLE
   };

   LPC_actor master;
   struct S_follower{
      LPC_actor act;
      dword id;
      bool active;
      E_look_mode look_mode;
      int mode_count;

      S_follower():
         look_mode(LM_FORWARD),
         //mode_count(700+Random(700)),
         mode_count(700 + S_int_random(700)),
         active(true)
      {}
      void ResetLookMode(){
         look_mode = LM_FORWARD;
         //mode_count = 8000 + Random(4000);
         mode_count = 8000 + S_int_random(4000);
      }
      void Tick(int time){
         if(mode_count && (mode_count -= time) <= 0){
            mode_count = 0;
            look_mode=LM_CIRCLE;
         }
      }
   };
   vector<S_follower> followers;
   enum E_reaction_mode{
      RM_FIGHT,
      RM_QUIET,
   } reaction_mode;

   void AddFollower(LPC_actor f){
      dword id = GetID();
      followers.push_back(S_follower());
      followers.back().act = f;
      followers.back().id = id;
   }

   int FollowerIndx(LPC_actor f) const{
      for(int i=followers.size(); i--; ) if(followers[i].act==f) break;
      return i;
   }

   bool RemoveFollower(LPC_actor f){
      int i = FollowerIndx(f);
      if(i==-1) return false;
      //followers.fast_erase(i);
      followers[i] = followers.back(); followers.pop_back();
      return true;
   }

   S_vector GetPosition(int indx){
      S_vector pos = master->GetFrame()->GetWorldPos();
      S_vector mdir = master->GetFrame()->GetWorldDir();
                              //get center of circle
      float frad = tab_game_cfg->ItemF(TAB_F_GAME_AI_FOLLOW_CIRCLE_RAD);
      pos -= mdir * frad;
                              //get our man's
      RotateDir(mdir, indx);
      pos += mdir * frad;
      return pos;
   }

   S_vector GetDirection(int indx){
      S_vector ret = master->GetFrame()->GetWorldDir();
      if(followers[indx].look_mode==LM_CIRCLE){
         RotateDir(ret, indx);
      }
      return ret;
   }
   void Tick(int time, int indx){
      followers[indx].Tick(time);
   }

   C_follow_formation():
      master(NULL),
      reaction_mode(RM_FIGHT)
   {
   }
};

typedef C_follow_formation *LPC_follow_formation;

//----------------------------

/*
enum E_FOLLOW_MODE{
   CMD_FOLLOW_WATCH, CMD_FOLLOW_RUN, CMD_FOLLOW_WALK
};
*/

class S_command{
                              //PRG_MOVE, other path-finding modes
   C_movement *movement;

                              //subject for: ATTACK, USE,
   LPC_actor subject;
   friend class C_player;
public:

   union U_dummy{
      void Clear(){
         memset(this, 0, sizeof(U_dummy));
      }

      float f;
      int i;
      struct{                 //PRG_WALK_CP
         LPC_checkpoint cp_dest, cp_next;
         bool walk_cp_run;
      };
                              //PRG_MOVE
      struct{
         bool run, force_smart;
         E_MOVE_REASON move_reason;
         int subj_seen_count; //counter for checking if subject is seen - it's used with move_reason
      };

                              //PRG_FOLLOW
      struct{
         bool follow_turn;
         int follow_sm_delay;
         LPC_follow_formation follow_form;
         bool follow_init;
      };
                              //PRG_STAY_???
      bool stay_processed;

                              //PRG_PRG1
      bool prg1_bool;

                              //PRG_GUARD
      struct{
         bool guard_good_aim;
         bool guard_is_turning;
         bool guard_dest_set; //true if guard destination specified (in dest)
         LPC_checkpoint guard_aim_dest;

         int aim_count;
         int guard_count;     //how long to guard (0 = forever)
         float guard_aim_dest_v[3];
         bool guard_aim_dest_set;   //true if guard aim destination specified (in guard_aim_dest_v)
      };

                              //PRG_STEP
      struct{
         int step_counter;
         float step_dest[3];  //used as S_vector
         float step_dir[3];   //used as S_vector
         float step_min_dist;
         byte step_phase;     //0 - turn to dir, 1 - go to dest
         bool step_dir_set;
         bool step_is_turning;
         bool step_run;
      };
                              //PRG_SETVISIBLE
      bool setvisible_status;

      struct{                 //PRG_ATTACK
         int no_sub_seen_count;
         bool is_turning;
         int enm_body_part_index;   //body part of enemy we're attacking
         E_ATTACK_MODE attack_mode;
         int no_hit_count;    //counter how many times we didn't hit enemy, so that we can adjust position
      };
      struct{                 //PRG_WAIT_SIGNAL
         int wait_signal_id;
      };
      struct{                 //PRG_SEND_SIGNAL
         int send_signal_id;
      };

      struct{                 //PRG_USE_INV
         short use_inv_id;
         word change_phase;
      };
                              //PRG_SUSPEND
      int suspend_count;

                              //PRG_USE
      struct{
         int use_no_sub_seen_count;
         int use_reserve_indx;   //-1 = try all possible use positions
         bool use_pending;       //network progress...
         float min_use_dist;
      };

      struct{                 //PRG_WATCH
         float base_dest[3];  //used as S_vector
         float curr_dest[3];
         int phase_count;
         int idle_count;
         bool aim_ok, is_turning;
      } watch;
                              //PRG_LADDER_CLIMB
      struct{
         bool ladder_climb_up;
      };

      struct{                 //PRG_DRIVE
         byte braking;        //0=false, must set both 1(forward) and 2(backward) bits in order to succeed
         bool last_dir_backward;
         int last_dir_count;
         int drive_ideal_speed;     //0 = default
      };
   } sub_param;

   E_PRG_ITEM prg_item;


                              //proposed values
   S_vector dest;
   int process_time;          //time which will take this cmd to proceed
   E_STAY_MODE stay_mode;


   int pause_time;            //time to pause since last cmd finished
   int data;

   S_command():
      movement(NULL),
      subject(NULL),
      pause_time(0), process_time(1000),
      prg_item(PRG_LAST),
      stay_mode(SM_NULL),
      data(0)
   {
      sub_param.Clear();
   }
   ~S_command(){
      if(movement)
         delete movement;

      switch(prg_item){
      case PRG_USE:
         if(subject) subject->Release();
         break;
      case PRG_FOLLOW:
         if(sub_param.follow_form) sub_param.follow_form->Release();
         break;
      }
   }
   S_command(const S_command&);
   S_command &operator =(const S_command&);

   const t_move_path *GetMovePath() const{ return &movement->move_path; }
   inline void SetMovement(C_movement *mv){ movement = mv; }
   inline C_movement *GetMovement() const{ return movement; }
   inline LPC_actor SetSubject(LPC_actor a){ return(subject=a); }
   inline LPC_actor GetSubject() const{ return subject; }

/*--------------------------------------------------------
   Compute approx. time to proceed command.
--------------------------------------------------------*/

   void CompProcessTime(S_command *prev = NULL){

      int time=5000;
      switch(prg_item){
                              //known times
      case PRG_MOVE:
         if(movement){
                              //get approx distance
            float dist = movement->GetLength();
                              //get movement speed
            bool run = sub_param.run;
            LPS_vector spd = (LPS_vector)&tab_human_anim->ItemF(TAB_F_ANI_SPEEDX,
               (POSE_MOVE_FORWARD | (run ? POSE_ACCEL : 0) + stay_base[stay_mode]));
            float speed = spd->Magnitude();
            speed = Max(speed, .05f);
            time = dist*500.0f/speed;
         }
         break;

      case PRG_STAY_UP:
      case PRG_STAY_MID:
      case PRG_STAY_DOWN:
         if(prev && prev->stay_mode==stay_mode)
            time=1000;
         else
            time = 1500;
         break;

      case PRG_USE:
         time = 1500;
         break;

      case PRG_USE_INV:
         time = 1500;
         break;
                              //unknown times
      case PRG_FOLLOW:
      case PRG_GUARD:
         time = 5000;
         break;

      case PRG_ATTACK:
         time = 10000;
         break;
      default:
         time = 5000;
      }
      process_time = time;
   }
};

//----------------------------
//----------------------------
                              //C_human

                              /*
static const C_string body_part_names[] = {
   "Trup", "Hrud", "krk", "Hlva", "RamL", "LktL", "DlnL", "RamR",
   "LktR", "DlnR", "gun", "SthL", "LtkL", "ChdL", "SthR", "LtkR",
   "ChdR"
};
*/
static const struct S_body_part_name{
   const char *name;
   int size;
} body_part_names[] = {
   "Trup", 4,
   "Hrud", 4,
   "krk", 3,
   "Hlva", 4,

   "RamL", 4,
   "LktL", 4,
   "DlnL", 4,
   "RamR", 4,

   "LktR", 4,
   "DlnR", 4,
   "gun", 3,
   "SthL", 4,

   "LtkL", 4,
   "ChdL", 4,
   "SthR", 4,
   "LtkR", 4,

   "ChdR", 4,
};

static const char *body_part_names1[] = {
   "Trup*", "Hrud*", "krk*", "Hlva*", "RamL*", "LktL*", "DlnL*", "RamR*",
   "LktR*", "DlnR*", "gun*", "SthL*", "LtkL*", "ChdL*", "SthR*", "LtkR*",
   "ChdR*"
};

typedef class C_human *LPC_human;

//----------------------------

static const char tab_prg_enum[] =
   "<empty>\0"
   "MOVE\0"
   "FOLLOW\0"
   "USE\0"
   "USE_INV\0"
   "ATTACK\0"
   "GUARD\0"
   "WATCH\0"
   "STAY_UP\0"
   "STAY_MID\0"
   "STAY_DOWN\0"
   "RESTART\0"
   "PRG1\0"
   "WALK CP\0"
   "WAIT SIGNAL SUSPENDED\0"
   "SETVISIBLE\0"
   "SUICIDE\0"
   "DRIVE\0"
   "SEND SIGNAL\0"
   "WAIT SIGNAL\0"
;

                              //template
C_table_template templ_hum_prop = {
   // {7A7622E0-43E5-11d2-9B9E-004F4905FF1A}
   { 0x7a7622e0, 0x43e5, 0x11d2, { 0x9b, 0x9e, 0x0, 0x4f, 0x49, 0x5, 0xff, 0x1a } },
   "Human properties",
   NULL,
   {
      {TE_BRANCH, 0,  "AI", 11},
         {TE_ENUM, TAB_E_AI_ENABLED,  "Enabled", (dword)ENUM_AI_NOYES},
         {TE_ENUM, TAB_E_AI_LISTEN,  "Listen", (dword)ENUM_AI_NOYES},
         {TE_ENUM, TAB_E_AI_HUNT,  "Hunt enemy...", (dword)ENUM_AI_NOYES},
         {TE_FLOAT, TAB_F_AI_HUNT_MAX_DIST,  "... up to max distance"},
         {TE_ENUM, TAB_E_AI_SEARCH_DEAD,  "Search dead", (dword)ENUM_AI_NOYES},
         {TE_ENUM, TAB_E_AI_SEARCH_HEARD,  "Search heard", (dword)ENUM_AI_NOYES},
         {TE_FLOAT, TAB_F_AI_WATCH_MAX_DIST,  "Watch distance"},
         {TE_INT, TAB_I_AI_SHOOT_QUALITY,  "Shoot quality %"},
         {TE_FLOAT, TAB_F_AI_MIN_SHOOT_DIST,  "Min. shoot distance"},
         {TE_INT, TAB_I_AI_REACTION,  "Reaction %"},
         {TE_INT, TAB_I_AI_ENDURANCE,  "Endurance %"},

      //{TE_BRANCH, 0,  "General", 2, (dword)"\"%[0]\",\"%[1]\",\"%[2]\""},
      {TE_BRANCH, 0,  "Character", 5},
         {TE_INT, TAB_I_HUM_BAR1_SHOOTING, "Shooting", 0, 100, 75},
         {TE_INT, TAB_I_HUM_BAR2_REACTION, "Reaction", 0, 100, 75},
         {TE_INT, TAB_I_HUM_BAR3_STEALTH, "Stealth", 0, 100, 75},
         {TE_INT, TAB_I_HUM_BAR4_STRENGTH, "Strength", 0, 100, 75},
         {TE_INT, TAB_I_HUM_BAR5_ENDURANCE, "Endurance", 0, 100, 75},
         /*
         {TE_ARRAY, TAB_I_HUM_AUTO_ITM_ID, "Auto-setup items", 8},
            {TE_BRANCH, TAB_I_HUM_AUTO_ITM_ID,  NULL, 2, (dword)"ID=%[0], Amount=%[1]"},
               {TE_INT, TAB_I_HUM_AUTO_ITM_ID, "Item ID"},
               {TE_INT, TAB_I_HUM_AUTO_ITM_AMNT, "Amount"},
               */
      {TE_BRANCH, 0,  "Face/voice", 3},
         {TE_INT, TAB_I_ENM_GROUP,  "Enemy group"},
         {TE_BRANCH, 0,  "Face", 2, (dword)"%[0]"},
            {TE_INT, TAB_I_HUM_FACE,  "Face", 0, 50},
            {TE_BOOL, TAB_B_HUM_FACEMASK,  "Masked"},
            //{TE_INT, TAB_I_HUM_CARRIAGE,  "Carriage", 0, 100, 25},
         {TE_INT, TAB_I_HUM_VOICE,  "Voice ID"},
         //{TE_ENUM, TAB_E_HUM_UNIFORM_ID,  "Uniform", (dword)"Sas (white)\0Sas\0Civil\0German\0"},

      {TE_ARRAY, 0,  "Program", 16},
         {TE_BRANCH, 0,  "Item", 3, (dword)"%[0]"},
            {TE_ENUM, TAB_E_HUM_PRG_ITEM,  "Item", (dword)tab_prg_enum},
            {TE_STRING, TAB_S18_HUM_PRG_SUBJ_NAME, "Subject/CP0", 18},
            {TE_BRANCH, 0,  "Advanced data", 3},
               //{TE_STRING, TAB_S18_HUM_PRG_CP0, "Checkpoint", 18},
               {TE_STRING, TAB_S18_HUM_PRG_CP1, "Checkpoint 1", 18},
               //{TE_STRING, TAB_S18_HUM_PRG_SIGMASK, "Signal mask", 18},
               {TE_BOOL, TAB_B_HUM_PRG_SHOWON, "Visibility / Run"},
               {TE_INT, TAB_I_HUM_PRG_INV_ID, "ID / Count"},

      {TE_ARRAY, 0,  "Inventory", 10},
         {TE_BRANCH, 0,  "Item", 2, (dword)"%[0] (%[1])"},
            {TE_INT, TAB_I_HUM_INV_LIST,  "Item #", 0, 32},
            {TE_INT, TAB_I_HUM_INV_AMOUNT,  "Amount", 0, 0, 1},
      /*
      {TE_BRANCH, 0,  "AI", 2},
         {TE_INT, TAB_I_HUM_AI_WATCH_DIST, "Watch distance"},
         {TE_INT, TAB_I_HUM_AI_FORCE_DELAY, "Force shoot delay"},
         */

      {TE_NULL}
   }
};

//----------------------------

bool LoadSoldierTable(LPC_table tab, int man_indx){

   //C_fstring str("tables\\soldiers.%i\\%.2i.tab", game_configuration.datadisk_ver, man_indx+1);
   C_fstring str("tables\\soldiers\\%.2i.tab", man_indx+1);
   tab->Open((dword)&templ_hum_prop, TABOPEN_TEMPLATE);
   bool b = tab->Open((dword)(const char*)str, TABOPEN_FILENAME | TABOPEN_UPDATE);
   if(!b){
      ErrReport(C_fstring("Can't open table %s", (const char*)str), editor);
   }
   return b;
}

//----------------------------

struct C_collision_context{

   LPC_human tested_human;
   bool col_floor;    //current floor frame we're colliding with
   C_smart_ptr<I3D_frame> col_frame;
   dword num_coll_walls;      //number of walls we're colliding with
   S_vector wall_normal;
   bool is_idle;
   //bool head_in_water;      //(10.12.01)comment_out - not used. note:actually head collision can' be detected by this way 'cos face which was rejected (by feet) is no more responsed (by other sphere)
   int col_mat_id;            //set to mat_id of floor, if detected
   bool head_collide;

   C_collision_context(LPC_human th):
      tested_human(th),
      col_floor(false),
      num_coll_walls(0),
      //head_in_water(false),
      col_mat_id(-1),
      head_collide(false)
   {}
};

#ifdef EDITOR
# define AI_DEBUG(n)
//# define AI_DEBUG(n) OUTTEXT(n)
#else
 #define AI_DEBUG(n)
#endif

//#define MIN_USE_DISTANCE   8.0f
#define MIN_USE_DISTANCE   15.0f


//----------------------------

static int BodyPartIndex(const char *name){

   for(int i=0; i<17; i++){
      if(!strncmp(name, body_part_names[i].name, body_part_names[i].size))
         return i;
   }
   return -1;
};

//----------------------------
struct S_anim_info{
   int anim_id;
   dword type;
   int blend_time, cntdown;
   bool running;
   S_anim_info(): anim_id(-1),
      type(0), blend_time(0), cntdown(0), running(false)
   {}
};

struct S_anim_manager{
   S_anim_info stages[MAX_ANIM_STAGE+1];
   int main_stage; //where main anim running; obviously 1, sometimes 2 - when need blend with leaving anim which not fully blended
   int low_stage;  //this is last stage for blendin, we do not move anims more down.
private:

   // Move anim from stage to stage-1, anim from stage is removed.
   // Anim on stage 0 is modified to not blend mode.
   inline void MoveStageDown(int stage, PI3D_model model){

      assert(stage > 0);
      int lower_stage = stage - 1;
                              //remove anim from stage where we going to
      model->StopAnimation(lower_stage);

#ifdef REDUCE_ENEMY_ANIMS
      if(stage <= low_stage)
         return;
#endif

      stages[lower_stage] = stages[stage];
                              //ajust contdown to make make more weight older anim against new, when played at same time.
                              //removed - very small effect, visible only in zero time tick.
      //stages[lower_stage].cntdown = Max(0, stages[lower_stage].cntdown - (int)(stages[lower_stage].blend_time * .1f));
                           //move anim down (if any)
      const PI3D_interpolator *intps = model->GetInterpolators();
      for(int i=model->NumInterpolators(); i--; ){
         PI3D_interpolator intp = intps[i];
         PI3D_animation_base ab = intp->GetAnimation(stage);
         if(ab){
            int opt = intp->GetOptions(stage);
            //if(!lower_stage)
            if(lower_stage == low_stage)
               opt &= ~I3DANIMOP_BLEND; //blend only on higher level
            else              //make sure that higher stages will blend.
               opt |= (I3DANIMOP_ROT_BLEND | I3DANIMOP_POS_BLEND); //blend only pos and rot, scale is used for notify and has not correct tracks.

            intp->SetAnimation(lower_stage, ab, opt, 1.0f, 1.0f, .0f); //stop anim on time when moved down(speed 0)
            dword c_time = intp->GetCurrTime(stage);
            intp->SetCurrTime(lower_stage, c_time);
            intp->SetAnimation(stage, NULL); //remove from current stage
         }
      }
   }
public:
   S_anim_manager():
      main_stage(MAX_ANIM_STAGE),
      low_stage(0)
   {}

   //New played animation reside on main_stage, when oher one is played all stages are move
   //down by one, and faded out by blend time.
   void PlayAnim(PI3D_animation_set anim, int blend_time, dword type, int id, PI3D_model model){

      //PR_BEG;
      assert(model);
      //assert(main_stage == MAIN_ANIM_STAGE);
      //for(int j = 1; j <= main_stage; j++)
      for(int j = low_stage+1; j <= main_stage; j++)
         MoveStageDown(j, model);

      bool loop = !(type==ANIM_SIMPLE || type==ANIM_FULL);
      bool old_loop = !(stages[main_stage - 1].type != ANIM_SIMPLE) && (stages[main_stage - 1].type != ANIM_FULL);
                              //determine time (ratio) in previous anim
                              //find any interpolator using that
      int lower_stg = main_stage - 1;
      float prev_ratio = 0.0f;
      if(loop && old_loop){
         const PI3D_interpolator *intps = model->GetInterpolators();
         for(int i=model->NumInterpolators(); i--; ){
            PI3D_interpolator intp = intps[i];
            dword t = intp->GetCurrTime(lower_stg);
            if(t){
               prev_ratio = (float)t / (float)intp->GetEndTime(lower_stg);
               break;
            }
         }
      }
                              //setup new anim
      int opts = loop ? I3DANIMOP_LOOP : 0;
                              //blend only pos and rot, scale is used for notify and has not correct tracks.
      opts |= I3DANIMOP_ROT_BLEND | I3DANIMOP_POS_BLEND | I3DANIMOP_KEEPDONE;

      model->SetAnimation(main_stage, anim, opts, 1.0f, blend_time ? 0.0f : 1.0f);

      SetBlendFactor(main_stage, blend_time ? 0.0f : 1.0f, model); //override turn pose bug - set only wahat really need blend
      stages[main_stage].blend_time = stages[main_stage].cntdown = blend_time;
      stages[main_stage].running = true;
                              //update info about current anim
      stages[main_stage].anim_id = id;
      stages[main_stage].type = type;
                     //sync this anim's time with previous anim
      if(prev_ratio!=0.0f){
         int set_time = (float)anim->GetTime() * prev_ratio;
         const PI3D_interpolator *intps = model->GetInterpolators();
         for(int i=model->NumInterpolators(); i--; ){
                     //set interpolator stage time (ignored if stage is not active)
            intps[i]->SetCurrTime(main_stage, set_time);
         }
      }
      //PR_END;
                              //FIXME: jerk HECK
                              //this update is neccessary for remove anims jerk when more then one is played at one tick.
                              //for some reason PlayAnim produce different model state then anim_manager,
                              //so we tick it here for now to hide this difference user.
      Tick(0, model); 
   }

//----------------------------
//Used only in censored version where model is changed to bag. 
   void StopAllStages(){
      for(int j = 0; j <= main_stage; j++){
         stages[j].running = false;
         stages[j].cntdown = 0;
      }
   }

//----------------------------

   void ApplyAnim(PI3D_animation_set anim, int blend_time, dword type, int id, PI3D_model model, dword mask = 3){

      assert(model);
      //assert(main_stage == MAIN_ANIM_STAGE);

      for(int j = 0; j <= main_stage; j++){
         if(j == main_stage){
            assert(j != 0);
            MoveStageDown(j, model);
         }
         else
            model->StopAnimation(j);
      }
   
      for(int i = anim->NumAnimations(); i--; ){
         const char *al = anim->GetAnimLink(i);

         if((mask&3) != 3){
                                 //find out which part of body it is
            int j = BodyPartIndex(al);
            static const byte m[]={
               2, 1, 1, 1, 1, 1, 1, 1,
               1, 1, 1, 2, 2, 2, 2, 2,
               2
            };
            if(!(m[j]&mask)) continue;
         }

         PI3D_frame frm = model->FindChildFrame(al, ENUMF_ALL | ENUMF_USEMASK);
         if(!frm) continue;

         PI3D_animation_base ap = anim->GetAnimation(i);

                                 //find interpolator of this frame
         PI3D_interpolator aip;
         const PI3D_interpolator *intps = model->GetInterpolators();
         for(int k = model->NumInterpolators(); k--; )
         if(intps[k]->GetFrame()==frm){
            aip = intps[k];
            break;
         }
         if(k==-1){
                              //we don't have interpolator for this frame, create it
            aip = driver->CreateInterpolator();
            aip->SetFrame(frm);
            model->AddInterpolator(aip);
            aip->Release();
         }
                              //set animation 
         bool loop = !(type==ANIM_SIMPLE || type==ANIM_FULL);
         int opts = loop ? I3DANIMOP_LOOP : 0;
         opts |= I3DANIMOP_ROT_BLEND | I3DANIMOP_POS_BLEND | I3DANIMOP_KEEPDONE;

         bool low_anim = aip->GetAnimation(main_stage-1);
         aip->SetAnimation(main_stage, ap, opts, 1.0f, (blend_time && low_anim) ? 0.0f : 1.0f);
      }

      stages[main_stage].blend_time = stages[main_stage].cntdown = blend_time;
      stages[main_stage].running = true;
                           //update info about current anim
      stages[main_stage].anim_id = id;
      stages[main_stage].type = type;

   }

//----------------------------

   void Tick(int time, PI3D_model model){

      //PR_BEG;
      for(int i = main_stage; i>0; i--){
         float blend = 1.0f;
         if(stages[i].running){
            stages[i].cntdown = Max(0, stages[i].cntdown - time);
            int lower_stg = i - 1;
            if(!stages[i].cntdown){
               stages[i].running = false;
               assert(i); //ie lower_stg >= 0
               model->StopAnimation(lower_stg);
            }else{
               blend = stages[i].blend_time ? (float)stages[i].cntdown / stages[i].blend_time : .0f;
               blend = Max(.0f, Min(1.0f - blend, 1.0f));
            }
            SetBlendFactor(i, blend, model);
         }
      }

#if defined DEBUG_ANIMS //|| 1

      for(i = main_stage+1; i--; ){

         float blend = stages[i].blend_time ? (float)stages[i].cntdown / stages[i].blend_time : .0f;
         blend = Max(.0f, Min(1.0f - blend, 1.0f));
         DEBUG(C_fstring("stage %i running: %i, blend: %.2f, anim_id: %i, type: %i",
            i, stages[i].running, blend, stages[i].anim_id, stages[i].type));
      }
#endif
      //PR_END;
   }

   inline void SetBlendFactor(int stage, float blend, PI3D_model model){

      assert(model);
      assert(stage > 0);
      int lower_stage = stage-1;
      const PI3D_interpolator *intps = model->GetInterpolators();
      for(int i = model->NumInterpolators(); i--;){
         PI3D_interpolator intp = intps[i];
         bool stg0_anim = intp->GetAnimation(lower_stage);
         intp->SetBlendFactor(stage, stg0_anim ? blend : 1.0f);
      }
   }

   inline void SetLowStage(int new_stage_id, PI3D_model model){

      assert((new_stage_id >= 0) && (new_stage_id <= MAX_ANIM_STAGE));
                              //if reducing number of active stages, stop animations played beyond
      if(new_stage_id > low_stage){
         for(int i = low_stage; i < new_stage_id; i++){
            model->StopAnimation(i);
            stages[i].running = false;
            stages[i].cntdown = 0;
         }
      }
      low_stage = new_stage_id;
   }

};

//----------------------------

#ifdef KEEP_HUMAN_OUT_OF_WALL
struct S_spheres{
   bool valid;
   S_vector up_vol_pos;
   S_vector down_vol_pos;
   bool had_cam;
   S_vector cam_vol_pos;
   S_vector model_pos;
};
#endif

//----------------------------

class C_human: public C_actor, public C_inventory{
   C_smart_ptr<I3D_frame> floor_link;
   S_matrix m_floor;
   int barier_climb_count;
   bool force_model_tick;     //help for model ticking optimizator

#ifdef KEEP_HUMAN_OUT_OF_WALL

   PI3D_volume vol_up, vol_down;
   S_spheres spheres;

   static bool I3DAPI RepulseResponse(I3D_collision_data &cd){

      int mat_id = 0;
      switch(cd.GetHitFrm()->GetType()){
      case FRAME_VOLUME:
         {
            PI3D_volume vol = I3DCAST_VOLUME(cd.GetHitFrm());
                              //spheres easily raise human, rather skip.
                              //08.01.02:allow static spheres, many rocks use sphere aproximation.
            //if(vol->GetVolumeType() == I3DVOLUME_SPHERE)
            if((vol->GetVolumeType() == I3DVOLUME_SPHERE) && !(vol->GetFlags()&I3D_FRMF_STATIC_COLLISION))
               return false;
            mat_id = vol->GetCollisionMaterial(); break;
         }
      case FRAME_VISUAL:
         mat_id = I3DCAST_VISUAL(cd.GetHitFrm())->GetCollisionMaterial(); break;
      }
                              //ignore water
      if(mat_table->ItemB(TAB_B_MAT_WATER, mat_id)){
         return false;
      }
                              //ignore other humans - too hazardous, unexpected side effect can accure.
      if(mat_id == HUMAN_SPHERE_MAT)
         return false;
      driver->CollisionResponse(cd);
      return true;
   }

protected:

   void ResetSpheres(){

      //spheres.valid = (vol_up && vol_down);
      spheres.valid = (vol_up && vol_down && frame);
      if(!spheres.valid) return;
      spheres.model_pos = frame->GetWorldPos();
      spheres.up_vol_pos = vol_up->GetWorldPos();
      spheres.down_vol_pos = vol_down->GetWorldPos();
      spheres.had_cam = vol_cam;
      if(vol_cam)
         spheres.cam_vol_pos = vol_cam->GetWorldPos();
   }
private:

   bool CheckRepulseForce(const S_vector &from, PI3D_volume vol, S_vector &repulse){

      const S_vector &to = vol->GetWorldPos(); 
      float delta = (to - from).Magnitude();
      if(delta > MRG_ZERO){
         I3D_collision_data cd;
         cd.from = from;
         cd.dir = to - from;
#ifdef DEBUG_DRAW_REPULSE
         DebugLine(cd.from, cd.from + cd.dir, 0, 0xff00ffaf);
#endif
         cd.flags = I3DCOL_SPHERE;
         cd.radius = vol->GetWorldScale();
         if(!IsAlive())       //smaller volumes for dying, they fit better to floor.
            cd.radius *= .6f;
         cd.cresp_face = RepulseResponse;
         cd.frm_ignored = model;
         if(mission.GetScene()->TestCollision(cd)){
            //OUTTEXT(C_fstring("hit %s", cd.GetHitFrm()->GetName()));
            //DebugLine(to, cd.GetDestinationPos(), 0, 0xffff00ff);
            S_vector curr_repulse = cd.GetDestinationPos() - to;
#ifdef DEBUG_DRAW_REPULSE
            DebugLine(to, to + S_normal(curr_repulse), 0, 0xffff00ff);
#endif
            repulse += curr_repulse;
            return true;
         }
      }
      return false;
   }

   void PushHuman(const S_vector &push_dir){

      const S_vector &curr_pos = model->GetWorldPos();
#ifdef DEBUG_DRAW_REPULSE
      DebugLine(curr_pos, curr_pos + S_normal(push_dir), 0, 0xff0000ff);
#endif
      I3D_collision_data cd;
      cd.from = curr_pos;
      cd.dir = push_dir;
      cd.flags = I3DCOL_SPHERE_GROUP;
      cd.cresp_face = RepulseResponse;
      cd.frm_ignored = cd.frm_root = model;
      if(mission.GetScene()->TestCollision(cd)){
#ifdef DEBUG_DRAW_REPULSE
         DebugLine(curr_pos, cd.GetDestinationPos(), 0, 0xff0a0aff);
#endif
      }
      model->SetPos(cd.GetDestinationPos());
      model->Update();
   }

   void KeepHumanOutOfWall(){

      if(!spheres.valid) return;
                              //can' check spheres if human suddenly change position
                              //this is for unexpected opereatins, never should happen.
      float model_chage_dist = (spheres.model_pos - frame->GetWorldPos()).Magnitude();
      //static const float ALLOWED_POS_CHANGE  = MRG_ZERO;
      static const float ALLOWED_POS_CHANGE  = .1f;
      if(model_chage_dist > ALLOWED_POS_CHANGE){                               
         //OUTTEXT(C_fstring("KeepHumanOutOfWall: human moved (%.8f), ignoring test", model_chage_dist));
         return;
      }
      S_vector repulse_force;
      repulse_force.Zero();
      bool repulse(false);
                              //brest
      repulse |= CheckRepulseForce(spheres.up_vol_pos, vol_up, repulse_force);
                              //feets
      repulse |= CheckRepulseForce(spheres.down_vol_pos, vol_down, repulse_force);
                              //head: if human had camera last frame and still has it, chek also camera volume in head for better collision handling
                              //IsOn is only just for safe, we don't want check head if volume is off.
      if(spheres.had_cam && vol_cam && vol_cam->IsOn()){
         repulse |= CheckRepulseForce(spheres.cam_vol_pos, vol_cam, repulse_force);
      }
                              //push human back
      if(repulse){
         PushHuman(repulse_force);
      } 
   }

#endif
protected:

   PI3D_volume vol_cam;
   struct S_anim_manager anim_man;

                                 //current pose, used to adjust animations
   C_smart_ptr<I3D_animation_set> pset;
   struct  S_blend_info{
      int blend_time;
      int cntdown;
      dword anim_id;
      S_blend_info() : blend_time(0),
          cntdown(0),
          anim_id(0)
      {}
      inline float GetBlend(){
         return blend_time ? (float)cntdown / blend_time : .0f;
      }
      void Update(int time){
         if(cntdown){
            cntdown = Max(0, cntdown - time);
         }
      }
   } blend_info;
   struct S_anim_store{
      bool waiting;
      int id_to;
      bool force;
      bool sm_dependent;
      E_STAY_MODE stay_mode;
      S_anim_store(): waiting(false){}
   }anim_store;

   bool col_floor;

   LPC_table tab;
   dword face_id;

   S_vector move_dir;
   float fall_speed;
   int curr_pose;
   float turn_angle;          //relative
                              //free aiming
   PI3D_frame brest, frm_head;
   PI3D_visual vis_body;
   S_vector aim_dir, aim_fade_base;
   int aim_count;
   bool our_update;
   C_ease_interpolator aim_ease;

                              //network sync
                              //turn:
   byte net_sync_abs_turn;   //proposed network player dir
   byte net_sync_want_turn;  //abs turn angle where human should be
                              //pos:
   S_vector net_sync_pos;     //proposed network player pos
   S_vector net_sync_want_pos;//position where human should be
                              //aim dir:
   S_vector net_sync_aim_dir; //proposed network player aim dir
   S_vector net_sync_aim_want;//aim dir which should be
   int net_sync_aim_count;    //counter for forcing sending aim dir if it differs
   float net_sync_aim_fade_factor;  //proposed aim fade factor sent over network

   C_smart_ptr<C_net_sync> net_sync_grab;

   void TickGrabSync(){
      dword winner_pid;
      if(net_sync_grab->GetState(&winner_pid)==C_net_sync::SS_RESOLVED){
         if(winner_pid==net->GetPID()){
            assert(net_sync_grabber);
            bool b = net_sync_grabber->cbProc(CB_INV_GRAB, 0, (dword)this);
            if(b) SetUsingItem(net_sync_grabber, false);
                           //send grabber over net
            {
               const bool g = true;
               net_msg->Ascend(net_id);
               net_msg->AddBits(NM_HUMAN_GRAB_SYNC_USER, NET_ACTOR_CODE_BITS, g);
               net_msg->AddWord(using_item ? using_item->GetNetID() : NULL, g);
               net_msg->Descend();
            }
         }else{
            if(net_sync_grabber){
               net_sync_grabber->PlayAnimNet(POSE_RESET, false);
               net_sync_grabber = NULL;
            }
                           //wait for grabber
            net_sync_grab->Lock(true);
         }
         net_sync_grab->Reset();
      }
   }

   virtual void SetNetID(word id){

      net_sync_grab = CreateNetSync(id, NM_HUMAN_GRAB_SYNC, NET_ACTOR_CODE_BITS);
      net_sync_grab->Release();
      C_actor::SetNetID(id);
   }
   C_human *net_sync_grabber;//used in network game


   PI3D_model gun;
   C_smart_ptr<I3D_sound> gun_sound[2];  //exterier/interier

   //C_smart_ptr<C_actor> using_item;
   LPC_actor using_item;
   E_STAY_MODE stay_mode;
   int selected_inv_item;

   int throw_power;

   int shoot_cntdwn;
   bool falling;
   S_vector last_on_feet_pos; //for detecing death from falling
   int test_col_count;        //counter for testing collision - used when man is idle (= not moving)
   bool first_anim;           //true when created, to disable blend to 1st set anim
   bool relaxed_weapon_hold;
   int mine_field_ratio;      //0 means he's not in mine field

   C_smart_ptr<I3D_sound> voice;
                              //AI
   vector<S_command*> program;
   friend class C_enemy;
   bool prg_dirty;            //set when program modified in order to re-create menu icons
   bool cmd0_new;             //when set, P_rocessProgram prepares front command
   bool holding_fire;         //may get set only for C_player

   LPC_actor FindUseItem(int *use_indx = NULL);

//----------------------------

   void PrepareFrontCmd(int &dest_pose){
      if(program.size()){
         S_command &key = *program.front();
         static const bool rwh[]={
                              //PRG_MOVE
            false, false, false, false,
                              //PRG_ATTACK
            false, true, false, false,
                              //PRG_STAY_MID
            false, false, false, false,
                              //PRG_RESTART
            false, true, true, true,
         };
         bool nw =
            key.prg_item >= (sizeof(rwh)/sizeof(bool)) ? false :
            rwh[key.prg_item];
                              //adjust a bit
         switch(key.prg_item){
         case PRG_GUARD:      //dependent on if dest set
            if(key.sub_param.guard_aim_dest || !key.sub_param.guard_dest_set)
               //relaxed_weapon_hold = false;
               nw = false;
            key.sub_param.guard_good_aim = false;
            break;
         case PRG_MOVE:
            if(key.sub_param.move_reason==MR_WALK_CP)
               //relaxed_weapon_hold=true;
               nw=true;
            break;
         }
         if(relaxed_weapon_hold != nw){
            relaxed_weapon_hold = nw;
            dest_pose = POSE_RESET;
                              //send state change over net
            if(net && GetType()==ACTOR_ENEMY){
               net_msg->Ascend(net_id);
               net_msg->AddBits(NM_HUMAN_RELAXED_STAY, NET_ACTOR_CODE_BITS, true);
               net_msg->AddBits(relaxed_weapon_hold, 1, true);
               net_msg->Descend();
            }
         }
      }
   }

//----------------------------

   bool IsAnimated() const{

      if(model){
         const PI3D_interpolator *intps = model->GetInterpolators();
         for(int i = model->NumInterpolators(); i--; ){
            PI3D_interpolator intp = intps[i];
            assert(intp);
            if(intp->GetAnimation(anim_man.main_stage)){
               int end_time = intp->GetEndTime(anim_man.main_stage);
               int curr_time = intp->GetCurrTime(anim_man.main_stage);
               if(curr_time < end_time){
                  return true;
               }
            }
         }
      }
      return false;
   }

//----------------------------

   void StoreAnimToPlay(int id_to, bool force, bool sm_dependent){

      anim_store.stay_mode = stay_mode;
      anim_store.id_to = id_to;
      anim_store.force = sm_dependent;
      anim_store.sm_dependent = sm_dependent;
      anim_store.waiting = true;
   }

//----------------------------

   void PlayStoredAnim(){
      assert(anim_store.waiting);
      assert(anim_store.stay_mode == stay_mode);
      PlayAnim(anim_store.id_to, anim_store.force, anim_store.sm_dependent);
      anim_store.waiting = false;
   }

//----------------------------

   void SetUsingItem(LPC_actor a, bool net_send = false){
      using_item = a;
      if(net && net_send){
#ifndef ENEMY_NET_SYNC_INV
                              //alive enenies do not send this
         if(GetType()!=ACTOR_PLAYER && stay_mode!=SM_DEAD)
            return;
#endif
         const bool g = true;
         net_msg->Ascend(net_id);
         net_msg->AddBits(NM_HUMAN_SET_USING_ITEM, NET_ACTOR_CODE_BITS, g);
         net_msg->AddWord(a ? a->GetNetID() : 0, g);
         net_msg->Descend();
      }
   }

//----------------------------

   bool ActorColResp(I3D_collision_data &cd, C_collision_context &cc){

      bool stairs;

      int mat_id = 0;
      switch(cd.GetHitFrm()->GetType()){
      case FRAME_VOLUME: 
         mat_id = I3DCAST_VOLUME(cd.GetHitFrm())->GetCollisionMaterial(); break;
      case FRAME_VISUAL:
         mat_id = I3DCAST_VISUAL(cd.GetHitFrm())->GetCollisionMaterial(); break;
      }
      assert(mat_id < MAX_MATERIALS);
      if(mat_id>=MAX_MATERIALS)
         mat_id = 0;
      if(mat_id==40){   //callback
         LPC_actor a = (LPC_actor)cd.GetHitFrm()->GetData();
         assert(a);
         if(a)
            a->cbProc(CB_COLLISION, (dword)this);
      }

      switch(mat_table->ItemE(TAB_E_MAT_KILL, mat_id)){
      case 0:
         break;
      case 2:                    //water
         cc.tested_human->cbProc(CB_DIE_DROWN);
         break;
      case 3:                    //minefield
         cc.tested_human->cbProc(CB_SET_MINE_FIELD_RATIO, 20);
         break;
      case 4:                    //trow-out
         //cc.tested_human->cbProc(CB_DIE_THROW_OUT); //18.12.comment out
         cc.tested_human->cbProc(CB_DIE, -1);
         break;
      default:
         cc.tested_human->cbProc(CB_DIE, -1);
      }
      if(mat_table->ItemB(TAB_B_MAT_WATER, mat_id)){
         return false;
      }
      stairs = mat_table->ItemB(TAB_B_MAT_STAIRS, mat_id);

      const S_vector &limit_normal = cd.GetHitNormal();
      float fabs_y = fabs(limit_normal.y);

      
      cc.head_collide = (vol_cam && (vol_cam == cd.GetVolumeSource()));

      if(fabs_y >= tab_game_cfg->ItemF(TAB_F_GAME_WALL_Y_THRESH) || (stairs && limit_normal.y>=.2f)){

         if(limit_normal.y<0.0f){

            driver->CollisionResponse(cd);
            return true;
         }
         cc.col_frame = cd.GetHitFrm();
         cc.col_floor = (bool)cd.GetHitFrm();
         cc.col_mat_id = mat_id;

         if(!cc.is_idle){
            driver->CollisionResponse(cd);
            return true; 
         }
                              //adjust plane's normal
         cd.SetHitNormal(S_vector(.0f, 1.0f, .0f));
         driver->CollisionResponse(cd);
      }else{                  //this is considered to be wall
         ++cc.num_coll_walls;
                              //consider this wall
         //OUTTEXT(cd.GetHitFrm()->GetName());
         //DebugLine(cd.from, cd.from + limit_normal, 0, 0xff00ff00);
         S_vector n = limit_normal;
         if(limit_normal.y < .0f)
         {
                              //make this absolutely vertical
            n.y = 0.0f;
            n.Normalize();
            cd.SetHitNormal(n);
         }
         if(cc.num_coll_walls==1)
            cc.wall_normal = n;

         driver->CollisionResponse(cd);
         return true;
      }
      return true; 
   }

//----------------------------

   static bool I3DAPI ActorColResp_thunk(I3D_collision_data &cd){

      C_collision_context *cs = (C_collision_context*)cd.cresp_context;
      assert(cs);
      return cs->tested_human->ActorColResp(cd, *cs);
   }

//----------------------------

   bool ChangeFace(int id, bool masked){

      return false;
                                 //create texture
      C_fstring name("faces\\xn%s%.2i.png", masked ? "m" : "", id);
      I3D_CREATETEXTURE ct;

      ct.flags = TEXTMAP_DIFFUSE;
      ct.text_name = name;

      PI3D_texture tp;
      driver->CreateTexture(&ct, &tp);
      if(tp){
         PI3D_visual vis_base = I3DCAST_VISUAL(frame->FindChildFrame("Trup*", ENUMF_VISUAL | ENUMF_USEMASK));
         CPI3D_mesh_base mb = NULL;
         if(vis_base)
            mb = vis_base->GetMesh();

         if(mb){
            PI3D_visual vis = driver->CreateVisual(vis_base->GetVisualType());
            while(vis_base->NumChildren()){
               vis_base->GetChild(0)->LinkTo(vis);
            }
            vis->LinkTo(vis_base->GetParent());
            vis->Duplicate(vis_base);
            
            model->DeleteFrame(vis_base);
            model->AddFrame(vis);
            vis->Release();
         }else{
            ReportActorError("cannot find base mash");
         }
         /*
         for(int p_i=0; p_i<2; p_i++){
            static const char *part_name[]={"Hlva*", "krk*"};
            PI3D_frame frm = frame->FindChildFrame(part_name[p_i], ENUMF_VISUAL | ENUMF_USEMASK);
            if(!frm)
               continue;
            PI3D_object part = I3DCAST_OBJECT(frm);
                           //make mesh unique
            PI3D_mesh_object mo1, mo = driver->CreateMesh();
            mo1 = part->GetMeshObject();
            mo->Duplicate(mo1);
            part->SetMeshObject(mo);
            mo->Release();
                           //process all LODs
            for(int i = mo->NumLevels(); i--; ){
                           //make LOD unique
               PI3D_mesh_level ml1(mo->GetLOD(i)), ml(driver->CreateMeshLevel());
               ml->Duplicate2(ml1);
               mo->SetLOD(ml, i);
               ml->Release();

               PI3D_material mp;
               PI3D_face_group fg;
               for(int j = ml->NumFGroups(); j--; ){
                  fg = ml->GetFGroup(j);
                  mp = fg->GetMaterial();
                  C_string name = mp->GetName();
                  if(name.Match("face*")) break;
               }
               if(j!=-1){
                  PI3D_material mp1 = driver->CreateMaterial();
                  mp1->Duplicate(mp);
                  mp1->SetTexture(tp);
                  fg->SetMaterial(mp1);
                  mp1->Release();
               }else{
                  ReportActorError("cannot find face material 'face*'");
               }
            }
         }
         */
         tp->Release();
         return true;
      }
      return false;
   }

//----------------------------

   void ApplyAimDir(){

      S_quat q;
      q.SetDir(aim_dir, 0.0f);

      switch(pset->NumAnimations()){
      case 1:
         {
            if(stay_mode==SM_LAY){
               float a = Angle2D(S_vector2(0, 1), S_vector2(aim_dir.x, aim_dir.z));
               S_matrix m;
               m.SetDir(S_vector(0, aim_dir.y, 1), a);
               S_quat q1;
               //q.Make(m);
               q = S_quat(m);
            }
            PI3D_anim_pose pose = (PI3D_anim_pose)pset->GetAnimation(0);
            pose->SetRot(&q);
         }
         break;
      case 5:
         {
            static S_quat qz(S_vector(0, 0, 1), 0);
            S_quat q_3 = qz.Slerp(q, .333f);
            for(int i=0; i<3; i++){
               PI3D_anim_pose pose = (PI3D_anim_pose)pset->GetAnimation(i);
               pose->SetRot(&q_3);
            }
            S_quat q_2 = qz.Slerp(q, .5f);
            for(; i<5; i++){
               PI3D_anim_pose pose = (PI3D_anim_pose)pset->GetAnimation(i);
               pose->SetRot(&q_2);
            }
         }
         break;
      }
      if(mission.game_cam.GetFocusDir()==frame)
         mission.game_cam.SetDeltaDir(aim_dir);
      force_model_tick = true;
   }

//----------------------------

   void FreeAimFade(int time, bool count_down = true, float count_factor = 1.0f, bool net_send = true){

      if(aim_count){
         if(count_down){
            if(aim_count>=AIM_FADE_TIME){
               aim_count -= Max(1, int(time*count_factor));
                              //network support - send start of fade
               if(aim_count<AIM_FADE_TIME){
                  aim_fade_base = aim_dir;

                  if(net && net_send){
                              //check if it's worth to send
                     float a = aim_dir.AngleTo(S_vector(0.0f, 0.0f, 1.0f));
                     if(a >= PI*.1f){

                        //bool g = true;
                        bool g = false;
                        net_msg->Ascend(net_id);
                        net_msg->AddBits(NM_HUMAN_AIM_DIR, NET_ACTOR_CODE_BITS, g);
                        net_msg->AddBits(1, 1, g);
                        bool cf_def = (!count_factor || count_factor==1.0f);
                        net_msg->AddBits((!cf_def), 1, g);
                        if(!cf_def) net_msg->AddFloat(count_factor, g);
                        net_msg->Descend();
                     }
                  }
               }
            }else{
               aim_count -= time;
            }
            if(aim_count<=0){
               aim_count = 0;
               aim_dir = S_vector(0.0f, 0.0f, 1.0f);
            }else
            if(aim_count < AIM_FADE_TIME){
               float f = (float)aim_count / (float)AIM_FADE_TIME;
               aim_dir = S_vector(0, 0, 1) +
                  (aim_fade_base-S_vector(0.0f, 0.0f, 1.0f)) * aim_ease[f];
            }
         }
         ApplyAimDir();
      }
   }

   void ResetAim(){
      aim_count = Min(aim_count, AIM_FADE_TIME);
   }

   void ClearAimDir(){
      aim_count = 0;
      aim_dir = S_vector(0.0f, 0.0f, 1.0f);
      ApplyAimDir();
      net_sync_aim_dir = net_sync_aim_want = aim_dir;
      net_sync_aim_count = 0;
   }

//----------------------------

#define AIM_SPEED PI
   virtual void SetAimDir(const S_vector &dir, int time, bool net_send = true){

      if(time){               //limit by time
         float a = dir.AngleTo(aim_dir);
         float tsec = (float)time*.001f;
         if(a < AIM_SPEED*tsec){
            aim_dir = dir;
         }else{
            float f = (AIM_SPEED*tsec)/a;
            aim_dir = (aim_dir*(1.0f-f) + dir*f/dir.Magnitude());
            aim_dir.Normalize();
         }
      }else
         aim_dir = dir;

      if(net_send){
         aim_count = AIM_COUNT;
                              //network support
         if(net){
                              //check if it differs by some value
            float delta = net_sync_aim_dir.AngleTo(aim_dir);
            float thresh = PI*.05f;
            if(delta > thresh){
               net_sync_aim_dir = net_sync_aim_want = aim_dir;
               bool g = false;
               net_msg->Ascend(net_id);
               net_msg->AddBits(NM_HUMAN_AIM_DIR, NET_ACTOR_CODE_BITS, g);
               net_msg->AddBits(0, 1, g);
               net_msg->AddVector(aim_dir, g);
               net_msg->Descend();
            }
         }
      }
   }

//----------------------------

   bool PlayVoice(const char *base, float power, bool net_send, bool stop_old = false, int cmd_type = 0){

      if(isound){
         C_string name;
         //bool b = GetVoiceName(base, cbProc(CB_GET_VOICE_ID), name);
         bool b = GetVoiceName(base, GetVoiceID(), name);
         if(!b) return false;
         if(voice){
            if(voice->IsPlaying()){
               if(!stop_old)
                  return false;
               voice->SetOn(false);
            }
            //voice->Release();
         }
         voice = mission.CreateSound(name);
         if(voice){
            voice->LinkTo(frm_head);
            voice->SetRange(tab_game_cfg->ItemF(TAB_F_GAME_SNDR_HUM_MIN),
               tab_game_cfg->ItemF(TAB_F_GAME_SNDR_HUM_MAX));
            voice->SetLoop(false);
            voice->SetOn(true);
            voice->Release();
         }
      }
      S_listen_source ls = S_listen_source(LISTEN_HUMAN, frm_head->GetWorldPos(), power);
      ls.sub_type = cmd_type;
      mission.EmitListen(ls, tab_game_cfg->ItemF(TAB_F_GAME_SNDR_HUM_MAX), false, this);

      if(net && net_send){
         //const bool g = false;
         net_msg->Ascend(net_id);
         net_msg->AddBits(NM_HUMAN_PLAY_VOICE, NET_ACTOR_CODE_BITS, true);
         net_msg->AddBits(*(dword*)base, 24, true);
         bool pow = (power!=10.0f);
         net_msg->AddBits(pow, 1, true);
         if(pow) net_msg->AddFloat(power, true);
         net_msg->AddBits(stop_old, 1, true);
         net_msg->Descend();
      }
      return true;
   }

   virtual void GrenadeStopThrow(){}

   int FindBestWeapon(dword inv_mask = 0){

      int i;
      int best_id = -1;
      if(!inv_mask){
                           //look to inv. to find 'good' weapon
         int curr_id = C_inventory::GetItem(selected_inv_item);
         int best_prio = 0;
         for(i = C_inventory::NumItems(); i--; )
         if(C_inventory::GetItemAmount(i)){
            int id = C_inventory::GetItem(i);
            switch(tab_inventory->ItemI(TAB_I_INV_ID, id)){
            case INV_WEAPON:
            case INV_COLT:
            case INV_GRENADE:
            case INV_BAZOOKA:
            case INV_PANZER:
            case INV_KNIFE:
               break;
            default: continue;
            }
            if(id!=curr_id){
               int prio = ((int*)tab_inventory->Item(TAB_I_INV_PRIORITY))[id];
               if(prio<=100)
               if(best_prio < prio){
                  best_prio = prio;
                  best_id = id;
               }
            }
         }
      }
      return best_id;
   }

public:
   C_human::C_human(C_game_mission &m, E_ACTOR_TYPE at):
      C_inventory(mission.game_menu),
      C_actor(m, at),
      force_model_tick(false),
      was_in_scene(false),
      using_item(NULL),
      face_id(0),
      stay_mode(SM_STAY),
      selected_inv_item(0),
      gun(NULL),
      frm_head(NULL),
      floor_link(NULL),
      throw_power(0),
      barier_climb_count(0),
      brest(NULL),
      vis_body(NULL),
      shoot_cntdwn(0),
      aim_count(0), aim_dir(S_vector(0.0f, 0.0f, 1.0f)),
      net_sync_aim_fade_factor(1.0f),
      curr_pose(-1),
      fall_speed(.01f),
      turn_angle(0.0f),
      net_sync_abs_turn(0.0f),
      net_sync_want_turn(0.0f),
      our_update(false),
      falling(false),
      holding_fire(false),
      test_col_count(0),
      relaxed_weapon_hold(false),
      mine_field_ratio(0),
      net_sync_grabber(NULL),
      prg_dirty(true),
      actor_enum_count(0),
      col_floor(false),
      vol_cam(NULL),
#ifdef KEEP_HUMAN_OUT_OF_WALL
      vol_up(NULL), vol_down(NULL), 
#endif
      first_anim(true)
   {
      pset = driver->CreateAnimationSet(); pset->Release();

      move_dir.Zero();

                                 //free hands - has every human
      C_inventory::AddItem(30);
      //WatchReset();
      //cbProc(CB_LISTEN_RESET);
      ListenReset();

      tab = CreateTable();
      tab->Open((dword)&templ_hum_prop, TABOPEN_TEMPLATE);

      net_sync_aim_dir = net_sync_aim_want = aim_dir;
      net_sync_aim_count = 0;

      {
         static const char *names[] = {
            "Hrud*",
#if 0
            "krk*",
            "Hlva*",
            "RamL*",
            "RamR*",
#endif
            NULL
         };
         for(const char **cpp=names; *cpp; cpp++){
            PI3D_animation_base pose = driver->CreateAnimation(I3DANIM_POSE);
            pset->AddAnimation(pose, *cpp);
            pose->Release();
         }
      }
   }

   //----------------------------

   C_human::~C_human(){

      SetGun(NULL);
      tab->Release();
      ClrProgram(false);
      if(C_inventory::IsVisible())
         mission.game_menu.SetInventory(NULL);
   }

   void ClrProgram(bool net_send){
      for(int i=program.size(); i--; )
         delete program[i];
      program.clear();
      prg_dirty = true;

#ifdef ENEMY_NET_SYNC_INV
      if(net && net_send)
#else
      if(net && net_send && GetType()==ACTOR_PLAYER)
#endif
      {
         net_msg->Ascend(net_id);
         net_msg->AddBits(NM_HUMAN_CLR_PRG, NET_ACTOR_CODE_BITS, true);
         net_msg->Descend();
      }
   }

   virtual dword cbProc(dword msg, dword prm1=0, dword prm2=0);
   bool UseItem(const S_tick_context &tc, int &dest_pose, bool aim_shoot=false, const S_vector *aim_disp=NULL, dword use_data=0);
   void ApplyShootMagnet(const S_vector &pos, S_vector &shoot_dir, float magnet_angle);
   dword Tick(const S_tick_context&);
   bool PlayAnim(int id_to, bool force=false, bool sm_dependent = true, bool tick_wait = false);
   inline void ResetBody(int new_id);

//----------------------------
// Special version sending animation change over network.
   bool PlayAnimNet(int id_to, bool guarant, bool force=false, bool sm_dependent = true, bool tick_wait = false){

      bool b = PlayAnim(id_to, force, sm_dependent, tick_wait);
      if(b && net){
                              //send priority message, so that we don't lose animations
         E_INET_MESSAGE_TYPE mtype = guarant ? INET_MSG_G : INET_MSG_NGP;
         assert(!network_actor);
         net_msg->Ascend(net_id);
         net_msg->AddBits(NM_HUMAN_PLAY_ANIM, NET_ACTOR_CODE_BITS, mtype);
         net_msg->AddBits(id_to, 9, mtype);
         net_msg->Descend();
      }
      return b;
   }

//----------------------------

   bool IsFullAnim(){
      dword anim_type = ((byte*)tab_human_anim->Item(TAB_E_ANI_TYPE))[curr_pose];
      return (anim_type==ANIM_FULL && IsAnimated());
   }

/*--------------------------------------------------------
   Check if current stay mode is good for using item.
   Switch to other stay mode if required.
--------------------------------------------------------*/
                              //network_actor: no

   bool CheckItemUsePose(){

      assert(!network_actor);

      static const byte stay_mask[] = {0, 1, 2, 4};
      byte use_pose_mask = tab_inventory->ItemE(TAB_E_INV_USEPOSE, GetItem(selected_inv_item));
      if(!(use_pose_mask&stay_mask[stay_mode])){
                              //try to required switch to stay mode
         if(CheckFreeStand(1.2f))
            SwitchStayMode((dword)use_pose_mask);
         return false;
      }
                              //check special items
      E_INV_ITEM itm = (E_INV_ITEM)tab_inventory->ItemI(TAB_I_INV_ID, C_inventory::GetItem(selected_inv_item));
      switch(itm){
      case INV_BAZOOKA:
      case INV_PANZER:
         {
            if(shoot_cntdwn>0) break;
            bool aim;
            switch(curr_pose){
            case POSE_BAZOOKA_AIM: case POSE_BAZOOKA_AIM + 0x20:
            case POSE_BAZOOKA_BREATH: case POSE_BAZOOKA_BREATH + 0x20:
            case POSE_PANZER_AIM: case POSE_PANZER_AIM + 0x20:
            case POSE_PANZER_BREATH: case POSE_PANZER_BREATH + 0x20:
               aim = true;
               break;
            default:
               aim = false;
            }
            if(!aim){
               //int dest_pose = (itm==INV_BAZOOKA) ? POSE_BAZOOKA_AIM : POSE_PANZER_AIM;
               int dest_pose = POSE_BAZOOKA_AIM;
               PlayAnimNet(dest_pose, true);
               return false;
            }
         }
         break;
      case INV_COLT:
         {
            switch(curr_pose){
            case POSE_COLT_AIM: case POSE_COLT_AIM + 0x20: case POSE_COLT_AIM + 0x40:
            case POSE_COLT_BREATH: case POSE_COLT_BREATH + 0x20: case POSE_COLT_BREATH + 0x40:
               break;
            default:
               PlayAnimNet(POSE_COLT_AIM, true);
               return false;
            }
         }
         break;
      }
      return true;
   }

/*--------------------------------------------------------
   Check if current stay mode is good for moving (due to weapon we're holding).
   Switch to other stay mode if required.
--------------------------------------------------------*/
                              //network_actor: no

   bool CheckMoveMode(){
      assert(!network_actor);
      static const byte stay_mask[]={0, 1, 2, 4};
      byte carry_pose_mask = tab_inventory->ItemE(TAB_E_INV_CARRYPOSE, GetItem(selected_inv_item));
      if(!(carry_pose_mask&stay_mask[stay_mode])){
                              //check minimal free space for any change mode
         if(CheckFreeStand(1.2f)){
            SwitchStayMode((dword)carry_pose_mask);
         }else{
            AI_DEBUG("CheckMoveMode: item need special move mode which is not possible at this place, hiding item");
            SetSelectedInvItem(0);
         }
         return false;
      }
      return true;
   }

//----------------------------

   bool CheckFreeStand(float len){

      S_vector from = model->GetWorldPos();
      from.y += .1f;
      const S_vector dir(0, len, 0);

      I3D_collision_data cd(from, dir, 0, model, WatchColResp2);
      bool b = mission.GetScene()->TestCollision(cd);
      PI3D_frame vol = b ? cd.GetHitFrm() : NULL;
      if(vol){
         AI_DEBUG(C_fstring("volume %s above head, not standing!", (const char*)vol->GetName()));
         return false;
      }
      return true;
   }

//----------------------------

   bool SwitchStayMode(bool up, bool force = false, bool check_vol1 = true){

      if(!force && IsFullAnim())
         return false;
      if(using_item)
         return false;

      E_STAY_MODE new_mode = SM_NULL;
      bool check_vol(false);
      bool check_lay_vol(false); //when trying lay, check if for body and head
      float len;
                              //when staying up, check volume above head
      if(up){
         switch(stay_mode){
         case SM_LAY:
            check_vol=true;
            len = 1.2f;
            break;
         case SM_BENCH:
            check_vol=true;
            len = 1.85f;
            break;
         case SM_STAY:
            check_lay_vol = true;
            break;
         }
         new_mode = (E_STAY_MODE)(((stay_mode+1) % 3) + 1);
      }else{
         switch(stay_mode){
         case SM_LAY:
            check_vol=true;
            len = 1.85f;
            break;
         case SM_BENCH:
            check_lay_vol = true;
            break;
         }
         new_mode = (E_STAY_MODE)(((stay_mode) % 3) + 1);
      }
      if(check_vol && check_vol1){
         if(!CheckFreeStand(len))
            return false;
         /*S_vector from = model->GetWorldPos();
         from.y += .1f;
         const S_vector dir(0, len, 0);

         I3D_collision_data cd(from, dir, 0, model, WatchColResp2);
         bool b = mission.GetScene()->TestCollision(cd);
         PI3D_frame vol = b ? cd.GetHitFrm() : NULL;
         if(vol){
            AI_DEBUG(C_fstring("volume %s above head, not standing!", (const char*)vol->GetName()));
            return false;
         }*/
      }
      if(check_lay_vol && check_vol1){
         const S_matrix &m = frame->GetMatrix();
         static const S_vector forw(.0f, .0f, 1.0f);
         S_vector mdir = forw.RotateByMatrix(m);
         PI3D_frame up_vol = frame->FindChildFrame("~020v1*");
         assert(up_vol);
         const S_vector &up_pos = up_vol->GetWorldPos();
         PI3D_frame down_vol = frame->FindChildFrame("~020v2*");
         assert(down_vol);
         const S_vector &down_pos = down_vol->GetWorldPos();
         I3D_collision_data cd;
         cd.from = up_pos;
         S_vector to = down_pos + (mdir * 1.06f);
         cd.dir = to - cd.from;
         cd.frm_ignored = model;
         cd.cresp_face = WatchColResp2;
         //DebugLine(cd.from, cd.from+cd.dir, 0, 0xff00ffff);
         if(mission.GetScene()->TestCollision(cd)){
            AI_DEBUG(C_fstring("volume %s under, not laying!", (const char*)cd.GetHitFrm()->GetName()));
            return false;
         }
      }

      stay_mode = new_mode;

      if(net){                //send over network
         bool g = true;
         net_msg->Ascend(net_id);
         net_msg->AddBits(NM_HUMAN_STAY_MODE, NET_ACTOR_CODE_BITS, g);
         net_msg->AddBits(stay_mode-SM_STAY, 2, g);
         net_msg->Descend();
      }
      return true;
   }

/*--------------------------------------------------------
   Switch to other stay-mode defined by mask. Mask bits are as follows:
   b.0 - STAY
   b.1 - BENCH
   b.2 - LAY
   If more poses are available, those with less movement is selected.
--------------------------------------------------------*/

   bool SwitchStayMode(dword stay_mask, bool net_send = true){

      if(using_item)
         return false;
      int dest_pose;
      switch(stay_mode){
      case SM_STAY:
         if(stay_mask&1) return true;
         if(stay_mask&2) stay_mode=SM_BENCH, dest_pose=POSE_STAY_DOWN;
         else
         if(stay_mask&4) stay_mode=SM_LAY, dest_pose=POSE_STAY_UP;
         else return false;
         break;
      case SM_BENCH:
         if(stay_mask&2) return true;
         if(stay_mask&1) stay_mode=SM_STAY, dest_pose=POSE_STAY_UP;
         else
         if(stay_mask&4) stay_mode=SM_LAY, dest_pose=POSE_STAY_DOWN;
         else return false;
         break;
      case SM_LAY:
         if(stay_mask&4) return true;
         if(stay_mask&2) stay_mode=SM_BENCH, dest_pose=POSE_STAY_UP;
         else
         if(stay_mask&1) stay_mode=SM_STAY, dest_pose=POSE_STAY_DOWN;
         else return false;
         break;
      case SM_DEAD:
                              //already dead? network sync, just pass on
         return false;
      default:
         assert(0);
         return false;
      }
      PlayAnim(dest_pose, true);
      turn_angle = 0.0f;

      if(net && net_send){    //send over network
         bool g = true;
         net_msg->Ascend(net_id);
         net_msg->AddBits(NM_HUMAN_STAY_MODE, NET_ACTOR_CODE_BITS, g);
         net_msg->AddBits(stay_mode-SM_STAY, 2, g);
         net_msg->Descend();
      }

      return true;
   }

   bool SwitchStayMode(E_STAY_MODE sm, bool net_send = true){
      return SwitchStayMode((dword)(1<<(sm-SM_STAY)), net_send);
   }

   void ProcessProgram(const S_tick_context &tc);

//----------------------------

   bool MayHunt(const S_vector &subj_pos, const S_command &key) const{

      switch(type){
      case ACTOR_PLAYER:
      /*
         if(using_item)
         switch(using_item->GetType()){
         case ACTOR_AUTOMOBIL:
         case ACTOR_AUTO_CANNON:
                                 //check if we're following someone
            for(i=0; i<program.size(); i++){
               if(program[i]->prg_item==PRG_FOLLOW){

                  LPC_follow_formation ff = program[i]->sub_param.follow_form;
                  if(!ff) break;
                  LPC_actor master = ff->master;
                                 //check if

                  return false;
               }
            }
            break;
         }
         return false;
         */
         if(key.sub_param.attack_mode==AM_MUST_SUCCEED) return true;
         break;
      case ACTOR_ENEMY:
         if(AI_e(TAB_E_AI_HUNT)==2){
            S_vector our_pos = frame->GetWorldPos();
            our_pos.y += 1.0f;
            const S_vector &origin_pos = program.back()->dest;
            S_vector our_dir = our_pos-origin_pos;
            float dist = our_dir.Magnitude();
            float max_hunt_dist = AI_f(TAB_F_AI_HUNT_MAX_DIST);
            if(dist < (max_hunt_dist-.5f)) return true;
                              //there's possibility that subject is towards our origin
            S_vector spos = subj_pos;
            spos.y += 1.0f;
            float u = (spos-origin_pos).Dot(our_dir) / our_dir.Dot(our_dir);
            if(u<.95f) return true;
         }
         break;
      }
      return false;
   }

//----------------------------
                              //network_actor: no

   bool FaceToWall(int time, const S_vector &face_dir, const S_vector &wall_normal){
                              //check angle against wall
      float f;
      f = Angle2D(S_vector2(face_dir.x, face_dir.z), S_vector2(wall_normal.x, wall_normal.z));
      f += GetPI();
      if(f>GetPI()) f -= GetPI2();

      if(fabs(f) > (PI*.01f)){

         turn_angle = 0.0f;

         float tsec = (float)time*.001f;

         float angle = WALL_ALIGN_SPEED;
         angle *= tsec;
         angle = Min((float)fabs(f), angle);
         if(f<0.0f) angle = -angle;

         S_quat rot;
         rot.Make(S_vector(0.0f, 1.0f, 0.0f), angle);
         frame->SetRot(frame->GetRot() * rot);
         frame->Update();

         f -= angle;
      }
      return (fabs(f)<=PI*.01f);
   }

//----------------------------
                              //WATCHING
#ifdef _DEBUG
 #define WATCH_DEBUG(n)
 //#define WATCH_DEBUG(n) OUTTEXT(n)

 #define WATCH_LOG(n)
// #define WATCH_LOG(n) DEBUG(n)
#else
 #define WATCH_DEBUG(n)
 #define WATCH_LOG(n)
#endif

                              //watching
#define WATCH_ENUM_COUNT 1000
#define WATCH_RECOGNIZE_VALUE .4f
//#define HEAR_RECOGNIZE_VALUE .3f

#define WATCH_CONE_ANGLE_OUT (PI*.5)
#define WATCH_CONE_ANGLE_IN (PI*.3)

#define WATCH_DIST_NEAR_RATIO .33f

   int actor_enum_count;      //counter by which we enumerate actors and add enemies to watch list based by their distance from us
   struct S_watch_actor{
      LPC_actor actor;        //reference on this kept
      int check_count;
      float cumulate_time;
      E_RELATION relation;

      int last_test_part_indx;   //last bodypart we tested
      int last_seen_part_indx;   //last bodypart we have seen (-1 = none)
      int curr_seen_part_indx;   //for later attack use

      float seen_amount;      //raise by 1.0/sec by ideal conditions
      //float heard_amount;

      S_watch_actor(): actor(NULL)
      {}
      S_watch_actor(LPC_actor a1, E_RELATION rel):
         actor(a1),
         last_test_part_indx(0), last_seen_part_indx(-1),
         curr_seen_part_indx(0),
         relation(rel),
         //check_count(Random(tab_game_cfg->ItemI(TAB_I_GAME_WATCH_CHECK_COUNT))),
         check_count(S_int_random(tab_game_cfg->ItemI(TAB_I_GAME_WATCH_CHECK_COUNT))),
         seen_amount(0.0f),
         //heard_amount(0.0f),
         cumulate_time(0.0f)
      {
      }
      operator LPC_actor() const{ return actor; }
      bool operator < (const S_watch_actor &wa) const{ return seen_amount<wa.seen_amount; }
      bool IsSeen() const{ return (seen_amount >= WATCH_RECOGNIZE_VALUE); }
      void ResetTestPart(){
         last_seen_part_indx = -1;
         last_test_part_indx = -1;
      }
   };
   typedef vector<S_watch_actor> t_watch_list;
   t_watch_list watch_actors;

//----------------------------
                              //network_actor: no

   void WatchReset(){
      actor_enum_count = WATCH_ENUM_COUNT;
      watch_actors.clear();
   }

/*--------------------------------------------------------
   //Watch - keep list of enemies within range, check them and sort
   //list by visibility amount.

   //Rules:
   // - watches and listens to all humans
--------------------------------------------------------*/
                              //network_actor: no

   void WatchHumans(int time, float care_factor = 1.0f){

                              //tab = human compatible table
      float watch_test_range = AI_f(TAB_F_AI_WATCH_MAX_DIST);

      if((actor_enum_count += time) >= WATCH_ENUM_COUNT){
         actor_enum_count = 0;

         //WATCH_DEBUG(C_fstring("Human %s: Scanning for enemies in range %i", model->GetName(), WATCH_TEST_RANGE));
                              //refresh actors watch list
         struct S_hlp{
            LPC_actor actor;
            S_vector pos;
            t_watch_list *watch_actors;
            int watch_test_range;
            static bool cb(LPC_actor a, dword t1){
               S_hlp &t = *(S_hlp*)t1;

               //if(!a->IsHuman()) return true;
               //if(a->GetType()==t.actor->GetType()) return true;
               if(!a->IsEnemy(t.actor))
                  return true;
               if(!a->IsAlive())
                  return true;
                              //don't watch on yourself
               if(a==t.actor) return true;
                              //also invisible are invisible, if they're enemies
               if(a->GetType()==ACTOR_ENEMY){
                  if(!a->GetFrame()->IsOn()) return true;
                  /*
                  C_human *ha = (C_human*)a;
                  if(!ha->program.size() != ha->program[0]->prg_item==PRG_SETVISIBLE) return true;
                  */
               }
                              //only check enemies
               for(int i=t.watch_actors->size(); i--; )
                  if((*t.watch_actors)[i]==a) break;

               {
                  if(((*a->GetPos()) - t.pos).Magnitude() < t.watch_test_range){
                              //add to list (if not yet)
                     if(i==-1){
                        E_RELATION rel = ((C_human*)a)->GetRelation(t.actor);
                        t.watch_actors->push_back(C_human::S_watch_actor(a, rel));
                        WATCH_DEBUG(C_fstring("Human %s: Adding human %s to watch list", (const char*)t.actor->GetName(), (const char*)a->GetName()));
                     }
                  }else
                  if(i!=-1){
                     //t.watch_actors->fast_erase(i);
                     (*t.watch_actors)[i] = t.watch_actors->back(); t.watch_actors->pop_back();
                     WATCH_DEBUG(C_fstring("Human %s: Removing human %s from watch list", (const char*)t.actor->GetName(), (const char*)a->GetName()));
                  }
               }
               return true;
            }
         } hlp;
         hlp.actor = this;
         hlp.pos = model->GetWorldPos();
         hlp.watch_actors = &watch_actors;
         hlp.watch_test_range = watch_test_range;
         mission.EnumActors(S_hlp::cb, (dword)&hlp);
      }
                              //check all actors on list in intervals
      float tsec = (float)time*.001f;
      for(int i=watch_actors.size(); i--; ){
         S_watch_actor &wa = watch_actors[i];
                              //we're not interested in dead ones
         if(!wa.actor->IsAlive()){
            //watch_actors.fast_erase(i);
            watch_actors[i] = watch_actors.back(); watch_actors.pop_back();
            continue;
         }

         wa.cumulate_time += tsec;
                              //always use counted in final release
#ifdef _DEBUG 
         if((wa.check_count -= time) <= 0)
#else
         if((wa.check_count -= time) <= 0)
#endif
         {
                              //the higher care factor, the more frequent checking
            wa.check_count +=
               tab_game_cfg->ItemI(TAB_I_GAME_WATCH_CHECK_COUNT)/care_factor;
                              //'look' at him
            S_vector from(frm_head->GetWorldPos());
            S_vector to = *wa.actor->GetBrestPos();
            S_vector dir(to-from);
            float dist = dir.Magnitude();
            float seen_factor;
            bool is_seen = true;
                              //test 1 - check viewing cone, get seen_factor
            const S_vector &head_dir = frm_head->GetWorldDir();
            float seen_angle = S_vector2(head_dir.x, head_dir.z).AngleTo(S_vector2(-dir.x, -dir.z));
            WATCH_LOG(C_fstring("Seen angle = %.2f", seen_angle));

                              //compute distance
            float dist_factor;
            {
               float dist_near = watch_test_range*WATCH_DIST_NEAR_RATIO;
               if(dist>=watch_test_range) dist_factor = 0.0f;
               else
               if(dist<=dist_near) dist_factor = 1.0f;
               else dist_factor = (watch_test_range-dist)/(watch_test_range-dist_near);
            }

            if(fabs(seen_angle) >= WATCH_CONE_ANGLE_OUT){
               is_seen = false;
               WATCH_LOG("Out of view cone");
            }else{
               is_seen = true;
               seen_factor = 1.0f;
               if(seen_angle>WATCH_CONE_ANGLE_IN)
                  seen_factor = (WATCH_CONE_ANGLE_OUT-seen_angle)/(WATCH_CONE_ANGLE_OUT-WATCH_CONE_ANGLE_IN);
               WATCH_LOG(C_fstring("Inside of view cone, factor = %.2f", seen_factor));

                              //apply distance
               seen_factor *= dist_factor;
               WATCH_LOG(C_fstring("* distance factor (%.2f) = %.2f", dist_factor, seen_factor));
            }

            if(is_seen){
               const float min_watch_dist = .4f;
               if(dist < min_watch_dist){
                  WATCH_LOG("too close - seen for sure");
               }else{
                              //body part on which we periodically look at
                              //these indicies are into body part names
                  static const int body_part_watch_indx[] = {
                     1,                         //brest
                     3,                         //head
                     0,                         //body
                     11,                        //sthl
                     14,                        //SthR
                     4,                         //RamL
                     7,                         //RamR
                     13,                        //ChdL
                     16,                        //ChdL
                     6,                         //DlnL
                     9,                         //DlnR
                  };
                  /*
                     "Trup*", "Hrud*", "krk*", "Hlva*", "RamL*", "LktL*", "DlnL*", "RamR*",
                     "LktR*", "DlnR*", "gun*", "SthL*", "LtkL*", "ChdL*", "SthR*", "LtkR*",
                     "ChdR*"
                  */
                              //look to last seen part, or to random part
                  int part_i;
                  bool upper_test=false;  //true if we try to have a look at better bodypart than currently seen
                  if(wa.last_seen_part_indx!=-1){
                     part_i = wa.last_seen_part_indx;
                     switch(part_i){
                     case 0:  //brest
                     case 1:  //head
                     case 2:  //body
                              //we're happy with this
                        break;
                     default:
                        if(wa.seen_amount>=.6f){
                           upper_test = true;
                           (++wa.last_test_part_indx) %= 3;
                           part_i = wa.last_test_part_indx;
                        }
                     }
                  }else{
                     part_i = wa.last_test_part_indx;
                              //next time look to something else
                     (++wa.last_test_part_indx) %= (sizeof(body_part_watch_indx)/sizeof(int));
                  }
                  PI3D_frame a_frm = wa.actor->GetFrame();
                  PI3D_frame body_part = a_frm->FindChildFrame(body_part_names1[body_part_watch_indx[part_i]]);
                  if(body_part){ //should always pass, maybe not if human is thrown to pieces
                     dir = body_part->GetWorldPos() - from;
                  }
                              //avoid colliding with our own volumes
#ifdef EDITOR
                  float dir_len = dir.Magnitude();
#endif
                  S_vector rpos;
                  {
                     if(using_item && using_item->GetType()==ACTOR_AUTO_CANNON)
                        can_see_through_car = true;

                     I3D_collision_data cd(from, dir, 0, frame, WatchColResp2);
                     bool b = mission.GetScene()->TestCollision(cd);
                     can_see_through_car = false;

                     PI3D_frame vol =  b ? cd.GetHitFrm() : NULL;
                     if(b)
                        rpos = cd.GetHitPosition();

                     if(vol && vol->GetType()==FRAME_VOLUME){
                        PI3D_frame own = I3DCAST_VOLUME(vol)->GetOwner();
                              //the volume may be soldier's one
                        if(own==a_frm)
                           vol = NULL;
                        else
                        if(own){
                              //or car he's sitting in
                           LPC_actor a = (LPC_actor)own->GetData();
                           if(a){
                              switch(a->GetType()){
                              case ACTOR_AUTOMOBIL:
                              case ACTOR_AUTO_CANNON:
                                 if(a->cbProc(CB_USE_AUTO, 15, (dword)wa.actor))
                                    vol = NULL;
                                 break;
                              }
                           }
                        }
                     }
                     is_seen = (!vol);
                  }
#ifdef EDITOR
                  if(tab_game_cfg->ItemB(TAB_B_GAME_DEBUG_SHOW_WATCH)){
                     DebugLine(from,
                        is_seen ? (from + dir*watch_test_range/dir_len) : rpos,
                        2, 0xff40c040);
                  }
#endif
                              //next time look to this again, or to random part
                  if(is_seen){
                     wa.last_seen_part_indx = part_i;
                     wa.curr_seen_part_indx = body_part_watch_indx[part_i];
                  }else
                  if(!upper_test){
                     wa.last_seen_part_indx = -1;
                     wa.curr_seen_part_indx = -1;
                  }
                  WATCH_LOG(C_fstring("collision: %i", !is_seen));
               }
            }

            if(!is_seen)
               wa.seen_amount = Max(0.0f, wa.seen_amount - wa.cumulate_time*.3f);
            else{
                              //apply stay factor
               //E_STAY_MODE sm = (E_STAY_MODE)wa.actor->cbProc(CB_GET_STAY_MODE);
               E_STAY_MODE sm = ((C_human*)wa.actor)->GetStayMode();
               int indx;
               switch(sm){
               case SM_STAY:
                  indx = 0;
                  break;
               case SM_BENCH:
                  indx = 1;
                  break;
               case SM_LAY:
                  indx = 2;
                  break;
               default:
                  indx = 3;
               }
               float stay_factor = tab_game_cfg->ItemF(TAB_F_GAME_WATCH_STAY_FACTOR, indx);
               //seen_factor *= 1.0f;
               seen_factor *= stay_factor;
               WATCH_LOG(C_fstring("* stay_factor(%.2f) = %.2f", stay_factor, seen_factor));

                              //apply movement
               //int curr_pose = wa.actor->cbProc(CB_GET_CURR_POSE);
               int curr_pose = ((C_human*)wa.actor)->GetCurrPose();
               float move_factor;
               if(curr_pose!=-1){
                  S_vector move_speed;
                  move_speed.x = tab_human_anim->ItemF(TAB_F_ANI_SPEEDX, curr_pose);
                  move_speed.y = tab_human_anim->ItemF(TAB_F_ANI_SPEEDY, curr_pose);
                  move_speed.z = tab_human_anim->ItemF(TAB_F_ANI_SPEEDZ, curr_pose);
                  move_factor = 1.0f + move_speed.Magnitude() / 3.0f;
               }else curr_pose = .5f;
               seen_factor *= move_factor;
               WATCH_LOG(C_fstring("* move factor(%.2f) = %.2f", move_factor, seen_factor));

                              //apply lightness
               {
                  S_vector color = mission.GetScene()->GetLightness(to);
                  float lightness = color[0]*.3f + color[1]*.6f + color[2]*.1f;
                  WATCH_LOG(C_fstring("scene lightness = %.2f", lightness));
                  if(lightness<0.0f)
                     lightness = 0.0f;
                  else
                     lightness = Min(1.0f, lightness*tab_game_cfg->ItemF(TAB_F_GAME_WATCH_LIGHT_MULT));
                  seen_factor *= lightness;
                  WATCH_LOG(C_fstring("* lightness(%.2f) = %.2f", lightness, seen_factor));
               }

               seen_factor *= care_factor;
               WATCH_LOG(C_fstring("* care_factor(%.2f) = %.2f", care_factor, seen_factor));

                              //apply uniform - only enemy may get confused by this
               if(type==ACTOR_ENEMY){
                  E_UNIFORM_ID uid = cbProc(CB_IGNORE_UNIFORMS) ?
                     UID_SAS :
                     (E_UNIFORM_ID)wa.actor->cbProc(CB_GET_UNIFORM_ID);
                  switch(uid){
                  case UID_GERMAN:
                     {
                        float f = tab_game_cfg->ItemF(TAB_F_GAME_WATCH_UNIF_GERMAN);
                        //seen_factor *= f;
                        wa.cumulate_time *= f;
                        //WATCH_LOG(C_fstring("* E_UNIFORM_ID(%.2f) = %.2f", f, seen_factor));
                     }
                     break;
                  case UID_CIVIL:
                     {
                        //bool has_wpn = wa.actor->cbProc(CB_HAS_WEAPON_IN_HANDS);
                        LPC_actor ui = (LPC_actor)wa.actor->cbProc(CB_GET_USING_ITEM);
                        bool driving_vehicle = (ui &&
                           ((ui->GetType() == ACTOR_AUTOMOBIL) || (ui->GetType() == ACTOR_AUTO_CANNON)));
                        bool has_wpn = ((C_human*)wa.actor)->HasWeaponInHands();
                        //float f = tab_game_cfg->ItemF(has_wpn ? TAB_F_GAME_WATCH_UNIF_CIVIL_W : TAB_F_GAME_WATCH_UNIF_CIVIL);
                        float f = tab_game_cfg->ItemF((has_wpn || driving_vehicle)? TAB_F_GAME_WATCH_UNIF_CIVIL_W : TAB_F_GAME_WATCH_UNIF_CIVIL);
                        wa.cumulate_time *= f;
                        //seen_factor *= f;
                        //WATCH_LOG(C_fstring("* E_UNIFORM_ID(%.2f) = %.2f", f, seen_factor));
                     }
                     break;
                  }
               }

                              //determine amount by which actor's seen
               seen_factor -= .3f;
               WATCH_LOG(C_fstring("- 0.3 = %.2f", seen_factor));

               wa.seen_amount = Max(0.0f,
                  Min(wa.seen_amount + wa.cumulate_time * seen_factor,
                  WATCH_RECOGNIZE_VALUE*2.0f));
            }
            WATCH_LOG(C_fstring("seen amount = %.2f", wa.seen_amount));
            wa.cumulate_time = 0.0f;
         }
      }
   }

//----------------------------
                              //network_actor: yes

   int GetBreathPose() const{

      if(using_item)
      switch(using_item->GetType()){
      case ACTOR_AUTOMOBIL:
      case ACTOR_AUTO_CANNON:
         {
            int st = using_item->cbProc(CB_USE_AUTO, 5, (dword)this);
            if(st==2) return POSE_BIKE_BREATH;
            if((const C_actor*)using_item->cbProc(CB_USE_AUTO, 10) == this){
               return POSE_DRIVE_BREATH;
            }
         }
         break;
      case ACTOR_TIME_BOMB: return POSE_GRAB;
      case ACTOR_LADDER: return POSE_CLIMB_BREATH;
      }

      switch(curr_pose){
      case POSE_BAZOOKA_AIM: case POSE_BAZOOKA_AIM + 0x20:
         return POSE_BAZOOKA_BREATH;
      case POSE_PANZER_AIM: case POSE_PANZER_AIM + 0x20:
         return POSE_PANZER_BREATH;
      case POSE_BINOC_LOOK: case POSE_BINOC_LOOK + 0x20: case POSE_BINOC_LOOK + 0x40:
         return POSE_BINOC_BREATH;
      case POSE_COLT_AIM: case POSE_COLT_AIM + 0x20: case POSE_COLT_AIM + 0x40:
      case POSE_COLT_BREATH: case POSE_COLT_BREATH + 0x20: case POSE_COLT_BREATH + 0x40:
      case POSE_COLT_FIRE: case POSE_COLT_FIRE + 0x20: case POSE_COLT_FIRE + 0x40:
      case POSE_COLT_LOAD: case POSE_COLT_LOAD + 0x20: case POSE_COLT_LOAD + 0x40:
         return POSE_COLT_BREATH;
      default: return POSE_BREATH;
      }
   }

//----------------------------

   bool TurnedToDir(const S_vector &sub_dir, bool &is_turning, int &dest_pose,
      bool *allow_aim = NULL, const float *ref_angle = NULL, bool c_u_i = true){

      bool using_cannon = c_u_i && (using_item && using_item->GetType()==ACTOR_CANNON);
      //bool using_cannon = false;
               //turn to his direction
      S_vector dir;
      if(!using_cannon)
         dir = frame->GetWorldDir();
      else
         using_item->cbProc(CB_USE_CANNON, 4, (dword)&dir);
      float a = Angle2D(S_vector2(sub_dir.x, sub_dir.z),
         S_vector2(dir.x, dir.z));
      float abs_a = fabs(a);
      static const float ref_angle1[]={ PI*.4, PI*.2 };
      if(!ref_angle) ref_angle = ref_angle1;
      if(abs_a > ref_angle[is_turning]){
         if(c_u_i && using_item){
            if(allow_aim) *allow_aim=false;
            return false;
         }
         if(!is_turning){
            //AI_DEBUG(C_fstring("Human %s TurnedToDir: starting to turn", model->GetName()));
            is_turning = true;
         }
                     //turn to right position
         if(a > 0.0f){
            dest_pose = POSE_TURN_RIGHT;
            turn_angle = -TURN_SPEED_FAST;
         }else{
            dest_pose = POSE_TURN_LEFT;
            turn_angle = TURN_SPEED_FAST;
         }
               //no action until we're turned
         if(allow_aim) *allow_aim = (abs_a < PI*.6f);
         return false;
      }else{
         if(is_turning){
            //AI_DEBUG(C_fstring("Human %s TurnedToDir: stopping to turn", model->GetName()));
            is_turning = false;
         }
         turn_angle = 0.0f;
         if(dest_pose==-1)
            dest_pose = GetBreathPose();
      }
      if(allow_aim) *allow_aim = true;
      return true;
   }

//----------------------------
#define AIM_THRESH_ANGLE (PI*.02f)   //default value

   bool AimedToDir(const S_vector &aim_dir, PI3D_frame brest, int time, const S_vector *ref_dir = NULL, float req_angle = AIM_THRESH_ANGLE){

      if(using_item)
      switch(using_item->GetType()){
      case ACTOR_AUTO_CANNON:
         if(!using_item->cbProc(CB_USE_AUTO, 11, (dword)this)){
            break;
         }
                              //flow...
      case ACTOR_CANNON:
         {
                              //time can't be zero (we divide by it later)
            if(!time)
               return false;
            float f[3] = { 0.0, 0.0, (float)time*.001f };
                              //get cannon dir
            S_vector gun_dir;
            using_item->cbProc(CB_USE_CANNON, 4, (dword)&gun_dir);
                              //adjust Y axis
            f[1] = Angle2D(S_vector2(aim_dir.x, aim_dir.z), S_vector2(gun_dir.x, gun_dir.z)),
            f[1] /= f[2];
                              //adjust X axis
            f[0] = -Angle2D(S_vector2(S_vector2(aim_dir.x, aim_dir.z).Magnitude(), aim_dir.y),
               S_vector2(S_vector2(gun_dir.x, gun_dir.z).Magnitude(), gun_dir.y));
            f[0] /= f[2];
            using_item->cbProc(CB_USE_CANNON, 1, (dword)f);

                              //get new cannon dir
            using_item->cbProc(CB_USE_CANNON, 4, (dword)&gun_dir);
                              //check if in range
            float aim_angle = aim_dir.AngleTo(gun_dir);
            if(fabs(aim_angle) < req_angle) return true;
         }
         return false;
      }

      PI3D_frame prnt = brest->GetParent()->GetParent();
      S_matrix m = prnt->GetMatrix();

                              //aim to direction of enemy
      m.Inverse();
      S_vector v = aim_dir.RotateByMatrix(m);
      v.y = -v.y;
      v.Normalize();
      SetAimDir(v, time);

                              //check angle - gun assumed, defaulting to head
      if(!ref_dir) ref_dir = &frm_head->GetWorldDir();

      float aim_angle = aim_dir.AngleTo(-(*ref_dir));
      if(fabs(aim_angle) < req_angle) return true;

      return false;
   }

/*--------------------------------------------------------
   Use current inventory item - directly from list.
--------------------------------------------------------*/
                              //network_actor: only for uniform change

   bool UseInvItem(int &dest_pose, bool change_only = false, bool net_send = true){

      E_INV_ITEM itm = (E_INV_ITEM)tab_inventory->ItemI(TAB_I_INV_ID, C_inventory::GetItem(C_inventory::GetActiveItem()));
      switch(itm){

      case INV_WEAPON:
      case INV_COLT:
      case INV_HANDS:
      case INV_GRENADE:
      case INV_FLAREGUN:
      case INV_BAZOOKA:
      case INV_PANZER:
      case INV_KNIFE:
      case INV_BINOCULARS:
      case INV_CAMERA:
         assert(!network_actor);
                     //change to this weapon
         if(selected_inv_item || selected_inv_item != C_inventory::GetActiveItem()){
            //dest_pose = POSE_CHANGE;
            WeaponChangeAnim();
         }
         break;

      case INV_MINE:
      case INV_TIME_BOMB:
         assert(!network_actor);
         if(change_only) return false;
         dest_pose = POSE_ITEM_PUT;
         break;

      case INV_RADIO:
         assert(!network_actor);
         dest_pose = POSE_ITEM_DROP;
         break;

      case INV_UNIFORM:
         if(change_only)
            return false;
         if(type!=ACTOR_PLAYER)
            return false;
         {
            int i, j;
                              //find which clothing (inv. item) we had
            const char *cp = model->GetFileName();
            j = strlen(cp);
            while(j && cp[j-1]!='\\') --j;
            for(i=tab_inventory->ArrayLen(TAB_S16_INV_MODEL_S); i--; ){
               if(tab_inventory->ItemI(TAB_I_INV_ID, i)==INV_UNIFORM){
                  if(!stricmp(tab_inventory->ItemS(TAB_S16_INV_MODEL_S, i, 16), &cp[j]))
                     break;
               }
            }
            if(i==-1){
               ErrReport("Can't find current clothing in inventory, assuming #5", editor);
               i = 5;
            }
            int old_id = i;

                              //replace model
            PI3D_model mp = driver->CreateModel();
            mp->SetName(model->GetName());
            OptimiseEnemyShadow(mp);
            const char *uni_name = tab_inventory->ItemS(TAB_S16_INV_MODEL_S, C_inventory::GetItem(C_inventory::GetActiveItem()), 16);
            if(uni_name[0]=='c'){
                              //dressing to civil uniform, hold fire
               holding_fire = true;
                              //switch to free hands
               SetSelectedInvItem(0);
            }

            model_cache.Open(mp, uni_name, mission.GetScene(), 0, ErrReport, editor);
            //S_model_load s = {mp, &mission};
            //mp->EnumFrames(cbModelLoad, (dword)&s, ENUMF_DUMMY | ENUMF_USEMASK, "~0*");
            mp->EnumFrames(cbSetAllCallback, FRMCALLBACK_ANIMNOTE, ENUMF_VISUAL | ENUMF_DUMMY | ENUMF_JOINT, NULL);
            mp->EnumFrames(cbAddVolumeToScene, (dword)mission.GetScene(), ENUMF_VOLUME);

            mp->SetPos(model->GetPos());
            mp->SetRot(model->GetRot());
            mp->Update();
            mp->LinkTo(model->GetParent());
            struct S_hlp{
               static I3DENUMRET I3DAPI cbEnum(PI3D_frame frm, dword m){
                  PI3D_frame frm1 = ((PI3D_model)m)->FindChildFrame(frm->GetOrigName());
                  if(frm1){
                     frm->SetPos(frm1->GetPos());
                     frm->SetRot(frm1->GetRot());
                     frm->SetScale(frm1->GetScale());
                     frm->Update();
                  }
                  return I3DENUMRET_OK;
               }
            };
            mp->EnumFrames(S_hlp::cbEnum, (dword)model);
            if(gun) gun->LinkTo(mp->FindChildFrame("gun*", ENUMF_ALL | ENUMF_WILDMASK));

            //mission.GetScene()->DeleteFrame(model);

            SetFrame(mp);
            //mission.GetScene()->AddFrame(mp);

            mp->Release();
            PlayAnim(POSE_RESET);

                     //set new face
            cbProc(CB_SETFACE, face_id/2, face_id&1);

                              //change heads in all PRG_MOVE commands
            for(i=0; i<program.size(); i++){
               S_command &key = *program[i];
               if(key.prg_item==PRG_MOVE){
                  C_movement *mv = key.GetMovement();
                  if(mv){
                     mv->frm_head = frm_head;
                  }
               }
            }

                              //relpace item in inventory
            int new_id = C_inventory::GetItem(C_inventory::GetActiveItem());
            cbProc(CB_SET_UNIFORM_ID, new_id);
            C_inventory::ReplaceItem(C_inventory::GetActiveItem(), old_id);

            cbProc(CB_SET_UNIFORM_ID);

            if(net && net_send){
               const bool g = true;
               net_msg->Ascend(net_id);
               net_msg->AddBits(NM_HUMAN_USE_INV_ITEM, NET_ACTOR_CODE_BITS, g);
               net_msg->Descend();
            }
         }
         break;
      }
      return true;
   }
/*--------------------------------------------------------
   Drop current inventory item.
--------------------------------------------------------*/
                              //network_actor: no

   bool DropInvItem(int &dest_pose){

      E_INV_ITEM itm = (E_INV_ITEM)((dword*)tab_inventory->Item(TAB_I_INV_ID))[C_inventory::GetItem(C_inventory::GetActiveItem())];
      switch(itm){
      default:
         dest_pose = POSE_ITEM_DROP;
         break;

      case INV_HANDS:
         break;
      }
      return true;
   }

/*--------------------------------------------------------
   Check if all conditions satisfied to use particular item.
   Return 0 if item may be used, otherwise a code is returned.
      Codes:   1 - too far
               2 - bad stay mode
               3 - bad dir
               4 - free hands req.
   If 'adjust' flag is specified, do appropriate action to satisfy conditions.
--------------------------------------------------------*/
                              //network_actor: no

   dword CheckUseItemConds(LPC_actor use_item, bool adjust, int &dest_pose, int pos_indx = 0, bool reason_out = false, bool abs_index_mode = false, float min_use_pos = 2.0f){

      assert(!network_actor);

      float dist, best_dist = 1e+8f;
      bool mult_use_pos = (pos_indx==-1);
      int num_use_pos = !mult_use_pos ? 1 : use_item->NumUsePositions();
      if(!num_use_pos)
         return 1;

      S_vector pos;
      GetCenterPos(pos);

      while(num_use_pos--){
         const S_vector use_pos = use_item->GetUsePos(!mult_use_pos ? pos_indx : num_use_pos, abs_index_mode);
         S_vector d = pos - use_pos;
         d.y *= .5f;
         dist = d.Magnitude();

         if(!mult_use_pos)
            break;
         if(best_dist>dist){
            best_dist = dist;
            pos_indx = num_use_pos;
         }
      }
      if(mult_use_pos)
         dist = best_dist;

      float max_dist = use_item->GetUsePosThresh();

      if(dist > max_dist){
         if(!adjust){
            /*
#ifdef EDITOR
            if(reason_out) OUTTEXT("Use: too far");
#endif
            */
            return 1;
         }
         const S_vector &use_pos = use_item->GetUsePos(pos_indx, abs_index_mode);
         //if(mult_use_pos)     //get use pos again
            //use_item->cbProc(CB_GET_USE_POS, (dword)&use_pos, pos_indx | (abs_index_mode ? 0x10000 : 0));

                              //first get there
         if(dist>min_use_pos){
            AI_DEBUG(C_fstring("Use: too far (%.2f), adding MOVE", dist));
            AddProgram(0, PRG_MOVE, S_prg_add((dword)&use_pos, true, MR_USE_REACH));
            //cbProc(CB_PRG_PREPROCESS);
            cbProc(CB_PRG_SHOW);
            return 1;
         }else{
            bool b = GoTo(use_pos, S_vector(0, 0, 0), dest_pose, GOTOFLAGS_SMART, false, max_dist);
            if(!b)
               return 1;
         }
      }
                              //check proper stay mode
      E_STAY_MODE sm = (E_STAY_MODE)use_item->CheckUseStay(stay_mode, pos_indx);
      if(sm!=SM_NULL && sm!=stay_mode){
         if(adjust){
            AI_DEBUG("Use: bad stay mode, switching");
            E_PRG_ITEM prg;
            switch(sm){
            case SM_STAY: prg = PRG_STAY_UP; break;
            case SM_BENCH: prg = PRG_STAY_MID; break;
            case SM_LAY: prg = PRG_STAY_DOWN; break;
            default: assert(0);
            }
            AddProgram(0, prg, S_prg_add());
            //cbProc(CB_PRG_PREPROCESS);
         }else{
            /*
#ifdef EDITOR
            if(reason_out) OUTTEXT("Use: bad stay mode");
#endif
            */
         }
         return 2;
      }
                              //check direction
      S_vector use_dir;
      //int i = use_item->cbProc(CB_GET_USE_DIR, (dword)&use_dir, pos_indx);
      if(use_item->GetUseDir(use_dir, pos_indx)){
                              //get our dir
         const S_vector &dir = *GetDir();
         float a = Angle2D(S_vector2(use_dir.x, use_dir.z), S_vector2(dir.x, dir.z));
         //float thresh = I2F(use_item->cbProc(CB_GET_USE_DIR_THRESH));
         float thresh = use_item->GetUseDirThresh();

         if(fabs(a) > thresh){
            if(adjust){
                              //turn to right position
               if(a>=0.0f){
                  dest_pose = POSE_TURN_RIGHT;
                  turn_angle = -TURN_SPEED_FAST;
               }else{
                  dest_pose = POSE_TURN_LEFT;
                  turn_angle = TURN_SPEED_FAST;
               }
               //AI_DEBUG(C_fstring("PRG_USE: bad dir, turning %s", a>0.0 ? "right" : "left"));
               //PlayAnim(dest_pose);
            }else{
               /*
#ifdef EDITOR
            if(reason_out) OUTTEXT("Use: bad dir");
#endif
            */
            }
            return 3;
         }
      }
      if(selected_inv_item && use_item->CheckUseFreeHands(pos_indx, abs_index_mode)){
         if(adjust){
            AI_DEBUG("Use: free hands required, hiding item");
            SetSelectedInvItem(0);
         }else
            /*
#ifdef EDITOR
            if(reason_out) OUTTEXT("Use: free hands required");
#endif
            */
         return 4;
      }
                              //everything's ok
      return 0;
   }

/*--------------------------------------------------------
   Leave currently used item (if any) - program to use it again later.
--------------------------------------------------------*/
                              //network_actor: no

   bool LeaveUseItem(int save_on_pos = -1, bool force = false){

      assert(!network_actor);

      if(!using_item)
         return true;

      if(!force){
         switch(using_item->GetType()){
         case ACTOR_AUTOMOBIL:
         case ACTOR_AUTO_CANNON:
                                 //can't automatically leave vehices
            return false;
         case ACTOR_CANNON:
            {
                              //check if we have better weapon in inventory
               int best_id = FindBestWeapon();
               if(best_id==-1)
                  return false;
            }
            break;
         }
      }
      LPC_actor used = using_item;
      //bool ok = using_item->cbProc(CB_USE, (dword)this, false);
      bool ok = using_item->Use(this, 0);
      if(ok){
         AI_DEBUG(save_on_pos!=-1 ? "Leaving used item, going to return later" : "Leaving used item");
         if(save_on_pos!=-1){
            AddProgram(save_on_pos, PRG_USE, (dword)used);
            //AddProgram(save_on_pos, PRG_USE, S_prg_add((dword)used));
         }
         return true;
      }else
         AI_DEBUG("LeaveUseItem failed!");
      return false;
   }

/*--------------------------------------------------------
   Recompute humans position relative to floor to which he is linked.
   Adjust position given in parameter 'to',
   return turn angle in param 'turn'
--------------------------------------------------------*/
                              //network_actor: should

   bool DoFloorLink(S_vector &to, float &turn){
      if(floor_link){
         if(!floor_link->IsOn()){
            floor_link = NULL;
         }else
         if(memcmp(&m_floor, &floor_link->GetMatrix(), sizeof(S_matrix)))
         {
                           //compute displacement
            S_vector dir;// = m_floor(2);
            dir = frame->GetFrameMatrix()(2).RotateByMatrix(m_floor);
            m_floor.Inverse();
            S_vector p = to * m_floor;
            m_floor = floor_link->GetMatrix();
            to = p * m_floor;

            S_vector dir1;// = m_floor(2);
            dir1 = frame->GetFrameMatrix()(2).RotateByMatrix(m_floor);

            turn = Angle2D(S_vector2(dir.x, dir.z), S_vector2(dir1.x, dir1.z));
            return true;
         }
      }
      return false;
   }

   void DoFloorLink(){
      S_vector to = frame->GetPos();
      float turn;
      if(DoFloorLink(to, turn)){
         frame->SetPos(to);
         if(turn){
            S_quat q;
            q.Make(S_vector(0, 1, 0), turn);
            frame->SetRot(frame->GetRot()*q);
         }
         frame->Update();
      }
   }

/*--------------------------------------------------------
   Use lader item - check conditions, finish use.
--------------------------------------------------------*/
                              //network_actor: no

   bool UseLadder(const S_tick_context &tc, bool up, bool down, int &dest_pose){

      assert(!network_actor);

      if(curr_pose==POSE_CLIMB_DOWN1){
         if(IsFullAnim())
            C_human::Tick(tc);
         else
            dest_pose = GetBreathPose();
      }else
      if(up){
         dest_pose = POSE_CLIMB_UP;
         C_human::Tick(tc);
         assert(brest);
         S_vector from(brest->GetWorldPos()), dir(model->GetWorldDir());
         from.y -= .2f;
         I3D_collision_data cd(from, dir, 0, frame);
         //DebugLine(cd.from, cd.from + cd.dir, 0, 0xffff0000);
         if(!mission.GetScene()->TestCollision(cd))
         {
                              //check free place for head
                              //no ladder, end of anim, switch to obstacle climb
            assert(using_item);
            if(using_item)
               using_item->Use(this, 0);
            dest_pose = POSE_BARRIER_CLIMB;
            return true;
         }else{
                                 //align to ladder
            S_vector rnorm = cd.GetHitNormal();
            rnorm.y = 0.0f;
            model->SetDir(-rnorm);
         }
      }else
      if(down){
         dest_pose = POSE_CLIMB_DOWN;
         col_floor = false;
         C_human::Tick(tc);

         assert(brest);
         S_vector from(brest->GetWorldPos()), dir(model->GetWorldDir());
         from.y -= .2f;
         S_vector rnorm;
         I3D_collision_data cd(from, dir, 0, frame);
         bool vol = mission.GetScene()->TestCollision(cd);
         if(vol)    
            rnorm = cd.GetHitNormal();
         if(vol){             //align to ladder
            rnorm.y = 0.0f;
            model->SetDir(-rnorm);
         }

         if(col_floor){
            assert(using_item || !"No using_item when using ladder down");
            if(using_item)
               using_item->Use(this, 0);
            dest_pose = POSE_RESET;
            return true;
         }
      }
      return false;
   }

/*--------------------------------------------------------
   Get value from AI table - use defaults system, test human table, then mission table, then game table.
--------------------------------------------------------*/

   byte AI_e(dword indx) const{
      byte ret = tab->ItemE(indx);
      if(!ret) ret = mission.tab_property->ItemE(indx);
      if(!ret) ret = tab_game_cfg->ItemE(indx);
      return ret;
   }

   float AI_f(dword indx) const{
      float ret = tab->ItemF(indx);
      if(!ret) ret = mission.tab_property->ItemF(indx);
      if(!ret) ret = tab_game_cfg->ItemF(indx);
      return ret;
   }

   int AI_i(dword indx) const{
      int ret = tab->ItemI(indx);
      if(!ret) ret = mission.tab_property->ItemI(indx);
      if(!ret) ret = tab_game_cfg->ItemI(indx);
      return ret;
   }

/*--------------------------------------------------------
   General AI solution block.
   Inputs:
      - Current program
      - Watch+Hear list
      - Inventory
      - Current stay mode
      - Currently used item
   Output:
      - operations on program
   Return value:
      true if AI solution made

   Remarks:
      this method is called from some non-trivial commands to perform
      appropriate action
--------------------------------------------------------*/
#ifdef _DEBUG
# define AI_SOL_DEBUG(n)
//# define AI_SOL_DEBUG(n) OUTTEXT(n)

 #define AI_SOL_LOG(n)
 //#define AI_SOL_LOG(n) DEBUG(n)
#else
 #define AI_SOL_DEBUG(n)
 #define AI_SOL_LOG(n)
#endif
                              //network_actor: no

   bool AI_solution(int time, int &dest_pose, float vigilance = 1.0f){

      assert(!network_actor);

      int i;
                              //look and listen carefully
      WatchHumans(time, vigilance);
      ListenTick(time, vigilance);
      t_watch_list &wa_list = watch_actors;
      LPC_actor first_seen(NULL);
      int first_seen_indx;    //valid only when first_seen is not NULL
                              //make counts - seen enemies, dead mates
      int num_seen_enm(0), num_seen_deads(0);
      //int num_snds(0);
      float best_seen_amount = 0.0f;
      for(i=wa_list.size(); i--; ){
         const S_watch_actor &wa = wa_list[i];
         if(wa.IsSeen()){
            const LPC_actor a = wa.actor;
            E_RELATION rel = wa.relation;
            bool is_enemy = (rel==RELATION_ENEMY);
            (is_enemy ? num_seen_enm : num_seen_deads)++;
            if(is_enemy && (!first_seen || best_seen_amount<=wa.seen_amount)){
               first_seen=a;
               first_seen_indx = i;
               best_seen_amount = wa.seen_amount;
            }
         }
         /*
         if(AI_e(TAB_E_AI_LISTEN)==2){
                              //count sounds only on unseen subjects
            if(wa.IsHeard() && !wa.IsSeen()) ++num_snds;
         }
         */
      }

      enum{
         A_NONE,
         A_ATTACK,            //attack seen subject
         A_WATCH,             //look at (sound) origin
         A_ALARM,             //not implemented
         A_QUICK_WATCH,       //like A_WATCH, but much shorter
         A_BENCH,             //bench and continue in current program
         A_SEARCH_DEST,       //go to look into destination
      } action(A_NONE);

      //AI_SOL_LOG(C_fstring("AI_sol: enm_seen: %i, dead_seen: %i, num_snds: %i", num_seen_enm, num_seen_deads, num_snds));
      AI_SOL_LOG(C_fstring("AI_sol: enm_seen: %i, dead_seen: %i", num_seen_enm, num_seen_deads));
      //if(!(num_seen_enm|num_seen_deads|num_snds)) return false;
      //if(!num_seen_enm && !num_seen_deads)
      const S_listen_source *heard_sound = NULL;   //no sound heard

      if(AI_e(TAB_E_AI_LISTEN)==2)
      {
                              //listen to sounds
         for(i=listen_list.size(); i--; ){
            const S_listen_source &ls = listen_list[i];
            //if(ls.ignore_count) continue;
                              //accept only sources over thresh
            if(ls.power<1.0f) continue;
            if(heard_sound){
               if(heard_sound->type<ls.type) continue;
               if(heard_sound->type == ls.type && heard_sound->power>ls.power) continue;
                              //more important sound found, keep it
            }
            heard_sound = &ls;
         }
      }
      if(heard_sound){
         AI_SOL_LOG(C_fstring("Listen source of type: %i", heard_sound->type));
      }

      int num_dels = 0;

      if(program.size()){
         const S_command &key = *program.front();
         switch(key.prg_item){
         case PRG_GUARD:
         case PRG_WAIT_SIGNAL:
            {
                                 //1. check enemies - add ATTACK if some seen
               if(num_seen_enm){
                  //if(AI_b(TAB_B_AI_GUARD_ADD_ATTACK))
                  {
                     action = A_ATTACK;
                     if(key.prg_item==PRG_GUARD && key.sub_param.guard_count){
                        AI_SOL_DEBUG("AI_sol: deleting counted guard");
                        num_dels = 1;
                     }
                     break;
                  }
               }
               //if(num_snds)
               switch(key.prg_item){
               case PRG_GUARD://can't watch when counted guard
                  if(key.sub_param.guard_count) break;
                  if(heard_sound){
                     action = A_WATCH;
                     if(AI_e(TAB_E_AI_SEARCH_HEARD)==2){
                        switch(heard_sound->type){
                        case LISTEN_HUMAN:
                        case LISTEN_SHOOT:
                        case LISTEN_FLARE:
                           action = A_SEARCH_DEST;
                           break;
                        }
                     }
                  }
                  break;
               default:
                  if(heard_sound){
                     action = A_QUICK_WATCH;
                  }
               }
            }
            break;

         case PRG_WATCH:
            {
               if(num_seen_enm){
                  action = A_ATTACK;
                  num_dels = 1;  //delete PRG_WATCH
                  break;
               }
            }
            break;

         case PRG_ATTACK:
         case PRG_MOVE:
            {
               bool can_attack(true), can_watch(true);
               LPC_actor attack_subj = NULL;

               switch(key.prg_item){
               case PRG_ATTACK:
                  attack_subj = key.GetSubject();
                  break;
               case PRG_MOVE:
                  {
                                 //determine for what we're running
                     E_MOVE_REASON mr = key.sub_param.move_reason;
                     switch(mr){
                     case MR_ATTACK_REACH:
                        attack_subj = program[1]->GetSubject();
                        break;

                     case MR_FOLLOW_REACH:
                                 //attack possible, but not watching
                                 // - keeping discipline!
                        can_watch = false;
                     case MR_WALK_CP:
                        break;
                     }
                  }
                  break;
               }

               if(attack_subj){
                              //never listen when hunting/attacking
                  can_watch = false;
                  can_attack = false;
                  if(first_seen){
                              //that's question
                              //check if it's not the same
                     LPC_actor new_subj = first_seen;
                     if(new_subj!=attack_subj){
                              //when should we choose kill this instead of old?
                        for(i=wa_list.size(); i--; ) if(wa_list[i]==attack_subj) break;
                        if(i!=-1){
                           //float watch_delta = wa_list[first_seen_indx].seen_amount - wa_list[i].seen_amount;
                           if(fabs(wa_list[i].seen_amount)>MRG_ZERO){
                              float ratio = wa_list[first_seen_indx].seen_amount / wa_list[i].seen_amount;
                           //if(watch_delta<.4f) i=-1;
                              if(ratio<1.8f) i=-1;
                           }else
                              i=-1;
                        }
                        if(i!=-1){
                           AI_SOL_DEBUG(C_fstring("AI_sol: removing old ATTACK"));
                           num_dels = key.prg_item==PRG_ATTACK ? 1 : 2;
                           can_attack = true;
                        }
                     }
                  }
               }

               if(num_seen_enm && can_attack){
                  action = A_ATTACK;
                  break;
               }
               //if(num_snds && can_watch)
               if(heard_sound && can_watch){
                  if(key.sub_param.run)
                     action = A_BENCH;
                  else
                     action = A_WATCH;
                  break;
               }
               num_dels = 0;     //keep moving further
            }
            break;

         case PRG_FOLLOW:
            if(num_seen_enm){
               action = A_ATTACK;
            }
            if(heard_sound){
               action = A_QUICK_WATCH;
               break;
            }
            break;

         default:
            assert(0);
         }
      }else{
                              //watch, listen, anything
         if(num_seen_enm) action = A_ATTACK;
         else
         if(heard_sound){
            action = A_WATCH;
         }
      }
                              //delete appropriate commands
      while(num_dels--)
         DelProgram(0);
                              //make decided action
      bool ret = false;

                              //when shot heard, remove holding_fire
      if(type==ACTOR_PLAYER && heard_sound){
         switch(heard_sound->type){
         case LISTEN_SHOOT:
         case LISTEN_WHEEZ:
            holding_fire = false;
            break;
         }
      }

      switch(action){
      case A_ATTACK:
         {
            if(!first_seen) break;

            if(type==ACTOR_ENEMY){
                              //only germans cry
               if(tab->ItemI(TAB_I_ENM_GROUP)==0){
                  bool can_cry = true;
                  if(using_item)
                  switch(using_item->GetType()){
                  case ACTOR_AUTOMOBIL:
                  case ACTOR_AUTO_CANNON:
                  case ACTOR_CANNON:
                     can_cry = false;
                     break;
                  }
                  if(can_cry)
                     PlayVoice("see", 8.0f, true);
               }
            }else{
                              //players are capable of holding fire
               if(holding_fire)
                  break;
            }
            AI_SOL_DEBUG("AI_sol: enemy seen, adding PRG_ATTACK");
            AddProgram(0, PRG_ATTACK, S_prg_add((dword)first_seen, wa_list[first_seen_indx].curr_seen_part_indx));

                              //apply reaction time
            int delay = GetReactionDelay();
            delay /= 2;
            //AI_DEBUG(C_fstring("Setting delay before ATTACK: %i ms", delay));
            //shoot_cntdwn += delay;
            shoot_cntdwn = Min(shoot_cntdwn+delay, delay);

            ret = true;
         }
         break;

      case A_WATCH:
      case A_QUICK_WATCH:
         {
            if(holding_fire)
               break;
            i = -1;
                              //try to leave anything
            if(action==A_WATCH){
               if(!LeaveUseItem(0)) break;

               int delay = GetReactionDelay();
               delay /= 4;
               AddProgram(++i, PRG_SUSPEND, S_prg_add(delay));
            }

                              //get scr dir - no height please
            const S_vector &my_pos = frm_head->GetWorldPos();
            S_vector snd_pos = heard_sound->pos;
            snd_pos.y = my_pos.y;
                              //action depends on type of sound we've heard
            switch(heard_sound->type){
            case LISTEN_WHEEZ:
            //case LISTEN_HUMAN:
               if(!using_item){
                              //that's pretty bad, someone wants kill us
                              //let's lay down first and examine the situation,
                              //then, if noone appears we may stand back again
                  if(stay_mode!=SM_LAY)
                     AddProgram(++i, stay_mode==SM_STAY ? PRG_STAY_MID : PRG_STAY_DOWN, S_prg_add());
                  if(action==A_QUICK_WATCH){
                     AddProgram(++i, PRG_WATCH, S_prg_add((dword)&snd_pos, 1));
                  }else{
                     AddProgram(++i, PRG_WATCH, S_prg_add((dword)&snd_pos));
                     AddProgram(++i, PRG_GUARD, S_prg_add(0, 0, 3000));
                  }

                  if(stay_mode!=SM_LAY)
                     AddProgram(++i, stay_mode==SM_STAY ? PRG_STAY_UP : PRG_STAY_MID, S_prg_add());
               }
               break;
            default:
                              //examine what's going on - watch there
               {
                              //watch in the direction of sound
                  AI_SOL_DEBUG("AI_sol: something heard, adding PRG_WATCH");
                  AddProgram(++i, PRG_WATCH, S_prg_add((dword)&snd_pos, action==A_QUICK_WATCH ? 1 : 0));
               }
            }

            ret = true;
         }
         break;

      case A_SEARCH_DEST:
         {
                              //go to place where we heard sound and search there for a while
                              //algo: go there, watch there
            i = -1;
            AddProgram(++i, PRG_WATCH, S_prg_add((dword)&heard_sound->pos, 1));
            AddProgram(++i, PRG_MOVE, S_prg_add((dword)&heard_sound->pos, true));
            AddProgram(++i, PRG_WATCH, S_prg_add(0, 1));
         }
         break;

      case A_BENCH:
         {
                              //action depends on type of sound we've heard
            switch(heard_sound->type){
            case LISTEN_WHEEZ:
               if(stay_mode==SM_STAY){
                  i = -1;
                  AddProgram(++i, PRG_STAY_MID, S_prg_add());
                              //skip current cmd
                  ++i;
                  AddProgram(++i, PRG_STAY_UP, S_prg_add());
               }
               break;
            }
         }
         break;
      }
      return ret;
   }

/*--------------------------------------------------------
   Check if human is ready to use particular weapon
--------------------------------------------------------*/
                              //network_actor: no

   bool IsReadyToFire(){
      assert(!network_actor);

      E_INV_ITEM itm = (E_INV_ITEM)tab_inventory->ItemI(TAB_I_INV_ID, C_inventory::GetItem(selected_inv_item));
      switch(itm){
      case INV_COLT:
         {
            //bool may_shoot(false);
            switch(curr_pose){
            case POSE_COLT_AIM: case POSE_COLT_AIM + 0x20: case POSE_COLT_AIM + 0x40:
            case POSE_COLT_BREATH: case POSE_COLT_BREATH + 0x20: case POSE_COLT_BREATH + 0x40:
               break;
            default:
               PlayAnimNet(POSE_COLT_AIM, false);
               return false;
            }
         }
      }
      return true;
   }

//----------------------------

   void HideGunFlares(){
                              //this will run animation (if any) to the end, resulting in hiding all flares of gun
      if(gun)
         gun->Tick(1000);
   }

//----------------------------

   int GetReactionDelay() const{

      float reaction_ratio;

      switch(GetType()){
      case ACTOR_ENEMY:
         reaction_ratio = (float)AI_i(TAB_I_AI_REACTION)/100.0f;
         break;
      case ACTOR_PLAYER:
         {
            int plr_react = tab->ItemI(TAB_I_HUM_BAR2_REACTION);
            reaction_ratio = (plr_react<65) ? 0.0f :
               (plr_react>=85) ? 1.0f :
               float(85-plr_react)/20.0f;
         }
         break;
      }
      reaction_ratio = 1.0f-reaction_ratio;
      const int &reaction_min = tab_game_cfg->ItemI(TAB_F_GAME_REACTION_MIN);
      const int &reaction_max = tab_game_cfg->ItemI(TAB_F_GAME_REACTION_MAX);
      int delay = reaction_min + (reaction_max-reaction_min)*reaction_ratio;
                              //don't allow the delay to be less than zero
      delay = Max(2, delay);
      //return delay - delay/4 + Random(delay/2);
      return delay - delay/4 + S_int_random(delay/2);
   }

//----------------------------

   void ShootCountDown(int time){
      if(shoot_cntdwn>0)      //allow to be negative
         shoot_cntdwn -= time;
   }

//----------------------------
                              //network_actor: no

   bool WeaponChangeAnim(bool force = false){
      assert(!network_actor);
      return PlayAnimNet(POSE_CHANGE, false, force);
   }

//----------------------------
                              //network_actor: yes

   virtual void C_human::Die(int die_pose, bool net_send = true){

                              //can't die twice
      if(stay_mode==SM_DEAD)
         return;

      PlayVoice(game_configuration.censored ? "c_d" : "die", 12, false, true);

      //ResetAim();
      ClearAimDir(); //04.01.2001: clear now, countdown doesn work when player die
      turn_angle = 0.0f;

      if(net_send){
                           //stop using anything
         if(using_item)
            using_item->Use(this, 0, true);
      }

      if(!game_configuration.censored)
         PlayAnim(die_pose, true, false);

      stay_mode = SM_DEAD;
      floor_link = NULL;
      if(!game_configuration.censored){
         SetVisible(false, true, false);
      }
      HideGunFlares();

                              //optimize only enemies
      bool optim_dead = mission.tab_property->ItemB(TAB_B_SCN_OPTIM_DEAD_BODY);
      optim_dead = optim_dead && (type==ACTOR_ENEMY);

      if(game_configuration.censored || optim_dead){
                              //replace current model by neutral object
         bool is_focused = (mission.game_cam.GetFocus()==frm_head);
         PI3D_model mp = driver->CreateModel();
         mp->SetPos(model->GetPos());
         mp->SetRot(model->GetRot());
         mp->LinkTo(model->GetParent());
         mp->Update();
         mp->SetName(model->GetName());
         anim_man.StopAllStages();
         anim_store.waiting = false;

         brest = NULL;
         vis_body = NULL;
         frm_head = NULL;
         SetFrame(mp);
         model_cache.Open(mp, GetType()==ACTOR_PLAYER ? "bag_plr" : "bag_enm", mission.GetScene(), 0, ErrReport, editor);
         if(voice)
            voice->LinkTo(mp);
         PI3D_animation_set as = mp->GetAnimationSet();

         mp->SetAnimation(0, as);
         mission.GetScene()->AddFrame(mp);

         mp->Release();
         mission.SetFrameSector(frame);
         SetVisible(false, true, false);
         if(is_focused){
            //mission.game_cam.SetFocus(frame, frame);
                              //find bag frame, use it as head(model has pivot too close to ground -cause camera clip problems)
            frm_head = frame->FindChildFrame("*", ENUMF_VISUAL | ENUMF_WILDMASK);
            mission.game_cam.SetFocus(frm_head ? frm_head : frame, frame);
         }
      }

      if(net){
         if(net_send){
            bool g = true;
            net_msg->Ascend(net_id);
                                 //setup final position
            net_msg->AddBits(NM_HUMAN_POS, NET_ACTOR_CODE_BITS, g);
            net_msg->AddVector(frame->GetWorldPos(), g);
                                 //setup final rotation
            const S_vector &dir = frame->GetWorldDir();
            float angle = Angle2D(S_vector2(dir.x, dir.z));
            byte angle_8 = Angle_8bit(angle);   //convert angle to value 0-255
            net_msg->AddBits(NM_HUMAN_ABS_TURN, NET_ACTOR_CODE_BITS, g);
            net_msg->AddBits(angle_8>>(8-NET_HUMAN_ABS_DIR_BITS), NET_HUMAN_ABS_DIR_BITS, g);

            net_msg->AddBits(NM_HUMAN_DIE, NET_ACTOR_CODE_BITS, g);
            net_msg->AddBits(die_pose, 9, g);

#ifndef ENEMY_NET_SYNC_INV
            if(GetType()!=ACTOR_PLAYER){
               const bool g = true;
                                 //send inventory state now, so that it's synced for grabbers
                                 //1. clear all
               net_msg->AddBits(NM_HUMAN_INVENTORY, NET_ACTOR_CODE_BITS, g);
               net_msg->AddBits(0, 6, g); //dummy
               net_msg->AddBits(7, 3, g);
                                 //2. add all items again
               for(int i=1; i<C_inventory::NumItems(); i++){
                  net_msg->AddBits(NM_HUMAN_INVENTORY, NET_ACTOR_CODE_BITS, g);
                  net_msg->AddBits(C_inventory::GetItem(i), 6, g);
                  net_msg->AddBits(3, 3, g);
                  net_msg->AddBits(C_inventory::GetItemAmount(i), 12, g);
               }
            }
#endif
            net_msg->Descend();
         }
      }
   }

//----------------------------//18.12.comment out
                              //network_actor: yes
   /*virtual void ThrowToPieces(LPC_actor caller, bool net_send = true){

      const S_vector *caller_pos = caller ? &caller->GetFrame()->GetWorldPos() : NULL;

      if(!game_configuration.censored){
                           //throw away parts of body
         const int NUM_PARTS = 16;
         static const int body_part_indx[NUM_PARTS]={
            10, 6, 13, 9, 16, 3, 5, 12, 2, 8, 15, 11, 4, 2, 14, 7
         };
                           //choose parts to throw away
         bool off[NUM_PARTS];
         memset(&off, 0, sizeof(off));
         vector<PI3D_frame> parts;
         for(int num_off = S_int_random(12)+4; num_off--; ){
                           //select random
            int pi = S_int_random(NUM_PARTS);
            while(off[pi]) if(!pi--) pi=NUM_PARTS-1;
            off[pi] = true;

            PI3D_frame part = model->FindChildFrame(C_fstring("%s*", (const char*)body_part_names[body_part_indx[pi]]),
               ENUMF_VISUAL | ENUMF_DUMMY | ENUMF_WILDMASK);
            if(!part) continue;
            parts.push_back(part);
         }
                           //setup parts
         for(int i=parts.size(); i--; ){
            PI3D_frame part = parts[i];
                           //unlink from body
            part->LinkTo(NULL, I3DLINK_UPDMATRIX);
                           //select direction
            S_vector dir;
            if(caller_pos){
               const S_vector &prt_pos = part->GetWorldPos();
               dir = prt_pos-(*caller_pos);
               dir.y = .5f + S_float_random() * .5f;
               //float a = Angle2D(S_vector2(prt_pos.x, prt_pos.z), S_vector2(caller_pos->x, caller_pos->z));
               float a = Angle2D(S_vector2(dir.x, dir.z));
               a += (S_float_random() * 2.0f - 1.0f) * PI*.2f;
               //float xz_dir = Random(2.0f)-1.0f;
               float xz_dir = .5f + S_float_random() * .5f;
               dir.x = -sin(a) * xz_dir;
               dir.z = cos(a) * xz_dir;
            }else{
               //dir = S_vector(Random(2.0f)-1.0f, .5f+Random(.5f), Random(2.0f)-1.0f);
               dir.x = S_float_random() * 2.0f - 1.0f;
               dir.y = .5f + S_float_random() * .5f;
               dir.z = S_float_random() * 2.0f - 1.0f;
            }
            dir.Normalize();
            {
                           //attach some blood to bodypart
               S_vector dir1(-dir);
               LPC_actor a = mission.MakeParticle("blood", "particle\\blood.tab", S_vector(0, 0, 0), part, &dir1);
               if(a){
                  PI3D_frame prtc = a->GetFrame()->FindChildFrame(NULL, ENUMF_VISUAL);
                  if(prtc && prtc->GetType()==FRAME_VISUAL){
                     PI3D_visual vis = I3DCAST_VISUAL(prtc);
                     vis->SetProperty(PRT_ELEMENT_SCALE, FloatAsInt(.05f));
                  }
               }
            }

            S_grenade_init gi;
            gi.pos = part->GetWorldPos();
            gi.dir = dir;
            gi.model = part;
            mission.CreateActor(ACTOR_GRENADE, (dword)&gi);
         }
         if(net){
            if(net_send){
               bool g = true;
               net_msg->Ascend(net_id);
               net_msg->AddBits(NM_HUMAN_THROW_OUT, NET_ACTOR_CODE_BITS, g);
               net_msg->AddWord(caller ? caller->GetNetID() : 0, g);
               net_msg->Descend();
            }
         }
      }
   }*/

//----------------------------
                              //network_actor: yes

   virtual bool Hit(S_CB_hit &sh, int body_part_indx, int hit_power, int net_new_resist = 0, bool net_send = true){

                              //can't get hit when already dead
      if(stay_mode==SM_DEAD)
         return false;
                              //find bodypart frame from index
      PI3D_frame frm = frame->FindChildFrame(body_part_names1[body_part_indx], ENUMF_ALL | ENUMF_WILDMASK);
                              //may be NULL in censored or network version,
                              //when bodypart is not present (thrown or changed to rucksack)
      if(!frm)
         return false;
                              //make blood
      if(sh.hit_pos_ok){
         S_vector hpos, hdir;
         if(frm){
            S_matrix m = frm->GetMatrix();
            m.Inverse();
            hpos = sh.hit_pos*m;
            hdir = sh.hit_norm.RotateByMatrix(m);
         }else{
            hpos = sh.hit_pos;
            hdir = sh.hit_norm;
         }
         LPC_actor a = mission.MakeParticle(game_configuration.censored ? "g_blood" : "blood",
            game_configuration.censored ? "particle\\g_blood.tab" : "particle\\blood.tab",
            hpos, frm, &hdir);
         if(a){
            PI3D_frame prtc = a->GetFrame()->FindChildFrame(NULL, ENUMF_VISUAL);
            if(prtc && prtc->GetType()==FRAME_VISUAL){
               PI3D_visual vis = I3DCAST_VISUAL(prtc);
               vis->SetProperty(PRT_ELEMENT_SCALE, FloatAsInt(.05f));
            }
         }
      }
                              //adjust power by type of hit bodypart
      static const float part_mult[] = {
         1.0f, 1.5f, 2.0f, 8.0f, .9f, .8f, .75f, .9f,
         .8f, .75f, .4f, .9f, .8f, .6f, .9f, .8f,
         .6f
      };
      hit_power = (float)hit_power*part_mult[body_part_indx];

      bool ret = false;
      if(net_send){
         if(resistance && (resistance -= hit_power) <= 0){
            resistance = 0;
            cbProc(CB_DIE, -1);
            ret = true;
         }
         //OUTTEXT(resistance);
                              //send over network
         if(net){
            bool g = false;
            net_msg->Ascend(net_id);
            net_msg->AddBits(NM_HUMAN_HIT, NET_ACTOR_CODE_BITS, g);
            net_msg->AddBits(body_part_indx, 5, g);
            net_msg->AddBits(resistance, 14, g);
            net_msg->Descend();
         }
      }else{
         resistance = net_new_resist;
                              //dying is sent as separate network code
      }

      if(resistance){
                              //determine which anim & sound do we play
         static const byte voice_type[]={   //0-body, 1-arm, 2-leg
            0, 0, 0, 0,
            1, 1, 1, 1,
            1, 1, 1, 2,
            2, 2, 2, 2,
            2,
         };
         static const char *voice_base[]={
            "arm", "arm", "leg"
         };
         static const dword anim_type[]={
            POSE_HIT, POSE_HIT, POSE_HIT, POSE_HIT,
            POSE_HIT_AL, POSE_HIT_AL, POSE_HIT_AL, POSE_HIT_AR,
            POSE_HIT_AR, POSE_HIT_AR, POSE_HIT_AR, POSE_HIT_LL,
            POSE_HIT_LL, POSE_HIT_LL, POSE_HIT_LR, POSE_HIT_LR,
            POSE_HIT_LR,
         };
                              //only stay has specialized hit anims
         if(stay_mode!=SM_STAY) body_part_indx=0;
         PlayAnim(anim_type[body_part_indx], true);

         PlayVoice(game_configuration.censored ? "c_h" : voice_base[voice_type[body_part_indx]],
            8.0f, false);
         turn_angle = 0.0f;
         ret = false;
      }
      return ret;
   }

//----------------------------
                              //network_actor: yes

   void SetSelectedInvItem(int indx, bool net_send = true){

      if(selected_inv_item == indx)
         return;
      assert(indx<C_inventory::NumItems());
      if(indx >= C_inventory::NumItems())
         return;

      selected_inv_item = indx;
                           //set appropriate gun model
      if(!selected_inv_item)
         SetGun(NULL);
      else{
         C_string wpn_name =
            tab_inventory->ItemS(TAB_S16_INV_MODEL_S, C_inventory::GetItem(selected_inv_item), 16);
         SetGun((const char*)wpn_name);
         cbProc(CB_SETFOCUS, 2);
      }
      cbProc(CB_SHOW_AMMO);

      if(net && net_send){
         net_msg->Ascend(net_id);
         const bool g = true;
                              //6 = set selected_inv_item
         net_msg->AddBits(NM_HUMAN_INVENTORY, NET_ACTOR_CODE_BITS, g);
         net_msg->AddBits(selected_inv_item, 6, g);
         net_msg->AddBits(6, 3, g);
         net_msg->Descend();
      }
   }

//----------------------------
                              //network_actor: no
   bool GoTo(const S_vector &dest, const S_vector &next_dest, int &dest_pose, dword flags,
      bool next_dest_valid = false, float success_min_dist = .4f){

      assert(!network_actor);

      bool is_accel = (flags&GOTOFLAGS_RUN);
      bool smart = (flags&GOTOFLAGS_SMART);

      turn_angle = 0.0f;
                              //get distance to required destination
      S_vector ddir = dest - frame->GetWorldPos();
      const bool cp_height = false;
      if(fabs(ddir.y) < 1.5f)
         ddir.y = 0.0f;
      float dist = ddir.Magnitude();
      if(dist < success_min_dist && !cp_height){
                              //we're here!
         return true;
      }
      if(!CheckMoveMode())
         return false;
                              //get angle to required destination
      const S_vector &mdir = frame->GetDir();
      float angle = Angle2D(S_vector2(ddir.x, ddir.z), S_vector2(mdir.x, mdir.z));

      bool force_smart = (flags&GOTOFLAGS_FORCE_SMART);
      bool smart_move = force_smart;
      float abs_angle = fabs(angle);
      if(smart && !smart_move && dist<2.0f){
                              //check if desire-able to use smart move
         if(next_dest_valid){
            S_vector ddir1 = next_dest - frame->GetWorldPos();
            //angle = Angle2D(S_vector2(ddir1.x, ddir1.z), S_vector2(mdir.x, mdir.z));
            //DEBUG(angle);
         }
         smart_move = true;
      }

      if(smart_move){
                              //go direct anyhow
         if(abs_angle < PI*.25f){   //forward
            dest_pose = POSE_MOVE_FORWARD;

            if(fabs(angle) > PI*.05f)
               turn_angle= (angle>0.0f) ? -TURN_SPEED_SLOW : TURN_SPEED_SLOW;
         }else
         if(abs_angle < PI*.75f){   //straife
            if(angle>0.0f){
               dest_pose = POSE_MOVE_RIGHT;
               angle -= PI/2.0f;
               turn_angle = -TURN_SPEED_SLOW/2;
            }else{
               dest_pose = POSE_MOVE_LEFT;
               angle += PI/2.0f;
               turn_angle = TURN_SPEED_SLOW/2;
            }
            if(!force_smart) is_accel = false;
         }else{               //backward
            dest_pose = POSE_MOVE_BACKWARD;
            angle += (angle>0.0f) ? -GetPI() : GetPI();
            if(!force_smart) is_accel = false;

            if(fabs(angle) > PI*.05f)
               turn_angle = (angle>0) ? -TURN_SPEED_SLOW : TURN_SPEED_SLOW;
         }
      }else
      if(abs_angle >= PI*.2f){
                              //turn to right position
         if(angle > 0.0f){
            dest_pose = POSE_TURN_RIGHT;
            turn_angle = -TURN_SPEED_FAST;
         }else{
            dest_pose = POSE_TURN_LEFT;
            turn_angle = TURN_SPEED_FAST;
         }
         if(!force_smart) is_accel = false;
      }else{
                              //move & turn
         dest_pose = POSE_MOVE_FORWARD;
         if(abs_angle > PI*.05f){
            if(abs_angle > PI*.15f){
               if(!force_smart) is_accel = false;
            }
            turn_angle = (angle>0.0f) ? -TURN_SPEED_SLOW : TURN_SPEED_SLOW;
         }
      }
      if(dest_pose!=-1 && is_accel) dest_pose |= POSE_ACCEL;
      return false;
   }

//----------------------------

   virtual void SetVisible(bool on, bool vol_only, bool net_send){

      C_actor::SetVisible(on, vol_only, net_send);

      if(net && net_send){
         const bool g = true;
         net_msg->Ascend(net_id);
         net_msg->AddBits(NM_HUMAN_SET_VISIBLE, NET_ACTOR_CODE_BITS, g);
         net_msg->AddBits(on, 1, g);
         net_msg->AddBits(vol_only, 1, g);
         net_msg->Descend();
      }
   }
//----------------------------

   virtual bool AddProgram(int pos, E_PRG_ITEM itm, const S_prg_add &pa, bool net_send = true){

      assert(program.size()<256);
      if(program.size()>=256) return false;
      if(pos>program.size()) return false;
      if(!pos) cmd0_new = true;

      S_command *cmd = new S_command;
      cmd->prg_item = itm;

      cmd->dest = pos ? program[pos-1]->dest : frame->GetWorldPos();

      program.insert(&program[pos], cmd);
      if(!pos) cmd0_new = true;

      const bool g = true;
      if(net && net_send){
                              // //only C_player needs to sync program
#ifndef ENEMY_NET_SYNC_PRG
         if(GetType()!=ACTOR_PLAYER) net_send = false;
         else
#endif
         {
            net_msg->Ascend(net_id);
            net_msg->AddBits(NM_HUMAN_PROGRAM, NET_ACTOR_CODE_BITS, g);
            net_msg->AddBits((bool)pos, 1, g);
            if(pos) net_msg->AddByte(pos, g);
            net_msg->AddBits(itm, 5, g);
         }
      }else net_send = false;

                              //setup command's data
      S_command &key = *cmd;
      switch(itm){

      case PRG_MOVE:          //d0 = (LPS_vector)dest, d1 = (bool)run, d2 = E_MOVE_REASON, d3 = (bool)force_smart
      case PRG_DRIVE:         //d0 = (LPS_vector)dest, d1 = ideal_speed
                              //setup dest
         if(net_send) net_msg->AddBits((bool)pa.d[0], 1, g);
         if(pa.d[0]){
            const S_vector &dest = *(S_vector*)pa.d[0];
                              //find path
            S_vector from;
            if(pos) from = program[pos-1]->dest;
            else{
               from = key.dest;
               from.y += 1.0f;
            }

            C_movement *mv = new C_movement(mission);
            mv->frm_head = frm_head;
            bool b = mv->FindPath(from, dest, model, itm==PRG_MOVE ? CP_PATH : CP_DRIVE);
            //OUTTEXT(C_fstring("FindPath: %s", (const char*)GetName()));
            if(b){
               key.SetMovement(mv);
               key.dest = mv->GetDest();
            }else
               delete mv;
            if(net_send) net_msg->AddVector(dest, g);
         }
                              //set d1
         switch(key.prg_item){
         case PRG_MOVE:       //set run flag
            if(net_send) net_msg->AddBits((bool)pa.d[1], 1, g);
            key.sub_param.run = pa.d[1];
            break;
         case PRG_DRIVE:      //set ideal speed
            if(net_send) net_msg->AddBits((bool)pa.d[1], 1, g);
            key.sub_param.drive_ideal_speed = pa.d[1];
            if(net_send && pa.d[1]) net_msg->AddWord(pa.d[1], g);
            break;
         }

                              //set move reason
         if(net_send){
            net_msg->AddBits((bool)pa.d[2], 1, g);
            if(pa.d[2]) net_msg->AddByte(pa.d[2], g);
         }
         key.sub_param.move_reason = (E_MOVE_REASON)pa.d[2];

                              //setup smart movement
         key.sub_param.force_smart = pa.d[3];
         if(net_send) net_msg->AddBits((bool)pa.d[3], 1, g);
         break;

      case PRG_FOLLOW:        //d0 = (LPC_actor)subject
         if(pa.d[0]){
            LPC_actor master = (LPC_actor)pa.d[0];
            key.SetSubject(master);
            LPC_follow_formation &ff = key.sub_param.follow_form;
                              //find if master has some followers
            struct S_hlp{
               static bool cbE(LPC_actor a, dword c){
                  dword *dwp = (dword*)c;
                  dword ff = a->cbProc(CB_GET_FOLLOW_FORM, *dwp);
                  if(ff){
                     *dwp = (dword)ff;
                     return false;
                  }
                  return true;
               }
            };
            dword dw = (dword)master;
            mission.EnumActors(S_hlp::cbE, (dword)&dw);
            if(dw != (dword)master){
               ff = (LPC_follow_formation)dw;
               ff->AddRef();
            }else{
               ff = new C_follow_formation;
            }
            ff->master = master;
            ff->AddFollower(this);
            if(net_send) net_msg->AddWord(master->GetNetID(), g);
         }else
            if(net_send) net_msg->AddWord(0, g);
         break;

      case PRG_GUARD:         //d0 = (LPS_vector)dest, [d1 = (LPC_checkpoint)aim_dest, d2 = countdown, d3 = (S_vector*)dest, d4 = (LPC_actor)subject]
         {
                              //set guard dest
            if(net_send) net_msg->AddBits((bool)pa.d[0], 1, g);
            if(pa.d[0]){
               key.dest = *(LPS_vector)pa.d[0];
               key.sub_param.guard_dest_set = true;
               if(net_send) net_msg->AddVector(key.dest, g);
            }
                              //set aim dest (CP)
            if(net_send) net_msg->AddBits((bool)pa.d[1], 1, g);
            if(pa.d[1]){
               LPC_checkpoint cp = (LPC_checkpoint)pa.d[1];
               key.sub_param.guard_aim_dest = cp;
               if(net_send) net_msg->AddWord(cp->GetIndex(), g);
            }
                              //set countdown
            if(net_send) net_msg->AddBits((bool)pa.d[2], 1, g);
            key.sub_param.guard_count = pa.d[2];
            if(net_send && pa.d[2]) net_msg->AddWord(pa.d[2], g);
                              //set physical location
            if(net_send) net_msg->AddBits((bool)pa.d[3], 1, g);
            if(pa.d[3]){
               const S_vector &dest = *(LPS_vector)pa.d[3];
               ((S_vector&)key.sub_param.guard_aim_dest_v) = dest;
               key.sub_param.guard_aim_dest_set = true;
               if(net_send) net_msg->AddVector(dest, g);
            }
                              //subject
            if(net_send) net_msg->AddBits((bool)pa.d[4], 1, g);
            if(pa.d[4]){
               LPC_actor a = (LPC_actor)pa.d[4];
               key.SetSubject(a);
               if(net_send) net_msg->AddWord(a->GetNetID(), g);
            }
         }
         break;

      case PRG_WATCH:         //d0 = (LPS_vector)dest, [d1 = phase_count (def.=4)]
                              //set dest
         if(net_send) net_msg->AddBits((bool)pa.d[0], 1, g);
         if(pa.d[0]){
            const S_vector &dest = *(S_vector*)pa.d[0];
            (*(LPS_vector)&key.sub_param.watch.base_dest) = dest;
            if(net_send) net_msg->AddVector(dest, g);
         }
                              //set phase count
         if(net_send) net_msg->AddBits((bool)pa.d[1], 1, g);
         key.sub_param.watch.phase_count = pa.d[1] ? pa.d[1] : 4;
         if(net_send && pa.d[1]) net_msg->AddBits(pa.d[1], 4, g);
         break;

      case PRG_USE:           //d0 = (LPC_actor)subject, [d1 = use_indx, d2 = (float)min_use_dist]
         {
                              //subject
            {
               LPC_actor subj = (LPC_actor)pa.d[0];
               if(subj) (key.SetSubject(subj))->AddRef();
               //key.sub_param.use_reserve_indx = Max(0ul, subj->cbProc(CB_RESERVE_USE, (dword)this));
               if(net_send) net_msg->AddWord(subj ? subj->GetNetID() : 0, g);
            }
                              //use index
            if(net_send) net_msg->AddBits((bool)pa.d[1], 1, g);
            if(pa.d[1]){
               key.sub_param.use_reserve_indx = pa.d[1];
               //assert(key.sub_param.use_reserve_indx>=0);
               if(net_send) net_msg->AddByte((schar)pa.d[1], g);
            }
            if(pa.d[2]){
               key.sub_param.min_use_dist = I2F(pa.d[2]);
            }
         }
         break;

      case PRG_ATTACK:        //d0 = (LPC_actor)subject, [d1 = attack_body_part_index, d2 = E_ATTACK_MODE]
         {
                              //set subject
            LPC_actor a = (LPC_actor)pa.d[0];
            key.SetSubject(a);
            if(net_send) net_msg->AddWord(a ? a->GetNetID() : 0, g);
                              //set body part index
            if(net_send)
               net_msg->AddBits((bool)pa.d[1], 1, g);
            if(pa.d[1]){
               key.sub_param.enm_body_part_index = pa.d[1];
               if(net_send){
                  net_msg->AddBits(pa.d[1] & ((1<<5)-1), 5, g);
               }
            }
                              //set attack mode
            key.sub_param.attack_mode = (E_ATTACK_MODE)pa.d[2];
            if(net_send) net_msg->AddBits(pa.d[2], 2, g);
         }
         break;

      case PRG_USE_INV:       //d0 = int inv_itm_id
         //if(net_send) todo("net send: check functionality");
         if(net_send) net_msg->AddBits(pa.d[0], 6, g);
         key.sub_param.use_inv_id = pa.d[0];
         break;

      case PRG_WALK_CP:       //d0 = (LPC_checkpoint)start_CP, [d1 = (LPC_checkpoint)next, d2 = (bool)run]
         assert(!net_send);
         {
                              //destination checkpoint
            LPC_checkpoint cp = (LPC_checkpoint)pa.d[0];
            //if(net_send) net_msg->AddWord(cp ? cp->GetIndex() : 0, g);
            key.sub_param.cp_dest = cp;
                              //next checkpoint
            //if(net_send) net_msg->AddBits((bool)pa.d[1], 1, g);
            if(pa.d[1]){
               LPC_checkpoint cp = (LPC_checkpoint)pa.d[1];
               key.sub_param.cp_next = cp;
               //if(net_send) net_msg->AddWord(cp->GetIndex(), g);
            }

            if(key.sub_param.cp_dest && !key.sub_param.cp_next){
                              //select next CP now
               if(cp->NumConnections())
                  key.sub_param.cp_next = cp->GetCPoint(S_int_random(cp->NumConnections()));
            }
                              //run flag
            //if(net_send) net_msg->AddBits((bool)pa.d[2], 1, g);
            key.sub_param.walk_cp_run = pa.d[2];
         }
         break;

      case PRG_SEND_SIGNAL:   //d0 = int signal_id, d1 = (LPC_actor)subject <NULL=broadcast>
                              //subject
         //if(net_send) net_msg->AddBits((bool)pa.d[1], 1, g);
         if(pa.d[1]){
            LPC_actor a = (LPC_actor)pa.d[1];
            key.SetSubject(a);
            //if(net_send) net_msg->AddWord(a->GetNetID(), g);
         }
                              //flow...
      case PRG_WAIT_SIGNAL:   //d0 = int signal_id
      case PRG_WAIT_SUSPENDED:
                              //signal id
         assert(!net_send);
         //if(net_send) net_msg->AddWord(pa.d[0], g);
         key.sub_param.wait_signal_id = pa.d[0];
         break;

      case PRG_SETVISIBLE:    //d0 = (bool)on
         assert(!net_send);
         key.sub_param.setvisible_status = pa.d[0];
         //if(net_send) net_msg->AddBits(pa.d[0], 1, g);
         /*
         if(pos==0){
                              //apply immediately
            SetVisible(false, false, false);
         }
         */
         break;

      case PRG_STEP:          //d0 = (LPS_vector)dest, [d1 = (float)goto_min_dist, d2 = (S_vector*)turn_dir, d3 = (bool)run]
         {
            if(net_send) net_msg->AddBits((bool)pa.d[0], 1, g);
            if(pa.d[0]){
               const S_vector &dest = *(S_vector*)pa.d[0];
               *(LPS_vector)&key.sub_param.step_dest = dest;
               if(net_send) net_msg->AddVector(dest, g);
            }
                              //min dist
            if(net_send) net_msg->AddBits((bool)pa.d[1], 1, g);
            if(pa.d[1]){
               float f = I2F(pa.d[1]);
               key.sub_param.step_min_dist = f;
               if(net_send) net_msg->AddFloat(f, g);
            }
                              //durn dir
            if(net_send) net_msg->AddBits((bool)pa.d[2], 1, g);
            if(pa.d[2]){
               const S_vector &dest = *(S_vector*)pa.d[2];
               *(LPS_vector)&key.sub_param.step_dir = dest;
               key.sub_param.step_dir_set = true;
               if(net_send) net_msg->AddVector(dest, g);
            }
                              //run
            if(net_send) net_msg->AddBits((bool)pa.d[3], 1, g);
            key.sub_param.step_run = pa.d[3];
         }
         break;

      case PRG_PRG1:
         assert(!net_send);
         key.sub_param.prg1_bool = pa.d[0];
         break;

      case PRG_SUSPEND:       //d0 = dword time
         if(net_send) net_msg->AddWord(pa.d[0], g);
         key.sub_param.suspend_count = pa.d[0];
         break;

      case PRG_LADDER_CLIMB:  //d0 = bool climb_up
         {                    //ladder
                              //direction
            if(net_send) net_msg->AddBits((bool)pa.d[0], 1, g);
            key.sub_param.ladder_climb_up = pa.d[0];
         }
         break;
      }
      if(net_send) net_msg->Descend();

      return true;
   }

//----------------------------

   virtual bool DelProgram(int pos, bool net_send = true){

      assert(pos<program.size());
      if(pos >= program.size())
         return false;

      switch(program[pos]->prg_item){
      case PRG_FOLLOW:
         if(program[pos]->sub_param.follow_form) program[pos]->sub_param.follow_form->RemoveFollower(this);
         break;
      }
      delete program[pos];
      program.erase(&program[pos]);
      if(!pos) cmd0_new = true;

      if(net && net_send){
                              // //only C_player needs to sync program
#ifndef ENEMY_NET_SYNC_PRG
         if(GetType()!=ACTOR_PLAYER) net_send = false;
         else
#endif
         {
            const bool g = true;
            net_msg->Ascend(net_id);
            net_msg->AddBits(!pos ? NM_HUMAN_DEL_PRG_0 : NM_HUMAN_DEL_PRG, NET_ACTOR_CODE_BITS, g);
            if(pos) net_msg->AddByte(pos, g);
            net_msg->Descend();
         }
      }else net_send = false;

      return true;
   }

//----------------------------

   bool ClrPrgToFollow(LPC_actor master = NULL){

      int i;
                              //erase all paths
      /*
      for(i=program.size(); i--; ){
         if(program[i]->prg_item==PRG_MOVE){
            C_movement *mv = program[i]->GetMovement();
            if(mv){
               delete mv;
               program[i]->SetMovement(NULL);
            }
         }
      }
      */

      for(i=program.size(); i--; )
         if(program[i]->prg_item==PRG_FOLLOW)
            break;
      if(i!=-1){
         if(!master || program[i]->GetSubject()==master){;
            ++i;              //including FOLLOW
            while(i--)
               DelProgram(0, true);
         }
         return true;
      }
      return false;
   }

//----------------------------
                              //network_actor: true

   virtual void VoiceCommand(LPC_actor caller, int cmd_type, bool net_send = true){

                              //check if we may hear this
      if(AI_e(TAB_E_AI_LISTEN)!=2)
         return;

      if(net && network_actor){
         if(net_send){
                              //our duty is to send this over net
            const bool g = false;
            net_msg->Ascend(net_id);
            net_msg->AddBits(NM_HUMAN_VOICE_COMMAND, NET_ACTOR_CODE_BITS, g);
            net_msg->AddWord(caller->GetNetID(), g);
            net_msg->AddBits(cmd_type, 3, g);
            net_msg->Descend();
         }
         return;
      }

                              //check command type
      switch(cmd_type){
      case 0:                 //"Follow me!"
                              //remove old follow, if any
         ClrPrgToFollow();
         AddProgram(0, PRG_FOLLOW, S_prg_add((dword)caller));
         break;
      case 1:                 //"Continue!"
                              //only current master may give us commands
         ClrPrgToFollow(caller);
         turn_angle = 0.0f;
         break;
      case 2:                 //"Move on!"
         {
            {                 //try remove 'wait on signal' command first
               S_signal_data sd;
               sd.actor = caller;
               if(cbProc(CB_SIGNAL, (dword)&sd, 1.0f)) break;
            }
            ClrPrgToFollow();
            const S_command *key = program.size() ? program.front() : NULL;
            //if(key.prg_item!=PRG_FOLLOW) break;
                           //find nice place in front of caller
            LPC_actor master = caller;
            S_vector mdir = - *master->GetHeadDir();
            const S_vector &mpos = *master->GetPos();
            S_vector pos = *GetPos();
                              //get collision with master's plane
            S_plane pl(mdir, -mpos.Dot(mdir));
            S_vector p;
            pl.Intersection(pos, mdir, p);

            if(key && key->prg_item==PRG_FOLLOW)
            {
               C_follow_formation *ff = key->sub_param.follow_form;
               ff->followers[ff->FollowerIndx(this)].ResetLookMode();
            }
                              //choose dest in distance from master's plane
            //pos = p + mdir * (8.0f + Random(4.0f));
            pos = p + mdir * (16.0f + S_float_random() * 8.0f);
            AddProgram(0, PRG_MOVE, S_prg_add((dword)&pos, true));
            cbProc(CB_PRG_SHOW);
         }
         break;
      case 3:                 //"Hey!" (get off caller's sight)
         {
            {                 //try remove 'wait on signal' command first
               S_signal_data sd;
               sd.actor = caller;
               if(cbProc(CB_SIGNAL, (dword)&sd, 1.0f)) break;
            }

            LPC_actor master = caller;
            S_vector mdir = - *master->GetHeadDir();
            const S_vector &mpos = *master->GetPos();
            const S_vector &pos = *GetPos();
                              //he looks 10 meters straight
            mdir.y = 0.0f;
            mdir.Normalize();
            mdir *= 10.0f;
                              //check how far we're to his sight
            float u = (pos-mpos).Dot(mdir) / mdir.Dot(mdir);
            if(u<0.0f || u>1.0f) break;
            float dist = (pos-(mpos+mdir*u)).Magnitude();
            if(dist > 1.0f) break;

            S_obstacle_move om(mpos, mpos+mdir, F2I(1.0));
            //cbProc(CB_OBSTACLE_MOVE, (dword)&om);
            ObstacleMove(om);
            turn_angle = 0.0f;
         }
         break;
      case 4:                 //"Hold fire!"
         holding_fire = true;
         break;
      }
   }

//----------------------------
                              //network actor: yes

   void GunMakeAnim(bool net_send){

      assert(gun);
      if(!gun) return;
      bool aim_shoot = mission.game_cam.GetFocusDir()==frame ? (mission.game_cam.GetDistanceMode() == 0) : false;
                              //run gun anim
      PI3D_animation_set anim;

      anim = mission.GetAnim("gunshoot.i3d");
      if(anim){
                              //apply to either gun or aim model
         PI3D_model mod(NULL);
         if(aim_shoot){
            PI3D_frame frm = mission.game_cam.GetAimModel();
            if(frm && frm->GetType()==FRAME_MODEL)
               mod = I3DCAST_MODEL(frm);
         }else mod = gun;
         if(mod){
            mod->StopAnimation(0);
            mod->SetAnimation(0, anim);
         }
      }
      const S_vector &gun_pos = gun->GetWorldPos();
      bool make_flare = true;
      if(mission.fps_counter.GetCount() < GUN_LIGHT_MIN_FPS)
         make_flare = false;

      if(make_flare && mission.tab_property->ItemB(TAB_B_SCN_OPTIM_GUNFLR)){
         make_flare = (!mission.GetScene()->GetSector(gun_pos)->IsPrimary());
      }
      if(make_flare)
         mission.MakeParticle("sh_flash", NULL, gun_pos, NULL, NULL);

      if(net && net_send){
         const bool g = false;
         net_msg->Ascend(net_id);
         net_msg->AddBits(NM_HUMAN_GUN_ANIM, NET_ACTOR_CODE_BITS, g);
         net_msg->Descend();
      }
   }

//----------------------------

   void SetGun(const char *name){

      if(!model) return;
      int i;
                              //remove old gun
      if(gun){
         gun->LinkTo(NULL);
         gun->Release();
         gun = NULL;
         if(GetType()==ACTOR_PLAYER && IsActive())
            mission.game_cam.SetAimModel(NULL, NULL);
      }
                              //release gun sound
      gun_sound[0] = NULL;
      gun_sound[1] = NULL;

      if(!name) return;

      PI3D_frame hand = model->FindChildFrame("gun*", ENUMF_WILDMASK | ENUMF_ALL);
      //assert(hand);
      if(!hand)
         return;

      gun = driver->CreateModel();
      if(I3D_FAIL(model_cache.Open(gun, name, mission.GetScene(), 0, ErrReport, editor))){
         gun->Release();
         gun = NULL;
         //OUTTEXT(C_fstring("Can't load weapon '%s'", (const char*)name));
         return;
      }
      gun->SetAnimation(0, NULL);
                              //put it into hand

            //if(hand->NumChildren()) hand->GetChild(0)->Release();
      assert(!hand->NumChildren());
      gun->LinkTo(hand);

      if(isound){
                              //open sound
         const char *cp = tab_inventory->ItemS(TAB_S16_INV_USESOUND, GetItem(selected_inv_item), 16);
         if(*cp){
            for(i=0; i<2; i++){
               C_fstring snd_name("%s%s", cp, !i ? "e" : "");
               gun_sound[i] = mission.CreateSound(snd_name, false);
               if(gun_sound[i]){
                  gun_sound[i]->LinkTo(gun);
                  gun_sound[i]->SetOn(false);
                  gun_sound[i]->SetRange(tab_game_cfg->ItemF(TAB_F_GAME_SNDR_GUN_MIN),
                     tab_game_cfg->ItemF(TAB_F_GAME_SNDR_GUN_MAX));
                  gun_sound[i]->SetLoop(false);
                  gun_sound[i]->Release();
               }else
               if(!i)
                  ReportActorError(C_fstring("can't open sound '%s'", (const char*)snd_name));
            }
         }
      }
   }

//----------------------------
                              //network support for C_human
   virtual void NetCodeIn(byte msg_code, PC_net_in_msg in_msg);

//----------------------------
   
   virtual void NetPlrDisconnect(dword pid){

      net_sync_grab->OnPlayerDisconnect(pid);
      C_actor::NetPlrDisconnect(pid);
   }

//----------------------------

                              //perform action to put to state similar to original human
   void NetSyncTick(int time){

                              //no position and dir update allowed when riding vehicle (shadow)
      bool enable_pos_dir_update(true);
      if(using_item)
      switch(using_item->GetType()){
      case ACTOR_AUTOMOBIL:
      case ACTOR_AUTO_CANNON:
         enable_pos_dir_update = false;
         break;
      }

      bool upd = false;

      if(enable_pos_dir_update)
      {
                              //adjust turn
         byte delta = abs(net_sync_abs_turn - net_sync_want_turn);
         if(delta){
                              //turn there
            net_sync_abs_turn = net_sync_want_turn;
            float angle = ((float)net_sync_abs_turn + .5f) * GetPI2()/256.0f;
            frame->SetDir(S_vector(-sin(angle), 0, cos(angle)));
            upd = true;
         }
      }

      if(enable_pos_dir_update)
      {
                              //adjust pos
         float delta = (net_sync_want_pos-net_sync_pos).Magnitude();
         if(delta){
            net_sync_pos = net_sync_want_pos;
            frame->SetPos(net_sync_pos);
            cbProc(CB_SET_FRAME_SECTOR);
            upd = true;
         }
      }

      {
                              //adjust aim dir
         if(aim_count && aim_count<=AIM_FADE_TIME){
            FreeAimFade(time, true, net_sync_aim_fade_factor, false);
            net_sync_aim_dir = net_sync_aim_want = aim_dir;
         }else{
            float delta = (net_sync_aim_want-aim_dir).Square();
            if(!IsMrgZero(delta)){
               SetAimDir(net_sync_aim_want, 0, false);
               ApplyAimDir();
            }
         }
      }
      if(upd)
         frame->Update();
      if(gun)
         gun->Tick(time);
   }

//----------------------------

   void LoadProgram(){

      if(!tab)
         return;

      static const E_PRG_ITEM prg_map[]={
         PRG_RESTART, PRG_MOVE, PRG_FOLLOW, PRG_USE,
         PRG_USE_INV, PRG_ATTACK, PRG_GUARD, PRG_WATCH,
         PRG_STAY_UP, PRG_STAY_MID, PRG_STAY_DOWN, PRG_RESTART,
         PRG_PRG1, PRG_WALK_CP, PRG_WAIT_SUSPENDED, PRG_SETVISIBLE,
         PRG_SUICIDE, PRG_DRIVE, PRG_SEND_SIGNAL, PRG_WAIT_SIGNAL,

      };
      ClrProgram(false);
      for(int i = 0, ii = -1; i<tab->ArrayLen(TAB_E_HUM_PRG_ITEM); i++){
         byte itm1 = tab->ItemE(TAB_E_HUM_PRG_ITEM, i);
         if(!itm1) continue;
         ++ii;
         E_PRG_ITEM itm = prg_map[itm1];
         S_vector pos;
                           //get add data
         const char *cp_name[2] = {
            tab->ItemS(TAB_S18_HUM_PRG_CP0, i, 18),
            tab->ItemS(TAB_S18_HUM_PRG_CP1, i, 18)
         };
         const char *subj_name = tab->ItemS(TAB_S18_HUM_PRG_SUBJ_NAME, i, 18);

         S_prg_add pa;

         switch(itm){
         case PRG_MOVE:
                           //setup running
            pa.d[1] = tab->ItemB(TAB_B_HUM_PRG_SHOWON, i);
         case PRG_GUARD:
         case PRG_WATCH:
         case PRG_DRIVE:
            {
               for(int j=0; j<(itm==PRG_GUARD ? 2 : 1); j++){
                  if(*cp_name[j]){
                     LPC_checkpoint cp = mission.FindCP(cp_name[j]);
                     if(!cp)
                        ReportActorError(C_fstring("can't find checkpoint '%s'", cp_name[j]));
                     if(!j){
                           //get physical location
                        if(cp) pos = cp->GetPos();
                        else pos.Zero();
                        pa.d[0] = (dword)&pos;
                     }else
                        pa.d[1] = (dword)cp;
                  }
               }
               switch(itm){
               case PRG_GUARD:
                  pa.d[2] = tab->ItemI(TAB_I_HUM_PRG_INV_ID, i);
                  break;
               case PRG_DRIVE:
                  pa.d[1] = tab->ItemI(TAB_I_HUM_PRG_INV_ID, i);
                  break;
               }
            }
            break;

         case PRG_WALK_CP:
            if(*cp_name[0]){
               LPC_checkpoint cp = mission.FindCP(cp_name[0]);
               if(cp){
                  pa.d[0] = (dword)cp;
                  if(*cp_name[1]){
                     cp = mission.FindCP(cp_name[1]);
                     if(cp){
                        pa.d[1] = (dword)cp;
                     }else
                        ReportActorError(C_fstring("can't find checkpoint '%s'", cp_name[1]));
                  }
               }else
                  ReportActorError(C_fstring("can't find checkpoint '%s'", cp_name[0]));
            }else{
               pa.d[0] = (dword)(LPC_checkpoint)(mission.GetCheckpoints()[S_int_random(mission.NumCheckpoints())]);
            }
            pa.d[2] = tab->ItemB(TAB_B_HUM_PRG_SHOWON, i);
            break;

         case PRG_FOLLOW:
            {              //find subject
               LPC_actor act = mission.FindActor(subj_name);
               if(act){
                  pa.d[0] = (dword)act;
               }else
                  ReportActorError(C_fstring("can't find subject '%s'", subj_name));
            }
            break;

         case PRG_PRG1:
            pa.d[0] = tab->ItemB(TAB_B_HUM_PRG_SHOWON, i);
            break;

         case PRG_ATTACK:
         case PRG_USE:
            {
                           //find subject & setup
               LPC_actor act = mission.FindActor(subj_name);
               if(act){
                  pa.d[0] = (dword)act;
                  switch(itm){
                  case PRG_USE:
                     pa.d[1] = tab->ItemI(TAB_I_HUM_PRG_INV_ID, i);
                     break;
                  case PRG_ATTACK:
                     pa.d[2] = AM_MUST_SUCCEED;
                     break;
                  }
               }else
                  ReportActorError(C_fstring("can't find subject '%s'", subj_name));
            }
            break;

         case PRG_USE_INV:
            pa.d[0] = tab->ItemI(TAB_I_HUM_PRG_INV_ID, i);
            break;

         case PRG_SEND_SIGNAL:
            if(*subj_name){
               LPC_actor a = mission.FindActor(subj_name);
               if(a)
                  pa.d[1] = (dword)a;
               else
                  ReportActorError(C_fstring("can't find subject '%s'", subj_name));
            }
                           //flow...
         case PRG_WAIT_SIGNAL:
         case PRG_WAIT_SUSPENDED:
            pa.d[0] = tab->ItemI(TAB_I_HUM_PRG_INV_ID, i);
            break;

         case PRG_SETVISIBLE:
            pa.d[0] = tab->ItemB(TAB_B_HUM_PRG_SHOWON, i);
            break;
         }
         AddProgram(ii, itm, pa, false);
      }
      cbProc(CB_PRG_PREPROCESS);
      cbProc(CB_PRG_SHOW, false, 1);

                              //if we're initially invisible, hide beforehand in net game
                              // so that synced players don't see enemies' positions
      if(net && program.size()){
         const S_command &cmd = *program.front();
         if(cmd.prg_item==PRG_SETVISIBLE){
            bool on = cmd.sub_param.setvisible_status;
            if(!on)
               SetVisible(on, false, false);
         }
      }
   }

//----------------------------

   virtual void SoundNotify(PI3D_frame frm, dword notify_id, dword stage){

#ifdef EDITOR
      if(type==ACTOR_ENEMY && AI_e(TAB_E_AI_ENABLED)!=2)
         return;
#endif
                              //accept notify only from animations from main stage (others fading out - invalid)
      //if(stage != MAIN_ANIM_STAGE)
      if(stage != anim_man.main_stage)
         return;

      if(last_mat_id==8 || last_mat_id==9){
                              //make footsteps
         if(col_floor){
            S_vector pos, normal;
            I3D_collision_data cd(frm->GetWorldPos(), S_vector(0, -1, 0), 0, model);
            bool floor = mission.GetScene()->TestCollision(cd);
            if(floor){
               pos = cd.GetHitPosition();
               normal = cd.GetHitNormal();

                              //make footsteps
               const S_vector &dir = frm->GetWorldDir();

               //float roll = Angle2D(S_vector2(dir.x, dir.z))+GetPI();

               bool left_feet = (frm->GetOrigName()[3]=='L');
               const char *cp = NULL;
               switch(stay_mode){
               case SM_STAY:
                  cp = left_feet ? "fstp_l" : "fstp_r";
                  break;
               case SM_BENCH:
                  cp = left_feet ? "fstp_l" : "fstp_1";
                  break;
               case SM_LAY:
                  cp = "fstp_1";
                  break;
               }
               if(!cp)
                  return;

               PI3D_model model = driver->CreateModel();
               if(I3D_SUCCESS(model_cache.Open(model, cp, mission.GetScene(), 0, ErrReport, editor))){
                  pos += normal*.02f;
                  model->SetPos(pos);
                  model->SetDir1(-normal, -dir);
                  model->Update();

                  LPC_actor act = mission.CreateActor(ACTOR_GUNHOLE);
                  act->SetFrame(model);
                  act->cbProc(CB_SETPARAM, 0, FloatAsInt(.25f));
               }
               model->Release();
            }
         }
      }
      {
                              //emit noise
         S_vector md(tab_human_anim->ItemF(TAB_F_ANI_SPEEDX, curr_pose),
            tab_human_anim->ItemF(TAB_F_ANI_SPEEDY, curr_pose),
            tab_human_anim->ItemF(TAB_F_ANI_SPEEDZ, curr_pose));
         float speed = md.Magnitude();
         //noise_accumulate += .2 + (speed*.2);
         S_listen_source ls(LISTEN_HUMAN, brest->GetWorldPos(), .3f + speed*2.8f);
                              //don't send over net - this source is generated on each machine
         mission.EmitListen(ls, tab_game_cfg->ItemF(TAB_F_GAME_SNDR_HUM_MAX)*.9f, false, this);

                              //make mine-field support
         if(mine_field_ratio){
            if(!S_int_random(mine_field_ratio)){
                              //exploded!
               S_explosion_init ei;
               ei.pos = frame->GetWorldPos();
               ei.creator = this;
               ei.id = EXPLOSION_MINE;
               mission.CreateActor(ACTOR_EXPLOSION, (dword)&ei);
            }
            mine_field_ratio=0;
         }
      }
      C_actor::SoundNotify(frm, notify_id, stage);
   }

//----------------------------

   virtual bool AnimNotify(PI3D_frame frm, dword notify_id, dword stage){

      if(network_actor)
         return false;

                              //accept notify only from animations from main stage (others fading out - invalid)
      //if(stage != MAIN_ANIM_STAGE)
      if(stage != anim_man.main_stage)
         return false;

      switch(notify_id){
      case NOTIFY_PUT:     //put item
         {
            bool del = false;
            int itm_i = C_inventory::GetActiveItem();
            E_INV_ITEM itm = (E_INV_ITEM)tab_inventory->ItemI(TAB_I_INV_ID, C_inventory::GetItem(itm_i));
            bool drop = false;
            switch(curr_pose){
            case POSE_ITEM_DROP: case POSE_ITEM_DROP + 0x20: case POSE_ITEM_DROP + 0x40:
               drop = true;
               break;
            }
            if(drop){
               int i = itm_i;

               S_resource_init ri;
               ri.pos = frm->GetWorldPos();
               ri.inv_id = C_inventory::GetItem(i);
               ri.amount = C_inventory::GetItemAmount(i);
               mission.CreateActor(ACTOR_RESOURCE, (dword)&ri);
               del = true;
            }else
            switch(itm){
            case INV_MINE:
               {           //dig it here
                  S_mine_init mi;

                              //put to special position:
                              // - Y from hand's pos
                              // - XZ from head's pos
                  //mi.pos = frm->GetWorldPos();
                  mi.pos = frm_head->GetWorldPos();
                  mi.pos.y = frm->GetWorldPos().y;
                  I3D_collision_data cd(mi.pos, -axis_y, 0, frame);
                  //DebugLine(cd.from, cd.from+cd.dir, 0, 0xffffffff);
                  if(!mission.GetScene()->TestCollision(cd))
                     break;   //no place for dig, do not put mine
                  //else DebugLine(mi.pos, cd.GetHitPosition(), 0, 0xffffff00);
                  mi.id = C_inventory::GetItem(itm_i);
                  mission.CreateActor(ACTOR_MINE, (dword)&mi);

                  int i = GetItemAmount(itm_i);
                  if(!--i) del = true;
                  else{
                     C_inventory::SetItemAmount(itm_i, i);
                     if(net)
#ifndef ENEMY_NET_SYNC_INV
                     if(GetType()==ACTOR_PLAYER)
#endif
                     {
                        const bool g = true;
                        net_msg->Ascend(net_id);
                              //0 = set amount (bits:12 amount)
                        net_msg->AddBits(NM_HUMAN_INVENTORY, NET_ACTOR_CODE_BITS, g);
                        net_msg->AddBits(itm_i, 6, g);
                        net_msg->AddBits(0, 3, g);
                        net_msg->AddBits(i, 12, g);
                        net_msg->Descend();
                     }
                  }
               }
               break;
            case INV_TIME_BOMB:
               {
                  S_time_bomb_init ti;
                  ti.pos = frm->GetWorldPos();
                  ti.who_put_it = this;
                  LPC_actor a = mission.CreateActor(ACTOR_TIME_BOMB, (dword)&ti);

                  int i = GetItemAmount(itm_i);
                  if(!--i) del = true;
                  else{
                     C_inventory::SetItemAmount(itm_i, i);

                     if(net)
#ifndef ENEMY_NET_SYNC_INV
                     if(GetType()==ACTOR_PLAYER)
#endif
                     {
                        const bool g = true;
                        net_msg->Ascend(net_id);
                              //0 = set amount (bits:12 amount)
                        net_msg->AddBits(NM_HUMAN_INVENTORY, NET_ACTOR_CODE_BITS, g);
                        net_msg->AddBits(itm_i, 6, g);
                        net_msg->AddBits(0, 3, g);
                        net_msg->AddBits(i, 12, g);
                        net_msg->Descend();
                     }
                  }
                           //if programmed, set time directly, rather than waiting for player
                  if(program.size() && program.front()->prg_item==PRG_USE_INV &&
                     program.front()->sub_param.use_inv_id==10){

                     a->cbProc(CB_USE_TIME_BOMB, 4, 40000);
                     a->cbProc(CB_USE_TIME_BOMB, 3);
                  }else{
                     SetUsingItem(a, true);
                     PlayAnimNet(POSE_GRAB, false, true, true, true);
                  }
               }
               break;
            default:
               assert(0);
            }
            if(del){

               int active = itm_i;
               C_inventory::DeleteItem(active);
               if(net)
#ifndef ENEMY_NET_SYNC_INV
               if(GetType()==ACTOR_PLAYER)
#endif
               {              //4 = delete item
                  const bool g = true;
                  net_msg->Ascend(net_id);
                  net_msg->AddBits(NM_HUMAN_INVENTORY, NET_ACTOR_CODE_BITS, g);
                  net_msg->AddBits(active, 6, g);
                  net_msg->AddBits(4, 3, g);
                  net_msg->Descend();
               }
               if(selected_inv_item>=active){
                  if(selected_inv_item==active) SetSelectedInvItem(0);
                  else SetSelectedInvItem(selected_inv_item-1);
               }
            }
         }
         if(C_inventory::IsVisible())
            mission.game_menu.SetInventory(NULL);
         break;

      case NOTIFY_GET:     //get item (resource)
         {
            LPC_actor use_item = FindUseItem();
            if(use_item && use_item->GetType()==ACTOR_RESOURCE){
               LPC_table r_tab = use_item->GetTable(0);
               if(r_tab){
                  int itm = r_tab->ItemI(TAB_I_RES_INVTYPE);
                  int amount = r_tab->ItemI(TAB_I_RES_AMOUNT);
                           //check if we may carry this
                  float max_carriage = CountManCarriage(tab);
                           //count what we have in the pack, including new item
                  float weight_sum = C_inventory::CountWeight() +
                     C_inventory::GetItemWeight(itm, amount);
                  if(weight_sum>max_carriage){
                     mission.PlaySoundGlobal("inv_cant");
                     return false;
                  }
                           //tell to resource that it should belong to us (it will call us later)
                  return use_item->cbProc(CB_USE_RESOURCE, 0, (dword)this);
               }
            }
         }
         break;

      case NOTIFY_CHANGE:  //change weapon
         {
            //if(C_inventory::IsVisible()) game_menu.SetInventory(NULL);
            //E_INV_ITEM itm = (E_INV_ITEM)tab_inventory->ItemI(TAB_I_INV_ID, C_inventory::GetItem(C_inventory::GetActiveItem()));
                           //change weapon
            if(selected_inv_item != C_inventory::GetActiveItem()){
               SetSelectedInvItem(C_inventory::GetActiveItem());
            }else{
               SetSelectedInvItem(0);
            }
            //if(cbProc(CB_ISACTIVE)) game_menu.SetInventory(this);
         }
         break;

      case NOTIFY_THROW:
      case NOTIFY_FLARE_FIRE:
         {
            int itm_i = selected_inv_item;
            E_INV_ITEM itm = (E_INV_ITEM)tab_inventory->ItemI(TAB_I_INV_ID, C_inventory::GetItem(itm_i));
            switch(itm){
            case INV_GRENADE:
               {
                              //get right hand
                  PI3D_frame rh = frm;
                  S_vector dir = model->GetWorldDir();

                  S_matrix m1, m2, m3;
                  m1.Identity();
                  m2.Identity();
                  m1.SetDir(dir, 0.0f);
                  S_vector dir1 = aim_dir;
                  dir1.y = -dir1.y;
                  //m1 = RotateXMatrix(PI*.2f)*m1*m2;
                  m3.RotationX(PI*.2f);
                  m1 = m3 * m1 * m2;

                  dir = dir1.RotateByMatrix(m1);
                  dir *= ((float)Min(throw_power, 700)/60.0f);
                  throw_power = 0;
                  S_vector pos = rh->GetWorldPos();
                  {
                           //check if not volume between the hand and body center (brest)
                     S_vector pos1 = brest->GetWorldPos();
                     pos1.y = pos.y;
                     I3D_collision_data cd(pos1, pos-pos1, 0, model);
                     //DebugLine(cd.from, cd.from + cd.dir, 0, 0xff0000ff);
                     if(mission.GetScene()->TestCollision(cd)){
                        const S_vector &pos2 = cd.GetHitPosition();
                        const S_vector &norm = cd.GetHitNormal();
                           //adjust position not to be behind volume
                        pos = pos2 + norm * .1f;
                     }
                  }
                  S_grenade_init gi;
                  gi.pos = pos;
                  gi.dir = dir;
                  //DebugLine(pos, pos+dir, 0, 0xffff0000);
                  gi.inv_id = C_inventory::GetItem(itm_i);
                  gi.thrower = this;
                  gi.net_create = true;
                  mission.CreateActor(ACTOR_GRENADE, (dword)&gi);

                  GrenadeStopThrow();
               }
               break;

            case INV_FLAREGUN:
               {
                  PI3D_frame rh = frm;
                  S_vector dir = rh->GetWorldDir();
                  dir.Invert();
                  dir.Normalize();
                  dir *= 30.0f;

                  S_flare_init fi;
                  fi.pos = rh->GetWorldPos();
                  fi.dir = dir;
                  fi.shooter = this;

                  mission.CreateActor(ACTOR_FLARE, (dword)&fi);
               }
               break;
            }
            const bool g = true;
                           //dec item
            int i = GetItemAmount(itm_i);
            if(!--i){
               DeleteItem(itm_i);
               if(net)
#ifndef ENEMY_NET_SYNC_INV
               if(GetType()==ACTOR_PLAYER)
#endif
               {
                  net_msg->Ascend(net_id);
                              //4 = delete item
                  net_msg->AddBits(NM_HUMAN_INVENTORY, NET_ACTOR_CODE_BITS, g);
                  net_msg->AddBits(itm_i, 6, g);
                  net_msg->AddBits(4, 3, g);
                  net_msg->Descend();
               }
               SetSelectedInvItem(0, true);
            }else{
               C_inventory::SetItemAmount(itm_i, i);
               cbProc(CB_SHOW_AMMO);

               if(net)
#ifndef ENEMY_NET_SYNC_INV
               if(GetType()==ACTOR_PLAYER)
#endif
               {
                  net_msg->Ascend(net_id);
                           //0 = set amount (bits:12 amount)
                  net_msg->AddBits(NM_HUMAN_INVENTORY, NET_ACTOR_CODE_BITS, g);
                  net_msg->AddBits(itm_i, 6, g);
                  net_msg->AddBits(0, 3, g);
                  net_msg->AddBits(i, 12, g);
                  net_msg->Descend();
               }
            }
         }
         break;

      case NOTIFY_JUMP:
         fall_speed = -4.0f;
         break;

      case NOTIFY_LOAD_GUN:
         {
            mission.PlaySound("load", frm->GetWorldPos(), 2.0f, 8.0f);
            C_inventory::Reload(selected_inv_item, true);
            cbProc(CB_SHOW_AMMO);
            if(net)
#ifndef ENEMY_NET_SYNC_INV
            if(GetType()==ACTOR_PLAYER)
#endif
            {                 //5 = reload ammo
               const bool g = true;
               net_msg->Ascend(net_id);
               net_msg->AddBits(NM_HUMAN_INVENTORY, NET_ACTOR_CODE_BITS, g);
               net_msg->AddBits(selected_inv_item, 6, g);
               net_msg->AddBits(5, 3, g);
               net_msg->AddBits(true, 1, g);
               net_msg->Descend();
            }
         }
         break;

      case NOTIFY_PULL_GUN:
         {
            mission.PlaySound("pullon", frm->GetWorldPos(), 2.0f, 8.0f);
         }
         break;

      case NOTIFY_KNIFE_HIT:
         {
                           //enum human actors and check who may be killed
            struct S_hlp{
               S_vector pos, dir;
               LPC_actor murderer;
               C_game_mission *mission;

               static bool cbAct(LPC_actor a, dword hp){
                  switch(a->GetType()){
                  case ACTOR_PLAYER:
                  case ACTOR_ENEMY:
                     if(a->IsAlive()){
                        S_hlp &sh = *(S_hlp*)hp;
                        if(a==sh.murderer)
                           break;
                        const S_vector &pos = sh.pos;
                                             //check if we're hit
                                             //get general dist
                        const S_vector &apos = *a->GetBrestPos();
                        float dist = (apos-pos).Magnitude();
                                             //no way my friend...
                        if(dist>2.0f)
                           break;
                                             //check any body part
                        struct S_hlp{
                           const S_vector *pos, *dir;
                           PI3D_frame hit;
                           static I3DENUMRET I3DAPI cbP(PI3D_frame frm, dword hp){
                              S_hlp &sh = *(S_hlp*)hp;
                              const S_vector &pos = *sh.pos;
                              const S_vector &frm_pos = frm->GetWorldPos();
                              float dist = (pos-frm_pos).Magnitude();
                              if(dist<1.0f){
                                             //check 2D direction to dest
                                 S_vector dir_to_f = frm_pos - pos;
                                 float a = Angle2D(S_vector2(sh.dir->x, sh.dir->z), S_vector2(dir_to_f.x, dir_to_f.z));
                                 if(fabs(a) < PI*.3f){
                                             //ok, we're hit
                                    sh.hit = frm;
                                    return I3DENUMRET_CANCEL;
                                 }
                              }
                              return I3DENUMRET_OK;
                           }
                        } hlp;
                        hlp.pos = &pos;
                        hlp.dir = &sh.dir;
                        hlp.hit = NULL;
                        a->GetFrame()->EnumFrames(S_hlp::cbP, (dword)&hlp, ENUMF_VISUAL | ENUMF_JOINT);
                        if(hlp.hit){
                                       //we're killed by knife!
                           a->cbProc(CB_DIE_BY_KNIFE, (dword)&pos);
                           LPC_actor a = sh.mission->MakeParticle(
                              game_configuration.censored ? "g_blood" : "blood",
                              game_configuration.censored ? "particle\\g_blood.tab" : "particle\\blood.tab",
                              S_vector(0, 0, 0), hlp.hit, &sh.dir);
                           if(a){
                              PI3D_frame prtc = a->GetFrame()->FindChildFrame(NULL, ENUMF_VISUAL);
                              if(prtc && prtc->GetType()==FRAME_VISUAL){
                                 PI3D_visual vis = I3DCAST_VISUAL(prtc);
                                 vis->SetProperty(PRT_ELEMENT_SCALE, FloatAsInt(.05f));
                              }
                           }
                           return false;
                        }
                     }
                     break;
                  }
                  return true;
               }
            } hlp;
            mission.PlaySound("knife", NULL, 3, 10);
            //hlp.pos = frm->GetWorldPos();
            hlp.pos = *GetBrestPos();
            hlp.dir = frame->GetWorldDir();
            hlp.murderer = this;
            hlp.mission = &mission;
            mission.EnumActors(S_hlp::cbAct, (dword)&hlp);
         }
         break;

      case NOTIFY_GRAB_OK:
         //OUTTEXT(frm->GetName());
         {
                           //negotiate with grabbed item
            LPC_actor a_grab = FindUseItem();
            if(a_grab)
            switch(a_grab->GetType()){
            case ACTOR_PLAYER:
            case ACTOR_ENEMY:
               int i = a_grab->cbProc(CB_INV_GRAB, 5, (dword)this);
               switch(i){
               case 0:     //failed
                  PlayAnimNet(POSE_GRAB_FINISH, false, false, true, true);
                  break;
               case 1:     //success
               case 2:     //in progress
                  PlayAnimNet(POSE_GRAB, false, true, true, true);
                  break;
               }
               break;
            }
         }
         break;

      case NOTIFY_DOOR_OPEN:
         if(using_item){
            using_item->cbProc(CB_USE_DOOR, 1, (dword)this);
            SetUsingItem(NULL, true);
         }
         break;
      }
      return true;
   }

//----------------------------

   virtual const S_vector *GetHeadDir() const{

      assert(frm_head);
      return &frm_head->GetWorldDir();
   }

//----------------------------

   virtual const S_vector *GetHeadPos() const{

      if(!frm_head)
         return NULL;
      return &frm_head->GetWorldPos();
   }

//----------------------------

   virtual bool GetCenterPos(S_vector &pos) const{

      PI3D_frame center_frame = model->FindChildFrame("Trup*", ENUMF_VISUAL | ENUMF_JOINT | ENUMF_WILDMASK);
      pos = (center_frame ? center_frame : frame)->GetWorldPos();
      return true;
   }

//----------------------------

   virtual const S_vector *GetBrestPos() const{
      return &(brest ? brest : frame)->GetWorldPos();
   }

//----------------------------

   virtual int NumUsePositions(C_actor *asker = NULL) const{
                              //dead with something in inv. may be 'used'
      if(!using_item){
         if(stay_mode==SM_DEAD && asker->IsHuman()){
            if(C_inventory::NumItems()>1)
               return 1;
         }
      }
      return 0;
   }

//----------------------------

   virtual bool IsAlive() const{ return (stay_mode != SM_DEAD); }

//----------------------------

   virtual bool IsHuman() const{ return true; }

//----------------------------

   virtual int Use(LPC_actor user, dword prm2, bool force_use_off){

                              //if I'm dead
                              // give him access to my inventory
      if(stay_mode==SM_DEAD){
         if(prm2){
                           //let user begin grab anim - this is only promise, real grabbing begins when he's ready with anim
            user->cbProc(CB_INV_GRAB, 4, (dword)this);
         }else{
                           //stop grabbing
            if(using_item==user){
               user->cbProc(CB_INV_GRAB, 0, NULL);
               SetUsingItem(NULL, true);
            }
         }
      }
      return 0;
   }

//----------------------------

   virtual E_STAY_MODE GetStayMode() const{ return stay_mode; }

//----------------------------

   virtual int GetCurrPose() const{ return curr_pose; }

//----------------------------

   virtual bool HasWeaponInHands() const{ return (selected_inv_item!=0); }

//----------------------------

   virtual int GetEnemyGroup() const{ return 0; }

//----------------------------

   virtual bool IsSeeing(C_actor *subj) const{

      for(int i=watch_actors.size(); i--; ){
         if(watch_actors[i].actor==subj)
            return (watch_actors[i].seen_amount>.2f);
      }
      return false;
   }

//----------------------------

   virtual C_actor *GetUsingItem() const{ return using_item; }

//----------------------------

   virtual bool ObstacleMove(const S_obstacle_move &om){

                              //look what can we do about this
                              //if we're dying, it's too late...
      if(stay_mode==SM_DEAD)
         return false;

                              //check if already moving...
      if(program.size()){
         switch(program.front()->prg_item){
         case PRG_STEP:
         case PRG_MOVE:
            return true;
         case PRG_ATTACK:
         case PRG_GUARD:
         case PRG_WALK_CP:
         case PRG_FOLLOW:
            break;
         default: return false;
         }
      }
                              //check if we aren't using anything
      if(using_item)
         return false;

                              //check where could we move...
      S_vector dest(frame->GetWorldPos());
      S_vector2 dest2(dest.x, dest.z);
      S_vector req_dir = om.to - om.from;
      S_vector2 req_dir2(req_dir.x, req_dir.z);

      S_vector my_dir = dest - om.from;

      float my_angle = Angle2D(req_dir2, S_vector2(my_dir.x, my_dir.z));
      bool right_side = (my_angle < 0.0f);

      S_vector possible_dest;
      S_vector2 possible_dest2;
      req_dir2.Normalize();
      float req_dir_angle = Angle2D(req_dir2);

      S_vector col_from(frame->GetWorldPos());
      col_from.y += 1.0f;
      bool solved = false;
      for(int i=0; i<3; i++){
         S_matrix2 m2;

         switch(i){
         case 0:              //try easier dir first
         case 1:
            m2.SetDir(req_dir_angle +
               ((!i ? right_side : !right_side) ? -PI/2 : PI/2));
            break;
         case 2:
            m2.SetDir(req_dir_angle);
            break;
         }
         possible_dest2 = dest2 + m2(1);

         possible_dest.x = possible_dest2[0];
         possible_dest.y = dest.y;
         possible_dest.z = possible_dest2[1];

                              //check if space free
         S_vector col_to(possible_dest);
         col_to.y += 1.0f;
            I3D_collision_data cd(col_from, col_to-col_from, 0, frame, WatchColResp2);
         bool b = mission.GetScene()->TestCollision(cd);
         if(!b){
            solved=true;
            break;
         }
      }

      if(solved){
                              //insert STEP program
         AddProgram(0, PRG_STEP, S_prg_add((dword)&possible_dest));
         return true;
      }
      return false;
   }

//----------------------------
   
   virtual E_RELATION GetRelation(C_actor *a) const{ return RELATION_NEUTRAL; }

//----------------------------

   virtual int GetVoiceID() const{ return tab->ItemI(TAB_I_HUM_VOICE); }

//----------------------------

   virtual bool IsOnMap() const{ return true; }

//----------------------------

   virtual LPC_table GetTable(int index) const{
      if(index==0)
         return tab;
      return C_actor::GetTable(index);
   }

//----------------------------

   virtual class C_table_template *GetTemplate(int) const{ return &templ_hum_prop; }

//----------------------------

   virtual void TableUpdate(int index, bool not_load_prg){

                              //(re)load inventory
      if(C_inventory::IsVisible())
         mission.game_menu.SetInventory(NULL);

      C_inventory::DeleteAllItems();

      for(int i=0; i<tab->ArrayLen(TAB_I_HUM_INV_LIST); i++){
         int itm = tab->ItemI(TAB_I_HUM_INV_LIST, i);
         if(!itm)
            continue;
         if(itm >= tab_inventory->ArrayLen(TAB_I_INV_ID) || !*tab_inventory->ItemS(TAB_S32_INV_NAME, itm, 32)){
            ReportActorError(C_fstring("Invalid inventory item in table: %i", itm));
            continue;
         }
         if(tab_inventory->ItemI(TAB_I_INV_ID, itm)!=INV_HANDS){
            C_inventory::AddItem(itm, tab->ItemI(TAB_I_HUM_INV_AMOUNT, i));
            if(!i){
               SetSelectedInvItem(1, false);
            }
            C_inventory::Reload(C_inventory::NumItems()-1, true);
         }
      }
      if(selected_inv_item >= C_inventory::NumItems())
         selected_inv_item = Min(1, C_inventory::NumItems()-1);
      cbProc(CB_SHOW_AMMO);
   }

//----------------------------

   virtual void MissionSave(C_chunk *ck) const{ SaveTable(ck, tab); }
   virtual bool MissionLoad(C_chunk *ck, int table_id){ return LoadTable(ck, tab); }

//----------------------------

   virtual void SaveGame(C_chunk *ck) const{

      SG_SaveModelInfo(ck, true);
                           //save visibility
      bool on = frame->IsOn();
      ck->Write(&on, sizeof(bool));
      PI3D_frame vol = frame->FindChildFrame(NULL, ENUMF_VOLUME);
      assert(vol);
      on = vol->IsOn();
      ck->Write(&on, sizeof(bool));
                           //save focus
      bool focus = (mission.game_cam.GetFocusDir()==frame);
      ck->Write(&focus, sizeof(bool));

                           //write data
      ck->Write(&fall_speed, sizeof(fall_speed));
      ck->Write(&curr_pose, sizeof(curr_pose));
                           //get curr anim time
      int anim_time = 10000;
      if(model->NumInterpolators()){
         //anim_time = model->GetInterpolators()[0]->GetCurrTime(MAIN_ANIM_STAGE);
         anim_time = model->GetInterpolators()[0]->GetCurrTime(anim_man.main_stage);
      }
      ck->Write(&anim_time, sizeof(anim_time));

      ck->Write(&aim_dir, sizeof(aim_dir));
      ck->Write(&aim_fade_base, sizeof(aim_fade_base));
      ck->Write(&aim_count, sizeof(aim_count));
      ck->Write(&stay_mode, sizeof(stay_mode));
      ck->Write(&throw_power, sizeof(throw_power));
      ck->Write(&shoot_cntdwn, sizeof(shoot_cntdwn));
      ck->Write(&falling, sizeof(falling));
      ck->Write(&last_on_feet_pos, sizeof(last_on_feet_pos));
      ck->Write(&relaxed_weapon_hold, sizeof(relaxed_weapon_hold));
      ck->Write(&holding_fire, sizeof(holding_fire));
      ck->Write(&resistance, sizeof(resistance));
                           //using item
      ck->WStringChunk(CT_NAME, using_item ? using_item->GetName() : "");
                           //inventory
      {
         word num_i = C_inventory::NumItems();
         ck->Write(&num_i, sizeof(num_i));
         word w = C_inventory::GetActiveItem();
         ck->Write(&w, sizeof(w));
         for(int i=1; i<num_i; i++){
            byte b = C_inventory::GetItem(i);
            ck->Write(&b, sizeof(b));
            w = C_inventory::GetItemAmount(i);
            ck->Write(&w, sizeof(w));
            w = C_inventory::GetBullets(i);
            ck->Write(&w, sizeof(w));
         }
      }
                           //program
      word prg_size = program.size();
      ck->Write(&prg_size, sizeof(prg_size));
      for(int i=0; i<prg_size; i++){
         const S_command &key = *program[i];
                           //write program
         ck->Write(&key.prg_item, sizeof(byte));

         bool sub_write = false;

         switch(key.prg_item){
         case PRG_MOVE:          //d0 = (LPS_vector)dest, d1 = (bool)run, d2 = E_MOVE_REASON, d3 = (bool)force_smart
            ck->Write(&key.dest, sizeof(S_vector));
            ck->Write(&key.sub_param.run, sizeof(bool));
            ck->Write(&key.sub_param.move_reason, sizeof(byte));
            ck->Write(&key.sub_param.force_smart, sizeof(bool));
            break;
         case PRG_GUARD:   //d0 = (LPS_vector)dest, [d1 = (LPC_checkpoint)aim_dest, d2 = countdown, d3 = (S_vector*)dest, d4 = (LPC_actor)subject]
            {
               ck->Write(&key.sub_param.guard_dest_set, sizeof(bool));
               ck->Write(&key.dest, sizeof(S_vector));
               {
                  word w = key.sub_param.guard_aim_dest ? key.sub_param.guard_aim_dest->GetIndex() : -1;
                  ck->Write(&w, sizeof(w));
               }
               ck->Write(&key.sub_param.guard_count, sizeof(dword));
               ck->Write(&key.sub_param.guard_aim_dest_set, sizeof(bool));
               ck->Write(key.sub_param.guard_aim_dest_v, sizeof(S_vector));
               sub_write = true;
            }
            break;
         case PRG_FOLLOW:  //d0 = (LPC_actor)subject
            sub_write = true;
            break;
         case PRG_USE:     //d0 = (LPC_actor)subject, [d1 = use_indx, d2 = (float)min_use_dist]
            {
               ck->Write(&key.sub_param.use_reserve_indx, sizeof(dword));
               ck->Write(&key.sub_param.min_use_dist, sizeof(dword));
               sub_write = true;
            }
            break;
         case PRG_ATTACK:  //d0 = (LPC_actor)subject, [d1 = attack_body_part_index, d2 = E_ATTACK_MODE]
            ck->Write(&key.sub_param.enm_body_part_index, sizeof(int));
            ck->Write(&key.sub_param.attack_mode, sizeof(byte));
            sub_write = true;
            break;
         case PRG_USE_INV: //d0 = int inv_itm_id
            ck->Write(&key.sub_param.use_inv_id, sizeof(short));
            break;
         case PRG_WATCH:   //d0 = (LPS_vector)dest, [d1 = phase_count (def.=4)]
            //ck->Write(&key.dest, sizeof(S_vector));
            ck->Write(key.sub_param.watch.base_dest, sizeof(S_vector));
            ck->Write(&key.sub_param.watch.phase_count, sizeof(short));
            break;
         case PRG_WALK_CP: //d0 = (LPC_checkpoint)start_CP, [d1 = (LPC_checkpoint)next, d2 = (bool)run]
            {
               word w = key.sub_param.cp_dest ? key.sub_param.cp_dest->GetIndex() : -1;
               ck->Write(&w, sizeof(w));
               w = key.sub_param.cp_next ? key.sub_param.cp_next->GetIndex() : -1;
               ck->Write(&w, sizeof(w));
               ck->Write(&key.sub_param.walk_cp_run, sizeof(bool));
            }
            break;

         case PRG_SETVISIBLE:    //d0 = (bool)on
            ck->Write(&key.sub_param.setvisible_status, sizeof(bool));
            break;

         case PRG_STEP:
         case PRG_PRG1:
                           //ignoring
            break;

         case PRG_SEND_SIGNAL:   //d0 = int signal_id, d1 = (LPC_actor)subject <NULL=broadcast>
            sub_write = true;
                           //flow...
         case PRG_WAIT_SIGNAL:   //d0 = int signal_id
         case PRG_WAIT_SUSPENDED:
                                 //signal id
            ck->Write(&key.sub_param.wait_signal_id, sizeof(int));
            break;

         case PRG_SUSPEND: //d0 = dword time
            ck->Write(&key.sub_param.suspend_count, sizeof(int));
            break;

         case PRG_DRIVE:   //d0 = (LPS_vector)dest, d1 = ideal_speed
            ck->Write(&key.dest, sizeof(S_vector));
            ck->Write(&key.sub_param.drive_ideal_speed, sizeof(int));
            break;

         case PRG_LADDER_CLIMB:  //d0 = bool climb_up
            ck->Write(&key.sub_param.ladder_climb_up, sizeof(bool));
            break;

         case PRG_STAY_UP:
         case PRG_STAY_MID:
         case PRG_STAY_DOWN:
            break;

         default:
            assert(0);
         }
         if(sub_write)
         {
            ck->WStringChunk(CT_NAME, key.GetSubject() ? key.GetSubject()->GetName() : "");
         }
      }
      ck->Write(&selected_inv_item, sizeof(selected_inv_item));

      C_actor::SaveGame(ck);
   }

//----------------------------

   virtual bool LoadGame(C_chunk *ck){

      if(!frame)
         return false;

      if(!SG_LoadModelInfo(ck, true))
         return false;
                              //read visibility

      bool on;
      ck->Read(&on, sizeof(bool));
      frame->SetOn(on);
      ck->Read(&on, sizeof(bool));
      if(!on)
         SetVisible(on, true, false);
                              //read focus
      bool focus;
      ck->Read(&focus, sizeof(bool));
      if(focus)
         cbProc(CB_SETFOCUS, 1);

                              //read data
      ck->Read(&fall_speed, sizeof(fall_speed));
      int anim_pose;
      ck->Read(&anim_pose, sizeof(anim_pose));
      int anim_time ;
      ck->Read(&anim_time, sizeof(anim_time));
      ck->Read(&aim_dir, sizeof(aim_dir));
      ck->Read(&aim_fade_base, sizeof(aim_fade_base));
      ck->Read(&aim_count, sizeof(aim_count));
      ck->Read(&stay_mode, sizeof(stay_mode));
      ck->Read(&throw_power, sizeof(throw_power));
      ck->Read(&shoot_cntdwn, sizeof(shoot_cntdwn));
      ck->Read(&falling, sizeof(falling));
      ck->Read(&last_on_feet_pos, sizeof(last_on_feet_pos));
      ck->Read(&relaxed_weapon_hold, sizeof(relaxed_weapon_hold));
      ck->Read(&holding_fire, sizeof(holding_fire));
      ck->Read(&resistance, sizeof(resistance));
      ApplyAimDir();
                              //set using item
      C_string str;
      ck->ReadString(CT_NAME, str);
      if(str.Size()){
         using_item = mission.FindActor(str);
         if(!using_item){
            ReportActorError(C_fstring("Loadgame: can't find using actor: '%s'", (const char*)str));
            return false;
         }
      }
                              //inventory
      {
         word num_i;
         ck->Read(&num_i, sizeof(num_i));
         word a_i;
         ck->Read(&a_i, sizeof(a_i));
         C_inventory::DeleteAllItems();
         for(int i=1; i<num_i; i++){
            byte b;
            ck->Read(&b, sizeof(b));
            word ia, nb;
            ck->Read(&ia, sizeof(ia));
            ck->Read(&nb, sizeof(nb));
            C_inventory::AddItem(b, ia);
            C_inventory::SetBullets(C_inventory::NumItems()-1, nb);
         }
         C_inventory::SetActiveItem(a_i);
      }
                              //load program
      ClrProgram(false);
      word prg_size;
      ck->Read(&prg_size, sizeof(prg_size));
      for(int i=0; i<prg_size; i++){
                              //read program
         byte b;
         ck->Read(&b, sizeof(byte));
         S_vector tmp1, tmp2;
         S_prg_add pa;
         bool tmp_bool;
         byte tmp_b;
         short tmp_s;
         dword tmp_d;
         int sub_index = -1;  //don't load subject

         switch(b){
         case PRG_MOVE:
            ck->Read(&tmp1, sizeof(S_vector));
            pa.d[0] = (dword)&tmp1;
            ck->Read(&tmp_bool, sizeof(bool));
            pa.d[1] = tmp_bool;
            ck->Read(&tmp_b, sizeof(byte));
            pa.d[2] = tmp_b;
            ck->Read(&tmp_bool, sizeof(bool));
            pa.d[3] = tmp_bool;
            break;
         case PRG_GUARD:      //d0 = (LPS_vector)dest, [d1 = (LPC_checkpoint)aim_dest, d2 = countdown, d3 = (S_vector*)dest, d4 = (LPC_actor)subject]
            ck->Read(&tmp_bool, sizeof(bool));
            ck->Read(&tmp1, sizeof(S_vector));
            if(tmp_bool) pa.d[0] = (dword)&tmp1;
            ck->Read(&tmp_s, sizeof(short));
            if(tmp_s!=-1) pa.d[1] = (dword)(LPC_checkpoint)mission.GetCheckpoints()[(word)tmp_s];
            ck->Read(&tmp_d, sizeof(dword));
            pa.d[2] = tmp_d;
            ck->Read(&tmp_bool, sizeof(bool));
            ck->Read(&tmp2, sizeof(S_vector));
            if(tmp_bool) pa.d[3] = (dword)&tmp2;
            sub_index = 4;
            break;
         case PRG_FOLLOW:     //d0 = LPC_actor subject
            sub_index = 0;
            break;
         case PRG_USE:        //d0 = (LPC_actor)subject, [d1 = use_indx, d2 = (float)min_use_dist]
            ck->Read(&pa.d[1], sizeof(dword));
            ck->Read(&pa.d[2], sizeof(dword));
            sub_index = 0;
            break;
         case PRG_ATTACK:     //d0 = (LPC_actor)subject, [d1 = attack_body_part_index, d2 = E_ATTACK_MODE]
            ck->Read(&pa.d[1], sizeof(int));
            ck->Read(&tmp_b, sizeof(byte));
            pa.d[2] = tmp_b;
            sub_index = 0;
            break;
         case PRG_USE_INV:    //d0 = int inv_itm_id
            ck->Read(&tmp_s, sizeof(short));
            pa.d[0] = tmp_s;
            break;
         case PRG_WATCH:      //d0 = (LPS_vector)dest, [d1 = phase_count (def.=4)]
            ck->Read(&tmp1, sizeof(S_vector));
            pa.d[0] = (dword)&tmp1;
            ck->Read(&tmp_s, sizeof(short));
            pa.d[1] = tmp_s;
            break;
         case PRG_WALK_CP:    //d0 = (LPC_checkpoint)start_CP, [d1 = (LPC_checkpoint)next, d2 = (bool)run]
            ck->Read(&tmp_s, sizeof(short));
            if(tmp_s!=-1) pa.d[0] = (dword)(LPC_checkpoint)mission.GetCheckpoints()[(word)tmp_s];
            ck->Read(&tmp_s, sizeof(short));
            if(tmp_s!=-1) pa.d[1] = (dword)(LPC_checkpoint)mission.GetCheckpoints()[(word)tmp_s];
            ck->Read(&tmp_bool, sizeof(bool));
            pa.d[2] = tmp_bool;
            break;
         case PRG_SETVISIBLE: //d0 = (bool)on
            ck->Read(&tmp_bool, sizeof(bool));
            pa.d[0] = tmp_bool;
            break;
         case PRG_STEP:
         case PRG_PRG1:
                              //ignoring
            continue;
         case PRG_SEND_SIGNAL://d0 = int signal_id, d1 = (LPC_actor)subject <NULL=broadcast>
            sub_index = 1;
                              //flow...
         case PRG_WAIT_SIGNAL://d0 = int signal_id
         case PRG_WAIT_SUSPENDED:
                              //signal id
            ck->Read(&pa.d[0], sizeof(dword));
            break;
         case PRG_SUSPEND:    //d0 = dword time
            ck->Read(&pa.d[0], sizeof(dword));
            break;
         case PRG_DRIVE:      //d0 = (LPS_vector)dest, d1 = ideal_speed
            ck->Read(&tmp1, sizeof(S_vector));
            pa.d[0] = (dword)&tmp1;
            ck->Read(&tmp_d, sizeof(dword));
            pa.d[1] = tmp_d;
            break;
         case PRG_LADDER_CLIMB:  //d0 = bool climb_up
            ck->Read(&tmp_b, sizeof(bool));
            pa.d[0] = tmp_b;
            break;
         case PRG_STAY_UP:
         case PRG_STAY_MID:
         case PRG_STAY_DOWN:
            break;

         default:
            assert(0);
         }
         if(sub_index!=-1){
                              //find subject
            C_string name;
            ck->ReadString(CT_NAME, name);
                              //if name=="", no subject is set
            if(name.Size()){
               LPC_actor subj = mission.FindActor(name);
               if(subj){
                  pa.d[sub_index] = (dword)subj;
               }else{
                  //OUTTEXT(C_fstring("LoadGame: cannot find subject: %s", (const char*)name));
                  assert(0);
                  continue;
               }
            }
         }
         AddProgram(i, (E_PRG_ITEM)b, pa, false);
      }

      int sel_i;
      ck->Read(&sel_i, sizeof(sel_i));
      assert(sel_i<C_inventory::NumItems());
      SetSelectedInvItem(0);
      SetSelectedInvItem(sel_i);

      if(using_item)
      switch(using_item->GetType()){
      case ACTOR_AUTOMOBIL:
      case ACTOR_AUTO_CANNON:
         {
                              //get seat type
            int dest_pose = -1;
            int st = using_item->cbProc(CB_USE_AUTO, 5, (dword)this);
            switch(st){
            case 0:           //sit
               dest_pose = POSE_DRIVE;
               break;
            case 1:           //stay
               dest_pose = POSE_RESET;
               break;
            case 2:           //bike
               dest_pose = POSE_BIKE;
               break;
            case 3:           //bench
               dest_pose = POSE_RESET + 0x20;
               break;
            }
            if(dest_pose!=-1){
               LPC_actor save = using_item;
               using_item = NULL;
               PlayAnim(dest_pose, true);
                              //leave SetUsingItem after PlayAnim - to set entire body anim
               SetUsingItem(save);
            }
            if(dest_pose!=-1){
               model->Tick(1);
               anim_man.Tick(1000, model);
            }
         }
         break;
      }

      PlayAnim(POSE_MOVE_FORWARD); //Jirka: I think it is here for properly set of enemies gun (they hold gun aka in bazuka walk mode)
      model->Tick(1000);
      anim_man.Tick(1000, model);
      first_anim = true; //to hide effect of POSE_MOVE_FORWARD

      PlayAnim(anim_pose, true, false);
      model->Tick(anim_time);
      anim_man.Tick(anim_time, model);
                              //tick bags for get them to the ground
      bool optim_dead = mission.tab_property->ItemB(TAB_B_SCN_OPTIM_DEAD_BODY);
      optim_dead = optim_dead && (type==ACTOR_ENEMY);
      if((stay_mode == SM_DEAD) && (game_configuration.censored || optim_dead)){
         PI3D_animation_set as = model->GetAnimationSet();
         model->SetAnimation(0, as);
         model->Tick(10000);
      }

      return true;
   }

//----------------------------

   virtual bool MayExplode() const{

      return (model->IsOn() && (stay_mode != SM_DEAD));
   }

   virtual bool Explode(C_actor *caller, int power){

      if(stay_mode != SM_DEAD){
         if(resistance && (resistance -= power) <= 0){

                              //check direction of explosion
            const S_vector &a_pos = *caller->GetPos();
            S_vector pos = frame->GetWorldPos();
            pos = a_pos-pos;
            const S_vector &dir=model->GetWorldDir();
            float ang = Angle2D(S_vector2(pos.x, pos.z), S_vector2(dir.x, dir.z));
            int i;
            if(ang < -.75f*PI) i = 3;
            else
            if(ang < -.25f*PI) i = 0;
            else
            if(ang < .25f*PI) i = 1;
            else
            if(ang < .75f*PI) i = 2;
            else i = 3;
                              //18.12.comment out
            /*if(power > 500) 
               cbProc(CB_DIE_THROW_OUT, (dword)caller);*/
            cbProc(CB_DIE, i);
            return true;
         }
         S_CB_hit sh;
         sh.sub_frame=frame;
         sh.shooter = NULL;
         return cbProc(CB_HIT, (dword)&sh, power);
      }
      return false;
   }

//----------------------------

   virtual float Crash(LPC_actor who, float power){

      if(stay_mode!=SM_DEAD){
                              //check if it's boat we're standing on
         const I3D_frame *frm_m = floor_link;
         while(frm_m && frm_m->GetType()!=FRAME_MODEL) frm_m = frm_m->GetParent();
         if(frm_m && frm_m==who->GetFrame())
            return .001f;

         if(power>.4f){
            //cbProc(CB_DIE_THROW_OUT, (dword)who); //18.12.comment out
            cbProc(CB_DIE);
            mission.PlaySound("smash", frame->GetWorldPos(), 3.0f, 14.0f);
         }else{
            S_CB_hit cbh;
            memset(&cbh, 0, sizeof(cbh));
            cbh.sub_frame = brest;
            cbh.shooter = who;
            cbProc(CB_HIT, (dword)&cbh, power*1000.0f);
         }
      }
      return (float)tab_game_cfg->ItemI(TAB_I_GAME_HUM_CRASH_RESIST) * .01f;
   }

//----------------------------
// Disable cast dynamic shadows for enemies, if set in scene table.
   inline void OptimiseEnemyShadow(PI3D_frame frm){

      assert(frm && mission.tab_property);
      bool scn_shadow_disabled = 
         mission.tab_property->ItemB(TAB_B_SCN_DISABLE_SHDWS) && (type != ACTOR_PLAYER);
      frm->SetFlags(scn_shadow_disabled ? 0 : I3D_FRMF_SHADOW_CAST, I3D_FRMF_SHADOW_CAST);
   }

//----------------------------

   virtual void SetFrame(PI3D_frame frm){

      if(frm){
         //assert(frm->GetType()==FRAME_MODEL);
         if(frm->GetType()==FRAME_MODEL){
            PI3D_model mp = I3DCAST_MODEL(frm);
            if(!mp->GetParent()){
               mission.SetFrameSector(mp);
            }else
            if(mp->GetParent()->GetType()!=FRAME_SECTOR){
               ErrReport(C_fstring("Human '%s': can't be linked", mp->GetName()), editor);
               PI3D_frame ps = mp;
               while((ps=ps->GetParent()) && (ps->GetType()!=FRAME_SECTOR));
               if(ps)
                  mp->LinkTo(ps, I3DLINK_UPDMATRIX);
            }
            mp->SetAnimation(10, pset, I3DANIMOP_ADD);

            brest = mp->FindChildFrame("Hrud*", ENUMF_VISUAL | ENUMF_JOINT | ENUMF_WILDMASK);
            vis_body = I3DCAST_VISUAL(mp->FindChildFrame("Trup*", ENUMF_VISUAL | ENUMF_WILDMASK));
            frm_head = mp->FindChildFrame("Hlva*", ENUMF_VISUAL | ENUMF_JOINT | ENUMF_WILDMASK);
#ifdef KEEP_HUMAN_OUT_OF_WALL
            {
               PI3D_frame fvol;
               fvol = mp->FindChildFrame("~020v1*");
               vol_up = (fvol && fvol->GetType()==FRAME_VOLUME) ? I3DCAST_VOLUME(fvol) : NULL;
               fvol = mp->FindChildFrame("~020v2*");
               vol_down = (fvol && fvol->GetType()==FRAME_VOLUME) ? I3DCAST_VOLUME(fvol) : NULL;
               ResetSpheres();
            }
#endif
            last_on_feet_pos = mp->GetWorldPos();
            const S_vector &dir = mp->GetWorldDir();

                           //set special material on sphere volumes - one which is ignored in gunshot tests
            struct S_hlp{
               static I3DENUMRET I3DAPI cbVol(PI3D_frame frm, dword){
                  PI3D_volume vol = I3DCAST_VOLUME(frm);
                  vol->SetCollisionMaterial(HUMAN_SPHERE_MAT);
                  return I3DENUMRET_OK;
               }
            };
            mp->EnumFrames(S_hlp::cbVol, 0, ENUMF_VOLUME);

                           //network sync init
         //net_sync_want_turn = net_sync_abs_turn = Angle2D(S_vector2(dir.x, dir.z));
            net_sync_want_turn = net_sync_abs_turn = Angle_8bit(Angle2D(S_vector2(dir.x, dir.z)));
            net_sync_pos = mp->GetWorldPos();
            net_sync_want_pos = net_sync_pos;
         }
         OptimiseEnemyShadow(frm);
      }else{
         brest = NULL;
         vis_body = NULL;
         frm_head = NULL;
      }
      C_actor::SetFrame(frm);
      if(model){
                              //reset to default anim
         PlayAnim(POSE_RESET);
         model->Tick(500);
      }
   }

//----------------------------

   virtual const S_vector GetUsePos(int indx, bool abs_index_mode) const{
      return (brest ? brest : frame)->GetWorldPos();
   }

//----------------------------
   bool was_in_scene;

   virtual void GameBegin(){

      I3D_RESULT ir;
      ir = mission.GetScene()->DeleteFrame(frame);
      was_in_scene = (I3D_SUCCESS(ir));
      assert(was_in_scene);
   }

//----------------------------

   virtual void GameEnd(){

      SetUsingItem(NULL, false);
      if(was_in_scene)
         mission.GetScene()->AddFrame(frame);
   }

//----------------------------

   virtual int GetNetDirSendThresh() const{ return 4; }

//----------------------------

   inline bool IsFirstPersonMode() const{ return (mission.game_cam.GetFocusDir()==frame && mission.game_cam.GetDistanceMode() == 0); }

//----------------------------

   virtual float GetUsePosThresh() const{ return .85f; }
};//C_human

typedef C_human *LPC_human;

//----------------------------

void C_human::NetCodeIn(byte msg_code, PC_net_in_msg in_msg){

   switch(msg_code){

   case NM_HUMAN_STAY_MODE:
      {
         E_STAY_MODE sm = (E_STAY_MODE)(in_msg->GetBits(2)+SM_STAY);
         if(stay_mode!=SM_DEAD)
            SwitchStayMode(sm, false);
      }
      break;

   case NM_HUMAN_PLAY_ANIM:
      {
         byte anim_id = in_msg->GetBits(9);
                           //no more anims desired after death
         if(stay_mode!=SM_DEAD)
            PlayAnim(anim_id, true);
      }
      break;

   case NM_HUMAN_ABS_TURN:
      {
         byte b = in_msg->GetBits(NET_HUMAN_ABS_DIR_BITS);
         net_sync_want_turn = b<<(8-NET_HUMAN_ABS_DIR_BITS);
      }
      break;

   case NM_HUMAN_POS:
      net_sync_want_pos = in_msg->GetVector();
      break;

   case NM_HUMAN_DEAD_POS:
      {
         S_vector pos = in_msg->GetVector();
                              //parent should be present, check just to be sure
         if(frame->GetParent()){
                              //undo parent transformation and apply
            pos *= frame->GetParent()->GetInvMatrix();
            frame->SetPos(pos);
            frame->Update();
            mission.SetFrameSector(frame);
            S_vector pos;
            GetCenterPos(pos);
            mission.LinkToFloor(frame, pos, frame, false);
         }
      }
      break;

   case NM_HUMAN_DIE:
      Die(in_msg->GetBits(9), false);
      break;

   case NM_HUMAN_THROW_OUT:
      //ThrowToPieces(mission.NetFindActor(in_msg->GetWord()), false);18.12.comment out
      break;

   case NM_HUMAN_HIT:
      {
         S_CB_hit sh;
         sh.sub_frame = NULL;
         sh.shooter = NULL;
         int body_part_indx = in_msg->GetBits(5);
         int net_new_resist = in_msg->GetBits(14);
         if(stay_mode!=SM_DEAD)
            Hit(sh, body_part_indx, 0, net_new_resist, false);
      }
      break;

   case NM_HUMAN_INVENTORY: //bits:3 sub_command
      {
                           //hide inventory before any operation is performed
         if(C_inventory::IsVisible())
            mission.game_menu.SetInventory(NULL);
         int itm_indx = in_msg->GetBits(6);
         int sub_code = in_msg->GetBits(3);
         //NET_DEBUG(C_fstring("NM_HUMAN_INVENTORY, itm_indx = %i, sub_code = %i", itm_indx, sub_code));

         switch(sub_code){
         case 0:           //set amount (bits:6 itm_index, bits:12 amount)
            C_inventory::SetItemAmount(itm_indx, in_msg->GetBits(12));
            cbProc(CB_SHOW_AMMO);
            break;

         case 1:           //1 = set bullets (bits:6 itm_index, bits:6 amount)
            C_inventory::SetBullets(itm_indx, in_msg->GetBits(7));
            cbProc(CB_SHOW_AMMO);
            break;

         case 2:           //2 = set active item (bits:6 itm_index)
            C_inventory::SetActiveItem(itm_indx);
            break;

         case 3:           //3 = add item (bits:6 inv_item, bits:12 amount)
            C_inventory::AddItem(itm_indx, in_msg->GetBits(12));
            break;

         case 4:           //4 = delete item (bits:6 inv_index)
            C_inventory::DeleteItem(itm_indx);
            break;

         case 5:           //5 = reload ammo (bits:6 inv_index)
            {
               bool play_snd = in_msg->GetBits(1);
               if(play_snd)
                  mission.PlaySound("load", gun->GetWorldPos(), 2.0f, 8.0f);
               C_inventory::Reload(itm_indx, true);
               cbProc(CB_SHOW_AMMO);
            }
            break;

         case 6:           //set selected_inv_item
            SetSelectedInvItem(itm_indx, false);
            break;

         case 7:           //clear inventory
            C_inventory::DeleteAllItems();
            break;

         default:
            assert(0);
         }
      }
      break;

   case NM_HUMAN_AIM_DIR:
      switch(in_msg->GetBits(1)){
      case 0:              //set vector
         //NET_DEBUG("NetCodeIn: NM_HUMAN_AIM_DIR - vector received");
         net_sync_aim_want = in_msg->GetVector();
         aim_count = AIM_COUNT;
         break;
      case 1:              //start fade
         {
            //if(!aim_count)
            aim_fade_base = aim_dir;
            NET_DEBUG("NM_HUMAN_AIM_DIR - starting fade");
            aim_count = Max(1, (int)(AIM_FADE_TIME - in_msg->GetLatency()));
            net_sync_aim_fade_factor = 1.0f;
            if(in_msg->GetBits(1))
               net_sync_aim_fade_factor = in_msg->GetFloat();
         }
         break;
      }
      break;

   case NM_HUMAN_SET_VISIBLE:
      {
         byte on = in_msg->GetBits(1);
         SetVisible(on, in_msg->GetBits(1), false);
      }
      break;

   case NM_HUMAN_VOICE_COMMAND:
      {
         LPC_actor a = mission.NetFindActor(in_msg->GetWord());
         int cmd_type = in_msg->GetBits(3);
         VoiceCommand(a, cmd_type, false);
      }
      break;

   case NM_HUMAN_PLAY_VOICE:
      {
         dword base = in_msg->GetBits(24);
         float power = 10.0f;
         if(in_msg->GetBits(1)) power = in_msg->GetFloat();
         bool stop_old = in_msg->GetBits(1);
         PlayVoice((const char*)&base, power, false, stop_old);
      }
      break;

   case NM_HUMAN_SET_USING_ITEM:
      SetUsingItem(mission.NetFindActor(in_msg->GetWord()), false);
      break;

   case NM_HUMAN_GUN_ANIM:
      GunMakeAnim(false);
      break;

   case NM_HUMAN_RELAXED_STAY:
      relaxed_weapon_hold = in_msg->GetBits(1);
      if(stay_mode!=SM_DEAD)
         PlayAnim(POSE_RESET);
      break;

   case NM_HUMAN_GRAB_SYNC:
      net_sync_grab->NetIn(in_msg, false);
      break;

   case NM_HUMAN_GRAB_SYNC_USER:
      {
         SetUsingItem(mission.NetFindActor(in_msg->GetWord()));
         net_sync_grab->Lock(false);
      }
      break;

   case NM_HUMAN_USE_INV_ITEM:
      {
         int dest_pose = -1;
         UseInvItem(dest_pose, false, false);
      }
      break;

   case NM_HUMAN_PROGRAM:  //(byte insert_pos, bits:5 prg_item)
      {
         int pos = 0;
         if(in_msg->GetBits(1)) pos = in_msg->GetByte();
         E_PRG_ITEM itm = (E_PRG_ITEM)in_msg->GetBits(5);
         S_prg_add pa;
         S_vector tmp1, tmp2;
         switch(itm){
         case PRG_MOVE:    //? S_vector dest, bits:1 run, ? byte move_reason, bits: force_smart
            if(in_msg->GetBits(1)) pa.d[0] = (dword)&(tmp1 = in_msg->GetVector());
            pa.d[1] = in_msg->GetBits(1);
            if(in_msg->GetBits(1)) pa.d[2] = in_msg->GetByte();
            pa.d[3] = in_msg->GetBits(1);
            break;

         case PRG_DRIVE:   //? S_vector dest, ? word ideal_speed
            if(in_msg->GetBits(1)) pa.d[0] = (dword)&(tmp1 = in_msg->GetVector());
            if(in_msg->GetBits(1)) pa.d[1] = in_msg->GetWord();
            break;

         case PRG_GUARD:   //? S_vector dest, ? word cp_aim_dest, ? word countdown, ? S_vector dest, ? word subject_net_id
            if(in_msg->GetBits(1)) pa.d[0] = (dword)&(tmp1 = in_msg->GetVector());
            if(in_msg->GetBits(1)) pa.d[1] = (dword)(LPC_checkpoint)mission.GetCheckpoints()[in_msg->GetWord()];
            if(in_msg->GetBits(1)) pa.d[2] = in_msg->GetWord();
            if(in_msg->GetBits(1)) pa.d[3] = (dword)&(tmp2 = in_msg->GetVector());
            if(in_msg->GetBits(1)) pa.d[4] = (dword)mission.NetFindActor(in_msg->GetWord());
            break;

         case PRG_ATTACK:  //word subject_net_id, ? bits:5 attack_body_part_index, bits:2 E_ATTACK_MODE
            pa.d[0] = (dword)mission.NetFindActor(in_msg->GetWord());
            if(in_msg->GetBits(1)){
               int indx = in_msg->GetBits(5);
               if(indx==((1<<5)-1))
                  indx = -1;
               pa.d[1] = indx;
            }
            pa.d[2] = in_msg->GetBits(2);
            break;

         case PRG_SUSPEND: //word time
            pa.d[0] = in_msg->GetWord();
            break;

         case PRG_WATCH:   //? S_vector dest, ? bits:4 phase_count
            if(in_msg->GetBits(1)) pa.d[0] = (dword)&(tmp1 = in_msg->GetVector());
            if(in_msg->GetBits(1)) pa.d[1] = in_msg->GetBits(4);
            break;

         case PRG_STEP:    //? S_vector dest, ? float goto_min_dist, ? S_vector turn_dir, bits:1 run
            if(in_msg->GetBits(1)) pa.d[0] = (dword)&(tmp1 = in_msg->GetVector());
            if(in_msg->GetBits(1)) pa.d[1] = in_msg->GetDword();
            if(in_msg->GetBits(1)) pa.d[2] = (dword)&(tmp2 = in_msg->GetVector());
            pa.d[3] = in_msg->GetBits(1);
            break;

         case PRG_FOLLOW:  //word master_net_id
            pa.d[0] = (dword)mission.NetFindActor(in_msg->GetWord());
            break;

         case PRG_USE:     //word subj_net_id, ? byte use_indx
            pa.d[0] = (dword)mission.NetFindActor(in_msg->GetWord());
            if(in_msg->GetBits(1)) pa.d[1] = (int)(schar)in_msg->GetByte();
            break;

         case PRG_SETVISIBLE:
            //pa.d[0] = in_msg->GetBits(1);
            break;

         case PRG_SEND_SIGNAL:   //? word subj_net_id, word signal_id
            //if(in_msg->GetBits(1)) pa.d[1] = (dword)mission.NetFindActor(in_msg->GetWord());
                           //flow...
         case PRG_WAIT_SIGNAL:   //word signal_id
            //pa.d[0] = in_msg->GetWord();
            break;

         case PRG_USE_INV: //bits:6 inv_itm_id
            pa.d[0] = in_msg->GetBits(6);
            break;

         case PRG_WALK_CP: //word start_CP_indx, ? word next_CP_indx, bits:1 run
            //pa.d[0] = (dword)mission.GetCheckpoints()[in_msg->GetWord()];
            //if(in_msg->GetBits(1)) pa.d[1] = (dword)mission.GetCheckpoints()[in_msg->GetWord()];
            //pa.d[2] = in_msg->GetBits(1);
            break;

         case PRG_LADDER_CLIMB:  //word ladder_net_id, bool climb_up
            //pa.d[0] = (dword)mission.NetFindActor(in_msg->GetWord());
            pa.d[0] = in_msg->GetBits(1);
            break;

         case PRG_STAY_UP:
         case PRG_STAY_MID:
         case PRG_STAY_DOWN:
            break;

         default:
            assert(0);
         }
                           //no reason to modify program of dead human
         if(stay_mode!=SM_DEAD){
            AddProgram(pos, itm, pa, false);
            cbProc(CB_PRG_SHOW, false, 1 + !pos);
         }
      }
      break;

   case NM_HUMAN_DEL_PRG:
   case NM_HUMAN_DEL_PRG_0:
      {
         int pos = 0;
         if(msg_code==NM_HUMAN_DEL_PRG) pos = in_msg->GetByte();
                           //no reason to modify program of dead human
         if(stay_mode!=SM_DEAD){
            DelProgram(pos, false);
         }
      }
      break;

   case NM_HUMAN_CLR_PRG:
      ClrProgram(false);
      cbProc(CB_PRG_SHOW, false, 1);
      break;

   case NM_HUMAN_CAM_FLASH:
      {
         const S_vector flash_pos = in_msg->GetVector();
         const S_vector flash_dir = in_msg->GetVector();
         mission.MakeParticle("flash", NULL, flash_pos, NULL, &flash_dir);
         mission.PlaySound("photo", flash_pos, 2.0f, 6.0f);
         S_listen_source ls(LISTEN_HUMAN, frame->GetWorldPos(), 1.0f);
         mission.EmitListen(ls, 6.0f, true, this);
      }
      break;

   default:
      C_actor::NetCodeIn(msg_code, in_msg);
   }
}

/*--------------------------------------------------------
   Find item nearby which may be used.
   For each item check distance, then sort items by closest and by conditions
   which match to item's use and return best usable item.
--------------------------------------------------------*/
                              //network_actor: no
struct S_a{
   LPC_actor a;
   int use_pos;
   float d;
   float priority_d;          //used for make cannon and ladder more prior then other items
   S_a(){}
   S_a(LPC_actor a1, int u1, float d1): a(a1), use_pos(u1), d(d1){

      priority_d = d;
      if(a){
         switch(a->GetType()){
         case ACTOR_CANNON:
         case ACTOR_LADDER:
            priority_d -= 1.0f;
            break;
         }
      }
   }
   operator LPC_actor() const{ return a; }
   bool operator < (const S_a &s) const{ return d<=s.d; }

   struct myless{
      bool operator()(const S_a &x, const S_a &y) const { return (x.priority_d <= y.priority_d); }
   };
};


LPC_actor C_human::FindUseItem(int *use_indx){
                              //find something interesting around
   struct S_help{
      S_vector plr_pos;
      C_human *act;

      vector<S_a> good_items, close_items;
      E_STAY_MODE sm;

      static bool cbEnum(LPC_actor a, dword c){
         S_help *t = (S_help*)c;
         if(a==t->act)
            return true;
                              //get num of use positions

         int nup = a->NumUsePositions(t->act);
         if(!nup)
            return true;
         PI3D_frame frm;
         if(frm=a->GetFrame()){
            const S_vector &pos = frm->GetWorldPos();
            float dist = (t->plr_pos-pos).Magnitude();
            if(dist <= MIN_USE_DISTANCE){

               while(nup--){
                  const S_vector use_pos = a->GetUsePos(nup);
                  float d = (t->plr_pos-use_pos).Magnitude();
                              //check if all conds to use are ok
                  int dest_pose = -1;
                  int reason = t->act->CheckUseItemConds(a, false, dest_pose, nup);
                  if((!reason) || (reason == 4)) //make cannon accessable
                     t->good_items.push_back(S_a(a, nup, d));
                  else
                     t->close_items.push_back(S_a(a, nup, d));
               }
            }
         }
         return true;
      }
   } hlp;
   GetCenterPos(hlp.plr_pos);
   hlp.act = this;
   hlp.sm = stay_mode;
   mission.EnumActors(S_help::cbEnum, (dword)&hlp);

   vector<S_a>::iterator sp;
   bool ok = false;
                           //return best items first
   if(hlp.good_items.size()){
      //sp = min_element(hlp.good_items.begin(), hlp.good_items.end());
      sp = min_element(hlp.good_items.begin(), hlp.good_items.end(), S_a::myless());      
      ok = true;
   }else
   if(hlp.close_items.size()){
      sp = min_element(hlp.close_items.begin(), hlp.close_items.end());
      ok = true;
   }
   if(ok){
      if(use_indx) *use_indx = (*sp).use_pos;
      return *sp;
   }
   return NULL;
}

//----------------------------

void C_human::ResetBody(int new_id){

   int &prev_id = anim_man.stages[anim_man.main_stage].anim_id;
   if(new_id == prev_id)
      return;
   if((prev_id == 0x24) || (prev_id == 0x26) || (prev_id == 0x44) || (prev_id == 0x46)){
      const char *aname = (prev_id == 0x24) || (prev_id == 0x26) ? "~xstopg.i3d" : "~ystopg.i3d";
      PI3D_animation_set reset_anim = mission.GetAnim(aname);

      for(int trup_anim_id = reset_anim->NumAnimations(); trup_anim_id--; ){
         C_string al = reset_anim->GetAnimLink(trup_anim_id);
         if(al.Match("Trup*"))
            break;
      }
      assert(trup_anim_id != -1);
      PI3D_frame trup_frm = model->FindChildFrame("Trup*", ENUMF_ALL | ENUMF_USEMASK);
      assert(trup_frm);
                           //find interpolator of trup in prev anim
      const PI3D_interpolator *intps = model->GetInterpolators();
      for(int trup_ip_id = model->NumInterpolators(); trup_ip_id--; ){
         PI3D_interpolator intp = intps[trup_ip_id];
         if(intp->GetFrame() == trup_frm){
            PI3D_animation_base ap = reset_anim->GetAnimation(trup_anim_id);
            intp->SetAnimation(anim_man.main_stage, NULL); //remove old
            intp->SetAnimation(anim_man.main_stage, ap);
            break;
         }
      }
   }
}

//----------------------------
// PLay anim should do:
// -set animation on stage in 1 or 2 (stage 0 is only for ending, outgoing inimations)
// -keep anim which end alive to possibility blend with new. this anim should be removed, when new become full blended.
// - no blending should be applied when blend_time == 0

bool C_human::PlayAnim(int id_to, bool force, bool sm_dependent, bool tick_wait){

   if(id_to==-1)
      return false;

   int id_to_store = id_to;
   if(sm_dependent) id_to += stay_base[stay_mode];

                              //scan through to find required anim
   int i;
   dword anim_type = ((byte*)tab_human_anim->Item(TAB_E_ANI_TYPE))[curr_pose];
   if(curr_pose==id_to && (anim_type==ANIM_FULL)){
      i = model->NumInterpolators();
      if(i){
         const PI3D_interpolator *intps = model->GetInterpolators();
         while(i--){
            PI3D_interpolator intp = intps[i];
            dword end = intp->GetEndTime(anim_man.main_stage);
            dword t = intp->GetCurrTime(anim_man.main_stage);
            if(end && (t == end)){
               curr_pose = -1;
               first_anim = true;
               break;
            }
         }
      }else{
         curr_pose = -1;
         first_anim = true;
      }
   }
   if(curr_pose != id_to){
      if(!force && (anim_type==ANIM_FULL)){
                              //full anim must have finished
         if(IsAnimated()) 
            return false;
      }
      if(tick_wait){
         StoreAnimToPlay(id_to_store, force, sm_dependent);
         return true;
      }
      curr_pose = id_to;

      assert(curr_pose != -1);
      {

         C_string anim_name((char*)tab_human_anim->Item(TAB_S16_ANI_FILENAME)+16*curr_pose);
         char &modify_char = anim_name[(int)anim_name.Size()-1];
         if(modify_char == '?'){
                              //add modification based on selected inv item
            int inv = selected_inv_item < NumItems() ? GetItem(selected_inv_item) : 0;
            char chr = tab_inventory->ItemB(TAB_E_INV_POSEMODE, inv);
            static const char anim_modify[]={'n', 'g', 'b'};
            if(relaxed_weapon_hold && chr==1) chr=2;
            modify_char = anim_modify[chr];
         }
         PI3D_animation_set anim;
         anim_name += ".i3d";
         anim = mission.GetAnim(anim_name);
         if(anim){
            move_dir.x = tab_human_anim->ItemF(TAB_F_ANI_SPEEDX, curr_pose);
            move_dir.y = tab_human_anim->ItemF(TAB_F_ANI_SPEEDY, curr_pose);
            move_dir.z = tab_human_anim->ItemF(TAB_F_ANI_SPEEDZ, curr_pose);

            dword anim_type = tab_human_anim->ItemB(TAB_E_ANI_TYPE, curr_pose);

            int blend_time;
            if(first_anim){
               first_anim = false;
               blend_time = 0;
            }else
               blend_time = ((int*)tab_human_anim->Item(TAB_I_ANI_BLENDTIME))[curr_pose];
            blend_time = anim->GetTime()*blend_time/100;

            bool using_car = (using_item && (using_item->GetType()==ACTOR_AUTOMOBIL || using_item->GetType()==ACTOR_AUTO_CANNON));

#if defined DEBUG_ANIMS //|| 1
            OUTTEXT(C_fstring("'%s:'anim name: %s, blend time: %i, id: %i", 
               GetName(), (const char*)anim_name, blend_time, id_to));
#endif
            if(!using_car){                               
                           //roll anim change trup rotation by 360deg, reset it back
                           //because blend of these two different quaternions cause 360deg rotation
               ResetBody(curr_pose);
               anim_man.PlayAnim(anim, blend_time, anim_type, id_to, model);
            }else{
               anim_man.ApplyAnim(anim, blend_time, anim_type, id_to, model, 1);
            }
            return true;
         }else{
            ReportActorError(C_fstring("Can't load anim: %s", (const char*)anim_name));
            curr_pose = -1;
         }
      }
   }
   return false;
}

//----------------------------
                              //apply magnetism to shot, return best one

void C_human::ApplyShootMagnet(const S_vector &pos, S_vector &shoot_dir, float magnet_angle){

                              //apply magnetism to some actor in the way
   struct S_hlp{
      LPC_actor actor;
      const S_vector *from, *dir;
      S_vector best_dir;
      float best_ratio;
      bool first;
      float magnet_angle;

      static bool cbEnum(LPC_actor a, dword s){
         S_hlp *sh = (S_hlp*)s;
         if(a != sh->actor)
         if(a->IsAlive()){
            PI3D_frame frm = a->GetFrame();
            if(frm->GetType()==FRAME_MODEL){
               float ratio;
               S_vector ret;
               S_vector cpos;
               a->GetCenterPos(cpos);
               if(CheckHitRange(*sh->from, *sh->dir, ret, ratio, I3DCAST_MODEL(frm), sh->magnet_angle, cpos)){
                  if(sh->first || sh->best_ratio<ratio){
                     sh->first = false;
                     sh->best_ratio = ratio;
                     sh->best_dir = ret;
                  }
               }
            }
         }
         return true;
      }
   } hlp;
   hlp.from = &pos;
   hlp.dir = &shoot_dir;
   hlp.actor = this;
   hlp.first = true;
   hlp.magnet_angle = magnet_angle;

   mission.EnumActors(S_hlp::cbEnum, (dword)&hlp);

   if(!hlp.first){
      shoot_dir = hlp.best_dir;
      shoot_dir.Normalize();
   }
}

/*--------------------------------------------------------
   Use currently selected inventory item. First perform check on ammo,
   required stay mode, pose etc, then use item - create appropriate actor,
   lower munition.
--------------------------------------------------------*/
                              //network_actor: no

bool C_human::UseItem(const S_tick_context &tc, int &dest_pose, bool aim_shoot,
   const S_vector *aim_disp, dword use_data){

   assert(!network_actor);

   if(IsFullAnim()){
      switch(curr_pose&0x1f){
      case POSE_FIRE:
         break;
      default:
         return false;
      }
   }
   if(!gun)
      return false;
   if(!IsReadyToFire())
      return false;
                              //check munition
   int i = C_inventory::GetItemAmount(selected_inv_item);
   if(!i)
      return false;
                              //check if required pose for using item
   if(!CheckItemUsePose())
      return false;

   S_vector pos, dir;
   PI3D_frame weapon = gun;
   bool aim_zoom = false;
   int itm_indx = C_inventory::GetItem(selected_inv_item);
   if(aim_shoot){
      aim_zoom = tab_inventory->ItemB(TAB_B_INV_ZOOM, itm_indx);
      if(!aim_zoom){
         if(game_configuration.aim_mode==0){
            weapon = mission.game_cam.GetAimModel();
            if(weapon){
               S_vector cpos, cdir;
               mission.game_cam.GetCameraPos(cpos, cdir);
               pos = (*aim_disp) * weapon->GetMatrix();
               dir = pos - cpos;//cam->GetWorldPos();
                              //get angle from real gun
               float f = dir.AngleTo(gun->GetWorldDir()) - GetPI();
               if(fabs(f) < PI*.1f){
                  dir.Normalize();
                  pos += dir * tab_inventory->ItemF(TAB_F_INV_WPN_SHOT_Z, itm_indx);
               }else{
                  aim_shoot = false;
               }
            }else{
               pos.Zero();
               dir.Zero();
            }
         }else{
                              //cross aim
            mission.game_cam.Tick(1);
            mission.game_cam.GetCameraPos(pos, dir);
            pos += dir * .5f;
            weapon = NULL;
         }
      }else{
         PI3D_frame gun = mission.game_cam.GetAimModel();
         assert(gun);
         if(!gun) return false;
         pos = gun->GetWorldPos();
         dir = gun->GetWorldDir();
         dir.Normalize();
         pos += dir*.3f;
      }
   }

   if(!aim_shoot){
      const S_matrix &gmat = gun->GetMatrix();
      dir = -gmat(2);
      pos = gmat(3);
      pos += dir * tab_inventory->ItemF(TAB_F_INV_WPN_SHOT_Z, itm_indx);
      pos += gmat(1) * .06f;
   }

   {                          //apply shoot error and magnetism
      float shoot_quality;

      switch(GetType()){
      case ACTOR_PLAYER:
         {
            int character_shooting = tab->ItemI(TAB_I_HUM_BAR1_SHOOTING);
                              //usable range is 60-90 %
            shoot_quality = character_shooting<=60 ? 0.0f :
               character_shooting >= 90 ? 1.0f :
               float(90-character_shooting)/30.0f;
         }
         break;
      case ACTOR_ENEMY:
         shoot_quality = (float)AI_i(TAB_I_AI_SHOOT_QUALITY)/100.0f;
         break;
      default:
         shoot_quality = .5f;
      }

      const float max_err = tab_game_cfg->ItemF(TAB_F_GAME_SHOOT_ERR_MIN);
      const float min_err = tab_game_cfg->ItemF(TAB_F_GAME_SHOOT_ERR_MAX);
      float shoot_err = min_err + (max_err - min_err) * shoot_quality;
      if(aim_zoom) shoot_err *= tab_game_cfg->ItemF(TAB_F_GAME_SNIPER_ERR_FACTOR);
      ApplyShootErr(dir, shoot_err*PI/180.0f);

      const float max_mgnt = tab_game_cfg->ItemF(TAB_F_GAME_SHOOT_MAG_MIN);
      const float min_mgnt = tab_game_cfg->ItemF(TAB_F_GAME_SHOOT_MAG_MAX);
      float magnet_angle = min_mgnt + (max_mgnt-min_mgnt)*(1.0f-shoot_quality);
      if(aim_zoom) magnet_angle *= tab_game_cfg->ItemF(TAB_F_GAME_SNIPER_MAGNET_FACTOR);
      ApplyShootMagnet(pos, dir, magnet_angle*PI/180.0f);
   }

   E_INV_ITEM itm = (E_INV_ITEM)tab_inventory->ItemI(TAB_I_INV_ID, itm_indx);
   switch(itm){
   case INV_COLT:
   case INV_WEAPON:
      if(!gun || shoot_cntdwn>0)
         return false;
      {
         int itm1 = C_inventory::GetItem(selected_inv_item);
         byte fire_mode = tab_inventory->ItemE(TAB_E_INV_FIREMODE, itm1);
                              //check if weapon doesn't need to reload
         switch(fire_mode){
         case 1:              //single
         case 2:              //batch
            dword nb = C_inventory::GetBullets(selected_inv_item);
            if(!nb){
                              //oops, last re-loading canceled for some reason, do it again now
               dest_pose = (itm==INV_COLT) ? POSE_COLT_LOAD : POSE_LOAD;
                              //commented out - allow turn
               //turn_angle = 0.0f;
               return false;
            }
            break;
         }
                              //avoid firing through walls (player only, enemies are not so clever)
         bool wall_shot = false;
         if(type==ACTOR_PLAYER){
            S_vector to = frame->GetWorldPos();
            to.y = pos.y;
            S_vector dir = pos-to;
            I3D_collision_data cd(to, dir, 0, frame, FlyColRespGeo);
            bool vol = mission.GetScene()->TestCollision(cd);
            if(vol){
               wall_shot = true;
            }
         }
         if(wall_shot)
            break;
         GunMakeAnim(true);

         int cntdwn = tab_inventory->ItemI(TAB_I_INV_WPN_DELAY, itm_indx);

                              //emit sound
         S_listen_source ls = S_listen_source(LISTEN_SHOOT, pos, 30);
         mission.EmitListen(ls, tab_game_cfg->ItemF(TAB_F_GAME_SNDR_GUN_MAX), true, this);

         dest_pose = (itm==INV_COLT) ? POSE_COLT_FIRE : POSE_FIRE;

         int num_bullets = tab_inventory->ItemI(TAB_I_INV_NUM_BULLETS, itm1);

                              //prepare net chunk for inventory change
         const bool g = true;
         if(net)
            net_msg->Ascend(net_id);
         switch(fire_mode){
         case 1:                 //SINGLE
            dest_pose = POSE_PULL_GUN;
            //break;
                              //flow...
         case 2:                 //BATCH
            {
               int nb = C_inventory::GetBullets(selected_inv_item);
               num_bullets = Min(num_bullets, nb);
               nb -= num_bullets;
               C_inventory::SetBullets(selected_inv_item, nb);
               if(net)
#ifndef ENEMY_NET_SYNC_INV
               if(GetType()==ACTOR_PLAYER)
#endif
               {       //1 = set bullets (bits:6 amount)
                  net_msg->AddBits(NM_HUMAN_INVENTORY, NET_ACTOR_CODE_BITS, g);
                  net_msg->AddBits(selected_inv_item, 6, g);
                  net_msg->AddBits(1, 3, g);
                  net_msg->AddBits(nb, 7, g);
               }
               if(!nb && i!=num_bullets) dest_pose = (itm==INV_COLT) ? POSE_COLT_LOAD : POSE_LOAD;
            }
            break;
         }
         i -= num_bullets;

         C_inventory::SetItemAmount(selected_inv_item, i);

         if(net)
#ifndef ENEMY_NET_SYNC_INV
         if(GetType()==ACTOR_PLAYER)
#endif
         {             //0 = set amount (byte amount)
            net_msg->AddBits(NM_HUMAN_INVENTORY, NET_ACTOR_CODE_BITS, g);
            net_msg->AddBits(selected_inv_item, 6, g);
            net_msg->AddBits(0, 3, g);
            net_msg->AddBits(i, 12, g);
         }
         if(net) net_msg->Descend();

         {
                                 //create gun-shoot actor
            S_gun_shoot_init si;
            si.pos = pos;
            si.dir = dir;
            si.shoot_item = GetItem(selected_inv_item);
            si.shooter = this;
            si.weapon = weapon;
            si.weapon_inverse = true;
            si.aim_disp = aim_shoot ? aim_disp : NULL;
                              //determine if we're in or out-side
            for(PI3D_frame sct(model); sct=sct->GetParent(), sct && sct->GetType()!=FRAME_SECTOR; );
            assert(sct);
            bool in = !(I3DCAST_SECTOR(sct)->IsPrimary());
            if(in && sct->GetName()[3]=='~') in = false;
            si.gun_snd = gun_sound[in];
            if(!si.gun_snd)
               si.gun_snd = gun_sound[!in];

            for(i=0; i<num_bullets; i++){
               si.delay = i*cntdwn;
               mission.CreateActor(ACTOR_GUN_SHOOT, (dword)&si);
            }
            //shoot_cntdwn += cntdwn * num_bullets;
            {
               int i = cntdwn * num_bullets;
               shoot_cntdwn = Min(shoot_cntdwn+i, i);
            }
         }

         cbProc(CB_SHOW_AMMO);
                              //count stats
         if(type==ACTOR_PLAYER)
            mission.stat_ammo_spent += num_bullets;
      }
      break;

   case INV_BAZOOKA:
   case INV_PANZER:
      {
         if(shoot_cntdwn>0) break;
         bool aim;
         switch(curr_pose){
         case POSE_BAZOOKA_AIM: case POSE_BAZOOKA_AIM + 0x20:
         case POSE_BAZOOKA_BREATH: case POSE_BAZOOKA_BREATH + 0x20:
         case POSE_PANZER_AIM: case POSE_PANZER_AIM + 0x20:
         case POSE_PANZER_BREATH: case POSE_PANZER_BREATH + 0x20:
            aim=true;
            break;
         default: aim=false;
         }
         if(!aim){
            //dest_pose = (itm==INV_BAZOOKA) ? POSE_BAZOOKA_AIM : POSE_PANZER_AIM;
            dest_pose = POSE_BAZOOKA_AIM;
         }else{
            S_rocket_init ri;
            ri.pos = pos;
            ri.dir = dir;
            ri.id = itm_indx;
            ri.shooter = this;
                              //create rocket actor
            mission.CreateActor(ACTOR_ROCKET, (dword)&ri);
                              //emit sound
            S_listen_source ls = S_listen_source(LISTEN_SHOOT, pos, 30);
            mission.EmitListen(ls, tab_game_cfg->ItemF(TAB_F_GAME_SNDR_GUN_MAX), true, this);

            const bool g = true;

            i = C_inventory::GetItemAmount(selected_inv_item);
            if(!--i && itm!=INV_BAZOOKA){
                              //delete current item
               C_inventory::DeleteItem(selected_inv_item);
               if(net)
#ifndef ENEMY_NET_SYNC_INV
               if(GetType()==ACTOR_PLAYER)
#endif
               {             //4 = delete item
                  net_msg->Ascend(net_id);
                  net_msg->AddBits(NM_HUMAN_INVENTORY, NET_ACTOR_CODE_BITS, g);
                  net_msg->AddBits(selected_inv_item, 6, g);
                  net_msg->AddBits(4, 3, g);
                  net_msg->Descend();
               }

               SetSelectedInvItem(0);
                              //switch to free hands
               C_inventory::SetActiveItem(0);
               if(net)
#ifndef ENEMY_NET_SYNC_INV
               if(GetType()==ACTOR_PLAYER)
#endif
               {             //2 = set active
                  net_msg->Ascend(net_id);
                  net_msg->AddBits(NM_HUMAN_INVENTORY, NET_ACTOR_CODE_BITS, g);
                  net_msg->AddBits(0, 6, g);
                  net_msg->AddBits(2, 3, g);
                  net_msg->Descend();
               }
               if(!cbProc(CB_WEAPONCHANGE))
                  WeaponChangeAnim();
            }else{
               C_inventory::SetItemAmount(selected_inv_item, i);
               if(net)
#ifndef ENEMY_NET_SYNC_INV
               if(GetType()==ACTOR_PLAYER)
#endif
               {       //0 = set amount (byte amount)
                  net_msg->Ascend(net_id);
                  net_msg->AddBits(NM_HUMAN_INVENTORY, NET_ACTOR_CODE_BITS, g);
                  net_msg->AddBits(selected_inv_item, 6, g);
                  net_msg->AddBits(0, 3, g);
                  net_msg->AddBits(i, 12, g);
                  net_msg->Descend();
               }
            }
            cbProc(CB_SHOW_AMMO);
            dest_pose = POSE_BREATH;
            //shoot_cntdwn += tab_inventory->ItemI(TAB_I_INV_WPN_DELAY, itm_indx);
            {
               int i = tab_inventory->ItemI(TAB_I_INV_WPN_DELAY, itm_indx);
               shoot_cntdwn = Min(shoot_cntdwn+i, i);
            }
                              //count stats
            if(type==ACTOR_PLAYER)
               ++mission.stat_ammo_spent;
         }
      }
      break;

   case INV_GRENADE:
      throw_power = use_data & ~0x80000000;
      dest_pose = (use_data&0x80000000) ? POSE_THROW_DOWN : POSE_THROW;
      turn_angle = 0.0f;
      break;

   case INV_FLAREGUN:
      dest_pose = POSE_FLAREFIRE;
      break;

   case INV_KNIFE:
      dest_pose = POSE_KNIFE_HIT;
      break;

   case INV_BINOCULARS:
   case INV_CAMERA:
      switch(curr_pose){
      case POSE_BINOC_LOOK: case POSE_BINOC_LOOK + 0x20: case POSE_BINOC_LOOK + 0x40:
      case POSE_BINOC_BREATH: case POSE_BINOC_BREATH + 0x20: case POSE_BINOC_BREATH + 0x40:
         if(itm==INV_CAMERA){
            S_vector flash_dir = gun->GetWorldDir();
            if(tc.p_ctrl)
               tc.p_ctrl->IgnoreValue(GKEY_FIRE);
            S_vector flash_pos = gun->GetWorldPos();
            flash_pos += flash_dir*.1f;
            LPC_actor act_flash = mission.MakeParticle("flash", NULL, flash_pos, NULL, &flash_dir);
            {
                              //make flash appear immediatelly
               act_flash->GetModel()->Tick(10);
                              //put camera to 'camera'
               PI3D_frame cam = mission.game_cam.GetCamera();
               S_vector cpos = cam->GetPos();
               S_quat crot = cam->GetRot();
               cam->SetPos(gun->GetWorldPos());
               cam->SetDir(-gun->GetWorldDir(), 0.0f);
               cam->Update();

               mission.Render();
               SaveScreenShot(true);
                              //put camera back
               cam->SetPos(cpos);
               cam->SetRot(crot);
               cam->Update();
               mission.Render();
            }
            mission.PlaySound("photo", flash_pos, 2.0f, 6.0f);
            S_listen_source ls(LISTEN_HUMAN, frame->GetWorldPos(), 1.0f);
            mission.EmitListen(ls, 6.0f, true, this);

            if(net){
               const bool g = true;
               net_msg->Ascend(net_id);
               net_msg->AddBits(NM_HUMAN_CAM_FLASH, NET_ACTOR_CODE_BITS, g);
               net_msg->AddVector(flash_pos, g);
               net_msg->AddVector(flash_dir, g);
               net_msg->Descend();
            }
         }
         break;
      default:
         dest_pose = POSE_BINOC_LOOK;
      }
      break;
   }
   return true;
}

//----------------------------
#define MAX_ATTACK_NOSEEN_TIME 8000 //time after which subject's still not seen, PRG_ATTACK is erased

                              //network_actor: no

void C_human::ProcessProgram(const S_tick_context &tc){

   assert(!network_actor);

   int dest_pose = -1;
   if(cmd0_new){
      PrepareFrontCmd(dest_pose);
      cmd0_new=false;
   }

   int i;
   S_command &key = *program.front();
   int del = 0;
   bool preproc=false;
   bool allow_fade = true;
   if((key.pause_time -= tc.time) <= 0){
      key.pause_time = 0;
                              //start executing command
      switch(key.prg_item){

      case PRG_STAY_UP:
      case PRG_STAY_MID:
      case PRG_STAY_DOWN:
         if(!IsFullAnim()){   //wait if previous full anim done
            if(!key.sub_param.stay_processed){
                              //phase 0 - switch mode and start (full) anim
               key.sub_param.stay_processed =
                  SwitchStayMode((E_STAY_MODE)(key.prg_item-PRG_STAY_UP+SM_STAY));
            }else{
                              //phase 1 - stay mode change anim completed
               del=true;
            }
         }
         break;

#define FOLLOW_MAX_DIST 8.0f
#define FOLLOW_RUN_DIST 5.0f
#define FOLLOW_WALK_DIST 3.0f

      case PRG_MOVE:
         {
            bool running = key.sub_param.run;
                              //when running, we see and hear less
            if(AI_solution(tc.time, dest_pose, tab_game_cfg->ItemF(!running ? TAB_F_GAME_WATCH_CARE_WALK : TAB_F_GAME_WATCH_CARE_RUN))) break;
            if(!LeaveUseItem()) break;

            switch(curr_pose){
            case POSE_BARRIER_CLIMB:
                              //let the action run
               if(!IsFullAnim()){
                  dest_pose = POSE_RESET;
                  test_col_count = 0;
               }else{
                              //detect volume above head
                  I3D_collision_data cd(frm_head->GetWorldPos(), S_vector(0, 1.0f, 0), 0, model);
                  bool vol = mission.GetScene()->TestCollision(cd);
                  if(vol){
                     AI_DEBUG(C_fstring("volume %s above head, stopping climb!", (const char*)cd.GetHitFrm()->GetName()));
                     dest_pose = POSE_RESET;
                     test_col_count = 0;
                  }
               }
               break;
            default:
               {
                  bool next_dest_valid = true;
                  S_vector dest, next_dest;
                  C_movement *mv = key.GetMovement();
                  if(!mv){
                     del = true;
                     break;
                  }
                  int use_lad_door = 0;
                  bool b = mv->GetMovePos(dest, next_dest,
                     model, tc.time, this, &use_lad_door);
                  if(!b){
                     if(use_lad_door){
                              //if next command's use ladder, don't do this again
                        if(program.size()>1 && program[1]->prg_item==PRG_USE){
                           if(program[1]->GetSubject()->GetType()==ACTOR_LADDER ||
                              program[1]->GetSubject()->GetType()==ACTOR_DOOR){
                              use_lad_door = 0;
                           }
                        }
                     }
                     if(use_lad_door){
                              //add program for using closest ladder entry|door
                        struct S_hlp{
                           const S_vector *pos;
                           float best_dist;
                           vector<LPC_actor> ret_list;
                           S_vector cp_pos, cp_con_dir;
                           int what;
                           static bool cbE(LPC_actor a, dword c){
                              S_hlp *hp = (S_hlp*)c;
                              switch(hp->what){
                              case 1:  //ladder
                                 {
                                    if(a->GetType()!=ACTOR_LADDER) return true;
                                    float dist = (a->GetFrame()->GetWorldPos() - *hp->pos).Magnitude();
                                    if(hp->best_dist>dist){
                                       hp->best_dist = dist;
                                       if(!hp->ret_list.size()) hp->ret_list.push_back(a);
                                       else hp->ret_list.front() = a;
                                    }
                                 }
                                 break;
                              case 2:  //door
                                 if(a->GetType()!=ACTOR_DOOR)
                                    return true;
                                       //we're interested in closed only
                                 if(!a->cbProc(CB_USE_DOOR, 2))
                                    return true;
                                       //get closest dist to the CP connection line
                                 {
                                    S_vector v;
                                    a->GetCenterPos(v);
                                    //dist = (v-hp->cp_pos).Dot(hp->cp_con_dir) / (hp->cp_con_dir.Dot(hp->cp_con_dir));
                                    float u = hp->cp_con_dir.Dot(hp->cp_con_dir);
                                    if(u>MRG_ZERO)
                                       u = (v-hp->cp_pos).Dot(hp->cp_con_dir) / u;
                                    else
                                       return true;
                                    if(u<0.0f || u>1.0f) return true;
                                    S_vector v1 = hp->cp_pos + hp->cp_con_dir*u;
                                    float dist = (v-v1).Magnitude();
                                    if(dist<1.5f)
                                       hp->ret_list.push_back(a);
                                 }
                                 break;
                              }
                              return true;
                           }
                        } hlp;
                        //hlp.pos = &frame->GetWorldPos();
                        hlp.pos = &mv->GetPrevCP()->GetPos();
                        hlp.best_dist = 1e+10f;
                        hlp.what = use_lad_door;
                        mv->GetNextCPConDir(hlp.cp_pos, hlp.cp_con_dir);
                        mission.EnumActors(S_hlp::cbE, (dword)&hlp);
                        //S_hlp::cbE(mission.FindActor("door40"), (dword)&hlp);  //***debug test

                        if(hlp.ret_list.size()){
                           for(i=0; i<hlp.ret_list.size(); i++){
                                                   //setup using this actor
                              AddProgram(0, PRG_USE, S_prg_add((dword)hlp.ret_list[i], use_lad_door==2 ? -1 : 0));
                              AI_DEBUG(C_fstring("Going to use actor %s", (const char*)hlp.ret_list[i]->GetName()));
                           }
                           break;
                        }else
                           AI_DEBUG("Can't find any actor to use?!?");
                     }
                     {        //don't run downstairs!
                        S_vector pos = frame->GetWorldPos();
                        pos.y += 1.0f;
                        //float delta_y = frame->GetWorldPos().y - s_goto.dest.y;
                        float delta_y = frame->GetWorldPos().y - dest.y;
                        //float dist = (pos-s_goto.dest).Magnitude();
                        float dist = (pos-dest).Magnitude();
                        if(dist>MRG_ZERO){
                           if(delta_y/dist >= .3f)
                              running = false;
                        }
                     }

                     b = GoTo(dest, next_dest, dest_pose,
                        (running ? GOTOFLAGS_RUN : 0) |
                        (key.sub_param.force_smart ? GOTOFLAGS_FORCE_SMART : 0) |
                        GOTOFLAGS_SMART, next_dest_valid);
                     key.GetMovement()->SetCurrPos(model->GetWorldPos()+S_vector(0, 1, 0));
                     //del = key.GetMovement()->IsEnd();
                  }else{
                     AI_DEBUG("PRG_MOVE: destination accessed, removing cmd");
                     del = true;
                     dest_pose = POSE_RESET;
                     break;
                  }

                              //check command after MOVE
                  if(key.sub_param.move_reason!=MR_NORMAL){
                     bool test_dist = false;
                     float dist;
                     S_command &next_key = *program[1];
                     //bool can_look = true;

                     switch(key.sub_param.move_reason){
                     case MR_USE_REACH:
                              //check if item's still usable
                        {
                              //find PRG_USE up in program
                           LPC_actor subj = NULL;
                           {
                              for(int i=1; i<program.size(); i++)
                              if(program[i]->prg_item==PRG_USE){
                                 subj = program[i]->GetSubject();
                                 break;
                              }
                           }
                           assert(subj);
                           if(!subj){
                              del = true;
                              break;
                           }
                           bool for_use = subj->NumUsePositions(this);
                           bool use_res;
                           if(for_use){
                              //check if we've got reserved place
                              i = subj->cbProc(CB_RESERVE_USE, (dword)this);
                              use_res = (i!=-1);
                           }
                           if(!for_use || !use_res){
                              //oops, we're running for nothing
                              //check if we can see this
                              const S_vector &from = frm_head->GetWorldPos();
                              S_vector to;
                              subj->GetCenterPos(to);
                              bool seen;

                              I3D_collision_data cd(from, to-from, 0, model);
                              PI3D_frame vol = NULL;
                              if(mission.GetScene()->TestCollision(cd))
                                 vol = cd.GetHitFrm();
                              if(vol){
                                 if(vol->GetType()!=FRAME_VOLUME)
                                    seen = false;
                                 else
                                 do{
                                    vol=vol->GetParent();
                                    if(!vol){
                                       seen=true;
                                       break;
                                    }
                                    if(vol->GetType()==FRAME_MODEL){
                                       seen = (vol==subj->GetFrame());
                                       break;
                                    }
                                 }while(true);
                              }else seen=true;
                              if(seen){
                              //we see the disaster!
                                 int see_time = !for_use ? 500 : 1500;
                                 if((next_key.sub_param.use_no_sub_seen_count += tc.time) >= see_time){
                              //remove MOVE and USE
                                    del=2;
                                 }
                              }else next_key.sub_param.use_no_sub_seen_count = 0;
                           }/*else{
                              i = Max(0ul, subj->cbProc(CB_RESERVE_USE, (dword)this));
                              if(next_key.sub_param.use_reserve_indx!=i){
                              //reservation changed, remove MOVE
                                 next_key.sub_param.use_reserve_indx=i;
                                 del=true;
                              }
                           }
                           */
                        }
                        break;

                     case MR_FOLLOW_REACH:
                        {
                           test_dist = true;
                           dist = FOLLOW_WALK_DIST;
                        }
                        break;

                     case MR_ATTACK_REACH:
                        {
                              //find PRG_ATTACK up in program
                           LPC_actor subj = NULL;
                           {
                              for(int i=1; i<program.size(); i++)
                              if(program[i]->prg_item==PRG_ATTACK){
                                 subj = program[i]->GetSubject();
                                 break;
                              }
                           }
                           assert(subj);
                           if(!subj){
                              del = true;
                              break;
                           }
                           if(!MayHunt(subj->GetFrame()->GetWorldPos(), *program[1])){
                              AI_DEBUG("PRG_MOVE: over hunt distance, stopping attack, adding PRG_GUARD");
                              del = 2; //remove MOVE and ATTACK

                                             //look for a while at that direction
                              i = 1;
                              AddProgram(++i, PRG_GUARD, S_prg_add(0, 0, tab_game_cfg->ItemI(TAB_I_GAME_AI_MOVE_HUNT_COUNT)));
                              WatchReset();
                              //cbProc(CB_LISTEN_RESET);
                              ListenReset();
                              break;
                           }

                           if((subj->IsHuman() && !subj->IsAlive()) || subj->IsDestroyed()){
                                    //subject killed/destroyed by someone, reset watch list
                              AI_DEBUG("PRG_MOVE: hunted subject killed, removing 2 cmds");
                              WatchReset();
                              //cbProc(CB_LISTEN_RESET);
                              ListenReset();

                              del = 2; //remove MOVE and ATTACK
                           }else{
                              /*
                              test_dist = true;
                              dist = AI_f(TAB_F_AI_MIN_SHOOT_DIST) * .95f;
                              can_look = false;
                              */
                                             //check if the victim is seen
                              for(i=watch_actors.size(); i--; )
                              if(watch_actors[i].actor==subj){
                                 if(!watch_actors[i].IsSeen()) i=-1;
                                 break;
                              }
                              if(i!=-1){
                                             //wow, he's seen
                                 E_INV_ITEM itm = (E_INV_ITEM)tab_inventory->ItemI(TAB_I_INV_ID, C_inventory::GetItem(selected_inv_item));
                                 float fire_dist;
                                 switch(itm){
                                 case INV_GRENADE:
                                    fire_dist = GRENADE_THROW_DISTANCE;
                                    break;
                                 case INV_KNIFE:
                                    fire_dist = KNIFE_HIT_DISTANCE * .9f;
                                    break;
                                 default:
                                    fire_dist =
                                       GetType()==ACTOR_ENEMY ?
                                       AI_f(TAB_F_AI_MIN_SHOOT_DIST) :
                                       AI_f(TAB_F_AI_WATCH_MAX_DIST);
                                 }

                                 LPC_actor subject = next_key.GetSubject();
                                 S_vector m_pos;
                                 subject->GetCenterPos(m_pos);
                                 //const S_vector &pos = frm_head->GetWorldPos();
                                 const S_vector &pos = brest->GetWorldPos();
                                 S_vector dir(m_pos-pos);
                                 float m_dist = dir.Magnitude();
                                 if(m_dist <= fire_dist){
                                             //remove cmd
                                    AI_DEBUG("PRG_MOVE: victim seen, removing cmd");
                                    del = true;
                                    if(dest_pose==-1)
                                       dest_pose = GetBreathPose();
                                 }
                              }else{
                                 /*
                                             //count time
                                 int curr_t = igraph->ReadTimer();
                                 int not_seen_time = curr_t - key.sub_param.last_subj_seen_time;
                                 if(not_seen_time > 8000){
                                    if(not_seen_time > 7400){
                                       AI_DEBUG("PRG_MOVE: ATTACK subject not seen for too long, removing cmd");
                                       del = 2;
                                       dest_pose = GetBreathPose();
                                    }
                                    key.sub_param.run = true;
                                 }
                                 */
                              }
                           }
                        }
                        break;
                     }
                     if(test_dist){
                              //don't test every frame
                        if((key.sub_param.subj_seen_count += tc.time) > 500){
                           key.sub_param.subj_seen_count = 0;
                              //check how far we're to the subject
                              //and if we see him
                           LPC_actor subject = next_key.GetSubject();
                           assert(subject);
                           if(!subject){
                              del = true;
                              break;
                           }  
                           S_vector m_pos;
                           subject->GetCenterPos(m_pos);
                           S_vector pos = frm_head->GetWorldPos();
                           S_vector dir(m_pos-pos);
                           float m_dist = dir.Magnitude();
                           pos += dir * .6f / m_dist;
                           bool seen(false);
                           //bool real_unseen = false;
                           if(m_dist < dist){
                                    //check to see him
                              S_vector to(m_pos);
                              PI3D_frame obs = WatchObstacle(mission, this, model, frm_head->GetWorldPos(), to);
                              if(obs==subject->GetFrame()) obs = NULL;
                              //real_unseen = (obs);
                              seen = !obs;
                                 //*** debug
                              /*if(obs)
                              {
                                 dbLine(frm_head->GetWorldPos(), to);
                                 //OUTTEXT(C_fstring("PRG_ATTACK: obstacle in way: %s", obs->GetName()));
                              }*/
                           }
                           if(seen){
                              del = true;
                              if(dest_pose==-1)
                                 dest_pose = GetBreathPose();
                              AI_DEBUG("PRG_MOVE: can see subject, removing cmd");
                           }else
                           switch(key.sub_param.move_reason){
                           case MR_FOLLOW_REACH:
                                             //check if we need change strategy to get to him
                              if(m_dist>FOLLOW_RUN_DIST){
                                 if(!key.sub_param.run){
                                    AI_DEBUG("PRG_MOVE: follow master too far, modifying cmd to run");
                                    key.sub_param.run = true;
                                 }
                                 //del = true;
                              }
                              break;
                              /*
                           case MR_ATTACK_REACH:
                                 //don't hunt forever, count next key's time
                              if((next_key.sub_param.no_sub_seen_count += time) >= MAX_ATTACK_NOSEEN_TIME){
                                 AI_DEBUG("PRG_MOVE: can't see subject, removing MOVE & ATTACK");
                                 del=2;
                              }
                              break;
                              */
                           }
                        }
                     }
                  }
               }
            }
         }
         break;

      case PRG_ATTACK:
         {
            if(AI_solution(tc.time, dest_pose, tab_game_cfg->ItemF(TAB_F_GAME_WATCH_CARE_ATTACK)))
               break;
            //if(IsFullAnim()) break;

            bool gun_mode = false;
            bool on_vehicle = false;
            if(dest_pose==-1)
               dest_pose = GetBreathPose();
            if(using_item){
               switch(using_item->GetType()){
               case ACTOR_CANNON:
                  gun_mode = true;
                  break;

               case ACTOR_AUTO_CANNON:
                  on_vehicle = true;
                  if(using_item->cbProc(CB_USE_AUTO, 11, (dword)this)){
                     gun_mode = true;
                     break;
                  }
                              //flow...
               case ACTOR_AUTOMOBIL:
                  on_vehicle = true;
                              //check if we may use weapons from this position
                  if(using_item->cbProc(CB_USE_AUTO, 14, (dword)this))
                     break;
                  del = true;
                  break;
                              //flow...
               default:
                  if(!LeaveUseItem(1))
                     del = true;
                  break;
               }
               if(del)
                  break;
            }

                              //must have some weapon in hands
                              //or using special item
            if(!gun && !gun_mode){
               if(!cbProc(CB_WEAPONCHANGE))
                  del = true;
               break;
            }
                              //if re-loading, let it process
            if(curr_pose==POSE_LOAD || curr_pose==POSE_COLT_LOAD){
               if(IsAnimated())
                  break;
            }

            LPC_actor subj = key.GetSubject();
            if(!subj){
               del = true;
               break;
            }
                              //get bodypart we're attacking (if subject is human)
            S_vector sub_pos;
            PI3D_frame attack_frame = subj->GetFrame();
            bool is_human = subj->IsHuman();
            if(is_human){
               for(i=watch_actors.size(); i--; ){
                  if(watch_actors[i].actor==subj)
                     break;
               }
               if(i!=-1)
                  i = watch_actors[i].curr_seen_part_indx;
               else
                  i = key.sub_param.enm_body_part_index;

               PI3D_frame frm = i==-1 ? NULL :
                  attack_frame->FindChildFrame(body_part_names1[i]);
               if(frm) attack_frame = frm;
               sub_pos = attack_frame->GetWorldPos();
            }else{
               subj->GetCenterPos(sub_pos);
            }

            bool subject_seen;
                              //check if the subject is seen
            for(i=watch_actors.size(); i--; )
            if(watch_actors[i].actor==subj){
               if(!watch_actors[i].IsSeen()) i=-1;
                  break;
            }
            subject_seen = (i!=-1);

                     //check proper distance to the subject
            S_vector pos;
            if(!gun_mode)
               pos = gun->GetWorldPos();
            else
               using_item->cbProc(CB_USE_CANNON, 5, (dword)&pos);
            S_vector sub_dir = sub_pos - pos;
            float dist = sub_dir.Magnitude();

                              //shouldn't happen in ideal world
            if(dist<MRG_ZERO)
               break;
            E_INV_ITEM itm = (E_INV_ITEM)tab_inventory->ItemI(TAB_I_INV_ID, C_inventory::GetItem(selected_inv_item));

            float fire_dist;

            switch(itm){
            case INV_GRENADE:
               fire_dist = GRENADE_THROW_DISTANCE;
               break;
            case INV_KNIFE:
               fire_dist = KNIFE_HIT_DISTANCE * 1.1f;
               break;
            default:
               fire_dist =
                  GetType()==ACTOR_ENEMY ?
                  AI_f(TAB_F_AI_MIN_SHOOT_DIST) :
                  AI_f(TAB_F_AI_WATCH_MAX_DIST);
            }

            if(dist >= fire_dist){
               if(using_item){
                  break;
               }

               if(MayHunt(sub_pos, key) && subject_seen)
               {
                              //may move

                              //insert MOVE to the subject
                  AI_DEBUG(C_fstring("Human %s cmd ATTACK: too far, adding cmd MOVE", (const char*)model->GetName()));

                              //if we've to leave something, return to this after ATTACK complete
                  LeaveUseItem(1);

                  i = -1;
                              //hunt standing
                  if(stay_mode!=SM_STAY)
                     AddProgram(++i, PRG_STAY_UP, S_prg_add());
                  AddProgram(++i, PRG_MOVE, S_prg_add((dword)&sub_pos,
                     true,    //run
                     MR_ATTACK_REACH));

                  ResetAim();
                  break;
               }
                              //player's out of shoot range, and we're not
                              //operational, so let's wait and watch
               del = true;
               break;
            }else
            if(dist<1.0f){
               switch(itm){
               case INV_KNIFE:
                              //low distance is what we need
                  break;
               default:
                  if(!gun_mode && (dist > .01f)){
                              //can't make step while using some item...
                     if(using_item){
                        LeaveUseItem(1, true);
                        break;
                     }
                                 //step away from him
                     S_vector pos = frame->GetWorldPos();
                     pos -= sub_dir*1.0f / dist;

                     i = -1;
                     AddProgram(++i, PRG_STEP, S_prg_add((dword)&pos, 0, 0, true));
                     break;
                  }
               }
            }

            if(!gun_mode && !CheckItemUsePose())
               break;

            allow_fade = false;
            bool allow_aim;
            TurnedToDir(sub_dir, key.sub_param.is_turning, dest_pose, &allow_aim);
            if(!allow_aim){
                              //if using gun, we may leave the gun and attack by hands
               if(gun_mode){
                  if(!LeaveUseItem(1)){
                              //can't leave using item?
                     if(!subject_seen){
                              //if subject not seen, forget it
                        del = true;
                     }
                  }
               }
               break;
            }

            bool destroy_check = false;
            if(!is_human){
               PI3D_frame obs;
               S_vector to(sub_pos);
               obs = WatchObstacle(mission, this, model, frm_head->GetWorldPos(), to);
               if(obs==subj->GetFrame())
                  obs=NULL;
                                 //*** debug
                  //if(obs){
                     //dbLine(frm_head->GetWorldPos(), to);
                     //OUTTEXT(C_fstring("PRG_ATTACK: obstacle in way: %s", obs->GetName()));
                  //}
               subject_seen = (!obs);
            }
            if(!subject_seen){
                              //problem - our subject not seen
                              //check when we last saw him

               //int curr_t = igraph->ReadTimer();
               //int not_seen_time = curr_t - key.sub_param.last_subj_seen_time;

               key.sub_param.no_sub_seen_count += tc.time;
               if((key.sub_param.no_sub_seen_count += tc.time) < 5000 && MayHunt(sub_pos, key))
               //if(not_seen_time<5000 && MayHunt(sub_pos))
               {
                              //he's not seen, is he dead?
                  if((subj->IsHuman() && !subj->IsAlive()) || subj->IsDestroyed()){

                     AI_DEBUG("PRG_ATTACK: subject dead, removing cmd");
                     WatchReset();
                     //cbProc(CB_LISTEN_RESET);
                     ListenReset();

                     del = true;
                     dest_pose = POSE_RESET;
                     ResetAim();

                     if(subj->IsHuman() && AI_e(TAB_E_AI_SEARCH_DEAD)==2){
                              //go to enemy place and search there for a while
                              //algo: guard a second, go there, watch there
                        i = 0;
                        AddProgram(++i, PRG_GUARD, S_prg_add(0, 0, 800));
                        AddProgram(++i, PRG_MOVE, S_prg_add((dword)&sub_pos, true));
                        AddProgram(++i, PRG_WATCH, S_prg_add());
                     }
                     break;
                  }
                              //we know where he could be, go to there directly
                  AI_DEBUG("PRG_ATTACK: subject hid, adding cmd MOVE");

                              //if we've to leave something, return to this after ATTACK complete
                  LeaveUseItem(1);

                  i = -1;
                  if(stay_mode!=SM_STAY)
                     AddProgram(++i, PRG_STAY_UP, S_prg_add());
                  AddProgram(++i, PRG_MOVE, S_prg_add((dword)&sub_pos,
                     true,    //run
                     MR_ATTACK_REACH), true);

                  ResetAim();
                  break;
               }else{
                              //forget him!
                  bool guard = true;
                  if(gun_mode)
                     guard = false;
                  if(guard)
                  for(i=program.size(); i--; )
                  if(program[i]->prg_item==PRG_FOLLOW){
                     guard = false;
                     break;
                  }
                  if(GetType()==ACTOR_PLAYER) guard = false;
                  AI_DEBUG(C_fstring("PRG_ATTACK: subject not seen for long, deleting%s", guard ? " and adding PRG_WATCH" : ""));
                  del = true;
                  WatchReset();
                  //cbProc(CB_LISTEN_RESET);
                  ListenReset();

                  if(guard){
                              //but guard
                     i = 0;
                     //AddProgram(++i, PRG_WATCH, S_prg_add((dword)&sub_pos), 3);   //bug?
                     AddProgram(++i, PRG_WATCH, S_prg_add((dword)&sub_pos, 3));
                     AddProgram(++i, PRG_GUARD, S_prg_add(0, 0, tab_game_cfg->ItemI(TAB_I_GAME_AI_ATTACK_LOST_COUNT)));
                  }
                  break;
               }
            }else{
                              //subject seen
               //key.sub_param.last_subj_seen_time = igraph->ReadTimer();
                              //check if subject alive
               destroy_check = true;
            }

            bool grenade_mode = (itm==INV_GRENADE);
            S_vector *aim_disp = NULL;
            if(type==ACTOR_PLAYER){
               aim_disp = (LPS_vector)cbProc(CB_GET_AIM_DISP);
            }
            const S_vector *ref_dir = NULL;
            S_vector tmp_dir;
            float req_angle = AIM_THRESH_ANGLE;
            if(!grenade_mode){
               if(!aim_disp){
                  if(gun)
                     ref_dir = &gun->GetWorldDir();
               }else{
                  PI3D_frame weapon = mission.game_cam.GetAimModel();
                  if(weapon){
                     S_vector pos = (*aim_disp) * weapon->GetMatrix();
                     tmp_dir = mission.game_cam.GetCamera()->GetWorldPos() - pos;
                                       //get angle from real gun
                     float f = tmp_dir.AngleTo(gun->GetWorldDir());
                     if(fabs(f) < PI*.1f){
                        ref_dir = &tmp_dir;
                        req_angle *= 2.0f;
                     }else{
                        if(gun)
                           ref_dir = &gun->GetWorldDir();
                     }
                  }
               }
            }

            //const float req_angle = PI*.2f;
            i = AimedToDir(sub_dir, brest, tc.time, ref_dir, req_angle);
            if(i){
               bool use_ok = false;
               if(gun_mode){
                  if(shoot_cntdwn<=0 || ((shoot_cntdwn -= tc.time) <= 0)){
                              //check if cannon or reflector
                     int type = using_item->cbProc(CB_USE_CANNON, 8);
                     if(type==1){
                              //reflector - only point to enemy
                     }else{
                        destroy_check = true;
                        use_ok = using_item->cbProc(CB_USE_CANNON, 3, (dword)this);
                        if(use_ok){
                           int ammo = using_item->cbProc(CB_USE_CANNON, 6);
                           if(!ammo){
                              AI_DEBUG("PRG_ATTACK: out of ammo, stop using cannon");
                              using_item->Use(this, 0);
                              PlayVoice("sht", 3.0f, true);
                                       //try to switch to other weapon
                              if(!cbProc(CB_WEAPONCHANGE)){
                                 del=true;
#ifdef EXPIRED_ENEMY_OUT
                                 cbProc(CB_OUT_OF_GAME);
#endif
                              }
                           }
                        }
                     }
                  }
               }else{   //gun_mode
                  if(grenade_mode && dist<11.0f){
                              //don't throw for so short dist, better switch to other weapon
                     //cbProc(CB_WEAPONCHANGE);
                     AI_DEBUG(C_fstring("Human %s cmd ATTACK: throwing grenade to critical distance (%.1fm)", model->GetName(), dist));
                     //break;
                  }
                  /*
                              //if using vehicle, make sure we don't kill someone driving with us
                  if(using_item){
                     switch(using_item->GetType()){
                     case ACTOR_AUTOMOBIL:
                     case ACTOR_AUTO_CANNON:
                        {

                        }
                        break;
                     }
                  }
                  */
                              //fire!
                  use_ok = C_human::UseItem(tc, dest_pose, aim_disp, aim_disp, 0);
                  if(use_ok){
                              //check ammo
                     i = C_inventory::GetItemAmount(selected_inv_item);
                     if(!i){
                        AI_DEBUG(C_fstring("Human %s cmd ATTACK: out of ammo", model->GetName()));
                              //oops, no ammo, try to change weapon
                        i = cbProc(CB_WEAPONCHANGE);
                        if(!i){
                           cbProc(CB_OUT_OF_GAME);
                        }
                     }
                  }
               }
               if(use_ok){
                              //suspend after shot
                  //dest_pose = -1;
                  int suspend_time = 0;
                  int shoot_delay = 0;
                  if(grenade_mode){
                     throw_power = Max(dist, 11.0f) * 40;
                              //do nothing for a time - wait for destruction
                     suspend_time = 6000;
                     if(dist<11.0f){
                              //lay down before suspend, maybe we'll survive
                        AddProgram(0, PRG_STAY_DOWN, S_prg_add());
                        suspend_time = 1200;
                     }
                  }else{
                     shoot_delay = GetReactionDelay();
                  }
                  if(suspend_time){
                     AI_DEBUG(C_fstring("Forcing suspend after shoot: %i ms", suspend_time));
                     AddProgram(0, PRG_SUSPEND, S_prg_add(suspend_time));
                  }
                  if(shoot_delay){
                     //shoot_cntdwn += shoot_delay;
                     shoot_cntdwn = Min(shoot_cntdwn+shoot_delay, shoot_delay);
                     AI_DEBUG(C_fstring("Forcing delay after shoot: %i ms", shoot_cntdwn));
                  }
                  destroy_check = true;
               }
            }
                              //check if dead or destroyed
            if(destroy_check)
            if((subj->IsHuman() && !subj->IsAlive()) || subj->IsDestroyed()){
                        //ugh, killed someone, reset watch&listen lists
               WatchReset();
               //cbProc(CB_LISTEN_RESET);
               ListenReset();

               bool guard = true;
               for(i=program.size(); i--; )
               if(program[i]->prg_item==PRG_FOLLOW){
                  guard=false;
                  break;
               }
               del = true;
               if(guard){
                              //watch some time to the direction
                  i = 0;
                  AddProgram(++i, PRG_GUARD, S_prg_add(0, (dword)&sub_pos, tab_game_cfg->ItemI(TAB_I_GAME_AI_ATTACK_KILL_COUNT)));
               }
            }
         }
         break;

      case PRG_FOLLOW:
         {
                              //peek formation
            LPC_follow_formation ff = key.sub_param.follow_form;
            //assert(ff);
            if(!ff){
               del = true;
               break;
            }
            int indx = ff->FollowerIndx(this);
            ff->Tick(tc.time, indx);

            LPC_actor master = ff->master;
            assert(master);
                              //check if master alive
            if(!master->IsAlive()){
               PlayVoice("sht", 4.0f, true);
               holding_fire = false;
               del = true;
               break;
            }
            if(AI_solution(tc.time, dest_pose, tab_game_cfg->ItemF(TAB_F_GAME_WATCH_CARE_FOLLOW)))
               break;

            if(using_item){
                              //if we're using the same thing like master, we're OK
               if(using_item != ((C_human*)master)->GetUsingItem())
                  LeaveUseItem(-1, true);
               break;
            }

            {
                              //follow master into vehicle
               bool brk = false;
               LPC_actor u_itm = ((C_human*)master)->GetUsingItem();
               if(u_itm)
               switch(u_itm->GetType()){
               case ACTOR_AUTOMOBIL:
               case ACTOR_AUTO_CANNON:
                              //check our using item - should be the same
                  if(using_item!=u_itm){
                              //reserve place for us in the car
                     int res_indx = u_itm->cbProc(CB_RESERVE_USE, (dword)this, 3000);
                     if(res_indx!=-1){    //reservation ok
                        AI_DEBUG(C_fstring("Follower %s: master is in vehicle, I want go too (reserved seat: %i)", (const char*)GetName(), res_indx));
                        bool is_boat = (u_itm->GetTable(1)->ItemE(TAB_E_AUTO_TYPE) == 1);
                        AddProgram(0, PRG_USE, S_prg_add((dword)u_itm, res_indx, is_boat ? F2I(5.0f) : 0));
                        brk = true;
                     }
                  }else
                     brk = true;
                  break;
               }
               if(brk) break;
            }
                              //get ideal position in formation
            S_vector dest_pos = ff->GetPosition(indx);
            const S_vector &our_pos = frame->GetWorldPos();
            float m_dist = (dest_pos-our_pos).Magnitude();

            if(m_dist > FOLLOW_RUN_DIST || !key.sub_param.follow_init){
               key.sub_param.follow_init = true;
               bool run = (m_dist>FOLLOW_MAX_DIST);
                              //when run, then let's stay up
               if(run){
                  if(!CheckFreeStand(1.85f))
                     break;                  
                  if(!SwitchStayMode(1ul))
                     break;
               }
               AI_DEBUG(C_fstring("Follower %s: too far from master, adding PRG_MOVE", (const char*)model->GetName()));

               LeaveUseItem();

               i = -1;
                              //insert MOVE key
               AddProgram(0, PRG_MOVE, S_prg_add((dword)&dest_pos,
                  true,       //run
                  MR_FOLLOW_REACH,
                  false));     //force smart

                              //change look mode
               //ff->followers[indx].look_mode = C_follow_formation::LM_FORWARD;
               break;
            }
            {
                              //copy master's stay mode
               if(!using_item){
                  E_STAY_MODE sm = ((C_human*)master)->GetStayMode();
                  if(stay_mode != sm){
                              //must be delayed
                     int &d = key.sub_param.follow_sm_delay;
                     if(!d) d = 300 + S_int_random(700);
                     else
                     if((d -= tc.time) <= 0){
                        d = 0;
                        SwitchStayMode(sm);
                        break;
                     }
                  }
                  const S_vector &dir = ff->GetDirection(indx);
                  i = TurnedToDir(dir, key.sub_param.follow_turn, dest_pose);
                  if(i){
                     if(dest_pose==-1)
                        dest_pose = GetBreathPose();
                     turn_angle = 0.0f;
                  }
               }
            }
         }
         break;

      case PRG_USE:
         {
            LPC_actor use_item = key.GetSubject();
            if(!use_item){
               AI_DEBUG("PRG_USE: no subject set");
               del = true;
               break;
            }
                              //leave previous item
            if(!key.sub_param.use_pending){
               if(!LeaveUseItem())
                  break;
               float min_use_dist = key.sub_param.min_use_dist;
               if(!min_use_dist)
                  min_use_dist = 2.0f;
               if(CheckUseItemConds(use_item, true, dest_pose, key.sub_param.use_reserve_indx, false, true, min_use_dist))
                  break;
               turn_angle = 0.0f;
               dest_pose = POSE_RESET;
                              //now we have good pos, stay, dir, we may use this
               i = use_item->Use(this, (key.sub_param.use_reserve_indx<<16) | 1 | 0x8000);
               switch(i){
               case 0:
                              //can't use (now), wait here
                  break;

               case 1:
                              //use OK
                  switch(use_item->GetType()){
                  case ACTOR_RESOURCE:
                  case ACTOR_DOOR:
                     //if(i)
                     {
                              //let anim come to n_otify key
                        AddProgram(1, PRG_SUSPEND, S_prg_add(1200));
                        preproc = true;
                        dest_pose = -1;
                     }
                     del = true;
                     break;

                  case ACTOR_CANNON:
                     if(i){
                              //if reflector, switch it on
                        assert(using_item);
                        int type = using_item->cbProc(CB_USE_CANNON, 8);
                        if(type==1){
                           int state = using_item->cbProc(CB_USE_CANNON, 9);
                           if(!state)
                              using_item->cbProc(CB_USE_CANNON, 3, (dword)this);
                        }
                        del = true;
                     }
                     break;

                  case ACTOR_AUTOMOBIL:
                  case ACTOR_AUTO_CANNON:
                              //can't follow anyone when got inside of car
                     //if(!ClrPrgToFollow())
                        del = true;
                     break;

                  case ACTOR_LADDER:
                     if(i){
                              //change to PRG_LADDER_CLIMB
                        AddProgram(1, PRG_LADDER_CLIMB, S_prg_add(use_item->cbProc(CB_USE_LADDER, 1)));
                              //align to ladder
                        frame->SetRot(using_item->GetFrame()->GetWorldRot());
                        const S_vector &p = using_item->GetFrame()->GetWorldPos();
                        frame->SetPos(S_vector(p.x, frame->GetWorldPos().y, p.z));
                        frame->Update();
                        del = true;
                     }
                     break;
                  }
                  AI_DEBUG(C_fstring("PRG_USE: using item, ret code = %i%s", i, del ? ", deleting command" : ""));
                  break;

               case 2:
                              //pending
                  key.sub_param.use_pending = true;
                  break;
               }
               break;
            }
            if(key.sub_param.use_pending){
                              //wait until it's not ok
               if(use_item==using_item){
                              //align to ladder
                  switch(use_item->GetType()){
                  case ACTOR_LADDER:
                     frame->SetRot(using_item->GetFrame()->GetWorldRot());
                     const S_vector &p = using_item->GetFrame()->GetWorldPos();
                     frame->SetPos(S_vector(p.x, frame->GetWorldPos().y, p.z));
                     frame->Update();
                  }
                  del = true;
               }
               break;
            }
                              //use until next key (if any)
            if(program.size()>1){
               S_command &key = *program[1];
               if((key.pause_time -= tc.time) <= 0){
                  key.pause_time = 0;
                  del = true;
                  if(using_item)
                     using_item->Use(this, 0);
               }
               //cbProc(CB_PRG_SHOW, 1);
            }
         }
         break;

      case PRG_SUSPEND:
         if(!IsAnimated())
            dest_pose = GetBreathPose();
         if((key.sub_param.suspend_count -= tc.time) <= 0) del = true;
         break;

      case PRG_RESTART:
                              //(try to) reload program
         //cbProc(CB_PRG_LOAD);
         LoadProgram();
         break;

      case PRG_SETVISIBLE:
         SetVisible(key.sub_param.setvisible_status, false, true);
         del = true;
                              //expired enemies do this, so let them die without reason
         /*
         if(program.size() <= 1)
            stay_mode = SM_DEAD;
            */
         break;

      case PRG_SEND_SIGNAL:
         {
            LPC_actor a = key.GetSubject();

            S_signal_data sd;
            sd.actor = this;
            sd.type = SIGNAL_PROGRAM;
            sd.sub_type = key.sub_param.send_signal_id;
            if(a) a->cbProc(CB_SIGNAL, (dword)&sd, 0);
            else mission.BroadcastMessage(CB_SIGNAL, (dword)&sd, 0);

            del = true;
         }
         break;

      case PRG_PRG1:
                              //select random checkpoint & go there
         {
            int numcp = mission.NumCheckpoints();
            if(!numcp){
               del=true;
               break;
            }
                              //try to find non-marked CP
            int j = S_int_random(numcp);
            int i=j;
            LPC_checkpoint cp;
            do{
               if(++i == numcp) i=0;
               cp = mission.GetCheckpoints()[i];
               if(!cp->debug_flag) break;
            }while(i != j);
            if(i==j){
               del = true;
               AI_DEBUG("Checkpoint race done!");
            }else{
               //cp->debug_flag=1;
               AddProgram(0, PRG_MOVE, S_prg_add((dword)&cp->GetPos(), key.sub_param.prg1_bool));

               for(i=j=0; i<numcp; i++){
                  cp = mission.GetCheckpoints()[i];
                  if(!cp->debug_flag) ++j;
               }
               AI_DEBUG(C_fstring("Moving to random checkpoint (%i left)", j));
            }
         }
         break;

      case PRG_WAIT_SIGNAL:
         if(dest_pose==-1)
            dest_pose = GetBreathPose();
         AI_solution(tc.time, dest_pose, tab_game_cfg->ItemF(TAB_F_GAME_WATCH_CARE_GUARD));
         break;

      case PRG_GUARD:
         {
            if(key.sub_param.guard_count && (key.sub_param.guard_count-=tc.time)<=0){
               AI_DEBUG("PRG_GUARD: countdown expired, deleting");
               del = true;
               ResetAim();
               break;
            }
            /*
                              //check if we've got reasonable weapon
            if(!cbProc(CB_CHECKCURRWPNSTATUS)){
                              //try to switch to other weapon
               if(!cbProc(CB_WEAPONCHANGE)){
                              //try to look for some resource around
                  if(!cbProc(CB_FIND_WEAPON)){
                     //del=true;
                  }
#ifdef EXPIRED_ENEMY_OUT
                  cbProc(CB_OUT_OF_GAME);
#endif
               }
               break;
            }
            */
            if(IsFullAnim())
               break;
                              //check if we're at proper position
            S_vector pos(model->GetWorldPos());
            if(key.sub_param.guard_dest_set){

               pos.y += 1.0f;
               float dist = (key.dest - pos).Magnitude();
               if(dist > 2.0f){
                                 //MOVE to the guard position
                  AI_DEBUG(C_fstring("human %s: cmd GUARD: adding MOVE", (const char*)model->GetName()));
                  i = -1;
                  AddProgram(++i, PRG_MOVE, S_prg_add((dword)&key.dest, true));
                  break;
               }
            }
            if(dest_pose==-1)
               dest_pose = GetBreathPose();

                              //check if we're aiming to the target
            const S_vector *aim_dest = NULL;

            if(key.sub_param.guard_aim_dest) aim_dest = &key.sub_param.guard_aim_dest->GetPos();
            else
            if(key.sub_param.guard_aim_dest_set) aim_dest = (LPS_vector)key.sub_param.guard_aim_dest_v;
            else
            if(key.GetSubject()){
               LPC_actor subj = key.GetSubject();
                              //check if subject seen
               aim_dest = &subj->GetFrame()->GetWorldPos();
            }

            if(aim_dest){
               S_vector sub_dir((*aim_dest) - pos);
               if(!key.sub_param.guard_good_aim){
                  bool allow_aim;
                  bool b = TurnedToDir(sub_dir, key.sub_param.guard_is_turning, dest_pose, &allow_aim);
                  if(allow_aim){
                     b =
                        AimedToDir(sub_dir, brest, tc.time, gun ? &gun->GetWorldDir() : NULL);
                     key.sub_param.guard_good_aim = b;
                     if(b){
                        turn_angle = 0.0f;
                        LPC_checkpoint curr_cp = key.sub_param.guard_aim_dest;
                        key.sub_param.aim_count = !curr_cp ? 0 :
                           2000 + S_int_random(2000);
                     }
                  }
               }else{
                  if(key.sub_param.aim_count && (key.sub_param.aim_count -= tc.time) <= 0){
                              //try to choose another CP
                     LPC_checkpoint curr = key.sub_param.guard_aim_dest;
                     int numc = curr->NumConnections();
                     if(numc){
                        key.sub_param.guard_aim_dest = curr->GetCPoint(S_int_random(numc));
                     }
                     key.sub_param.guard_good_aim = false;
                  }
               }
               allow_fade = false;
            }
            AI_solution(tc.time, dest_pose, tab_game_cfg->ItemF(TAB_F_GAME_WATCH_CARE_GUARD));
         }
         break;

      case PRG_WATCH:
         {
            if(AI_solution(tc.time, dest_pose, tab_game_cfg->ItemF(TAB_F_GAME_WATCH_CARE_WATCH)))
               break;

            allow_fade = false;

            if(gun && !IsReadyToFire())
               break;

            S_vector &curr_dest = *(LPS_vector)key.sub_param.watch.curr_dest;
            const S_vector &head_pos = frm_head->GetWorldPos();
            S_vector curr_pos = frame->GetWorldPos();
            curr_pos.y = head_pos.y;
            int &idle_count = key.sub_param.watch.idle_count;
            if(!idle_count){
                              //choose where we're going to look at
               S_vector &base_dest = *(LPS_vector)key.sub_param.watch.base_dest;
               S_vector dir(base_dest-curr_pos);
               dir.Normalize();

               S_vector2 v2(dir.x, dir.z);
               float v2_len = v2.Magnitude();
               v2 /= v2_len;
               float a = Angle2D(v2);
               a += S_float_random() * PI*.6f - PI*.3f;
               v2.x = -sin(a);
               v2.y = cos(a);
               v2 *= v2_len;
               dir.x=v2.x, dir.z=v2.y;
               curr_dest = curr_pos + dir;
               //dbLine(frame->GetWorldPos(), curr_dest);

                              //setup random delay
               idle_count = 600 + S_int_random(600);
            }

            bool &aim_ok = key.sub_param.watch.aim_ok;
            if(!aim_ok){
               bool allow_aim;
               S_vector dir(curr_dest - curr_pos);
               bool b = TurnedToDir(dir, key.sub_param.watch.is_turning, dest_pose, &allow_aim);
               if(allow_aim){
                              //don't force aiming those who're not in their firing stay mode
                  static const byte stay_mask[] = {0, 1, 2, 4};
                  byte use_pose_mask = tab_inventory->ItemE(TAB_E_INV_USEPOSE, GetItem(selected_inv_item));
                  if(!(use_pose_mask&stay_mask[stay_mode])){
                                          //try to required switch to stay mode
                     //SwitchStayMode((dword)use_pose_mask);
                     aim_ok = true;
                     turn_angle = 0.0f;
                  }else{
                              //aim to dest
                     if(AimedToDir(dir, brest, tc.time, gun ? &gun->GetWorldDir() : NULL, PI*.1) && b){
                        aim_ok = true;
                        //AI_DEBUG("PRG_WATCH: aim ok, start counting");
                        turn_angle = 0.0f;
                     }
                  }
                              //don't fade until we're idle
                  //aim_count = Max(aim_count, idle_count + AIM_FADE_TIME);
                  allow_fade = false;
               }
               break;
            }else{
                              //now watch and count down
               if((idle_count -= tc.time) <= 0){
                  //AI_DEBUG("PRG_WATCH: end of staring");
                  if(!--key.sub_param.watch.phase_count){
                              //end of fun my friend, back to work
                     del = true;
                     AI_DEBUG("PRG_WATCH: finish, deleting");
                  }else{
                              //it's now time to check we've some weapon in hands
                     if(!gun){
                        if(!cbProc(CB_WEAPONCHANGE)){
                              //opps, what would you do if you saw enemy?
                           AI_DEBUG("PRG_WATCH: no weapon, removing");
                           del=true;
                           break;
                        }
                        AI_DEBUG("PRG_WATCH: taking out weapon");
                     }

                     idle_count = 0;
                     aim_ok = false;
                              //sometimes you may make a step
                     if(!S_int_random(3))
                     {
                        //AI_DEBUG("PRG_WATCH: adding PRG_STEP");
                        S_vector dest(frame->GetWorldPos());
                        dest.x += S_float_random() * 3.0f - 1.5f;
                        dest.z += S_float_random() * 3.0f - 1.5f;
                        AddProgram(0, PRG_STEP, S_prg_add((dword)&dest));
                     }
                  }
               }
               if(dest_pose==-1)
                  dest_pose = GetBreathPose();
            }
         }
         break;

      case PRG_USE_INV:
         {
            if(!key.sub_param.change_phase){
                              //determine how to use the item
               i = C_inventory::ItemIndex(key.sub_param.use_inv_id);
               if(i!=-1){
                  if(i!=selected_inv_item){
                     bool ok = false;
                     E_INV_ITEM itm = (E_INV_ITEM)tab_inventory->ItemI(TAB_I_INV_ID, C_inventory::GetItem(i));
                     switch(itm){
                     case INV_WEAPON: case INV_GRENADE: case INV_FLAREGUN:
                     case INV_BAZOOKA: case INV_KNIFE: case INV_BINOCULARS:
                     case INV_PANZER:
                     case INV_COLT:
                        {
                           bool b = WeaponChangeAnim();
                           if(b){
                              ++key.sub_param.change_phase;
                              C_inventory::SetActiveItem(i);
                              ok = true;
                           }
                        }
                        break;
                     default:
                        C_inventory::SetActiveItem(i);
                        UseInvItem(dest_pose);
                        ++key.sub_param.change_phase;
                        ok = true;
                     }
                     if(ok){
                        if(net)
#ifndef ENEMY_NET_SYNC_INV
                        if(GetType()==ACTOR_PLAYER)
#endif
                        {    //2 = set active
                           const bool g = true;
                           net_msg->Ascend(net_id);
                           net_msg->AddBits(NM_HUMAN_INVENTORY, NET_ACTOR_CODE_BITS, g);
                           net_msg->AddBits(i, 6, g);
                           net_msg->AddBits(2, 3, g);
                           net_msg->Descend();
                        }
                     }
                  }else
                     ++key.sub_param.change_phase;
               }else del = true;
            }else{
                              //when anim done, we may remove cmd
               if(!IsFullAnim()){
                  E_INV_ITEM itm = (E_INV_ITEM)tab_inventory->ItemI(TAB_I_INV_ID, C_inventory::GetItem(selected_inv_item));
                  switch(itm){
                  case INV_FLAREGUN:
                     dest_pose = POSE_FLAREFIRE;
                     break;
                  }
                  del = true;
               }
            }
         }
         break;

      case PRG_WALK_CP:
         {
            LPC_checkpoint cp = key.sub_param.cp_dest;
            if(!cp){
               del = true;
               break;
            }
            i = -1;
            LPC_checkpoint cp_next = key.sub_param.cp_next;
            if(!cp_next){
               del = true;
               ++i;
            }
                              //move to the dest
            AI_DEBUG(C_fstring("Moving to checkpoint: %s", (const char*)cp->GetName()));
            AddProgram(++i, PRG_MOVE, S_prg_add((dword)&cp->GetPos(), key.sub_param.walk_cp_run, MR_WALK_CP));

            if(!cp_next)
               break;
            key.sub_param.cp_dest = key.sub_param.cp_next;
            key.sub_param.cp_next = NULL;
                              //choose next CP now
            int num_cons = cp_next->NumConnections();
            switch(num_cons){
            case 1:
               key.sub_param.cp_next = cp_next->GetCPoint(0);
               break;
            default:          //choose random, but different thaw what we have now
               do{
                  key.sub_param.cp_next = cp_next->GetCPoint(S_int_random(num_cons));
               }while(key.sub_param.cp_next==cp);
            }
            /*
            C_smart_ptr<C_checkpoint> *checkpoints = mission.GetCheckpoints();
            for(int i=mission.NumCheckpoints(); i--; ){
               if(!checkpoints[i]->help_visited){
                  checkpoints[i]->help_visited = true;
                  key.sub_param.cp_next = checkpoints[i];
                  break;
               }
            }
            */
         }
         break;

      case PRG_STEP:
         {
                                       //move to destination
            bool passed = GoTo(*(LPS_vector)&key.sub_param.step_dest, S_vector(0, 0, 0), dest_pose,
               (key.sub_param.step_run ? GOTOFLAGS_RUN : 0) |
               GOTOFLAGS_SMART);

            if(!passed)       //give it just certain time
            if((key.sub_param.step_counter += tc.time) >= 1500) passed = true;

            if(passed){
               del = true;
               dest_pose = POSE_RESET;
            }
         }
         break;

      case PRG_SUICIDE:
         cbProc(CB_DIE, 1);
                              //program is empty now
         //del = true;
         break;

      case PRG_LADDER_CLIMB:
         {
            const bool &up = key.sub_param.ladder_climb_up;
            del = UseLadder(tc, up, !up, dest_pose);

            if(del){
               if(program.size()>1){
                  S_command &key1 = *program[1];
                  if(key1.prg_item==PRG_MOVE){
                     key1.GetMovement()->SetCurrPos(model->GetWorldPos()+S_vector(0, 1, 0));
                  }
               }
            }
         }
         break;

      case PRG_DRIVE:
         {
                              //make sure we're in a car
            int uit = using_item ? using_item->GetType() : ACTOR_NULL;
            if(uit!=ACTOR_AUTOMOBIL && uit!=ACTOR_AUTO_CANNON){
               AI_DEBUG("PRG_DRIVE: expecting to be user of car, deleting");
               del = true;
               break;
            }
            C_movement *mv = key.GetMovement();
            if(!mv){
               del = true;
               break;
            }
            PI3D_frame auto_frame = using_item->GetFrame();
            const S_vector &auto_pos = auto_frame->GetWorldPos();
            mv->SetCurrPos(auto_pos);

                              //until we don't have some speed, limit time passed to GetMovePos
            int speed = using_item->cbProc(CB_USE_AUTO, 8);
            /*
            int time1 = time;
            //if(speed<10) time1 = time1 * (.2f + (float)(speed-.2f)/10.0f);
            if(speed<60) time1 = time1 * speed/60;
            time1 /= 2;
            */
            //int time1 = 0;
            float dist_to_end = (mv->GetDest() - auto_pos).Magnitude();

            S_vector dest, next_dest;
            bool b;

            if(dist_to_end<6.0f){
               key.sub_param.braking = speed==0 ? 3 : (speed>=0) ? 1 : 2;
               if(key.sub_param.braking==3){
                              //stop automobil
                  using_item->cbProc(CB_USE_AUTO, 13);
                  del = true;
                  break;
               }
            }
            /*
            if(dist_to_end<2.0f) b = true;
            else
               b = mv->GetMovePos(dest, next_dest, model, time1, this, NULL);
            if(b){
               del=true;
               break;
            }
            */
            if(key.sub_param.braking){
               dest = mv->GetDest();
            }else{
               b = mv->GetMovePos(dest, next_dest, model, tc.time, this, NULL, false);
               if(b){
                  dest = mv->GetDest();
                  key.sub_param.braking = speed==0 ? 3 : (speed>=0) ? 1 : 2;
               }
            }
            //else dest = next_dest;

                              //get distance to the absolute end

                              //turn wheels as appropriate
            S_vector dest_dir = dest - auto_pos;
            const S_vector &auto_dir = auto_frame->GetWorldDir();
            float dir_delta = Angle2D(S_vector2(dest_dir.x, dest_dir.z), S_vector2(auto_dir.x, auto_dir.z));
            if(dir_delta>PI)
               dir_delta -= PI*2.0f;

            float dist_to_next = (dest - auto_pos).Magnitude();
            if(dist_to_next<3.5f)
               mv->SkipCP();
            /*
            else
            if(fabs(dir_delta) > PI*.7f)
               mv->SkipCP();
               */


                              //get ideal speed
            int ideal_speed = key.sub_param.drive_ideal_speed;
            if(!ideal_speed)
               ideal_speed = 25;
            ideal_speed = (PI*.45f - fabs(dir_delta)) * ideal_speed;

            if(key.sub_param.braking)
               ideal_speed = ideal_speed*2/5;
                              //if we're reaching the destination, brake
            //if(dist_to_end<10.0f) ideal_speed *= (dist_to_end-1.0f)/9.0f;
               /*
            if(key.sub_param.braking && speed<1)
               using_item->cbProc(CB_USE_AUTO, 4, time);
            else
            */
            bool want_backward;

            if(speed<ideal_speed){
                              //accelerate!
               want_backward = false;
            }else{
                              //brake
               want_backward = true;
            }

            float wheel_turn = I2F(using_item->cbProc(CB_USE_AUTO, 12));
            wheel_turn += Angle2D(S_vector2(auto_dir.x, auto_dir.z));
            if(speed<0)
               wheel_turn += GetPI();
            if(wheel_turn>=GetPI2())
               wheel_turn -= GetPI2();
            float wheel_delta = wheel_turn - Angle2D(S_vector2(dest_dir.x, dest_dir.z));

            if(wheel_delta>GetPI())
               wheel_delta -= GetPI2();
            else
            if(wheel_delta <= -GetPI())
               wheel_delta += GetPI2();
                              //turn wheels
            float turn_ratio = -wheel_delta*speed*tc.time*.002f;

            /*
                              //keep the same direction for a time
            if(key.sub_param.last_dir_backward != want_backward){
                              //go bacward longer
               int ref_time = want_backward ? 400 : 400;
               if((key.sub_param.last_dir_count += time) >= ref_time){
                              //ok, we may change direction now
                  key.sub_param.last_dir_backward = want_backward;
                  key.sub_param.last_dir_count = 0;
               }else{
                  want_backward = key.sub_param.last_dir_backward;
                  //turn_ratio = -turn_ratio;
               }
            }
            */
            if(!key.sub_param.last_dir_backward){
                              //go forward until
               if(fabs(dir_delta)>PI*.6f){
                  key.sub_param.last_dir_backward = true;
                  want_backward = true;
               }//else
                  //want_backward = false;
            }else{
               if(fabs(dir_delta)<PI*.2f){
                  key.sub_param.last_dir_backward = false;
                  want_backward = false;
               }else{
                  if(speed<0)
                     turn_ratio = -turn_ratio;
                  want_backward = true;
               }
            }

            using_item->cbProc(CB_USE_AUTO, want_backward ? 2 : 1, tc.time);

            using_item->cbProc(CB_USE_AUTO, 4, F2I(turn_ratio));

            if(using_item->IsDestroyed()){
               AI_DEBUG("PRG_DRIVE: destoyed, leaving vehicle");
               del = true;
            }
         }
         break;

      case PRG_WAIT_SUSPENDED:
         break;

      default:
         assert(0);
      }

      if(del){
         turn_angle = 0.0f;

         while(del){
            DelProgram(0);
            --del;
         }
      }
      if(preproc){
         cbProc(CB_PRG_PREPROCESS);
         cbProc(CB_PRG_SHOW);
      }
   }

   if(dest_pose!=-1)
      PlayAnimNet(dest_pose, false);
   FreeAimFade(tc.time, allow_fade);
}

//----------------------------
                              //network_actor: no

dword C_human::Tick(const S_tick_context &tc){

   assert(!network_actor);

   int i;

   if(!model){
      return -1;
   }

   C_collision_context cs(this);

   if(curr_pose!=-1 && frame){
      i = curr_pose;
      S_vector spd = move_dir;

      float tsec = tc.time * .001f;
      S_vector to;

      const S_matrix &m = frame->GetMatrix();
      S_vector dir = spd.RotateByMatrix(m);

      float turn_v;

      S_vector from = m(3);
      to = from;

#ifdef KEEP_HUMAN_OUT_OF_WALL
      S_vector repulsed_delta(0,0,0); //save dir we move back
                              //after anims check
                              //check player every frame he is almost on eyes
      if(GetType()==ACTOR_PLAYER){
         KeepHumanOutOfWall();
         from = model->GetWorldPos();
         repulsed_delta = from - to; //save dir we moved back
         to = from;
      }
#endif

      turn_v = turn_angle;

      if(turn_v && stay_mode==SM_LAY){
         const S_matrix &m = frame->GetMatrix();
         const S_vector &dir_x = m(0);
         const S_vector &dir_z = m(2);
                              //collision checking to avoid turning into walls
         for(i=0; i<2; i++){
            PI3D_frame vol;
            PI3D_frame ref_frm = (!i ? frame : brest);
            for(int j=ref_frm->NumChildren(); j--; ) if((vol=ref_frm->GetChild(j))->GetType()==FRAME_VOLUME) break;
            assert(j!=-1);
            const S_vector &from = vol->GetWorldPos();
            bool right_dir = bool(i) ^ (turn_v>0.0f);
            S_vector dir = right_dir ? dir_x : -dir_x;
            dir += (!i ? -dir_z : dir_z) * .5f;
            dir *= .4f;

            I3D_collision_data cd(from, dir, 0, frame);
            bool b = mission.GetScene()->TestCollision(cd);
            if(b){
               turn_v = 0.0f;
               break;
            }
         }
      }

      float turn_inherit = 0.0f;

      bool upd1 = DoFloorLink(to, turn_inherit);
      if(upd1){
         frame->SetPos(to);
         frame->Update();
      }
                              //countdown small-climb
      small_climb = Max(0, small_climb-tc.time);

      bool do_test_col = false;
      bool is_idle = spd.IsNull();
      if(!is_idle){
         do_test_col=true;
      }else
      if(fall_speed > 0.01f)
         do_test_col = true;
      else
      if((test_col_count-=tc.time) <= 0)
         do_test_col = true;
      else
      if(stay_mode==SM_DEAD)
         do_test_col = true;

      bool upd = false;
      if(do_test_col){
         test_col_count = 500;


#ifdef KEEP_HUMAN_OUT_OF_WALL
                              //after anims check
                              //optimization: enemies checking only when mooving.
                              //it can cause some unprecise test when they moved by LinkToFloor,
                              //but in that case test will be skipped due position change and
                              //because this test is mainly for clipping problems it seems to be ok.
         if(GetType()==ACTOR_ENEMY){
            KeepHumanOutOfWall();
            to = from = model->GetWorldPos();
         }/**/
#endif
                              //return to back to position we started test
#ifdef KEEP_HUMAN_OUT_OF_WALL
         to -= repulsed_delta;
#endif
                              //update all
         to += dir*tsec;
         if(!small_climb)
            to.y -= fall_speed*tsec;

                              //prepare for collision testing
         cs.is_idle = is_idle;
         col_floor = false;

         {
            I3D_collision_data cd;
            cd.from = from;
            cd.dir = to-from;
            cd.frm_root = frame;
            cd.flags = I3DCOL_SPHERE_GROUP;
            cd.frm_ignored = frame;
            cd.cresp_face = ActorColResp_thunk;
            cd.cresp_context = &cs;
            //DebugLine(cd.from, cd.from+cd.dir, 0, 0xff0000ff); 
            if(mission.GetScene()->TestCollision(cd))
               to = cd.GetDestinationPos();
                              //collision values used in tick
            col_floor = cs.col_floor;
         }

         bool is_active_1stview = (IsFirstPersonMode() && IsActive());
         if(cs.num_coll_walls==1 && !dir.IsNull() && !is_active_1stview){
                              //align movement with wall
            float f;
            S_vector2 dir2(dir.x, dir.z), wall(cs.wall_normal.x, cs.wall_normal.z);
            f = dir2.AngleTo(wall);
            bool right = (wall.DistanceToLine(S_vector2(0, 0), dir2) <= 0);
            if(f<(PI*WALL_ALIGN_RATIO))
               turn_v += right ? -WALL_ALIGN_SPEED : WALL_ALIGN_SPEED;
         }
         if(cs.col_mat_id != -1){
            last_mat_id = cs.col_mat_id;
            last_mat_id_count=100;
         }else
         if((last_mat_id_count -= tc.time) <= 0){
            last_mat_id_count = 0;
            last_mat_id = cs.col_mat_id;
         }
         //if(cs.head_in_water)
         //   cbProc(CB_IN_WATER);

         switch(curr_pose){
         case POSE_BARRIER_CLIMB:
         case POSE_CLIMB_UP:
         case POSE_CLIMB_DOWN:
         case POSE_CLIMB_DOWN1:
            {
               turn_v = 0.0f;
                              //detect volume above head
               I3D_collision_data cd(frm_head->GetWorldPos(), S_vector(0, .35f, 0), 0, model);
               bool b  = mission.GetScene()->TestCollision(cd);
               PI3D_frame vol = b ? cd.GetHitFrm() : NULL;
               if(vol){
                  AI_DEBUG(C_fstring("volume %s above head, stopping climb!", (const char*)vol->GetName()));
                  PlayAnim(POSE_STAY_DOWN, true, false);
                  SwitchStayMode(SM_BENCH);
                  test_col_count=0;
               }else
                  fall_speed = 0.0f;
            }
            break;

         case POSE_JUMP_FORWARD:
            if(col_floor){
               fall_speed = 0.0f;
            }else{
               fall_speed += tsec*FALL_ACCEL*.4;
               cs.col_frame = NULL;
            }
            break;

         default:
            if(col_floor){
               if(falling){
                  float fall_dist = fabs(last_on_feet_pos.y-to.y);
                  if(fall_dist>=tab_game_cfg->ItemF(TAB_F_GAME_DIE_FALL_DIST)){
                     cbProc(CB_DIE, -1);
                  }
               }
               fall_speed = INIT_FALL_SPEED;
               last_on_feet_pos = to;
            }else{
               if(!small_climb){
                  fall_speed += tsec*FALL_ACCEL;
                  if(falling){
                     float fall_dist = fabs(last_on_feet_pos.y-to.y);
                     //DEBUG(C_fstring("fall_speed %.2f, fall_distance %.2f", fall_speed, fall_dist));
                     if(fall_dist>50){
                        cbProc(CB_DIE, -1);
                     }else    //stick in two walls - allow break fall if falling too long and actually not mooving
                     if(fall_speed > 100){
                        falling = false;
                        fall_speed = .0f;
                              //die if fall too far
                        if(fall_dist>=tab_game_cfg->ItemF(TAB_F_GAME_DIE_FALL_DIST))
                           cbProc(CB_DIE, -1);
                     }
                  }
               }
               cs.col_frame = NULL;
            }
         }
         if(floor_link != cs.col_frame){
            floor_link = cs.col_frame;
            if(floor_link){
                              //human spheres can't be floor link(human could pull other up or walk with other on shoulder)
               if(floor_link->GetType()==FRAME_VOLUME && I3DCAST_VOLUME(floor_link)->GetCollisionMaterial() == HUMAN_SPHERE_MAT)
                  floor_link = NULL;
               else
                  m_floor = floor_link->GetMatrix();
            }
         }
         upd = true;
      }
      if(upd){
         frame->SetPos(to);
         frame->Update();
      }

#ifdef KEEP_HUMAN_OUT_OF_WALL
      ResetSpheres();
#endif

      if(turn_v) turn_v *= tsec;
      turn_v += turn_inherit;

      if(turn_v){
         S_quat rot;
         rot.Make(S_vector(0.0f, 1.0f, 0.0f), turn_v);
         frame->SetRot(frame->GetRot() * rot);
         upd = true;
#ifdef KEEP_HUMAN_OUT_OF_WALL
                              //after rotation check
                              //optimalization: check only player he is almost on eyes
                              //(it meen enemies can turn into wall, but while it is only brest
                              //and they checking free turn, i think we can skip this test for them)
      if(GetType()==ACTOR_PLAYER){
         frame->Update();
         KeepHumanOutOfWall(); 
         //from = model->GetWorldPos(); //comment out:from no more used in this block
      }
#endif
      }
      if(upd){
         frame->Update();

         cbProc(CB_SET_FRAME_SECTOR);

         if(net){
                              //make turn angle
            if(turn_v){
               const S_vector &dir = frame->GetWorldDir();
               float angle = Angle2D(S_vector2(dir.x, dir.z));
                              //convert angle to value 0-255
               byte angle_8 = Angle_8bit(angle);
               byte delta_8 = abs(net_sync_abs_turn-angle_8);
               int thresh = GetNetDirSendThresh();
               if(delta_8 >= thresh){
                  //net_sync_abs_turn = net_sync_want_turn = angle;
                  net_sync_abs_turn = net_sync_want_turn = angle_8;
                  bool g = false;
                  net_msg->Ascend(net_id);
                  net_msg->AddBits(NM_HUMAN_ABS_TURN, NET_ACTOR_CODE_BITS, g);
                  net_msg->AddBits(angle_8>>(8-NET_HUMAN_ABS_DIR_BITS), NET_HUMAN_ABS_DIR_BITS, g);
                  net_msg->Descend();
               }
            }
                              //make position
            {
               float pos_delta = (net_sync_pos-to).Magnitude();
               if(pos_delta > .04f){
                  net_sync_pos = net_sync_want_pos = to;
                  bool g = false;
                  net_msg->Ascend(net_id);
                  net_msg->AddBits(NM_HUMAN_POS, NET_ACTOR_CODE_BITS, g);
                  net_msg->AddVector(net_sync_pos, g);
                  net_msg->Descend();
               }
            }
         }
      }
   }
//----------------------------

   if(gun)
      gun->Tick(tc.time);
   ShootCountDown(tc.time);

   if(fall_speed > 12.0f){
      falling = true;
      return -2;
   }
   if(falling){
      falling = false;
      //PlayAnim(POSE_LAND, false, false);
      PlayAnimNet(POSE_LAND, true, false, false);
      return -1;
   }

   bool reset_bcc = true;     //barier_climb_count

   do{                        //allow break-out
                              //check if barier climb possible
   if(cs.num_coll_walls>=1 && stay_mode!=SM_LAY){
      bool good_move = false, forward_move = false;
      switch(curr_pose&0x1f){
      case POSE_MOVE_FORWARD:
      case POSE_ACCEL|POSE_MOVE_FORWARD:
         forward_move = true;
                              //flow...
      case POSE_MOVE_BACKWARD:
      case POSE_ACCEL|POSE_MOVE_BACKWARD:
      case POSE_MOVE_LEFT:
      case POSE_ACCEL|POSE_MOVE_LEFT:
      case POSE_MOVE_RIGHT:
      case POSE_ACCEL|POSE_MOVE_RIGHT:
         good_move = true;
         break;
      }
      if(good_move){
                              //check angle against wall
         const S_matrix &m = frame->GetMatrix();
         S_normal mdir = move_dir.RotateByMatrix(m);
         const S_vector &mpos = m(3);
         //const float test_dir = .8f;
         const float test_dir = .9f;
         float f = S_vector2(mdir.x, mdir.z).AngleTo(S_vector2(cs.wall_normal.x, cs.wall_normal.z));
         if(f >= (PI*WALL_ALIGN_RATIO)){
            bool is_active_1stview = (IsFirstPersonMode() && IsActive());
            if(!is_active_1stview)
            if(!FaceToWall(tc.time, mdir, cs.wall_normal))
               break;

            const float &check_height = tab_game_cfg->ItemF(TAB_F_GAME_BARRIER_LOW);
                           //check if we have where to climb
            I3D_collision_data cd(mpos + S_vector(0, check_height, 0), mdir * test_dir, 0, model);

#ifdef DEBUG_DRAW_BARRIER_CLIMB
            DebugLine(cd.from, cd.from+cd.dir, 0, 0xff00ff00); //green - where to climb
#endif
            if(mission.GetScene()->TestCollision(cd)){
                              //barrier climb allowed only for forward move.
                              //don't move it upper becouse we want small climb for all directions.
               if(!forward_move)
                  break;

               PI3D_frame v_wall = cd.GetHitFrm();
                              //climb everywhere except sphere
               if((v_wall->GetType() != FRAME_VOLUME) || (I3DCAST_VOLUME(v_wall)->GetVolumeType()!=I3DVOLUME_SPHERE)){

                              //check if we have what to stay on
                  const float &check_height = tab_game_cfg->ItemF(TAB_F_GAME_BARRIER_HI);
                  //I3D_collision_data cd(mpos + S_vector(0, check_height, 0), mdir * test_dir, 0, model);
                  I3D_collision_data cd(mpos + S_vector(0, check_height, 0), mdir * test_dir *1.78f, 0, model);
#ifdef DEBUG_DRAW_BARRIER_CLIMB
                  DebugLine(cd.from, cd.from+cd.dir, 0, 0xff00ffff); //bluegreen - free way what to stand on
#endif
                  if(!mission.GetScene()->TestCollision(cd)){
                                 //check stay mode
                     if(stay_mode != SM_STAY){
                        bool go_up=stay_mode==SM_BENCH;
                        if(SwitchStayMode(go_up, net_msg, true)){
                           PlayAnimNet(go_up ? POSE_STAY_UP : POSE_STAY_DOWN, true);
                           turn_angle = 0.0f;
                        }
                        break;
                     }
                     S_vector from = mpos;
                     from.y += .8f;
                     from += mdir*.6f;
                     I3D_collision_data cd(from, S_vector(0, 1.6f, 0), 0, model);
#ifdef DEBUG_DRAW_BARRIER_CLIMB
                     DebugLine(cd.from, cd.from+cd.dir, 0, 0xffff00ff); //purple - (maybe is there enough space?)
#endif
                     if(!mission.GetScene()->TestCollision(cd)){
                                 //all conditions ok, finally check count
                        if((barier_climb_count += tc.time) >= tab_game_cfg->ItemI(TAB_F_GAME_BARR_CLIMB_COUNT)){
                           PlayAnimNet(POSE_BARRIER_CLIMB, true, false, false);
                           turn_angle = 0.0f;
                           break;
                        }else
                           reset_bcc = false;   //keep counting
                     }
                  }
               }
            }else{
                              //small obstacle, try to climb it
               if(!cs.head_collide){
                              //letf delta, and right delta for make sure we should can climbing
                  S_normal center_delta = mdir.Cross(axis_y);
                  center_delta *= .2f;
                  I3D_collision_data cd_left(mpos + S_vector(0, check_height, 0), (mdir * test_dir) + center_delta, 0, model);
                  I3D_collision_data cd_right(mpos + S_vector(0, check_height, 0), (mdir * test_dir) - center_delta, 0, model);
#ifdef DEBUG_DRAW_BARRIER_CLIMB
                  DebugLine(cd_left.from, cd_left.from + cd_left.dir, 0, 0xfff90000); //red light
                  DebugLine(cd_right.from, cd_right.from + cd_right.dir, 0, 0xffff0000); //red strong
#endif //DEBUG_DRAW_BARRIER_CLIMB
                  if(!mission.GetScene()->TestCollision(cd_left) && !mission.GetScene()->TestCollision(cd_right)){
                     S_vector pos1 = model->GetPos();
                     pos1.y += (float)tc.time * .001f * 1.4f;
                     I3D_collision_data cd_up(pos1, axis_y * ((stay_mode == SM_BENCH) ? 1.2f : 1.85f), 0, model);
#ifdef DEBUG_DRAW_BARRIER_CLIMB
                     DebugLine(cd_up.from, cd_up.from + cd_up.dir, 1, 0xff0fff0f); //soft green
#endif //DEBUG_DRAW_BARRIER_CLIMB
                     if(!mission.GetScene()->TestCollision(cd_up)){
                        model->SetPos(pos1);
                        model->Update();
                        small_climb = 220;
                     }
                  }
               }
            }
         }
      }
   }
   }while(false);

   if(reset_bcc) barier_climb_count = 0;

   if(using_item && using_item->GetType()==ACTOR_CANNON){
      cbProc(CB_USE_CANNON, 10);
   }
                              //final save of human spheres, after this we expected no more changes of human position(except animation, which actually doesn't change model position, only body)
#ifdef KEEP_HUMAN_OUT_OF_WALL
   frame->Update();
   ResetSpheres();
#endif
   return 0;
}

//----------------------------

enum{
   CT_SG_HUMAN_STAYMODE=0,    //byte
   CT_SG_HUMAN_SHOOT_CNT=1,   //dword
   CT_SG_HUMAN_FALLING=2,     //bool
};

//----------------------------

dword C_human::cbProc(dword msg, dword prm1, dword prm2){

   int i;
   switch(msg){

   case CB_GET_GUN_SOUND:
      return (dword)(PI3D_sound)gun_sound[0];

      /*
   case CB_IS_SEEING:
      {
         LPC_actor subj = (LPC_actor)prm1;
         for(i=watch_actors.size(); i--; ){
            if(watch_actors[i].actor==subj){
               return (watch_actors[i].seen_amount>.2f);
            }
         }
      }
      return false;

   case CB_HAS_WEAPON_IN_HANDS:
      return (bool)selected_inv_item;
      */

   case CB_GET_FOLLOW_FORM:
      {
         LPC_actor m = (LPC_actor)prm1;
         for(i=0; i<program.size(); i++){
            switch(program[i]->prg_item){
            case PRG_FOLLOW:
               if(program[i]->sub_param.follow_form &&
                  program[i]->sub_param.follow_form->master==m)
                  return (dword)program[i]->sub_param.follow_form;
               break;
            }
         }
         return false;
      }
      break;

   case CB_SET_MINE_FIELD_RATIO: mine_field_ratio=prm1; return true;

   case CB_USE_LADDER:
      switch(prm1){
      case 0:
         {
            LPC_actor a = (LPC_actor)prm2;
            if(a){
               bool up = a->cbProc(CB_USE_LADDER, 1);
               int pose = up ? POSE_CLIMB_BREATH : POSE_CLIMB_DOWN1;
               //if(PlayAnim(pose))
               if(PlayAnimNet(pose, false))
               {
                  SetUsingItem(a, true);
                  return true;
               }
            }else{
               SetUsingItem(NULL, true);
               test_col_count = 0;
               last_on_feet_pos = frame->GetWorldPos();
               return true;
            }
         }
         break;
      }
      break;

   case CB_USE_DOOR:
      switch(prm1){
      case 0:
         {
            LPC_actor a=(LPC_actor)prm2;
            if(a){
               //if(PlayAnim(POSE_OPEN_DOOR))
               if(PlayAnimNet(POSE_OPEN_DOOR, false)){
                  SetUsingItem(a);
                  return true;
               }
            }
         }
         break;
      case 3:                 //do we have a key?
         return (C_inventory::ItemIndex(4)!=-1);
      }
      break;

   case CB_USE_RESOURCE:
      switch(prm1){
      case 2:                 //pick resource
         {
            assert(!network_actor);
            LPC_actor res = (LPC_actor)prm2;
            LPC_table r_tab = res->GetTable(0);
            if(!r_tab) break;
            int itm = r_tab->ItemI(TAB_I_RES_INVTYPE);
            int amount = r_tab->ItemI(TAB_I_RES_AMOUNT);
                                 //get the resource
            C_inventory::AddItem(itm, amount);
            AI_DEBUG(C_fstring("Item: %s, amount: %i", tab_inventory->ItemS(TAB_S32_INV_NAME, 32, itm), amount));
            mission.DestroyActor(res);

            if(net)
#ifndef ENEMY_NET_SYNC_INV
            if(GetType()==ACTOR_PLAYER)
#endif
            {                 //3 = add item (bits:12 amount)
               const bool g = true;
               net_msg->Ascend(net_id);
               net_msg->AddBits(NM_HUMAN_INVENTORY, NET_ACTOR_CODE_BITS, g);
               net_msg->AddBits(itm, 6, g);
               net_msg->AddBits(3, 3, g);
               net_msg->AddBits(amount, 12, g);
               net_msg->Descend();
            }
            return true;
         }
         break;
      }
      break;

      /*
   case CB_GET_VOICE_ID:
      return tab->ItemI(TAB_I_HUM_VOICE);
      */

   case CB_SET_FRAME_SECTOR:
      mission.GetScene()->SetFrameSectorPos(frame, (brest ? brest : frame)->GetWorldPos());
      return true;

      /*
   case CB_USE:
   case CB_FORCE_USE_OFF:
      {
         LPC_actor user = (LPC_actor)prm1;
                              //if I'm dead
                              //give him access to my inventory
         if(stay_mode==SM_DEAD){
            if(prm2){
                              //let user begin grab anim - this is only promise, real grabbing begins when he's ready with anim
               user->cbProc(CB_INV_GRAB, 4, (dword)this);
            }else{
                              //stop grabbing
               if(using_item==user){
                  user->cbProc(CB_INV_GRAB, 0, NULL);
                  SetUsingItem(NULL, true);
               }
            }
         }
      }
      return false;
      */

   case CB_USE_AUTO:
      switch(prm1){
      case 0:                 //start/stop use
         {
            LPC_actor car = (LPC_actor)prm2;
            if(car){
                              //get seat type
               int dest_pose = -1;
               int st = car->cbProc(CB_USE_AUTO, 5, (dword)this);
               switch(st){
               case 0:        //sit
                  dest_pose = POSE_DRIVE;
                  break;
               case 1:        //stay
                  dest_pose = POSE_RESET;
                  break;
               case 2:        //bike
                  dest_pose = POSE_BIKE;
                  break;
               case 3:        //bench
                  dest_pose = POSE_RESET + 0x20;
                  break;
               }
               if(dest_pose!=-1)
                  PlayAnim(dest_pose, true);
                              //leave SetUsingItem after PlayAnim - to set entire body anim
               SetUsingItem(car);
               if(dest_pose==POSE_DRIVE){
                  LPC_actor act_driver = (LPC_actor)car->cbProc(CB_USE_AUTO, 10);
                  if(act_driver!=this){
                     model->Tick(1);
                     anim_man.Tick(1, model);
                     PlayAnim(POSE_RESET);
                  }
               }
                              //link to seat
               PI3D_frame seat = (PI3D_frame)using_item->cbProc(CB_USE_AUTO, 6, (dword)this);
               model->LinkTo(seat);
               model->SetPos(S_vector(0, 0, 0));
               model->SetDir(S_vector(0, 0, 1), 0.0f);
               model->Update();
               model->Tick(1);
               anim_man.Tick(1, model);
               ClearAimDir();
               SetVisible(false, true, false);
            }else{
                              //link to real world
               LPS_vector ppos = (LPS_vector)using_item->cbProc(CB_USE_AUTO, 7, (dword)this);
                              //test collision from car to drop place
               S_vector drop_pos = *ppos;
               {
                  assert(frame && using_item);
                  const S_vector &w_pos = frame->GetWorldPos();
                  S_vector human_free_delta = S_normal(*ppos - w_pos) * .5f;
                  human_free_delta.y = .0f;
                  S_normal close_dir = frame->GetWorldDir(); close_dir.y = .0f;
                  close_dir *= .7f;
                  for(int i3 = 0; i3 < 3; i3++)
                  {
                     drop_pos = (i3 == 0) ? (*ppos) : (i3 == 1) ? (*ppos + close_dir) : (*ppos - close_dir);
                     I3D_collision_data cd;
                     cd.from = w_pos;
                     cd.dir = (drop_pos + human_free_delta - w_pos);
                     cd.flags = 0;
                     cd.frm_ignored = using_item->GetFrame();
                     //DebugLine(cd.from, cd.from+cd.dir, 0, 0xff00ff00);
                     bool free_place = !mission.GetScene()->TestCollision(cd);
                     if(free_place)
                        break;
                     if(using_item->IsBoat())
                        return false;
                  }
                  //if((i3 == -1) && !using_item->IsDestroyed())
                  if(i3 == -1){
                     if(using_item->IsDestroyed())
                        drop_pos = *ppos;
                     else
                        return false;
                  }
               }
                              //pick collision down to earth
               I3D_collision_data cd(drop_pos, S_vector(0, -2.0, 0), 0, frame);
               bool b = mission.GetScene()->TestCollision(cd);
                              //no step out into air
               if(!b)
                  return false;
               S_vector dir = model->GetWorldDir();
               dir.y = 0.0f;
               //model->SetPos(b ? cd.GetHitPosition() : drop_pos);
               model->SetPos((cd.GetClosestHit() < 1.0f) ? cd.GetHitPosition() : drop_pos);
               model->SetDir(dir, 0.0f);
               model->LinkTo(NULL);
               model->Update();
               mission.GetScene()->SetFrameSector(model);
               SetUsingItem(NULL, false);
               first_anim = true;
               SetVisible(true, true, false);
               PlayAnim(POSE_RESET, true);
               model->Tick(1);
               anim_man.Tick(1, model);
               floor_link = NULL;
#ifdef KEEP_HUMAN_OUT_OF_WALL
               ResetSpheres();
#endif
            }
         }
         break;
      case 9:                 //translate
         PlayAnim(POSE_DRIVE_TRANS, true);
         break;
      }
      return true;

   case CB_USE_CANNON:
      switch(prm1){
      case 0:                 //start/stop use
         {
            LPC_actor can = (LPC_actor)prm2;
            if(can){
               if(!using_item){
                  SetUsingItem(can);
                  PlayAnim(POSE_GUN_AIM, true, false);
                  return true;
               }
            }else{
               SetUsingItem(NULL, true);
               return true;
            }
            //PlayAnim(POSE_USE_CANNON, true);
         }
         break;
      case 7:                 //turn to cannon dir
         {
            S_vector cdir;
            using_item->cbProc(CB_USE_CANNON, 4, (dword)&cdir);
                              //anti-rotate by brest
            S_matrix bm = brest->GetParent()->GetMatrix();
            bm.Inverse();

            SetAimDir(-cdir.RotateByMatrix(bm), prm2);
            ApplyAimDir();
         }
         break;

      case 10:                //adjust position
         break;
         {
            S_vector use_pos = *(S_vector*)using_item->cbProc(CB_USE_CANNON, 11);
            const S_vector &pos = frame->GetWorldPos();
            float dist = (S_vector2(use_pos.x, use_pos.z) - S_vector2(pos.x, pos.z)).Magnitude();
            if(dist>.1f){
               use_pos.y = pos.y;
               S_vector head_dir;
               using_item->cbProc(CB_USE_CANNON, 4, (dword)&head_dir);
               /*
                              //move to proper position
               cbProc(CB_ADD_PRG, 0, PRG_STEP);
               */
               /*
               int dest_pose = GetBreathPose();
               {
                  static const float ref_angle[]={ PI*.2, PI*.1 };
                  bool step_is_turning=false;
                  TurnedToDir(head_dir, step_is_turning, dest_pose, NULL, ref_angle, false);
                  PlayAnim(dest_pose);
               }
               */
               assert(0);
               /*
               S_goto s_goto;
               s_goto.next_dest_valid = false;
               s_goto.dest = use_pos;
               s_goto.success_min_dist = .15f;
               bool b = cbProc(CB_GOTO, (dword)&s_goto, GOTOFLAGS_SMART);
               */
            }
         }
         break;

      case 12:                //apply shoot error and magnetism to angle
         {
            LPS_vector pos_dir = (LPS_vector)prm2;

            float shoot_quality;

            switch(GetType()){
            case ACTOR_PLAYER:
               {
                  int character_shooting = tab->ItemI(TAB_I_HUM_BAR1_SHOOTING);
                                    //usable range is 60-90 %
                  shoot_quality = character_shooting<=60 ? 0.0f :
                     character_shooting >= 90 ? 1.0f :
                     float(90-character_shooting)/30.0f;
               }
               break;
            case ACTOR_ENEMY:
               shoot_quality = (float)AI_i(TAB_I_AI_SHOOT_QUALITY)/100.0f;
               break;
            default:
               shoot_quality = .5f;
            }

            //const float max_err = tab_game_cfg->ItemF(TAB_F_GAME_SHOOT_ERR_MIN);
            //const float min_err = tab_game_cfg->ItemF(TAB_F_GAME_SHOOT_ERR_MAX);
            //float shoot_err = min_err + (max_err-min_err) * shoot_quality * .5f;
            //ApplyShootErr(pos_dir[1], shoot_err*PI/180.0f);

            const float max_mgnt = tab_game_cfg->ItemF(TAB_F_GAME_SHOOT_MAG_MIN);
            const float min_mgnt = tab_game_cfg->ItemF(TAB_F_GAME_SHOOT_MAG_MAX);
            float magnet_angle = min_mgnt + (max_mgnt-min_mgnt)*(.5f-shoot_quality*.5f);
            ApplyShootMagnet(pos_dir[0], pos_dir[1], magnet_angle*PI/180.0f);
         }
         break;
      }
      return true;

   case CB_INV_GRAB:
      switch(prm1){
      case 1:                 //show/hide inventory
         if(prm2)
            mission.game_menu.SetInventory(this);
         else{
            if(C_inventory::IsVisible())
               mission.game_menu.SetInventory(NULL);
         }
         break;
      case 2:                 //scroll
         {
            C_inventory::Scroll(prm2==1);
            if(net){          //2 = set active
               const bool g = true;
               net_msg->Ascend(net_id);
               net_msg->AddBits(NM_HUMAN_INVENTORY, NET_ACTOR_CODE_BITS, g);
               net_msg->AddBits(C_inventory::GetActiveItem(), 6, g);
               net_msg->AddBits(2, 3, g);
               net_msg->Descend();
            }
         }
         break;

      case 3:                 //grab item
         {
            i = C_inventory::GetActiveItem();
            int itm = C_inventory::GetItem(i);
                              //check if grabbing possible
            E_INV_ITEM id = (E_INV_ITEM)tab_inventory->ItemI(TAB_I_INV_ID, itm);
            switch(id){
            case INV_HANDS: return -1;
            }

            mission.game_menu.SetInventory(NULL);
            if(prm2) *(dword*)prm2 = C_inventory::GetItemAmount(i);

            if(selected_inv_item == i) SetSelectedInvItem(0);
            //else
            //if(selected_inv_item>i) --selected_inv_item;

            if(net) net_msg->Ascend(net_id);
            const bool g = true;
                              //delete item
            C_inventory::DeleteItem(i);
            if(net){          //4 = delete item
               net_msg->AddBits(NM_HUMAN_INVENTORY, NET_ACTOR_CODE_BITS, g);
               net_msg->AddBits(i, 6, g);
               net_msg->AddBits(4, 3, g);
            }

            if(i>=C_inventory::NumItems()){
               C_inventory::SetActiveItem(i-1);
               if(net){          //2 = set active item
                  net_msg->AddBits(NM_HUMAN_INVENTORY, NET_ACTOR_CODE_BITS, g);
                  net_msg->AddBits(i-1, 6, g);
                  net_msg->AddBits(2, 3, g);
               }
            }
            mission.game_menu.SetInventory(this);

            if(net) net_msg->Descend();
            return itm;
         }
         break;

      case 4:                 //start animation
         if(!using_item){
                              //just start grab animation, n_otify key will do the rest
            //PlayAnim(POSE_GRAB_BEGIN);
            PlayAnimNet(POSE_GRAB_BEGIN, false);
         }
         break;

      case 5:                 //comfirm grabbing
         if(!using_item){
            assert(!IsAlive());
            LPC_human a = (LPC_human)prm2;
            if(!net){
               bool b = a->cbProc(CB_INV_GRAB, 0, (dword)this);
               if(b) SetUsingItem(a, true);
               return b;
            }else{
               if(!net_sync_grab->BeginEvent())
                  return false;
               net_sync_grabber = a;
               return 2;
            }
            return false;
         }
         break;
      case 6:                 //get item info
         {
            i = C_inventory::GetActiveItem();
            int itm = C_inventory::GetItem(i);
                              //check if grabbing possible
            E_INV_ITEM id=(E_INV_ITEM)tab_inventory->ItemI(TAB_I_INV_ID, itm);
            switch(id){
            case INV_HANDS: return -1;
            }
            if(prm2) *(dword*)prm2 = C_inventory::GetItemAmount(i);
            return itm;
         }
         break;
      }
      break;

   case CB_WEAPONCHANGE:
      {
         int best_id = FindBestWeapon(prm1);
         if(best_id == -1) return false;

         AddProgram(0, PRG_USE_INV, S_prg_add(best_id));
         cbProc(CB_PRG_PREPROCESS, 1);
         cbProc(CB_PRG_SHOW);
      }
      return true;

   case CB_FIND_WEAPON:
      break;

      /*
   case CB_CHECKCURRWPNSTATUS:
      {
         int ammo=0;
         if(using_item){
            switch(using_item->GetType()){
            case ACTOR_CANNON:
               ammo=using_item->cbProc(CB_USE_CANNON, 6);
               break;
            }
         }else
         if(selected_inv_item){
            ammo = C_inventory::GetItemAmount(selected_inv_item);
         }
         return (ammo!=0);
      }
      */

   case CB_CHEAT:
      switch(prm1){
      case CHEAT_BIGHEAD:
         {
            model->SetScale(.9f);
            model->Update();
            static const char *prt_names[]={
               "Hlva*", "ChdL*", "ChdR*", "RamL*", "RamR*"
            };
            static const float scales[]={
               3.0, 1.5, 1.5, 1.5, 1.5
            };
            for(i=0; i<5; i++){
               float f=scales[i];
               PI3D_frame frm;
               frm = frame->FindChildFrame(prt_names[i], ENUMF_VISUAL | ENUMF_JOINT | ENUMF_USEMASK);
               frm->SetScale(f);
               frm->Update();
            }
         }
         break;
      case 9:                 //allammo
         if(!net)             //don't affect sync
         if(type==ACTOR_PLAYER)  //players only
         {
            static const int items[]={
               14, 100,
               15, 100,
               16, 100,
               17, 100,
               18, 100,
               19, 100,
               20, 100,
               21, 100,
               22, 100,
               23, 100,
               24, 100,
               12, 100,
               25, 100,
               26, 100,
               27, 100,
               29, 1,
               32, 100,
               13, 1,
               11, 1,
               10, 2,
               8, 2,
               9, 2,
               3, 1,
               5, 1,
               6, 1,
               7, 1,
               4, 1,
               1, 1,
               0
            };
            mission.game_menu.SetInventory(NULL);
            for(i=0; items[i]; i += 2){
               int indx = C_inventory::ItemIndex(items[i]);
               if(indx!=-1) C_inventory::SetItemAmount(indx, items[i+1]);
               else C_inventory::AddItem(items[i], items[i+1]);
            }
         }
         break;
      }
      break;

   case CB_SETFOCUS:
      {
         bool on;
         switch(prm1){
         case 0:
            mission.game_cam.SetAimModel(NULL, NULL);
            on = true;
            break;
         case 1:
                                 //find head
            mission.game_cam.SetFocus(frm_head ? frm_head : frame, frame, this);
            mission.game_cam.SetDeltaDir(aim_dir);
            on = mission.game_cam.GetDistanceMode()!=0;
            break;
         default:
            return true;
         }
         if(frame){
            //frame->SetOn(on ? I3D_ON : I3D_ON_CONDITIONAL);
            struct S_hlp{
               static I3DENUMRET I3DAPI cbEnum(PI3D_frame frm, dword c){
                  frm->SetFlags(c ? 0 : I3D_FRMF_NO_FLARE_COLLISION, I3D_FRMF_NO_FLARE_COLLISION);
                  return I3DENUMRET_OK;
               }
            };
            frame->EnumFrames(S_hlp::cbEnum, on, ENUMF_VOLUME);
         }
      }
      return true;

   case CB_IS_FOCUSED:
      return (mission.game_cam.GetFocusDir()==frame);

   case CB_BEFORE_UPDATE:
      if(!our_update && aim_count){
         S_matrix m;
         if(stay_mode==SM_LAY){
            float a = Angle2D(S_vector2(0, 1), S_vector2(aim_dir.x, aim_dir.z));
            m.SetDir(S_vector(0, aim_dir.y, 1), a);
         }else{
            m.SetDir(aim_dir, 0.0f);
         }
         S_quat q(m);
         //q.Make(m);
         if(prm2) q.s = -q.s;
         brest->SetRot(brest->GetRot() * q);
      }
      return 1;

   case CB_ITEM_PICK:
                              //try to set pick anim
      return PlayAnimNet(POSE_ITEM_GET, false);

   case CB_DIE_DROWN:
      Die(POSE_DIE_DROWN);
      break;

   case CB_DIE:               //C_human
      {
         int from_dir = (int)prm1;
         if(from_dir==-1 || stay_mode==SM_LAY) from_dir = 4 + S_int_random(4);
         if(!game_configuration.censored){
                              //check if the direction is free, otherwise choose different
            static byte dir_map[]={    //dirs: 0=l, 1=t, 2=r, 3=b
               2, 3, 0, 1, 1, 1, 1, 3
            };
            int j = dir_map[from_dir];

            const S_vector &dir = frame->GetWorldDir();
            S_vector from = frame->GetWorldPos();
            from.y += 1.0f;
            S_vector2 v2(dir.x, dir.z);
            int best_dir = 0;
            for(i=0; i<4; i++, ++j%=4){
               S_matrix2 m2;
               m2.SetDir(GetPI()*(-j+1)*.5f);
               S_vector2 v2a = v2*m2;
               S_vector dir1(v2a.x*2.0f, 0.0f, v2a.y*2.0f);
               //DebugLine(from, from+dir1, 0, 0xffff00ff);
                              //check col. to the side
               I3D_collision_data cd(from, dir1, 0, frame);
               bool b = mission.GetScene()->TestCollision(cd);
               if(!b){
                  best_dir = i;
                              //check col. down
                  //dbLine(from+dir1, from+dir1+S_vector(0, -2, 0), 255-63*i, 0, 0);
                  I3D_collision_data cd2(from+dir1, S_vector(0, -2, 0), 0, frame);
                  b = mission.GetScene()->TestCollision(cd2);
                  if(b) break;
               }
               //OUTTEXT(b->GetName());
            }
            if(i<4){
               if(i)
                  from_dir = (j+2)%4;
            }else{
               //from_dir = best_dir;
               from_dir = 0;
            }
         }
         Die(POSE_DIE + from_dir);
      }
      break;

   case CB_DIE_BY_KNIFE:
      Die(POSE_DIE_BY_KNIFE);
      break;

   case CB_DIE_THROW_OUT:
      //ThrowToPieces((LPC_actor)prm1); //18.12.comment out
      assert(0 &&"call CB_DIE_THROW_OUT not implemented");
      break;

   case CB_GET_EXPLODE_RATIO:
      {                       //get line collision from explosion center to our center
         if(stay_mode==SM_DEAD)
            return 0;
         static const int test_parts[] = {
            3,                //head
            6,                //palml
            9,                //palmr
            13,               //feetl
            16,               //feetr
         };
         static const float part_inportant[] = {.3f, .15f, .15f, .2f, .2f};
         const S_vector &from = *(const S_vector*)prm2;
         float sum = 0.0f;
         for(i=0; i<5; i++){
            PI3D_frame frm = model->FindChildFrame(body_part_names1[test_parts[i]], ENUMF_ALL | ENUMF_WILDMASK);
            if(frm){
               const S_vector &to = frm->GetWorldPos();
               I3D_collision_data cd(from, to-from,
                  I3DCOL_FORCE2SIDE,
                  frame, FlyColResp);
               bool vol = mission.GetScene()->TestCollision(cd);
#ifdef EDITOR
               if(tab_game_cfg->ItemB(TAB_B_GAME_DEBUG_EXPL_LINES))
                  DebugLine(from, vol ? cd.GetHitPosition() : to, 0, vol ? 0xff00ff00 : 0xffff0000, 5000);
#endif
               if(!vol) sum += part_inportant[i];
            }
         }
                              //affect by stay-mode
         static const float stay_mode_affect[] = {0, 1.0f, .75f, .5f};
         sum *= stay_mode_affect[stay_mode];
         return F2I(sum);
      }
      break;

   case CB_HIT:               //C_human
      if(stay_mode!=SM_DEAD){
         S_CB_hit &sh = *(S_CB_hit*)prm1;
         PI3D_frame frm = sh.sub_frame;
                              //determine which part of body got this
         i = BodyPartIndex(frm->GetOrigName());
         if(i==-1) break;
         return Hit(sh, i, prm2);
      }
      break;

   case CB_SETFACE:
      if(prm1){
                              //find face texture
         if(!frame) break;
         face_id = prm1*2 + prm2;
         ChangeFace(prm1, prm2);
      }
      break;

   case CB_GET_PRG_SIZE:
      return program.size();

   case CB_GET_PRG:
      return program[prm1]->prg_item;

   case CB_SET_PRG_TIME:
      {
         if(prm1>=program.size())
            return false;
         i = program[prm1]->pause_time;
         i += (int)prm2;
         i = Max(0, i);
         program[prm1]->pause_time = i;
         cbProc(CB_PRG_SHOW);
         return true;
      }

   case CB_GET_PRG_DATA:
      {
         if(prm1 >= program.size())
            return false;
         S_command &key = *program[prm1];
         switch(key.prg_item){
         case PRG_MOVE:
            {
               C_movement *mv = key.GetMovement();
               if(mv){
                  vector<S_vector> &path = *(vector<S_vector>*)prm2;
                  mv->DumpPath(path);
               }
            }
            return true;
         }
      }
      return true;

   case CB_SIGNAL:
      {
         if(network_actor)
            break;
         LPS_signal_data sd = (LPS_signal_data)prm1;
         //LPC_actor sender = sd->actor;
         if(program.size()){
            bool del = false;
            switch(program.front()->prg_item){
            case PRG_WAIT_SIGNAL:
            case PRG_WAIT_SUSPENDED:
               {
                  int id = program.front()->sub_param.wait_signal_id;
                  if(id==sd->sub_type){
                                 //ok, process
                     del = true;
                  }
               }
               break;
            }
            if(del){
               AI_DEBUG(C_fstring("Human %s - removing WAIT_SIGNAL", (const char*)frame->GetName()));
                              //unwait & continue in program
               DelProgram(0);
               return true;
            }
         }
      }
      break;

   case CB_GET_USING_ITEM:
      return (dword)using_item;

   case CB_GETINVENTORY:
      return (dword)&C_inventory::GetItems();
   }
   return C_actor::cbProc(msg, prm1, prm2);
}

//----------------------------
//----------------------------

enum E_PLR_MODE{
   PLRMODE_NULL, PLRMODE_ACTIVE, PLRMODE_PROGRAM, PLRMODE_DYING,
   PLRMODE_DEAD, PLRMODE_KILLER_SHOW
};

#define STAY_PLRMODE_DELAY 500

//----------------------------

class C_player: public C_human{
   int menu_id;               //index of his data in menu
   E_PLR_MODE mode;
   bool active;
   int inv_on_count;
   bool throwing;
   bool breath;
   int last_aim_test_time;
   S_vector aim_disp;
   bool no_hit_cheat;         //true if cheat for no hitting is applied
   int init_resistance;       //for health computing
   C_smart_ptr<C_hint_base> name_hint;
   bool aiming_on_player;     //flag set if we're aiming to a player
   float curr_aim_zoom;

                              //network support
   float net_aim_zoom;
   C_smart_ptr<C_net_sync> net_switch_sync;

   virtual void SetNetID(word id){
      
      net_switch_sync = CreateNetSync(id, NM_HUMAN_SWITCH_SYNC, NET_ACTOR_CODE_BITS);
      net_switch_sync->Release();
      C_human::SetNetID(id);
   }

   E_UNIFORM_ID uniform_id;

                              //help editing counters
   int mouse_acc[2];
   int inv_list_count;

   LPC_actor killer;          //after death, use to show killer
   int killer_show_time;

                              //for ammo/time | grenade throwing
   C_smart_ptr<C_icon_info> ii_ammo, ii_grenade_time;

public:
   void CameraZoom(bool in, bool roll=true){

      int dm = mission.game_cam.GetDistanceMode(), oldm=dm;
      if(in){
         if(!dm--) dm = roll ? 2 : 0;
      }else
         if(++dm==3) dm = roll ? 0 : 2;
      if(dm!=oldm){
         bool skip_anim = (using_item && (using_item->GetType()==ACTOR_AUTOMOBIL || using_item->GetType()==ACTOR_AUTO_CANNON));
         //mission.game_cam.SetDistanceMode(dm);
         mission.game_cam.SetDistanceMode(dm, skip_anim);
         cbProc(CB_SETFOCUS, true);
      }
   }

   void CameraView(bool up, bool roll=true){

      int am = mission.game_cam.GetAngleMode();
      if(up){
         if(!am--) am = roll ? 2 : 0;
      }else
         if(++am==3) am = roll ? 0 : 2;
      mission.game_cam.SetAngleMode(am);
   }
private:
/*--------------------------------------------------------
   Perform inventory 'use' - scan inv key, show inv if not shown, while held,
   switch among phases.
      inv - pointer to inventory, used to show it if not yet, if NULL then only toggle
         functionality requested.
   Returns: -1 if no action, action id if action selected.
--------------------------------------------------------*/
#define USE_DROP_COUNT 800
   int UseInventory(C_inventory *inv, /*dword gk, */bool key, int time, int min_i, int num_i){

      if(key){
         if(inv && !inv->IsVisible()){
            mission.game_menu.SetInventory(inv);
            mission.PlaySoundGlobal("inv_show");
            inv_list_count = -1;
         }else{
            if(inv_list_count!=-1){
               int old_i, new_i;
               old_i = (!inv_list_count) ? -1 : ((inv_list_count/USE_DROP_COUNT)%num_i);
               inv_list_count += time;
               new_i = (inv_list_count/USE_DROP_COUNT)%num_i;
               if(old_i!=new_i){
                  mission.PlaySoundGlobal("inv_u_d");
                  mission.spr_use_drop = new C_poly_sprite(.7125f, .225f, .03f, &icons_img, 50+min_i+new_i);
                  mission.spr_use_drop->Release();
               }
            }
         }
         inv_on_count = INVENTORY_COUNT;
      }else{
         if(inv_list_count>0){
                           //use key released, do something
            int ret = min_i + ((inv_list_count/USE_DROP_COUNT)%num_i);
            mission.spr_use_drop = NULL;
            inv_list_count = 0;
            return ret;
         }else
         if(inv_list_count==-1)
            inv_list_count = 0;
      }
      return -1;
   }

//----------------------------

   void ProcessKeysPassive(const S_tick_context &tc){

      if(!tc.p_ctrl)
         return;
      int i;
      if(IsAlive()){
         if(tc.p_ctrl->Get(GKEY_CAM_ZOOM_IN)){
            tc.p_ctrl->IgnoreValue(GKEY_CAM_ZOOM_IN);
            CameraZoom(true);
         }else
         if(tc.p_ctrl->Get(GKEY_CAM_ZOOM_OUT)){
            tc.p_ctrl->IgnoreValue(GKEY_CAM_ZOOM_OUT);
            CameraZoom(false);
         }
      }
      if(tc.p_ctrl->Get(GKEY_CAM_VIEW_UP)){
         tc.p_ctrl->IgnoreValue(GKEY_CAM_VIEW_UP);
         CameraView(true);
      }else
      if(tc.p_ctrl->Get(GKEY_CAM_VIEW_DOWN)){
         tc.p_ctrl->IgnoreValue(GKEY_CAM_VIEW_DOWN);
         CameraView(false);
      }else
      if((i=GKEY_PLR_SWITCH,tc.p_ctrl->Get(i)) || (i=GKEY_PLR_SWITCH_1,tc.p_ctrl->Get(i)) ||
         (i=GKEY_PLR_SWITCH_2,tc.p_ctrl->Get(i)) || (i=GKEY_PLR_SWITCH_3,tc.p_ctrl->Get(i)) ||
         (i=GKEY_PLR_SWITCH_4,tc.p_ctrl->Get(i))){
         tc.p_ctrl->IgnoreValue(i);
         mission.PlayerSwitch(igraph->GetShiftKeys()&SKEY_SHIFT,
            (i==GKEY_PLR_SWITCH) ? -1 : i-GKEY_PLR_SWITCH_1);
      }
   }

//----------------------------

   void SetResistance(int r){
      resistance = r;
      mission.game_menu.SetHealth(menu_id, (float)resistance/(float)init_resistance);
   }

/*--------------------------------------------------------
   Controll cannon on used item - communicate through CB_USE_CANNON messages.
   The using_item may be any actor responding to these messages.
--------------------------------------------------------*/

   void ControllCannon(const S_tick_context &tc, bool allow_keys, int time, int rx, int ry){

      float move_x(0.0), move_y(0.0);
      if(allow_keys && tc.p_ctrl){
         if(I2F(tc.p_ctrl->Get(GKEY_LEFT)) > .4f)
            move_x -= PI*.5f;
         if(I2F(tc.p_ctrl->Get(GKEY_RIGHT)) > .4f)
            move_x += PI*.5f;
         if(tc.p_ctrl->Get(GKEY_FORWARD))
            move_y += PI*.5f;
         if(tc.p_ctrl->Get(GKEY_BACKWARD))
            move_y -= PI*.5f;
      }
      if(rx) move_x += (float)rx*PI/50.0f;
      if(ry) move_y += (float)-ry*PI/50.0f;
      float f[3]={move_y, move_x, (float)time*.001f};
      if(move_x || move_y)
         using_item->cbProc(CB_USE_CANNON, 1, (dword)f);

      if(tc.p_ctrl){
         if(tc.p_ctrl->Get(GKEY_FIRE)){
            using_item->cbProc(CB_USE_CANNON, 3, (dword)this);
            using_item->cbProc(CB_USE_CANNON, 8);
            cbProc(CB_SHOW_AMMO);
         }
         if(tc.p_ctrl->Get(GKEY_USE)){
            tc.p_ctrl->IgnoreValue(GKEY_USE);
            bool b = using_item->Use(this, 0);
            if(b) cbProc(CB_SHOW_AMMO);
         }
      }
   }

   void GrenadeStopThrow(){
      if(ii_grenade_time){
         throwing = false;
         mission.DelIconInfo(ii_grenade_time);
         ii_grenade_time = NULL;
      }
   }

//----------------------------

   bool CheckAimVolume(PI3D_frame frm, dword &color){

      LPC_actor act = NULL;
                              //check what's hit
      switch(frm->GetType()){
      case FRAME_VOLUME:
         act = (LPC_actor)frm->GetData();
         break;
      case FRAME_VISUAL:
      case FRAME_JOINT:
                              //find parent model
         while(frm=frm->GetParent()){
            if(frm->GetType()==FRAME_MODEL){
               act = (LPC_actor)frm->GetData();
               break;
            }
         }
         break;
      default:
         assert(0);
      }
      if(act){
         if(act->GetType()==ACTOR_PLAYER){
                              //set red arrow
            color = 0xffff0000;
            if(!aiming_on_player){
               aiming_on_player = true;
                              //draw actor's name
               act->cbProc(CB_SHOW_PLAYER_NAME);
            }
            return true;
         }
      }
      color = -1;
      aiming_on_player = false;
      return false;
   }

//----------------------------

   static bool I3DAPI FlyColRespAim(I3D_collision_data &cd){

      int mat_id = -1;
      assert(cd.GetHitFrm());
      switch(cd.GetHitFrm()->GetType()){
      case FRAME_VOLUME:
         mat_id = I3DCAST_VOLUME(cd.GetHitFrm())->GetCollisionMaterial();
         break;
      case FRAME_VISUAL:
         mat_id = I3DCAST_VISUAL(cd.GetHitFrm())->GetCollisionMaterial();
         break;
      case FRAME_JOINT:
         break;
      default: 
         assert(0);
      }
      if(mat_id!=-1){
         if(mat_table->ItemB(TAB_B_MAT_BORDER, mat_id) ||
            mat_table->ItemB(TAB_B_MAT_WATER, mat_id) ||
            mat_table->ItemB(TAB_B_MAT_AI_SEE_THROUGH, mat_id) ||
            mat_id==HUMAN_SPHERE_MAT)
            return false;
      }
      return true;
   }

//----------------------------

   void DrawAimLine(){

      if(active){

         int curr_time = igraph->ReadTimer();

         bool line_mode = (mission.game_cam.GetDistanceMode()!=0);
         bool cannon_mode = false;
         if(using_item)
         switch(using_item->GetType()){
         case ACTOR_AUTO_CANNON:
            if(!using_item->cbProc(CB_USE_AUTO, 11, (dword)this))
               break;
                           //flow...
         case ACTOR_CANNON:
            line_mode = true; 
            cannon_mode = true;
            break;
         }

         if(line_mode){
            if(!game_configuration.draw_aim_line)
               return;

            S_vector from, from1, v;
            bool grenade = false;
            if(!cannon_mode){
               assert(gun);
               int itm_indx = C_inventory::GetItem(selected_inv_item);
               E_INV_ITEM itm = (E_INV_ITEM)tab_inventory->ItemI(TAB_I_INV_ID, C_inventory::GetItem(selected_inv_item));
               switch(itm){
               case INV_GRENADE:
                  from = from1 = frm_head->GetWorldPos();
                  //v = -frm_head->GetWorldDir() * (throw_power * .03f);
                  v = -frm_head->GetWorldDir() * (throw_power * .01f);
                  grenade = true;
                  break;
               default:
                  {
                     const S_matrix &gmat = gun->GetMatrix();
                     from = gmat(3);
                     v = -gmat(2);
                     from += v * tab_inventory->ItemF(TAB_F_INV_WPN_SHOT_Z, itm_indx);
                     from += gmat(1) * .06f;
                     from1 = gmat(3) - v*.4f;
                  }
               }
            }else{
                              //must be cannon
               using_item->cbProc(CB_USE_CANNON, 5, (dword)&from);
               using_item->cbProc(CB_USE_CANNON, 4, (dword)&v);
               from1 = from;
            }

            static float last_col_dist;

            static dword color = -1; //white
            if(abs(curr_time-last_aim_test_time) > 50){
               last_aim_test_time = curr_time;
                                 //perform collision test now
               if(!grenade)
                  v *= 100.0f;
               PI3D_frame vol = NULL;
               I3D_collision_data cd(from1, v, I3DCOL_TEXTURE | I3DCOL_JOINT_VOLUMES, model, FlyColRespAim);
               if(mission.GetScene()->TestCollision(cd)){
                  v = cd.GetHitPosition();
                  vol = cd.GetHitFrm();
               }
               if(!vol){
                  if(grenade)
                     last_col_dist = v.Magnitude();
                  else
                     last_col_dist = 100.0f;
                  v += from1;
                  color = -1;
                  aiming_on_player = false;
               }else{
                  last_col_dist = (from1-v).Magnitude();
                              //determine who's there
                  CheckAimVolume(vol, color);
               }
            }else{
                                 //use previously cached distance
               if(grenade) v.Normalize();
               v *= last_col_dist;
               v += from1;
            }
            mission.DisplayAimLine(from, v);

            mission.DisplayCross(color, false);
         }else
         if(game_configuration.aim_mode==1 || game_configuration.aim_mode==2){

                              //check who we're aiming at
            static dword color = -1;
            if(abs(curr_time-last_aim_test_time) > 200){
               last_aim_test_time = curr_time;
               const S_vector &from = mission.game_cam.GetCamera()->GetWorldPos();
               S_vector dir = mission.game_cam.GetCamera()->GetWorldDir() * 100.0f;
               I3D_collision_data cd(from, dir, I3DCOL_TEXTURE | I3DCOL_JOINT_VOLUMES, model, FlyColRespAim);
               bool b = mission.GetScene()->TestCollision(cd);
               PI3D_frame vol = b ? cd.GetHitFrm() : NULL;
               if(vol){
                  CheckAimVolume(vol, color);
               }else{
                  color = -1;
                  aiming_on_player = false;
               }
            }
            mission.DisplayCross(color, true);
         }
      }
   }
public:
   C_player(C_game_mission&);
   ~C_player();

   virtual dword cbProc(dword msg, dword prm1=0, dword prm2=0);
   dword Tick(const S_tick_context&);
   E_PLR_MODE GetMode() const{ return mode; }

   virtual void NetIn(PC_net_in_msg in_msg);

//----------------------------
// Get name of player - this is either name of network player, or game character.
   C_string GetPlayerName(bool &wide, dword &color){

      char buf[256];
      wide = false;
      if(net && mode==PLRMODE_ACTIVE){
         dword pid = network_actor ? network_actor : net->GetPID();
         net->GetPlayerName(pid, buf, sizeof(buf));
         color = 0xffff0000;
         return buf;
      }
      color = 0xffc0c0c0;
      int i = tab->ItemI(TAB_I_HUM_FACE);
      if(!i)
         return "unknown";
      i = GT_GAME_MENU_SOLDIER_NAME+i-1;
      wide = all_txt.IsWide(i);
      return all_txt[i];
   }

//----------------------------
                              //network_actor: true

   virtual void C_player::Die(int die_pose, bool net_send = true){

      if(net && IsAlive()){
         bool wide;
         dword color;
         C_string name = GetPlayerName(wide, color);
         C_string msg;
         if(!all_txt.IsWide(20402)){
            assert(!wide);
            msg = all_txt[20402] + name;
         }else{
            if(!wide)
               name = MakeGameText(name);
            msg = AddGameText(all_txt[20402], name);
            wide = true;
         }
         console_main.OutText(msg, color, wide);
      }
                              //camera out of head
      if(active){
         int dm = mission.game_cam.GetDistanceMode();
         if(!dm){
            mission.game_cam.SetDistanceMode(1);
            cbProc(CB_SETFOCUS, true);
         }
         if(inv_list_count)
            mission.spr_use_drop = NULL;
         PI3D_volume v_cam = mission.GetCamVolume();
         if(v_cam && v_cam->GetOwner()==model){
            v_cam->LinkTo(NULL);
            v_cam->SetOwner(NULL);
            vol_cam = NULL;
         }
      }
      mode = PLRMODE_DYING;

      GrenadeStopThrow();
                              //play music
      {
         static int rnd_mus_i;
         mission.PlaySoundGlobal(C_fstring("clips\\jnm00%i", 1 + (rnd_mus_i%6)));
         ++rnd_mus_i;
      }
      mission.game_menu.SetHealth(menu_id, 0.0f);

      C_human::Die(die_pose, net_send);

      {
         if(C_inventory::IsVisible())
            mission.game_menu.SetInventory(NULL);
         ClrProgram(false);
         mission.game_menu.SetDeathFace(menu_id);
         cbProc(CB_PRG_SHOW);
      }
   }

//----------------------------

   virtual bool Hit(S_CB_hit &sh, int body_part_indx, int hit_power, int net_new_resist = 0, bool net_send = true){

      if(mission.game_cam.GetFocusDir()==frame && !mission.game_cam.GetDistanceMode()){
         byte a = Min(0x80, hit_power*10);
         mission.CreateScreenEffect((a<<24) | 0xff0000, 100, 0, 500);
      }

      throw_power = 0;
      bool b = C_human::Hit(sh, body_part_indx, hit_power, net_new_resist, net_send);
      if(b){
         killer = sh.shooter;
                              //send killer
         if(net && net_send && killer){
            bool g = true;
            net_msg->Ascend(net_id);
            net_msg->AddBits(NM_HUMAN_KILLER, NET_ACTOR_CODE_BITS, g);
            net_msg->AddWord(killer->GetNetID(), g);
            net_msg->Descend();
         }
      }else
         SetResistance(resistance);

      holding_fire = false;
      GrenadeStopThrow();
      return b;
   }

//----------------------------

   bool RequestActivity(const S_tick_context &tc){

      if(!tc.p_ctrl)
         return false;

      bool ret = false;

      static const byte irq_tab[] = {
         GKEY_LEFT, GKEY_FORWARD, GKEY_RIGHT, GKEY_BACKWARD,
         GKEY_FIRE, /*GKEY_FIRE1, */GKEY_MOVE_LEFT, GKEY_JUMP,
         GKEY_MOVE_RIGHT, GKEY_UP, GKEY_DOWN, GKEY_ITEM_USE,
         GKEY_UP, GKEY_DOWN, GKEY_INV_SCROLL_LEFT, GKEY_INV_SCROLL_RIGHT,
         GKEY_CAM_ZOOM_IN, GKEY_CAM_ZOOM_OUT, GKEY_CAM_VIEW_UP, GKEY_CAM_VIEW_DOWN,
         GKEY_CENTER, GKEY_RELOAD, GKEY_CMD_FOLLOW, GKEY_CMD_STOP,
         GKEY_CMD_MOVE, GKEY_CMD_HEY, GKEY_CMD_HOLD_FIRE, GKEY_CMD_PRG_CLR,
         GKEY_USE, GKEY_ESCAPE
      };

      for(int i=0; i<sizeof(irq_tab); i++){
         dword val = tc.p_ctrl->Get(irq_tab[i]);
         if(val){
                              //if float controller, it must be significand
            C_controller::E_VALUE_MODE vm;
            C_controller::E_INPUT_DEVICE id;
            dword data;
            tc.p_ctrl->GetSlotSetting(irq_tab[i], 0, vm, id, data);
            if(vm==C_controller::VM_FLOAT){
               if(fabs(I2F(val)) < .4f)
                  continue;
            }
            ret = true;
            break;
         }
      }
      if(ret && active){
         if(network_actor && mode!=PLRMODE_ACTIVE){
            NET_DEBUG("C_player::RequestActivity: putting to sync mode");
            net_switch_sync->BeginEvent();
         }
      }
      return ret;
   }

//----------------------------

   virtual bool AddProgram(int pos, E_PRG_ITEM itm, const S_prg_add &pa, bool net_send = true){

      bool b = C_human::AddProgram(pos, itm, pa, net_send);
      if(b){
         mode = PLRMODE_PROGRAM;
         prg_dirty = true;
      }
      return b;
   }

//----------------------------

   virtual bool DelProgram(int pos, bool net_send = true){

      bool b = C_human::DelProgram(pos, net_send);
      if(b){
         cbProc(CB_PRG_SHOW);
         prg_dirty = true;
      }
      return b;
   }

//----------------------------

   virtual void VoiceCommand(LPC_actor caller, int cmd_type, bool net_send = true){
                              //active may refuse
      if(active)
         return;
      if(network_actor && (mode!=PLRMODE_PROGRAM))
         return;
      C_human::VoiceCommand(caller, cmd_type, net_send);
   }

//----------------------------

                              //network support for C_player
   virtual void NetCodeIn(byte msg_code, PC_net_in_msg in_msg){

      switch(msg_code){

      case NM_HUMAN_KILLER:
         killer = mission.NetFindActor(in_msg->GetWord());
         break;

      case NM_HUMAN_SWITCH_SYNC:
         net_switch_sync->NetIn(in_msg, false);
         break;

      case NM_HUMAN_PLR_SET_ACTIVE:
         {
            bool st = in_msg->GetBits(1);
            switch(mode){
            case PLRMODE_ACTIVE:
            case PLRMODE_PROGRAM:
               if(st){
                  if(network_actor){
                     mode = PLRMODE_ACTIVE;
                     cbProc(CB_SHOW_PLAYER_NAME, true);
                  }
               }else{
                  mode = PLRMODE_PROGRAM;
                  cbProc(CB_SHOW_PLAYER_NAME, true);
               }
               break;
            }
         }
         break;

      case NM_HUMAN_ZOOM:
         {
            curr_aim_zoom = in_msg->GetFloat();
            net_aim_zoom = curr_aim_zoom;
            if(active && !mission.game_cam.GetDistanceMode())
               mission.game_cam.SetZoom(curr_aim_zoom);
         }
         break;

      default:
         C_human::NetCodeIn(msg_code, in_msg);
      }
   }

//----------------------------

   virtual void NetPlrDisconnect(dword pid){

                              //if this was net-controlled guy, make it host-controlled
      bool was_net_actor = (network_actor);
      if(was_net_actor)
         mode = PLRMODE_PROGRAM;
      net_switch_sync->OnPlayerDisconnect(pid);
      C_human::NetPlrDisconnect(pid);
      if(was_net_actor)
         network_actor = net->IsHost() ? 0 : net->GetHostPID();
   }

//----------------------------

   virtual bool AnimNotify(PI3D_frame frm, dword notify_id, dword stage){
                              //accept notify only from animations from main stage (others fading out - invalid)
      //if(stage != MAIN_ANIM_STAGE)
      if(stage != anim_man.main_stage)
         return false;

      switch(notify_id){
      case NOTIFY_GET:             //get item (resource)
         if(C_inventory::IsVisible())
            mission.game_menu.SetInventory(NULL);
         if(C_human::AnimNotify(frm, notify_id, stage)){
            mission.game_menu.SetInventory(this);
            inv_on_count = INVENTORY_COUNT;
            return true;
         }
         return false;
      }
      return C_human::AnimNotify(frm, notify_id, stage);
   }

//----------------------------

   virtual bool ObstacleMove(const S_obstacle_move &om){

                              //only programmed guys can move
      if(mode!=PLRMODE_PROGRAM)
         return false;
      if(network_actor)
         return false;
      return C_human::ObstacleMove(om);
   }

//----------------------------

   virtual E_RELATION GetRelation(C_actor *caller) const{

      if(stay_mode==SM_DEAD)
         return RELATION_NEUTRAL;
      switch(caller->GetType()){
      case ACTOR_ENEMY:
         int i = caller->GetTable(0)->ItemI(TAB_I_ENM_GROUP);
         return (i==-1) ? RELATION_NEUTRAL : RELATION_ENEMY;
      }
      return RELATION_FRIEND;
   }

//----------------------------

   virtual bool IsEnemy(C_actor *asker){

      switch(asker->GetType()){
      case ACTOR_PLAYER:
         return false;
      case ACTOR_ENEMY:
         {
            int his_group = asker->GetTable(0)->ItemI(TAB_I_ENM_GROUP);
                              //our enemy is german only
            return (his_group==0);
         }
         break;
      default:
         return false;
      }
   }

//----------------------------

   virtual int GetMenuID() const{ return menu_id; }

//----------------------------

   virtual void SetActive(bool b, bool write_activate_msg = false){

      if(active==b)
         return;
      cbProc(CB_SETFOCUS, b);
      if(b){
         if(stay_mode==SM_DEAD)
            return;
         SetCamHeadVolume(true);
         active = true;
         if(!network_actor){
            if(net && net_id){
               const bool g = true;
               net_msg->Ascend(net_id);
               net_msg->AddBits(NM_HUMAN_PLR_SET_ACTIVE, NET_ACTOR_CODE_BITS, g);
               net_msg->AddBits(true, 1, g);
               net_msg->Descend();
            }
            if(program.size())
               mode = PLRMODE_PROGRAM;
            else
               mode = PLRMODE_ACTIVE;
         }
         mission.game_cam.SetDeltaDir(aim_dir);
         mission.game_menu.SetActive(menu_id);
      }else{
         SetCamHeadVolume(false);
         if(!network_actor){
            if(net && net_id){
                              //tell to all that we lost activity
               const bool g = true;
               net_msg->Ascend(net_id);
               net_msg->AddBits(NM_HUMAN_PLR_SET_ACTIVE, NET_ACTOR_CODE_BITS, g);
               net_msg->AddBits(false, 1, g);
               net_msg->Descend();
            }
            if(IsAlive())
               mode = PLRMODE_PROGRAM;
         }
         active = false;
         turn_angle = 0.0f;
         GrenadeStopThrow();

         if(inv_list_count)
            mission.spr_use_drop = NULL;
      }
      cbProc(CB_SHOW_AMMO);
      if(C_inventory::IsVisible())
         mission.game_menu.SetInventory(NULL);

      if(write_activate_msg)
         cbProc(CB_SHOW_PLAYER_NAME, true, 5000);
   }

//----------------------------

   virtual bool IsActive() const{ return active; }

//----------------------------

   virtual void TableUpdate(int index, bool not_load_prg){

                           //reset face
      cbProc(CB_SETFACE, tab->ItemI(TAB_I_HUM_FACE), tab->ItemB(TAB_B_HUM_FACEMASK));
      if(!not_load_prg)
         LoadProgram();
      float endurance = (tab->ItemI(TAB_I_HUM_BAR5_ENDURANCE)-30)/70.0f;
      resistance = Max(1, 200 + (int)(endurance*1400.0f));
      init_resistance = resistance;
      C_human::TableUpdate(index, not_load_prg);
   }

//----------------------------

   virtual void SaveGame(C_chunk *ck) const{

                              //let human save first
      C_human::SaveGame(ck);

                              //write data
      ck->Write(&mode, sizeof(mode));
      ck->Write(&throwing, sizeof(throwing));
      ck->Write(&breath, sizeof(breath));
      ck->Write(&aim_disp, sizeof(aim_disp));
      ck->Write(&uniform_id, sizeof(uniform_id));
      ck->Write(&killer_show_time, sizeof(killer_show_time));

      ck->Write(&active, sizeof(active));
                           //write table (character, face)
      ck->Write(&tab->ItemI(TAB_I_HUM_FACE), sizeof(int));
      ck->Write(&tab->ItemB(TAB_B_HUM_FACEMASK), sizeof(bool));
      for(int i=0; i<5; i++)
         ck->Write(&tab->ItemI(TAB_I_HUM_BAR1_SHOOTING+i), sizeof(int));
      ck->Write(&curr_aim_zoom, sizeof(curr_aim_zoom));
   }

//----------------------------

   virtual bool LoadGame(C_chunk *ck){

      active = false;
                              //let human load first
      if(!C_human::LoadGame(ck))
         return false;

                              //read data
      ck->Read(&mode, sizeof(mode));
      ck->Read(&throwing, sizeof(throwing));
      ck->Read(&breath, sizeof(breath));
      ck->Read(&aim_disp, sizeof(aim_disp));
      ck->Read(&uniform_id, sizeof(uniform_id));
      ck->Read(&killer_show_time, sizeof(killer_show_time));

      ck->Read(&active, sizeof(active));
      if(active){
         mission.game_menu.SetActive(menu_id);
         SetCamHeadVolume(true);
      }
                              //read table (character, face)
      ck->Read(&tab->ItemI(TAB_I_HUM_FACE), sizeof(int));
      ck->Read(&tab->ItemB(TAB_B_HUM_FACEMASK), sizeof(bool));
      cbProc(CB_SETFACE, tab->ItemI(TAB_I_HUM_FACE), tab->ItemB(TAB_B_HUM_FACEMASK));
      for(int i=0; i<5; i++)
         ck->Read(&tab->ItemI(TAB_I_HUM_BAR1_SHOOTING+i), sizeof(int));
      ck->Read(&curr_aim_zoom, sizeof(curr_aim_zoom));
      net_aim_zoom = curr_aim_zoom;
                              //compute init resistance
      {
         float endurance = (tab->ItemI(TAB_I_HUM_BAR5_ENDURANCE)-30)/70.0f;
         init_resistance = Max(1, 200 + (int)(endurance*1400.0f));

         switch(game_profile.difficulty){
         case S_game_profile::DIF_EASY:
                              //easy - increase resistance
            init_resistance *= 2.0f;
            break;
         case S_game_profile::DIF_HARD:
                              //hard - decrease resistance
            init_resistance *= .75f;
            break;
         }
      }

      /*
      if(using_item)
      switch(using_item->GetType()){
      case ACTOR_PLAYER:
      case ACTOR_ENEMY:
         if(active)
            using_item->cbProc(CB_INV_GRAB, 1, true);
         break;
      }
      */

      switch(mode){
      case PLRMODE_DYING:
      case PLRMODE_DEAD:
         mission.game_menu.SetDeathFace(menu_id);
         cbProc(CB_PRG_SHOW);
         break;
      }
      SetResistance(resistance);
      if(active){
         cbProc(CB_SHOW_AMMO);
         cbProc(CB_SETFOCUS, 1);
      }
      cbProc(CB_PRG_SHOW, false, 1);
      return true;
   }

//----------------------------

   virtual bool Explode(C_actor *caller, int power){

      throw_power = 0;
      bool b = C_human::Explode(caller, power);
      if(b){
         caller->cbProc(CB_SETPARAM, 2, (dword)&killer);
      }else
         SetResistance(resistance);
      return b;
   }

//----------------------------
// Setup volume around head. Used for active player to improve camera clipping.
   void SetCamHeadVolume(bool on_off){

      if(on_off){
         PI3D_volume v_cam = mission.GetCamVolume();
         if(v_cam && frm_head){
            v_cam->LinkTo(frm_head);
            v_cam->SetOwner(model);
                              //set camera volume on_off like oher volume of player.
            PI3D_frame fvol = frame->FindChildFrame("~020v1*");
            PI3D_volume v_up = (fvol && fvol->GetType()==FRAME_VOLUME) ? I3DCAST_VOLUME(fvol) : NULL;
            bool is_volumes_on = (v_up && v_up->IsOn());
            v_cam->SetOn(is_volumes_on);
            v_cam->Update();
            vol_cam = v_cam;
         }
      }else{
         vol_cam = NULL;
      }

   }

//----------------------------

   virtual void SetFrame(PI3D_frame frm){

      C_human::SetFrame(frm);
      if(active && frame){
         cbProc(CB_SETFOCUS, true);
         SetCamHeadVolume(true);
      }else{
         SetCamHeadVolume(false);
      }

   }

//----------------------------
// Get 2D position where to display name hint text.
   bool GetNameHintPos(S_vectorw &pos) const{

      S_vector v = frm_head ? frm_head->GetWorldPos() : frame->GetWorldPos();
      v.y += .3f;
      mission.GetScene()->TransformPoints(&v, &pos, 1);
      return (pos.z >= 0.0f);
   }

//----------------------------

   virtual void SetAimDir(const S_vector &dir, int time, bool net_send = true){

      C_human::SetAimDir(dir, time, false);

      if(net_send){
         aim_count = AIM_COUNT;
                              //network support
         if(net){
                              //check if it differs by some value
            float delta = net_sync_aim_dir.AngleTo(aim_dir);
            float thresh = PI*.05f;
            if(active && !mission.game_cam.GetDistanceMode()){
               thresh *= (curr_aim_zoom * (.5f + .5f*curr_aim_zoom));
            }
            if(delta > thresh){
               net_sync_aim_dir = net_sync_aim_want = aim_dir;
               bool g = false;
               net_msg->Ascend(net_id);
               net_msg->AddBits(NM_HUMAN_AIM_DIR, NET_ACTOR_CODE_BITS, g);
               net_msg->AddBits(0, 1, g);
               net_msg->AddVector(aim_dir, g);
               net_msg->Descend();
            }
         }
      }
   }

//----------------------------

   virtual int GetNetDirSendThresh() const{

      if(active && !mission.game_cam.GetDistanceMode()){
         int t = 3.0f * curr_aim_zoom;
         return Max(1, t);
      }
      return 4;
   }

//----------------------------

};//C_player

typedef C_player *LPC_player;

//----------------------------
#include <functional>

template<class T, class T1>
struct deref_equal_to: public binary_function<T, T1, bool>
{
   bool operator()(const T &x, const T1 &y) const{
      return (*x) == y;
   }
};

bool operator == (const C_actor &act, E_ACTOR_TYPE type){
   return act.GetType()==type;
}

C_player::C_player(C_game_mission &m):
   C_human(m, ACTOR_PLAYER),
   //net_switch_sync(0, NM_HUMAN_SWITCH_SYNC, NET_ACTOR_CODE_BITS),
   mode(PLRMODE_PROGRAM),
   menu_id(-1),
   throwing(false),
   last_aim_test_time(0),
   active(false),
   breath(false),
   inv_list_count(0),
   uniform_id(UID_NULL),
   no_hit_cheat(false),
   aiming_on_player(false),
   curr_aim_zoom(1.0f),
   net_aim_zoom(1.0f),
   killer(NULL)
{
   memset(mouse_acc, 0, sizeof(mouse_acc));

   menu_id = mission.game_menu.AddPlayerMenu(1);
   cbProc(CB_PRG_SHOW);

                              //all players are priamrily networks on non-host machine
   if(net) network_actor = net->IsHost() ? 0 : net->GetHostPID();

#ifdef EDITOR
//#if 1
   if(!net){
                              //debug - is 1st created player, grab activity
   if(find_if(mission.GetActors().begin(), mission.GetActors().end(),
      bind2nd(deref_equal_to<LPC_actor, E_ACTOR_TYPE>(), ACTOR_PLAYER)) ==
      mission.GetActors().end()){
                              //1st player, keep atention
      SetActive(true);
   }
   }
#endif
}

C_player::~C_player(){

   if(menu_id!=-1){
      mission.game_menu.DestroyPlayerMenu(menu_id);
      menu_id = -1;
   }
   ClrProgram(false);
   if(ii_ammo)
      mission.DelIconInfo(ii_ammo);
   if(ii_grenade_time)
      mission.DelIconInfo(ii_grenade_time);
   if(active)
      cbProc(CB_SETFOCUS, 0);
}

//----------------------------
                              //player SAVEGAME chunks
enum{
   CT_PLR_PROGRAM=0,          //
      //E_PRG_ITEM
      //int time
      CT_PLR_PRG_DATA,
};


//----------------------------

dword C_player::cbProc(dword msg, dword prm1, dword prm2){

   int i;
   switch(msg){

   case CB_IS_NET_PLAYER:
      return (bool)network_actor;

   case CB_SHOW_PLAYER_NAME:
      {
         bool force = prm1;
         if(name_hint){
            if(!force)
               return false;
            name_hint = NULL;
         }
         bool wide;
         dword color;
         C_string name = GetPlayerName(wide, color);
                              //map head to screen
         S_vectorw scr;
         bool on = GetNameHintPos(scr);

         float sx = igraph->Scrn_sx();
         float x = scr.x / sx, y = scr.y / sx;
         int time = prm2 ? prm2 : 2000;
         name_hint = CreateHint(name, wide, &mission.texts, x, y, .0225f, color, false, time, TEXT_JUSTIFY_CENTER);
         name_hint->SetOn(on);
         name_hint->Release();
      }
      break;

   case CB_SET_NETWORK_ACTOR:
      mode = PLRMODE_ACTIVE;
      break;

   case CB_GET_UNIFORM_ID:
      if(uniform_id==UID_NULL && model){
         const char *cp = model->GetFileName();
         i = strlen(cp);
         while(i && cp[i-1]!='\\') --i;
         switch(tolower(cp[i])){
         case 's': uniform_id = UID_SAS; break;
         case 'g': uniform_id = UID_GERMAN; break;
         default: uniform_id = UID_CIVIL;
         }
      }
      return uniform_id;

   case CB_SET_UNIFORM_ID:
      uniform_id = UID_NULL;
      break;

   case CB_GET_AIM_DISP:
      return (active && mission.game_cam.GetDistanceMode()==0) ? (dword)&aim_disp : NULL;

   case CB_SET_FRAME_SECTOR:
      {
         PI3D_frame frm = frame->GetParent();
                              //must be sector
         //assert(frm->GetType()==FRAME_SECTOR);
         if(frm->GetType()!=FRAME_SECTOR) break;
         PI3D_sector sct = I3DCAST_SECTOR(frm);
         const S_vector &head_pos = (frm_head ? frm_head : frame)->GetWorldPos();
         sct = mission.GetScene()->GetSector(head_pos, sct);
                              //perform more detailed placement only on active (focused) player
         PI3D_frame cam = mission.game_cam.GetCamera();
         if(cam->GetType()==FRAME_CAMERA)
         if(/*active && */sct!=I3DCAST_CAMERA(cam)->GetSector()){
            //const S_vector &cpos = cam->GetWorldPos();
            const S_vector &feet_pos = frame->GetWorldPos();
                              //check if feets closer than head
            float a = mission.game_cam.GetCamera()->GetWorldDir().AngleTo(head_pos-feet_pos);
            if(a<PI*.5f)
            {
                              //link to sector of feets instead
               S_vector v = feet_pos;
               v.y += .2f;
               sct = mission.GetScene()->GetSector(v, sct);
            }
         }
         frame->LinkTo(sct);
      }
      return true;

      /*
   case CB_OBSTACLE_MOVE:
                              //only programmed guys can move
      if(mode!=PLRMODE_PROGRAM) return false;
      if(network_actor) return false;
      break;
      */

   case CB_IN_WATER:
      if(active){
         int dm = mission.game_cam.GetDistanceMode();
         if(!dm){
            mission.game_cam.SetDistanceMode(1);
            cbProc(CB_SETFOCUS, true);
         }
      }
      break;

   case CB_USE_AUTO:
      if(!prm1 && prm2) 
         breath=false;
      break;

   case CB_INV_GRAB:
      switch(prm1){
      case 0:                 //start/stop grabbing other's inventory
         {
            LPC_actor a = (LPC_actor)prm2;
            if(a) a->cbProc(CB_INV_GRAB, 1, true);
            else
            if(using_item){
               UseInventory(NULL, false, 1, 2, 1);
               using_item->cbProc(CB_INV_GRAB, 1, false);
               PlayAnim(POSE_GRAB_FINISH, true);
            }
            SetUsingItem(a, true);
            return true;
         }
         break;
      }
      break;

   case CB_SHOW_AMMO:
      {
         bool on;
         bool using_i = false;
         int used_itm_ammo;
         if(active){
                              //check if multiple items
            if(using_item)
            switch(using_item->GetType()){
            case ACTOR_CANNON:
               if(using_item->cbProc(CB_USE_CANNON, 8) == 0){
                  using_i = on = true;
                  used_itm_ammo = using_item->cbProc(CB_USE_CANNON, 6);
               }
               break;
            case ACTOR_AUTO_CANNON:
               if(using_item->cbProc(CB_USE_AUTO, 11, (dword)this)){
                  using_i = on = true;
                  used_itm_ammo = using_item->cbProc(CB_USE_AUTO, 16);
               }
               break;
            }
            if(!using_i)
               on = tab_inventory->ItemB(TAB_B_INV_MULTIPLE, C_inventory::GetItem(selected_inv_item));
         }else on = false;

         if(on){
            E_ICON_IMAGE iimg;
                              //what are we using?
                              /*
            switch(tab_inventory->ItemI(TAB_I_INV_ID, C_inventory::GetItem(selected_inv_item))){
            case INV_CAMERA: iimg=IIMG_PHOTOS; break;
            default: iimg=IIMG_AMMO;
            }
            */
            iimg = IIMG_AMMO;
                              //check if id's the same
            if(ii_ammo && iimg != ii_ammo->GetID()){
               mission.DelIconInfo(ii_ammo);
               ii_ammo = NULL;
            }
            if(!ii_ammo){
               ii_ammo = new C_icon_info(mission.texts, iimg);
               ii_ammo->Release();
               mission.AddIconInfo(ii_ammo);
            }
            C_string str;
            if(using_i) str = C_fstring("%i", used_itm_ammo);
            else{
                              //check if batch weapon
               int ammo = C_inventory::GetItemAmount(selected_inv_item);
               int batch_size = tab_inventory->ItemI(TAB_I_INV_STACKSIZE, C_inventory::GetItem(selected_inv_item));
               if(batch_size){
                  dword num_bullets = C_inventory::GetBullets(selected_inv_item);
                  dword num_left = ammo - num_bullets;
                  dword num_stacks = (num_left+batch_size-1)/batch_size;
                  str = C_fstring("%i/%i", num_stacks, num_bullets);
               }else
                  str = C_fstring("%i", ammo);
            }
            ii_ammo->SetText(str);
         }else{
            if(ii_ammo){
               mission.DelIconInfo(ii_ammo);
               ii_ammo = NULL;
            }
         }
      }
      return true;

   case CB_USE_RESOURCE:
      switch(prm1){
      case 2:                 //pick resource
         {
            if(C_human::cbProc(msg, prm1, prm2) && active){
               cbProc(CB_SHOW_AMMO);
               mission.game_menu.SetInventory(this);
               mission.PlaySoundGlobal("inv_show");
               inv_on_count = INVENTORY_COUNT;
               return true;
            }
            return false;
         }
         break;
      }
      break;

   case CB_CHEAT:
      switch(prm1){
      case CHEAT_ZOMBIE:
         if(!net)             //not in network game
         if(!IsAlive()){
            stay_mode=SM_STAY;
            mode=PLRMODE_PROGRAM;
            SetResistance(init_resistance = 5000);
         }
         break;
      case 8:                 //goodhealth
         if(!net){
            SetResistance(init_resistance = 20000);
         }
         break;

      case 11:                   //debugport
         {
            if(!active)
               break;
            vector<PI3D_frame> v;
            struct S_hlp{
               static I3DENUMRET I3DAPI cbEnum(PI3D_frame frm, dword c){
                  vector<PI3D_frame> &v = *(vector<PI3D_frame>*)c;
                  v.push_back(frm);
                  return I3DENUMRET_OK;
               }
               static bool cbLess(PI3D_frame f1, PI3D_frame f2){
                  return (strcmp(f1->GetName(), f2->GetName()) < 0);
               }
            };
            mission.GetScene()->EnumFrames(S_hlp::cbEnum, (dword)&v, ENUMF_ALL | ENUMF_WILDMASK, "debug*");
            sort(v.begin(), v.end(), S_hlp::cbLess);
            vector<char> names;
            for(int i=0; i<v.size(); i++){
               const char *n = v[i]->GetName();
               names.insert(names.end(), n, n+strlen(n)+1);
            }
            names.push_back(0);
            igraph->FlipToGDI();
            int indx = WinSelectItem("Select frame to port to:", names.begin(), 0);
            if(indx!=-1){
               PI3D_frame df = v[indx];
               frame->SetPos(df->GetWorldPos());
               frame->SetRot(df->GetWorldRot());
               frame->Update();
#ifdef KEEP_HUMAN_OUT_OF_WALL
               ResetSpheres();
#endif
            }
         }
         break;

      case 14:
         no_hit_cheat = !no_hit_cheat;
         break;

      case 17:
         if(active && !net)
            cbProc(CB_DIE, -1);
         break;
      }
      break;

   case CB_APPLY_DIFFICULTY:
      switch(game_profile.difficulty){
      case S_game_profile::DIF_EASY:
                              //easy - increase resistance
         resistance *= 2.0f;
         init_resistance = resistance;
         break;
      case S_game_profile::DIF_HARD:
                              //hard - decrease resistance
         resistance *= .75f;
         init_resistance = resistance;
         break;
      }
      break;

   case CB_PRG_SHOW:          //(bool pos_change_only, int comp_times <0=no, 1=all, 2=only first>)
      {
         if(prg_dirty){
            prg_dirty=false;
            prm1=false;
         }
         vector<S_prg_item> plist;
         S_prg_item pi;
         pi.active=true;
         pi.show_time = 0;
         for(i=0; i<program.size(); i++){
            pi.prg_item = program[i]->prg_item;
            pi.show_time += program[i]->pause_time;
            plist.push_back(pi);
            pi.show_time += program[i]->process_time;
         }
         pi.prg_item = IsAlive() ? PRG_READY : PRG_DEAD;
         plist.push_back(pi);
         mission.game_menu.SetPrgList(menu_id, plist, prm1);
      }
      break;

   case CB_PRG_PREPROCESS:    //(int mode<0=all, 1=process_time for key #0>)
      {
         if(prm1!=1){
                              //preprocess all keys
            for(i=(!prm1 ? 0 : program.size()-1); i<program.size(); i++){
               S_command &key = *program[i];
               bool set_dest = true;
                              //detect commands which change something
               switch(key.prg_item){
               case PRG_GUARD:
                  if(!key.sub_param.guard_dest_set) break;
                  set_dest = false;
                  break;
               case PRG_MOVE:
                  {
                     C_movement *movement = key.GetMovement();
                     key.dest = movement ? movement->GetDest() : frame->GetWorldPos();
                     set_dest = false;
                  }
                  break;
               case PRG_STEP:
                  key.dest = *(LPS_vector)&key.sub_param.step_dest;
                  set_dest = false;
                  break;
               case PRG_LADDER_CLIMB:
               case PRG_STAY_UP: key.stay_mode = SM_STAY; break;
               case PRG_STAY_MID: key.stay_mode = SM_BENCH; break;
               case PRG_STAY_DOWN: key.stay_mode = SM_LAY; break;
               }
               if(!i){
                  if(set_dest)
                     key.dest = frame->GetWorldPos();
                  key.stay_mode = stay_mode;
               }else{
                  S_command &prev_key = *program[i-1];
                  if(set_dest)
                     key.dest = prev_key.dest;
                  key.stay_mode = prev_key.stay_mode;
               }
               key.CompProcessTime(i ? program[i-1] : NULL);
            }
         }else{
            if(program.size()){
               S_command &key = *program.front();
               //key.dest = frame->GetWorldPos();
               //key.stay_mode = stay_mode;
               key.CompProcessTime();
            }
         }
      }
      break;

   case CB_DIE_DROWN:
      if(mode==PLRMODE_DYING) return 0;
      if(active)
         mission.game_cam.SetFocus(NULL, NULL);
                              //flow...
      break;

   case CB_HIT:               //C_player
      if(no_hit_cheat) return 0;
      break;

   case CB_SETFOCUS:
      switch(prm1){
      case 0:
         if(frame)
            frame->SetOn(I3D_ON);
         break;
      case 2:
         if(!active)
            break;
      case 1:
         {
            if(frame)
               frame->SetOn((mission.game_cam.GetDistanceMode()!=0) ? I3D_ON : I3D_ON_CONDITIONAL);
                              //check if aim model available
            const char *cp = tab_inventory->ItemS(TAB_S16_INV_MODEL_AIM, GetItem(selected_inv_item), 16);
            if(*cp){
               PI3D_model mp = driver->CreateModel();
               i = I3D_SUCCESS(model_cache.Open(mp, cp, mission.GetScene(), 0, ErrReport, editor));
               if(!i){
                  ReportActorError(C_fstring("can't load aim model: %s", cp));
               }
               PI3D_frame frm;
               frm = mp->FindChildFrame("cross", ENUMF_VISUAL);

               if(frm)
                  aim_disp = frm->GetPos();
               else{
                  ReportActorError(C_fstring("can't find object 'cross' in %s", cp));
                  aim_disp.Zero();
               }
               bool zoom = tab_inventory->ItemB(TAB_B_INV_ZOOM, GetItem(selected_inv_item));
               mission.game_cam.SetAimModel(mp,
                  !zoom ? model->FindChildFrame("gun*", ENUMF_ALL | ENUMF_WILDMASK) : NULL);
               E_INV_ITEM itm = (E_INV_ITEM)tab_inventory->ItemI(TAB_I_INV_ID, GetItem(selected_inv_item));

               if(itm==INV_BINOCULARS && curr_pose!=POSE_BINOC_BREATH){
                              //binocs held in hand
                  mp->SetOn(false);
                  zoom = false;
               }else{
                  bool must_be_aim = false;
                                    //zoomers must be this
                  if(tab_inventory->ItemB(TAB_B_INV_ZOOM, GetItem(selected_inv_item)))
                     must_be_aim = true;
                  if(itm==INV_CAMERA) must_be_aim = true;

                  if(game_configuration.aim_mode!=0 && game_configuration.aim_mode!=2 && !must_be_aim){
                     mp->SetOn(false);
                  }
               }
               mp->Release();
               dword ret = C_human::cbProc(msg, prm1, prm2);
               if(zoom && mission.game_cam.GetDistanceMode()==0){
                  mission.game_cam.SetZoom(curr_aim_zoom);
               }
               return ret;
            }else
               mission.game_cam.SetAimModel(NULL, NULL);
         }
         break;
      }
      break;

   case CB_SETFACE:
      if(menu_id!=-1)
      {
         mission.game_menu.SetPlayerFace(menu_id, prm1);
      }
      break;

   case CB_SETINVENTORY:
      {
         C_inventory::DeleteAllItems();
         vector<::S_item> *item_list = (vector<::S_item>*)prm1;
         for(i=0; i<item_list->size(); i++){
            if(tab_inventory->ItemB(TAB_B_INV_MULTIPLE, (*item_list)[i].itm)){
               int itm = (*item_list)[i].itm;
               bool has_ammo = C_inventory::HasAmmo(itm);
               //C_inventory::AddItem((*item_list)[i].itm, (*item_list)[i].ammo);
               C_inventory::AddItem(itm, has_ammo ? (*item_list)[i].ammo : (*item_list)[i].pieces);
            }else
               C_inventory::AddItem((*item_list)[i].itm);
            C_inventory::Reload(C_inventory::NumItems()-1, true);
         }
                              //any gun away
         //** cbProc(CB_SETGUN, 0, NULL);
         SetGun(NULL);
         C_inventory::SetActiveItem(0);
         //selected_inv_item = 0;
         selected_inv_item = 0;
                              //put proper weapon into hands
         int best_id = FindBestWeapon();
         if(best_id != -1){
            i = C_inventory::ItemIndex(best_id);
            if(i!=-1){
               SetSelectedInvItem(i, false);
               C_inventory::SetActiveItem(i);
            }
         }
         cbProc(CB_SHOW_AMMO);
      }
      break;

   case CB_STOREINVENTORY:    //at the end of game
      {
         vector<::S_item> *item_list = (vector<::S_item>*)prm1;
                              //don't count empty hands item
         for(i=1; i<C_inventory::NumItems(); i++){
            int id = C_inventory::GetItem(i);
                              //some items are not passed through
            if(tab_inventory->ItemB(TAB_B_INV_TO_NEXT_MISS, id)){
               item_list->push_back(::S_item(id, 0, 1));
               //bool ammo = tab_inventory->ItemB(TAB_B_INV_MULTIPLE, C_inventory::GetItem(i));
               bool ammo = C_inventory::HasAmmo(id);
               (ammo ? item_list->back().ammo : item_list->back().pieces) =
                  C_inventory::GetItemAmount(i);
            }
         }
      }
      break;

   case CB_DESTROY_PLR_MENU:
      assert(menu_id!=-1);
      mission.game_menu.DestroyPlayerMenu(menu_id);
      menu_id = -1;
      break;

   case CB_CREATE_PLR_MENU:
      menu_id = mission.game_menu.AddPlayerMenu(1);
      cbProc(CB_PRG_SHOW);
      break;
   }
   return C_human::cbProc(msg, prm1, prm2);
}

//----------------------------

void C_player::NetIn(PC_net_in_msg in_msg){

   int old_pose = curr_pose;

   in_msg->Ascend();
   while(in_msg->GetChunkSize())
      NetCodeIn(in_msg->GetBits(NET_ACTOR_CODE_BITS), in_msg);
   in_msg->Descend();

                              //hide latency - move anim forward
   if(curr_pose!=old_pose)
      model->Tick(in_msg->GetLatency());
}

//----------------------------

                              //player action groups - for use by
                              //special types of ammos
enum E_ALLOW_ACTION{
   AA_MOVE=1,
   AA_STAY_CHANGE=2,
   AA_USE_ITEM=4,
   AA_MOUSE_AIM=8,
   AA_FIRE=0x10,
   AA_CHANGE=0x20,
   AA_USE_INV=0x40,

   AA_ALL=-1
};

enum E_ALLOW_GROUP{
   AG_DEFAULT,
   AG_DRIVER,
   AG_PASSENGER,
   AG_NONE,
   AG_LADDER,
};

static const dword allow_actions[]={
   AA_ALL, AA_USE_ITEM, AA_ALL & ~(AA_MOVE|AA_USE_INV), 0,
   AA_USE_ITEM,
};

//----------------------------

#define KILLER_SHOW_TIME 4500

//----------------------------

static float mouse_sens_scale[3] = {.7f, 1.0f, 1.6f};

//----------------------------

struct S_a1{
   LPC_human a;
   float power;
   float sortval;
   bool operator < (const S_a1 &r) const{ return sortval<r.sortval; }
};

//----------------------------

dword C_player::Tick(const S_tick_context &tc){

   if(!model)
      return 0;

   if(tc.time>=60){
      S_tick_context tc1 = tc;
      tc1.time /= 2;
      Tick(tc1);
      tc1.time = tc.time - tc1.time;
      return Tick(tc1);
   }

   if(anim_store.waiting)
      PlayStoredAnim();

   anim_man.Tick(tc.time, model);

   //DEBUG(GetName());
   int i;

                              //manage name hint (keep positioned properly)
   if(name_hint){
      S_vectorw scr;
      bool on = GetNameHintPos(scr);

      float sx = igraph->Scrn_sx();
      float x = scr.x / sx, y = scr.y / sx;
      name_hint->SetPos(S_vector2(x, y));
      name_hint->SetOn(on);
   }


   if(net){
      dword winner_pid;
      if(net_switch_sync->GetState(&winner_pid)==C_net_sync::SS_RESOLVED){
         if(winner_pid==net->GetPID()){
            NET_DEBUG("C_player: obtained controll access");
            network_actor = 0;
         }else{
            NET_DEBUG("C_player: lost controll access");
            //network_actor = true;
                           //get and display name of winner
            network_actor = winner_pid;
            mode = PLRMODE_ACTIVE;
         }
         cbProc(CB_SHOW_PLAYER_NAME, true);
         net_switch_sync->Reset();
      }
      TickGrabSync();
   }

   if(C_inventory::IsVisible()){
      bool do_count = true;
                              //do not count down if grabbing
      if(using_item)
      switch(using_item->GetType()){
      case ACTOR_PLAYER: case ACTOR_ENEMY: do_count = false; break;
      }
      if(do_count){
         if((inv_on_count -= tc.time) <= 0){
            mission.game_menu.SetInventory(NULL);
            mission.PlaySoundGlobal("inv_off");
         }
      }
   }

#if 1
                              //if using cannon, try adjust dir to cannon aim diresction, 
                              //otherwise use actor aim_dir
   if(active && (mission.game_cam.GetUser()==this)){
      S_vector canon_dir(aim_dir);
      if(using_item && (using_item->GetType() == ACTOR_CANNON)){
         if(mission.game_cam.GetUser()==this){
            PI3D_frame f_dir = mission.game_cam.GetFocusDir();
            if(f_dir){
               using_item->cbProc(CB_USE_CANNON, 4, (dword)&canon_dir);
               //DebugLine(frm_head->GetWorldPos(), frm_head->GetWorldPos()+canon_dir, 0, 0x0fffffff);
               S_matrix m = f_dir->GetMatrix();
               m.Inverse();
               canon_dir.y = -canon_dir.y;
               canon_dir %= m;
            }
         }
      }
      mission.game_cam.SetDeltaDir(canon_dir);
   }
#endif


   switch(mode){

   case PLRMODE_KILLER_SHOW:
      if((killer_show_time -= tc.time) <= 0 || !active){
         if(active) cbProc(CB_SETFOCUS, 1);
         mode=PLRMODE_DEAD;
                              //show killed prg icon
         cbProc(CB_PRG_SHOW, 0);
      }else
         if(active)
            ProcessKeysPassive(tc);
      break;

   case PLRMODE_DYING:
      if(network_actor){
         NetSyncTick(tc.time);
      }else{
         C_human::Tick(tc);
      }
      DoFloorLink();
      if(!IsAnimated()){
                              //show killer, if any
         bool abs_dead = (!active || !killer);
         if(mission.game_cam.GetFocusDir()!=frame)
            abs_dead = true;
         if(!abs_dead){
                              //show only visible killers
            //killer->GetFrame()->IsOn()
            if(killer->cbProc(CB_SETFOCUS, 1)){
               cbProc(CB_SETFOCUS, 0);
               killer_show_time=KILLER_SHOW_TIME;
               mode = PLRMODE_KILLER_SHOW;
            }else
               abs_dead = true;
         }
         if(abs_dead){
                                 //setup final position(network actor play animation without check collision, so adjust final position after die finshed)
            if(net && !network_actor){
               bool g = true;
               net_msg->Ascend(net_id);
               net_msg->AddBits(NM_HUMAN_DEAD_POS, NET_ACTOR_CODE_BITS, g);
               net_msg->AddVector(frame->GetWorldPos(), g);
               net_msg->Descend();
            }

            mode = PLRMODE_DEAD;
                              //show killed prg icon
            cbProc(CB_PRG_SHOW, 0);

            S_vector pos;
            GetCenterPos(pos);
            mission.LinkToFloor(frame, pos, frame, false);
         }
      }
                              //flow...
   case PLRMODE_DEAD:
      if(active)
         ProcessKeysPassive(tc);
      //DoFloorLink();
      break;

   case PLRMODE_ACTIVE:
      {
         //DEBUG(C_fstring("C_player %s: PLRMODE_ACTIVE, network_actor = 0x%x", GetName(), network_actor));
         if(network_actor){
            NetSyncTick(tc.time);
            RequestActivity(tc);
            if(active)
               ProcessKeysPassive(tc);
            break;
         }
         E_ALLOW_GROUP ag = AG_DEFAULT;
         int dest_pose = -1;

         int rx = tc.mouse_rel[0], ry = tc.mouse_rel[1];
         if(tc.p_ctrl){
            if(tc.p_ctrl->GetConfigValue(C_controller::CFG_INVERT_MOUSE_Y))
               ry = -ry;
                              //scale - apply sensitivity
            float f = (float)tc.p_ctrl->GetConfigValue(C_controller::CFG_MOUSE_SENSITIVITY) * .01f;
            rx = (float)rx * f;
            ry = (float)ry * f;
         }

                              //process several grabbing keys when focus is on something other
         if(active && (mission.game_cam.GetFocusDir() != frame) && tc.p_ctrl){
            if(tc.p_ctrl->Get(GKEY_PLR_SWITCH)){
               tc.p_ctrl->IgnoreValue(GKEY_PLR_SWITCH);
               cbProc(CB_SETFOCUS, 1);
            }
         }

         if(using_item)
         switch(using_item->GetType()){
         case ACTOR_LADDER:
            if(tc.p_ctrl){
               bool up = tc.p_ctrl->Get(GKEY_FORWARD);
               bool down = tc.p_ctrl->Get(GKEY_BACKWARD);
               dest_pose = POSE_CLIMB_BREATH;
               UseLadder(tc, up, down, dest_pose);

               ag = AG_LADDER;
               i=0;
            }
            break;
         case ACTOR_AUTO_CANNON:
         case ACTOR_AUTOMOBIL:
            {
               bool is_driver = ((LPC_actor)using_item->cbProc(CB_USE_AUTO, 10) == this);
               bool drive = false;
               if(is_driver){
                  ag = AG_DRIVER;
               }else{
                  //AG_NONE
                  bool weapon_allowed = using_item->cbProc(CB_USE_AUTO, 14, (dword)this);
                  ag = weapon_allowed ? AG_PASSENGER : AG_DRIVER;
               }
               if(is_driver) drive = true;
               else
               if(using_item->cbProc(CB_USE_AUTO, 11, (dword)this)){
                              //controll cannon on the seat
                  ControllCannon(tc, false, tc.time, rx, ry);
                  if(!using_item)
                     break;
                  ag = AG_DRIVER;
                  DrawAimLine();
               }
               if(!net){
                          //if driver's alive, we may control car also from non-driver positions
                  LPC_actor act = (LPC_actor)using_item->cbProc(CB_USE_AUTO, 10);
                  if(act && act->GetType()==ACTOR_PLAYER && act->IsAlive())
                     drive = true;
               }
               if(drive && tc.p_ctrl){
                              //controll car
                  int prm1 = 3;
                  if(tc.p_ctrl->Get(GKEY_FORWARD))
                     prm1 = 1;
                  else
                  if(tc.p_ctrl->Get(GKEY_BACKWARD))
                     prm1 = 2;

                  if(prm1!=3)
                     using_item->cbProc(CB_USE_AUTO, prm1, tc.time);

                  //using_item->cbProc(CB_USE_AUTO, 3, tc.time);

                  if(fabs(I2F(tc.p_ctrl->Get(GKEY_LEFT))) > .4f || tc.p_ctrl->Get(GKEY_MOVE_LEFT))
                     using_item->cbProc(CB_USE_AUTO, 4, FloatAsInt((PI*.5f)*tc.time*.001f));
                  else
                  if(fabs(I2F(tc.p_ctrl->Get(GKEY_RIGHT))) > .4f || tc.p_ctrl->Get(GKEY_MOVE_RIGHT))
                     using_item->cbProc(CB_USE_AUTO, 4, FloatAsInt(-(PI*.5f)*tc.time*.001f));
                              //our action depends on speed
                  int speed = using_item->cbProc(CB_USE_AUTO, 8);
                  if(is_driver && fabs(speed)>2){
                     if(using_item->cbProc(CB_USE_AUTO, 5, (dword)this)!=2)
                        dest_pose=POSE_DRIVE_STRAIGHT;
                     //else
                        //SetAimDir(S_vector(-.5, 0, .5), 10000);
                  }
               }
               if(gun)
                  gun->Tick(tc.time);
               ShootCountDown(tc.time);
            }
            i=0;
            break;

         case ACTOR_PLAYER:
         case ACTOR_ENEMY:
            {
               if(tc.p_ctrl){
                              //process several grabbing keys
                  if(tc.p_ctrl->Get(GKEY_USE)){
                     tc.p_ctrl->IgnoreValue(GKEY_USE);
                     using_item->Use(this, 0);
                  }else
                  if((i=GKEY_INV_SCROLL_LEFT, tc.p_ctrl->Get(i)) || (i=GKEY_INV_SCROLL_RIGHT, tc.p_ctrl->Get(i))){
                     tc.p_ctrl->IgnoreValue(i, 250);
                     using_item->cbProc(CB_INV_GRAB, 1, true);
                     using_item->cbProc(CB_INV_GRAB, 2, i==GKEY_INV_SCROLL_LEFT);
                     mission.PlaySoundGlobal("inv_scrl");
                  }

                  if(using_item)
                  switch(UseInventory(NULL, tc.p_ctrl->Get(GKEY_ITEM_USE), tc.time, 2, 1)){
                  case 2:
                     {
                        dword amount;
                                 //force the inventory on if someone else has hidden this
                        using_item->cbProc(CB_INV_GRAB, 1, true);
                        int itm = using_item->cbProc(CB_INV_GRAB, 6, (dword)&amount);
                        if(itm==-1)
                           break;
                                 //check if we may carry this
                        float max_carriage = CountManCarriage(tab);
                                 //count what we have in the pack, including new item
                        float weight_sum = C_inventory::CountWeight() +
                           C_inventory::GetItemWeight(itm, amount);

                        if(weight_sum>max_carriage){
                           mission.PlaySoundGlobal("inv_cant");
                        }else{
                           using_item->cbProc(CB_INV_GRAB, 3);
                                 //add to our inventory
                           int indx = C_inventory::AddItem(itm, amount);
                           cbProc(CB_SHOW_AMMO);

                                 //keep it loaded
                           if(indx!=selected_inv_item)
                              C_inventory::Reload(indx, true);


                           if(net){       //3 = add item (bits:12 amount)
                              bool g = true;
                              net_msg->Ascend(net_id);
                              net_msg->AddBits(NM_HUMAN_INVENTORY, NET_ACTOR_CODE_BITS, g);
                              net_msg->AddBits(itm, 6, g);
                              net_msg->AddBits(3, 3, g);
                              net_msg->AddBits(amount, 12, g);
                              net_msg->Descend();

                              if(indx!=selected_inv_item){
                                          //5 = reload ammo
                                 net_msg->Ascend(net_id);
                                 net_msg->AddBits(NM_HUMAN_INVENTORY, NET_ACTOR_CODE_BITS, g);
                                 net_msg->AddBits(selected_inv_item, 6, g);
                                 net_msg->AddBits(5, 3, g);
                                 net_msg->AddBits(false, 1, g);
                                 net_msg->Descend();
                              }
                           }
                        }
                     }
                     break;
                  }
               }
            }
            i = -1;
            break;
         case ACTOR_CANNON:
            ControllCannon(tc, true, tc.time, rx, ry);
            ag = AG_NONE;
            C_human::Tick(tc);
            if(using_item)
               DrawAimLine();
            i = 0;
            break;
         case ACTOR_TIME_BOMB:
            {
               i = 0;
               ag = AG_NONE;
               int msg = -1;

               if(tc.p_ctrl && tc.p_ctrl->Get(GKEY_ESCAPE)){
                  tc.p_ctrl->IgnoreValue(GKEY_ESCAPE);
                              //cancel using
                  using_item->cbProc(CB_USE_TIME_BOMB, 5);
                  SetUsingItem(NULL, true);
                  PlayAnimNet(POSE_GRAB_FINISH, false, true);
               }

               switch(tc.key){
               case K_CURSORUP: msg = 1; break;
               case K_CURSORDOWN: msg = 2; break;

                  /*
               case K_ENTER:  //activate and stop use
                  msg = 3;
                  PlayAnimNet(POSE_GRAB_FINISH, false, true);
                  i = 0;
                  ag = AG_DEFAULT;
                  */
               }
               if(tc.p_ctrl && tc.p_ctrl->Get(GKEY_ITEM_USE)){
                  tc.p_ctrl->IgnoreValue(GKEY_ITEM_USE);
                  msg = 3;
                  PlayAnimNet(POSE_GRAB_FINISH, false, true);
                  i = 0;
                  ag = AG_DEFAULT;
               }

               if(msg!=-1){
                  using_item->cbProc(CB_USE_TIME_BOMB, msg);
                  if(msg==3) SetUsingItem(NULL, true);
               }
            }
            C_human::Tick(tc);
            break;
         default:
            i = C_human::Tick(tc);
         }else
            i = C_human::Tick(tc);

         byte may_turn = 3;   //bit 0 = left, bit 1 = right

         switch(i){
         case 0: break;
         case -2:
            turn_angle = 0.0f;
            may_turn = false; 
            break;
         default:
            model->Tick(tc.time);
            return i;
         }

         E_INV_ITEM itm = (E_INV_ITEM)tab_inventory->ItemI(TAB_I_INV_ID, C_inventory::GetItem(selected_inv_item));
         switch(itm){
         case INV_COLT:
         case INV_PANZER:
         case INV_BAZOOKA:
            DrawAimLine();
            break;
         case INV_WEAPON:
            DrawAimLine();
            if(!tab_inventory->ItemB(TAB_B_INV_ZOOM, C_inventory::GetItem(selected_inv_item))) break;
                              //flow...
         case INV_BINOCULARS:
            {
               PI3D_frame am = mission.game_cam.GetAimModel();
               //assert(am);
               if(!am) break;
               bool on=false;
               if(itm==INV_BINOCULARS)
                  switch(curr_pose){
                  case POSE_BINOC_BREATH: case POSE_BINOC_BREATH + 0x20: case POSE_BINOC_BREATH + 0x40:
                     on=true;
                     break;
                  }
               else
                  switch(curr_pose&0x1f){
                  case POSE_BREATH: //case POSE_BREATH + 0x20: case POSE_BREATH + 0x40:
                  case POSE_PULL_GUN: //case POSE_PULL_GUN + 0x20: case POSE_PULL_GUN + 0x40:
                  case POSE_FIRE: //case POSE_FIRE + 0x20: case POSE_FIRE + 0x40:
                  case POSE_TURN_LEFT:
                  case POSE_TURN_RIGHT:
                  case POSE_RESET:
                  //case POSE_BINOC_BREATH:
                     on=true;
                     break;
                  }
               if((bool)am->IsOn() != on){
                  am->SetOn(on);
                  if(!on){
                     mission.game_cam.SetZoom(1.0f);
                  }else
                  if(mission.game_cam.GetDistanceMode()==0)
                     mission.game_cam.SetZoom(curr_aim_zoom);
               }
            }
            break;
         }
                              //controll interface - keyboard
         //bool is_accel = tc.p_ctrl ? tc.p_ctrl->Get(GKEY_RUN) : false;
         bool is_accel = false;
         if(tc.p_ctrl){
            is_accel = tc.p_ctrl->Get(GKEY_RUN);
            if(tc.p_ctrl->GetConfigValue(C_controller::CFG_ALWAYS_RUN))
               is_accel = !is_accel;
         }

         bool free_anim = false;
         bool is_moving = false;
         bool do_use = false;

         if(tc.p_ctrl){

            if(tc.p_ctrl->Get(GKEY_UP)){    //stay up
               if(allow_actions[ag]&AA_STAY_CHANGE)
               if(SwitchStayMode(true)){
                  dest_pose=POSE_STAY_UP;
                  ResetAim();
               }
            }else                //stay down
            if(tc.p_ctrl->Get(GKEY_DOWN)){
               if(allow_actions[ag]&AA_STAY_CHANGE)
               if(SwitchStayMode(false)){
                  dest_pose=POSE_STAY_DOWN;
                  //move=false;
                  ResetAim();
               }
            }else
            if(tc.p_ctrl->Get(GKEY_CAM_ZOOM_IN)){
               tc.p_ctrl->IgnoreValue(GKEY_CAM_ZOOM_IN);
               CameraZoom(true);
            }else
            if(tc.p_ctrl->Get(GKEY_CAM_ZOOM_OUT)){
               tc.p_ctrl->IgnoreValue(GKEY_CAM_ZOOM_OUT);
               CameraZoom(false);
            }else
            if(tc.p_ctrl->Get(GKEY_CAM_VIEW_UP)){
               tc.p_ctrl->IgnoreValue(GKEY_CAM_VIEW_UP);
               CameraView(true);
            }else
            if(tc.p_ctrl->Get(GKEY_CAM_VIEW_DOWN)){
               tc.p_ctrl->IgnoreValue(GKEY_CAM_VIEW_DOWN);
               CameraView(false);
            }else
            if((i=GKEY_INV_SCROLL_LEFT, tc.p_ctrl->Get(i)) || (i=GKEY_INV_SCROLL_RIGHT,tc.p_ctrl->Get(i))){
               tc.p_ctrl->IgnoreValue(i, 250);

               if(!C_inventory::IsVisible()){
                  mission.game_menu.SetInventory(this);
                  mission.PlaySoundGlobal("inv_show");
               }else{
                  C_inventory::Scroll(i==GKEY_INV_SCROLL_LEFT);
                  mission.PlaySoundGlobal("inv_scrl");

                  if(net){          //2 = set active
                     const bool g = true;
                     net_msg->Ascend(net_id);
                     net_msg->AddBits(NM_HUMAN_INVENTORY, NET_ACTOR_CODE_BITS, g);
                     net_msg->AddBits(C_inventory::GetActiveItem(), 6, g);
                     net_msg->AddBits(2, 3, g);
                     net_msg->Descend();
                  }
               }
               inv_on_count = INVENTORY_COUNT;
            }else
            if(tc.p_ctrl->Get(GKEY_CMD_PRG_CLR)){
               tc.p_ctrl->IgnoreValue(GKEY_CMD_PRG_CLR);
               if(program.size()){
                  ClrProgram(true);
                  cbProc(CB_PRG_SHOW, false, 1);
               }
            }else
            if(tc.p_ctrl->Get(GKEY_USE)){
               tc.p_ctrl->IgnoreValue(GKEY_USE);
               do_use = true;
            }else
            if(tc.p_ctrl->Get(GKEY_RELOAD)){
               tc.p_ctrl->IgnoreValue(GKEY_RELOAD);

               if(!(using_item && using_item->GetType()==ACTOR_LADDER)){
                              //check if reload possible, play anim if it is
                  if(C_inventory::Reload(selected_inv_item, false)){
                     int id = tab_inventory->ItemI(TAB_I_INV_ID, GetItem(selected_inv_item));
                     dest_pose = (id==INV_COLT) ? POSE_COLT_LOAD : POSE_LOAD;
                  }
               }
            }else
            if(tc.p_ctrl->Get(GKEY_CENTER)){
               tc.p_ctrl->IgnoreValue(GKEY_CENTER);
               ResetAim();
            }else
            if((i=GKEY_PLR_SWITCH,tc.p_ctrl->Get(i)) || (i=GKEY_PLR_SWITCH_1,tc.p_ctrl->Get(i)) ||
               (i=GKEY_PLR_SWITCH_2,tc.p_ctrl->Get(i)) || (i=GKEY_PLR_SWITCH_3,tc.p_ctrl->Get(i)) ||
               (i=GKEY_PLR_SWITCH_4,tc.p_ctrl->Get(i))){
               tc.p_ctrl->IgnoreValue(i);
                              //if we're programmed, don't switch, rather resume program
               if(program.size()){
                  mode = PLRMODE_PROGRAM;
               }else{
                  mission.PlayerSwitch(igraph->GetShiftKeys()&SKEY_SHIFT,
                     (i==GKEY_PLR_SWITCH) ? -1 : i-GKEY_PLR_SWITCH_1);
               }
            }else
            if((i=GKEY_CMD_FOLLOW,tc.p_ctrl->Get(i)) || (i=GKEY_CMD_STOP,tc.p_ctrl->Get(i)) ||
               (i=GKEY_CMD_MOVE,tc.p_ctrl->Get(i)) || (i=GKEY_CMD_HEY,tc.p_ctrl->Get(i)) ||
               (i=GKEY_CMD_HOLD_FIRE,tc.p_ctrl->Get(i))){
               tc.p_ctrl->IgnoreValue(i);
                              //broadcast voice command
               int cmd_id = i - GKEY_CMD_FOLLOW;

               static const char vb[][4]={"flw", "stp", "mov", "hey", "hld"};
               PlayVoice(vb[cmd_id], 4.0f, true, true, cmd_id+1);

               struct S_hlp{
                  LPC_actor caller;
                  PI3D_frame frm_head;
                  vector<S_a1> a_list;
                  static bool cbEnum(LPC_actor act, dword hp1){

                     S_hlp *hp = (S_hlp*)hp1;
                     LPC_actor this_a = hp->caller;
                              //don't give signal to ourself
                     if(act==this_a)
                        return true;
                     if(!act->IsHuman())
                        return true;
                     if(!act->IsAlive())
                        return true;
                              //our players and civilians listen to the commands
                     if(act->GetType()!=this_a->GetType()){
                        if(act->GetTable(0)->ItemI(TAB_I_ENM_GROUP)!=2)
                           return true;
                     }
                              //only inactive ones may listen
                     if(act->IsActive())
                        return true;
                              //get angle of our head to the target
                     const S_vector &tpos = *act->GetBrestPos();
                     const S_vector &pos = hp->frm_head->GetWorldPos();
                     float dist = (tpos-pos).Magnitude();
                     if(dist<SIGNAL_HEAR_DIST){
                        float f;
                        f = hp->frm_head->GetWorldDir().AngleTo(tpos-pos);
                        f = f/PI * .3f + .7f;
                        f *= 1.0f-(dist/SIGNAL_HEAR_DIST);
                        if(f>.6f){
                           hp->a_list.push_back(S_a1());
                           hp->a_list.back().a = (LPC_human)act;
                           hp->a_list.back().power = f;
                        }
                     }
                     return true;
                  }
               } hlp;
               hlp.caller = this;
               hlp.frm_head = frm_head;

                           //collect actors which should receive our message
               mission.EnumActors(S_hlp::cbEnum, (dword)&hlp);
               vector<S_a1> &a_list = hlp.a_list;
               switch(cmd_id){
               case 2:        //move on
                  if(a_list.size()){
                              //sort actors by distance in our direction

                              ////(including myself)
                     //a_list.push_back(S_a1());
                     //a_list.back().a = this;
                     S_plane pl;
                     pl.normal = -frm_head->GetWorldDir();
                     pl.d = -pl.normal.Dot(*GetBrestPos());
                     for(i=a_list.size(); i--; ){
                        const S_vector &apos = *a_list[i].a->GetBrestPos();
                        a_list[i].sortval = apos.DistanceToPlane(pl);
                     }
                     sort(a_list.begin(), a_list.end());
                              //send greater half of men forward
                     //int num_moves = (a_list.size()+1)/2;
                     int num_moves = 1;
                     for(i=0; i<num_moves; i++)
                     if(a_list[i].a!=this){
                        a_list[i].a->VoiceCommand(this, cmd_id);
                     }
                  }
                  break;
               case 4:        //hold fire!
                  holding_fire = true;
                              //flow...
               default:
                  for(i=a_list.size(); i--; )
                     a_list[i].a->VoiceCommand(this, cmd_id);
                  break;
               }
            }
         }

         if(allow_actions[ag]&AA_USE_ITEM)
         if(do_use){
            if(using_item){
               int b = using_item->Use(this, 0);
               if(b==1){
                  //using_special=false;
                  cbProc(CB_SHOW_AMMO);
                  dest_pose = POSE_RESET;
               }
            }else{
               int use_indx;
               LPC_actor use_item = FindUseItem(&use_indx);
               if(use_item){
                  dword reason = CheckUseItemConds(use_item, false, dest_pose, use_indx, true);
                  if(!reason){
                     int b = use_item->Use(this, (use_indx<<16)|1);
                     if(b==1){
                        cbProc(CB_SHOW_AMMO);
                        bool brk = false;
                        if(using_item)
                        switch(using_item->GetType()){
                        case ACTOR_AUTOMOBIL:
                        case ACTOR_AUTO_CANNON:
                           brk = true;
                           break;
                        case ACTOR_LADDER:
                           {
                                                   //align to ladder
                              frame->SetRot(using_item->GetFrame()->GetWorldRot());
                                                   //get ideal position
                              S_vector ideal_pos = using_item->GetFrame()->GetWorldPos();
                              const S_vector &plr_pos = frame->GetWorldPos();
                              ideal_pos.y = plr_pos.y;
                                          //get dir to current position
                              S_vector dir = plr_pos - ideal_pos;
                              const float MAX_DIST = .15f;
                              float mag = dir.Magnitude();
                              if(mag > MAX_DIST){
                                 S_vector pos = ideal_pos + dir * (MAX_DIST/mag);
                                 frame->SetPos(pos);
                              }
                              frame->Update();
                           }
                           break;
                        default:
                           dest_pose = POSE_RESET;
                        }
                        if(brk) break;
                     }
                  }else{
                     switch(reason){
                     case 2:  //bad stay mode
                        {
                           E_STAY_MODE sm = (E_STAY_MODE)use_item->CheckUseStay(stay_mode, use_indx);
                           SwitchStayMode(sm);
                           may_turn = false;
                           breath = false;
                        }
                        break;
                     case 4:  //switch to free hands
                        SetSelectedInvItem(0);
                        may_turn = false;
                        breath = false;
                        break;
                     }
                     //OUTTEXT(C_fstring("Can't use item %s", (const char*)use_item->GetName()));
                     //may_turn = false;
                     //breath = false;
                     //return 1;
                  }
               }
            }
         }

                              //check curr anim for ANIM_FULL
         if(may_turn){
            turn_angle = 0.0f;
            switch(curr_pose){
            case POSE_BARRIER_CLIMB:
            //case POSE_CLIMB_UP:
            //case POSE_CLIMB_DOWN:
               may_turn = false;
               break;
            default:
               may_turn = curr_pose==-1 ? false :
               tab_human_anim->ItemB(TAB_B_ANI_TURNENABLE, curr_pose) ? 3 : 0;
            }
         }

         if((allow_actions[ag]&AA_CHANGE) && tc.p_ctrl){
            switch(UseInventory(this, tc.p_ctrl->Get(GKEY_ITEM_USE), tc.time, 0, 2)){
            case 0:
               UseInvItem(dest_pose, !(allow_actions[ag]&AA_USE_INV));
               mission.game_menu.SetInventory(NULL);
               //move=false;
               break;
            case 1:
               if(!(allow_actions[ag]&AA_USE_INV)) break;
               DropInvItem(dest_pose);
               mission.game_menu.SetInventory(NULL);
               //move=false;
               break;
            }
         }else{
            UseInventory(this, 0, tc.time, 0, 2);
         }

         bool zoom_look = (mission.game_cam.GetDistanceMode()==0 && tab_inventory->ItemB(TAB_B_INV_ZOOM, C_inventory::GetItem(selected_inv_item)));
         byte moving_may_turn = 0;
         if(zoom_look){
                              //turn when aim dir too big
            S_vector2 dir2d(aim_dir.x, aim_dir.z);
            float a_d_angle = Angle2D(dir2d);
            if(fabs(a_d_angle)>PI*.1f){
               may_turn &= ~(a_d_angle<0.0f ? 1 : 2);
            }else{
               moving_may_turn = may_turn;
               may_turn = false;
            }
         }

         if(allow_actions[ag]&AA_MOVE){
            float mouse_turn = 0.0f;
                              //grab mouse x and use in movement
            if(!tc.p_ctrl || !tc.p_ctrl->Get(GKEY_ZOOM)){
               static float mouse_turn_acc;
               i = (may_turn|moving_may_turn);
               if(i && rx){
                  if(((i&1) && rx<0) || ((i&2) && rx>0)){
                     float angle = (float)rx * tab_game_cfg->ItemF(TAB_F_GAME_MOUSE_2_TURN);
                              //add new mouse movement
                     mouse_turn_acc += angle;
                              //limit to max speed
                     bool neg = (mouse_turn_acc<0.0f);
                     mouse_turn_acc = Min((float)fabs(mouse_turn_acc), TURN_SPEED_FAST);
                     if(neg) mouse_turn_acc = -mouse_turn_acc;
                     //rx = 0;
                  }
               }

               if(mouse_turn_acc){
                  //turn_angle = -mouse_turn_acc;
                  mouse_turn = -mouse_turn_acc;
                  if(zoom_look){
                     float curr_zoom = mission.game_cam.GetZoom();
                     mouse_turn *= curr_zoom;
                  }

                  float tsec = tc.time*.001f;
                  bool neg = (mouse_turn_acc<0.0f);
                  mouse_turn_acc = Max(0.0f, (float)fabs(mouse_turn_acc) - TURN_SPEED_FAST*tsec*tab_game_cfg->ItemF(TAB_F_GAME_MOUSE_TURN_CACHE));
                  if(neg)
                     mouse_turn_acc = -mouse_turn_acc;
               }
            }

            if(dest_pose==-1 && tc.p_ctrl){
               if(tc.p_ctrl->Get(GKEY_JUMP) && stay_mode==SM_STAY && fabs(fall_speed)<INIT_FALL_SPEED*2){
                  dest_pose = POSE_JUMP_FORWARD;
               }else
               if(tc.p_ctrl->Get(GKEY_FORWARD)){
                  //if(dest_pose==-1)
                  if(tc.p_ctrl->Get(GKEY_STRAIFE) && stay_mode==SM_STAY){
                     dest_pose = POSE_CREEP;
                  }else{
                     bool l = tc.p_ctrl->Get(GKEY_MOVE_LEFT), r = tc.p_ctrl->Get(GKEY_MOVE_RIGHT);
                     if(l || r){
                        dest_pose = l ? POSE_MOVE_LF : POSE_MOVE_RF;
                        if(is_accel)
                           dest_pose += 4;
                     }else       //move forward
                        dest_pose = POSE_MOVE_FORWARD;
                  }
                                 //check for simultaneous turning
                  if(may_turn || moving_may_turn){
                     float l = I2F(tc.p_ctrl->Get(GKEY_LEFT));
                     float r = I2F(tc.p_ctrl->Get(GKEY_RIGHT));
                     if(l > .2f) turn_angle = (is_accel || l > .6f) ? TURN_SPEED_FAST : TURN_SPEED_SLOW;
                     if(r > .2f) turn_angle = -((is_accel || r > .6f) ? TURN_SPEED_FAST : TURN_SPEED_SLOW);
                  }
                  is_moving = true;
               }else
               if(tc.p_ctrl->Get(GKEY_BACKWARD)){
                  float l = I2F(tc.p_ctrl->Get(GKEY_LEFT)), r = I2F(tc.p_ctrl->Get(GKEY_RIGHT));
                  if(l > .2f || r > .2f){
                     dest_pose = (l > .2f) ? POSE_MOVE_LB : POSE_MOVE_RB;
                     if(is_accel || l>.6f || r>.6f)
                        dest_pose += 4;
                  }else          //move backward
                     dest_pose = POSE_MOVE_BACKWARD;
                                 //check for simultaneous turning
                  if(may_turn || moving_may_turn){
                     float l = I2F(tc.p_ctrl->Get(GKEY_LEFT));
                     float r = I2F(tc.p_ctrl->Get(GKEY_RIGHT));
                     if(l > .2f) turn_angle = (is_accel || l > .6f) ? TURN_SPEED_FAST : TURN_SPEED_SLOW;
                     if(r > .2f) turn_angle = -((is_accel || r > .6f) ? TURN_SPEED_FAST : TURN_SPEED_SLOW);
                  }
                  is_moving = true;
               }else
               if(tc.p_ctrl->Get(GKEY_MOVE_LEFT) || tc.p_ctrl->Get(GKEY_MOVE_RIGHT)){
                  {
                     may_turn = false;
                     if(tc.p_ctrl->Get(GKEY_MOVE_LEFT)) dest_pose = POSE_MOVE_LEFT, may_turn = true;
                     else
                     if(tc.p_ctrl->Get(GKEY_MOVE_RIGHT)) dest_pose = POSE_MOVE_RIGHT, may_turn = true;
                     if(may_turn){
                        float l = I2F(tc.p_ctrl->Get(GKEY_LEFT));
                        float r = I2F(tc.p_ctrl->Get(GKEY_RIGHT));
                        if(l > .2f) turn_angle = (is_accel || l > .6f) ? TURN_SPEED_FAST : TURN_SPEED_SLOW;
                        if(r > .2f) turn_angle = -((is_accel || r > .6f) ? TURN_SPEED_FAST : TURN_SPEED_SLOW);
                     }
                  }
               }else
               if(I2F(tc.p_ctrl->Get(GKEY_LEFT))>.1f || I2F(tc.p_ctrl->Get(GKEY_RIGHT))>.1f){
                  dest_pose = (I2F(tc.p_ctrl->Get(GKEY_LEFT))>.1f) ? POSE_TURN_LEFT : POSE_TURN_RIGHT;
                  is_accel = false;
                  turn_angle = (I2F(tc.p_ctrl->Get(GKEY_LEFT)) - I2F(tc.p_ctrl->Get(GKEY_RIGHT))) * TURN_SPEED_SLOW;
               }
               if(!turn_angle && (may_turn || (moving_may_turn && is_moving)) && mouse_turn){
                  turn_angle = mouse_turn;
                  rx = 0;
               }
            }

                              //avoid turning without animation
            if(dest_pose==-1 && turn_angle!=0.0f){
               if(fabs(turn_angle)>TURN_SPEED_SLOW)
                  dest_pose = (turn_angle<0.0f) ? POSE_TURN_LEFT : POSE_TURN_RIGHT, may_turn=true;
               //else turn_angle = 0.0f;
            }
         }
#ifdef JOYSTICK
         if(joy){
                              //translate joy into keys
            S_joy_state js;
            joy->GetState(&js);
            if(may_turn)
            if(js.x != 0.0f){
               turn_angle = -js.x * TURN_SPEED_FAST;
            }
         }
#endif

         bool fire_action=false;
         /*
         if(mbut&4){
            mouse_acc[0] += rx;
            mouse_acc[1] += ry;
            rx=ry=0;
            for(i=0; i<2; i++)
            if(abs(mouse_acc[i])>120){
               bool up = (mouse_acc[i]>0);
               mouse_acc[i]=0;
               switch(i){
               case 0: CameraView(!up, false); break;
               case 1: CameraZoom(!up, false); break;
               }
            }
         }else
         */
         {
            mouse_acc[0] = 0;
            mouse_acc[1] = 0;
         }

         if(tc.p_ctrl && tc.p_ctrl->Get(GKEY_ZOOM)){
                              //check if zoom mode and aim camera mode
            if(ry){
#define ZOOM_MAX 1.0f
               //if(game_cam.GetDistanceMode()==0)
               //if(tab_inventory->ItemB(TAB_B_INV_ZOOM, C_inventory::GetItem(selected_inv_item)))
               if(zoom_look && !is_moving){
                  bool ok_zoom = true;
                  switch(itm){
                  case INV_BINOCULARS:
                     switch(curr_pose){
                     case POSE_BINOC_LOOK: case POSE_BINOC_LOOK + 0x20: case POSE_BINOC_LOOK + 0x40:
                     case POSE_BINOC_BREATH: case POSE_BINOC_BREATH + 0x20: case POSE_BINOC_BREATH + 0x40:
                        break;
                     default:
                        dest_pose = POSE_BINOC_LOOK;
                        ok_zoom=false;
                     }
                     if(ok_zoom && IsFullAnim()) ok_zoom=false;
                     break;
                  }
                  if(ok_zoom){
                     curr_aim_zoom = mission.game_cam.GetZoom();
                     curr_aim_zoom = Max(tab_game_cfg->ItemF(TAB_F_GAME_MIN_AIM_ZOOM),
                        Min(ZOOM_MAX,
                        curr_aim_zoom + (float)ry*.001f));
                     mission.game_cam.SetZoom(curr_aim_zoom);
                     rx = 0;
                     ry = 0;
                     if(net){
                              //compute delta, optionally send over net
                        float delta = (net_aim_zoom - curr_aim_zoom);
                        if(fabs(delta) >= .05f){
                           net_aim_zoom = curr_aim_zoom;
                           bool g = false;
                           net_msg->Ascend(net_id);
                           net_msg->AddBits(NM_HUMAN_ZOOM, NET_ACTOR_CODE_BITS, g);
                           net_msg->AddFloat(curr_aim_zoom, g);
                           net_msg->Descend();
                        }
                     }
                  }
               }
            }
         }

         if(tc.p_ctrl && tc.p_ctrl->Get(GKEY_FIRE) && (allow_actions[ag]&AA_FIRE)){
            fire_action = true;

            E_INV_ITEM itm = (E_INV_ITEM)tab_inventory->ItemI(TAB_I_INV_ID, C_inventory::GetItem(selected_inv_item));
            switch(itm){
            case INV_GRENADE:
               //if(throw_power<700)
               {
                  bool is_throwing = false;
                  switch(curr_pose){
                  case POSE_THROW: case POSE_THROW + 0x20: case POSE_THROW + 0x40:
                  case POSE_THROW_DOWN:
                     is_throwing = true;
                     GrenadeStopThrow();
                     break;
                  }
                  if(is_throwing)
                     break;
                  if(!ii_grenade_time){
                     ii_grenade_time = new C_icon_info(mission.texts, IIMG_GRENADE);
                     ii_grenade_time->Release();
                     mission.AddIconInfo(ii_grenade_time);
                  }
                  if(!throwing){
                     throwing = true;
                     throw_power = 0;
                  }

                  //throw_power += tc.time;
                  throw_power += tc.time * 1/2;
                              //show indicator
                  i = Min(700, throw_power);
                  i = i*100/700.0f;
                  i += 5;
                  i -= i%10;
                  ii_grenade_time->SetText(C_fstring("%i%%", i));

                  //DrawAimLine();
                  if(throw_power<700)
                     break;
                  if(tc.p_ctrl->Get(GKEY_RUN))
                     throw_power = (throw_power*2/3) | 0x80000000;
                  UseItem(tc, dest_pose, false, &aim_disp, throw_power);
                  free_anim = breath = true;
               }
               break;
            default:
               {
                              //use current item
                  int new_dest_pose = -1;
                  UseItem(tc, new_dest_pose, mission.game_cam.GetDistanceMode() == 0, &aim_disp);
                  if(dest_pose==-1) dest_pose = new_dest_pose;
                  if(new_dest_pose==POSE_PULL_GUN) dest_pose = new_dest_pose;
                  if(zoom_look){
                     switch(dest_pose){
                     case POSE_LOAD: case POSE_LOAD + 0x20: case POSE_LOAD + 0x40:
                     case POSE_BINOC_LOOK: case POSE_BINOC_LOOK + 0x20: case POSE_BINOC_LOOK + 0x40:
                        break;
                     default:
                        dest_pose=-1;
                     }
                  }
                  free_anim = false;
               }
            }
         }else
         if(throwing){
            
            if(tc.p_ctrl && tc.p_ctrl->Get(GKEY_RUN))
               throw_power = (throw_power*2/3) | 0x80000000;
            UseItem(tc, dest_pose, false, &aim_disp, throw_power);
            throwing = false;
            free_anim = breath = true;     //don't let breathing interrupt the throw anim
         }else
            GrenadeStopThrow();

         if(dest_pose==-1)
         {
            //move=false;
            free_anim = true;
                              //reset (breath)
            if(!breath || !IsAnimated()){
               is_accel=false;
               if(!breath){
                  if(!using_item)
                     dest_pose = POSE_RESET;
                  breath=true;
               }else
                  dest_pose = GetBreathPose();
            }
         }

         if(!free_anim) 
            breath=false;

         if(dest_pose!=-1){
            //if(move)
            if(is_moving){
               if(!CheckMoveMode()) break;
            }
            if(is_accel && dest_pose<POSE_ACCEL)
               dest_pose |= POSE_ACCEL;
            //PlayAnim(dest_pose, false);
            PlayAnimNet(dest_pose, false, false);
         }
                              //conroll aiming
         if(allow_actions[ag]&AA_MOUSE_AIM && tc.p_ctrl){
                              //only special animations allow turn in x, check for one
            bool allow_aim_x = tc.p_ctrl->Get(GKEY_ZOOM) ||
               tab_human_anim->ItemB(TAB_B_ANI_MOUSE_TURN_X, curr_pose);
            if(!allow_aim_x)
               rx = 0;
            if(mission.game_cam.IsAcquired() && (rx || ry || fire_action)){
               float range = (stay_mode!=SM_LAY) ? PI*.3f : PI*.15f;
               float curr_zoom = mission.game_cam.GetZoom();
               FreeCameraMove(aim_dir, S_vector(0, 0, 1), rx, -ry, range, curr_zoom*PI/2000.0f);
               SetAimDir(aim_dir, 0);
               ApplyAimDir();
            }
         }//else
         if(fabs(aim_dir.x)>.002f){
                              //aim fade speed is affected by movement speed
            S_vector md(tab_human_anim->ItemF(TAB_F_ANI_SPEEDX, curr_pose),
               tab_human_anim->ItemF(TAB_F_ANI_SPEEDY, curr_pose),
               tab_human_anim->ItemF(TAB_F_ANI_SPEEDZ, curr_pose));
            float speed = md.Magnitude();
            FreeAimFade(tc.time, true, speed*4.0f);
         }
                              //adjust compass
         const S_matrix &m_brest = brest->GetMatrix();
         float a;
         if(stay_mode!=SM_LAY){
            a = Angle2D(-S_vector2(m_brest(2).x, m_brest(2).z));
         }else{
            a = Angle2D(S_vector2(m_brest(1).x, m_brest(1).z));
         }
         mission.game_menu.SetCompassAngle(a);
      }
      break;

   case PLRMODE_PROGRAM:
      {
         //DEBUG(C_fstring("C_player %s: PLRMODE_PROGRAM, network_actor = 0x%x", GetName(), network_actor));
         if(active)
            ProcessKeysPassive(tc);
         if(network_actor){
            NetSyncTick(tc.time);
            RequestActivity(tc);
            break;
         }

         i=0;
         int dest_pose = -1;

         if(using_item)
         switch(using_item->GetType()){
         case ACTOR_AUTOMOBIL:
         case ACTOR_AUTO_CANNON:
         case ACTOR_LADDER:
            if(gun) gun->Tick(tc.time);
            ShootCountDown(tc.time);
            break;
         default: i = C_human::Tick(tc);
         }else i = C_human::Tick(tc);

         if(i) break;

         do{
         if(active){
                              //check if interrupt possible
            if(!program.size()){
               mode = PLRMODE_ACTIVE;
               break;
            }
            bool intr = true;
            bool del = false;
            switch(program[0]->prg_item){
            case PRG_LADDER_CLIMB:
               del = true;
               break;
            case PRG_USE_INV:
            case PRG_STEP:
               intr = false;
               break;
            }
            if(intr){
               intr = RequestActivity(tc);
               if(intr){
                  if(del)
                     DelProgram(0);
                  ClrPrgToFollow();
                  /*
                              //clear all our current program
                  for(i=0; i<program.size(); i++){
                     switch(program[i]->prg_item){
                     case PRG_LADDER_CLIMB:
                        break;
                     default:
                        DelProgram(i, true);
                     }
                  }
                  */

                              //gain controll
                  mode = PLRMODE_ACTIVE;
                  dest_pose = POSE_RESET;
                  break;
               }
            }
         }else
         if(!program.size()){
            if(AI_solution(tc.time, dest_pose)) break;
         }
         if(!program.size()){
            dest_pose = GetBreathPose();
            FreeAimFade(tc.time);
         }else{
            ProcessProgram(tc);
            cbProc(CB_PRG_PREPROCESS, 1);
            cbProc(CB_PRG_SHOW, 1);

            if(!program.size()){
               if(active && mode==PLRMODE_PROGRAM) mode=PLRMODE_ACTIVE;
               if(!using_item)
                  //PlayAnim(POSE_RESET);
                  dest_pose = GetBreathPose();
            }
         }
         }while(false);
         if(dest_pose!=-1) PlayAnimNet(dest_pose, false);
      }
      break;
   }
   if(name_hint && !name_hint->Tick(tc.time))
      name_hint = NULL;
   model->Tick(tc.time);

   return 0;
}

//----------------------------
//----------------------------

class C_enemy: public C_human{
   bool ignore_uniforms;      //when true, don't get confused by civil/german uniforms
   enum{
      ENMMODE_NORMAL,
      ENMMODE_DYING,
      ENMMODE_DEAD,
   } mode;
public:
   C_enemy(C_game_mission&);

   dword cbProc(dword msg, dword prm1=0, dword prm2=0);
   dword Tick(const S_tick_context&);

   virtual void NetIn(PC_net_in_msg in_msg){

      int old_pose = curr_pose;

      in_msg->Ascend();
      while(in_msg->GetChunkSize()){
         byte msg_code = in_msg->GetBits(NET_ACTOR_CODE_BITS);
         /*
         switch(msg_code){
         default:
            */
            NetCodeIn(msg_code, in_msg);
         //}
      }
                                 //hide latency - move anim forward
      if(curr_pose!=old_pose)
         model->Tick(in_msg->GetLatency());

      in_msg->Descend();
   }

   virtual void Die(int die_pose, bool net_send = true){

      mode = ENMMODE_DYING;
      C_human::Die(die_pose, net_send);
   }

//----------------------------

   virtual int GetEnemyGroup() const{ return tab->ItemI(TAB_I_ENM_GROUP); }

//----------------------------

   virtual E_RELATION GetRelation(C_actor *caller) const{

                              //dead enemy, good enemy
      if(stay_mode==SM_DEAD)
         return RELATION_NEUTRAL;
      switch(caller->GetType()){
      case ACTOR_PLAYER:
         return RELATION_ENEMY;
      case ACTOR_ENEMY:
                           //check our groups
         int i = caller->GetTable(0)->ItemI(TAB_I_ENM_GROUP);
         if(i==-1)
            return RELATION_NEUTRAL;
         if(i != tab->ItemI(TAB_I_ENM_GROUP))
            return RELATION_ENEMY;
         return RELATION_FRIEND;
      }
      return RELATION_FRIEND;
   }

//----------------------------

   virtual bool IsEnemy(C_actor *asker){
                              //when we're invisible, we're not enemy to anyone
      if(!frame->IsOn())
         return false;

      int my_group = tab->ItemI(TAB_I_ENM_GROUP);
      if(my_group==2){
                              //if I follow someone, I'm same type as russian
         if(program.size() && program.front()->prg_item!=PRG_GUARD)
            my_group = 1;
      }
      switch(asker->GetType()){
      case ACTOR_PLAYER:
         return (my_group==0);
      case ACTOR_ENEMY:
         {
            LPC_human hum = (LPC_human)asker;
            int his_group = asker->GetTable(0)->ItemI(TAB_I_ENM_GROUP);
            if(his_group==2){
                           //if I follow someone, I'm same type as russian
               if(hum->program.size() && hum->program.front()->prg_item!=PRG_GUARD)
                  his_group = 1;
            }
                           //civil is friend of everyone
            if(my_group==2 || his_group==2)
               return false;
            return (my_group!=his_group);
         }
         break;
      default:
         return false;
      }
   }

//----------------------------

   virtual int GetVoiceID() const{
      int group = tab->ItemI(TAB_I_ENM_GROUP);
      return tab->ItemI(TAB_I_HUM_VOICE) + (!group ? 50 : 0);
   }

//----------------------------

   virtual void TableUpdate(int index, bool not_load_prg){

      if(!not_load_prg)
         LoadProgram();
      cbProc(CB_SETFACE, tab->ItemI(TAB_I_HUM_FACE), tab->ItemB(TAB_B_HUM_FACEMASK));

      float endurance = AI_i(TAB_I_AI_ENDURANCE)/100.0f;
      resistance = Max(1, 200 + (int)(endurance*1400.0f));
      C_human::TableUpdate(index, not_load_prg);
   }

//----------------------------

   virtual void SaveGame(C_chunk *ck) const{

      C_human::SaveGame(ck);
                                 //write data
      ck->Write(&ignore_uniforms, sizeof(ignore_uniforms));
      ck->Write(&mode, sizeof(ignore_uniforms));
   }

//----------------------------

   virtual bool LoadGame(C_chunk *ck){

      if(!C_human::LoadGame(ck))
         return false;

                              //read data
      ck->Read(&ignore_uniforms, sizeof(ignore_uniforms));
      ck->Read(&mode, sizeof(ignore_uniforms));
      return true;
   }
};//C_enemy

typedef C_enemy *LPC_enemy;

//----------------------------

C_enemy::C_enemy(C_game_mission &m):
   C_human(m, ACTOR_ENEMY),
   mode(ENMMODE_NORMAL),
   ignore_uniforms(false)
{
                              //all enemies are primarily networks on non-host machine
   if(net) network_actor = net->IsHost() ? 0 : net->GetHostPID();
}

//----------------------------

dword C_enemy::cbProc(dword msg, dword prm1, dword prm2){

   int i;
   switch(msg){

      /*
   case CB_GET_VOICE_ID:
      {
         int group = tab->ItemI(TAB_I_ENM_GROUP);
         return tab->ItemI(TAB_I_HUM_VOICE) + (!group ? 50 : 0);
      }

   case CB_GETENEMYGROUP:
      return tab->ItemI(TAB_I_ENM_GROUP);
      */

   case CB_IGNORE_UNIFORMS:
      return ignore_uniforms;

   case CB_SIGNAL:
      {
         LPS_signal_data sd = (LPS_signal_data)prm1;
         if(sd->type==SIGNAL_DETECTOR && sd->sub_type==998)
            ignore_uniforms = true;
      }
      break;

   case CB_OUT_OF_GAME:
      {
                              //problem, we've got no weapon

                              //get pistol
         {
            assert(!network_actor);
            int best_id = -1;
            int best_prio = 0;
                              //find pistol in inventory
            for(i = tab_inventory->ArrayLen(TAB_I_INV_ID); i--; )
            if(tab_inventory->ItemI(TAB_I_INV_ID, i)==INV_COLT){
               int prio = tab_inventory->ItemI(TAB_I_INV_PRIORITY, i);
               if(best_prio < prio){
                  best_prio = prio;
                  best_id = i;
               }
            }
            if(best_id!=-1){
               AI_DEBUG("Adding ammo to pistol");
               int itm = best_id, amount = 20;
                                 //add the resource
               C_inventory::AddItem(itm, amount);

               if(net)
#ifndef ENEMY_NET_SYNC_INV
               if(GetType()==ACTOR_PLAYER)
#endif
               {          //3 = add item (bits:12 amount)
                  const bool g = true;
                  net_msg->Ascend(net_id);
                  net_msg->AddBits(NM_HUMAN_INVENTORY, NET_ACTOR_CODE_BITS, g);
                  net_msg->AddBits(itm, 6, g);
                  net_msg->AddBits(3, 3, g);
                  net_msg->AddBits(amount, 12, g);
                  net_msg->Descend();
               }
               cbProc(CB_WEAPONCHANGE);
               return true;
            }
         }
                              //fail-back - shouldn't happend!

                              //run away of game
         AI_DEBUG("going out");
                              //try to find special checkpoing
         LPC_checkpoint cp = mission.FindCP("CP_OUT");
         if(cp){
                              //insert program - MOVE to CP
                              //disappear
            AddProgram(0, PRG_MOVE, S_prg_add((dword)&cp->GetPos()));
            AddProgram(1, PRG_SETVISIBLE, S_prg_add(false));
            AddProgram(1, PRG_WAIT_SUSPENDED, S_prg_add(-1));
         }else{
            OUTTEXT(" - can't find checkpoint 'CP_OUT' - laying down");
            AddProgram(0, PRG_STAY_DOWN, S_prg_add());
                              //disappear
            AddProgram(1, PRG_SETVISIBLE, S_prg_add(false));
            //AddProgram(2, PRG_SUICIDE, S_prg_add());
         }
      }
      break;

   case CB_APPLY_DIFFICULTY:
      switch(game_profile.difficulty){
      case S_game_profile::DIF_HARD:
                              //hard - increase enemy reaction,
                              // increase enemy shoot quality
         tab->ItemI(TAB_I_AI_REACTION) = AI_i(TAB_I_AI_REACTION) * 1.7f;
         tab->ItemI(TAB_I_AI_SHOOT_QUALITY) = AI_i(TAB_I_AI_REACTION) * 1.7f;
         break;
      }
      break;

   case CB_HIT:
      ignore_uniforms = true;
                              //count stats
      ++mission.stat_num_hits;
      break;

   case CB_DIE:
   case CB_DIE_BY_KNIFE:
                              //count stats
      switch(tab->ItemI(TAB_I_ENM_GROUP)){
      case 0:                 //enemy
         ++mission.stat_enm_killed;
         break;
      case 2:                 //civil
         ++mission.stat_civil_killed;
         //OUTTEXT(GetName());
         break;
      }
      break;
   }
   return C_human::cbProc(msg, prm1, prm2);
}

//----------------------------

dword C_enemy::Tick(const S_tick_context &tc){

   if(!model)
      return 0;

   if(tc.time>=70){
      S_tick_context tc1 = tc;
      tc1.time /= 2;
      Tick(tc1);
      tc1.time = tc.time - tc1.time;
      return Tick(tc1);
   }

   if(net)
      TickGrabSync();

   if(anim_store.waiting){
      PlayStoredAnim();
   }
   anim_man.Tick(tc.time, model);

   int i;

   switch(mode){
   case ENMMODE_DYING:
      if(!network_actor)
         C_human::Tick(tc);
      else
         NetSyncTick(tc.time);
      if(!IsAnimated()){
                                 //setup final position (network actor play animation without check collision,
                                 // so adjust final position after die finshed)
         if(net && !network_actor){
            bool g = true;
            net_msg->Ascend(net_id);
            net_msg->AddBits(NM_HUMAN_DEAD_POS, NET_ACTOR_CODE_BITS, g);
            net_msg->AddVector(frame->GetWorldPos(), g);
            net_msg->Descend();
         }
         if(!network_actor){
            S_vector pos;
            GetCenterPos(pos);
            mission.LinkToFloor(frame, pos, frame, false);
         }
         mode = ENMMODE_DEAD;
      }
                              //flow...
   case ENMMODE_DEAD:
      FreeAimFade(tc.time);
      model->Tick(tc.time);
      break;

   case ENMMODE_NORMAL:
      assert(stay_mode!=SM_DEAD);
      bool allow_tick = true;
      {
         if(network_actor){
            NetSyncTick(tc.time);
            model->Tick(tc.time);
            break;
         }
#ifdef EDITOR
         if(AI_e(TAB_E_AI_ENABLED)!=2)
            break;
#endif

                              //optimization - check if we're longer not rendered (thus not visible)
         //if((scene->GetLastRenderTime()-brest->GetLastRenderTime()) >= 2000)
            //break;
/*
                              //optimization - check if we're in visible sector
         PI3D_frame sct = model;
         while(sct=sct->GetParent())
         if(sct->GetType()==FRAME_SECTOR){
            if(!scene->WasRendered(sct)) return 0;
            break;
         }
         */
                              //optimisation: only one stage for anims when enemy not visible
#ifdef REDUCE_ENEMY_ANIMS
                        //check last render time
         assert(vis_body);
         if(vis_body){
            if(vis_body->GetLastRenderTime()!=mission.GetScene()->GetLastRenderTime())
               anim_man.SetLowStage(MAX_ANIM_STAGE, model);
            else
               anim_man.SetLowStage(0, model);
         }
#endif


         if(program.size()){
            ProcessProgram(tc);
            if(!program.size() && IsAlive()){
               //OUTTEXT(C_fstring("WARNING: enemy %s - program expired!", model->GetName()));
#ifdef EXPIRED_ENEMY_OUT
               //cbProc(CB_OUT_OF_GAME);
#endif
               AddProgram(0, PRG_GUARD, S_prg_add());
            }else
               if(program.front()->prg_item==PRG_WAIT_SUSPENDED)
                  allow_tick = false;
         }else{
#if defined EDITOR && 0
            OUTTEXT(C_fstring("WARNING: enemy %s - no program, adding PRG_GUARD", (const char*)model->GetName()));
#endif
            AddProgram(0, PRG_GUARD, S_prg_add());
         }
//----------------------------
//----------------------------
         i = 0;
         if(using_item){
            switch(using_item->GetType()){
            case ACTOR_LADDER:
               break;
            case ACTOR_AUTOMOBIL:
            case ACTOR_AUTO_CANNON:
               {
                  int dest_pose = -1;
                  bool is_driver = ((LPC_actor)using_item->cbProc(CB_USE_AUTO, 10) == this);
                  if(is_driver){
                                 //our action depends on speed
                     int speed = using_item->cbProc(CB_USE_AUTO, 8);
                     if(fabs(speed)>2){
                        if(using_item->cbProc(CB_USE_AUTO, 5, (dword)this)!=2)
                           dest_pose=POSE_DRIVE_STRAIGHT;
                        else
                           dest_pose = GetBreathPose();
                     }else
                        dest_pose = GetBreathPose();
                  }else
                     dest_pose = GetBreathPose();

                  PlayAnim(dest_pose);

                  if(gun) gun->Tick(tc.time);
                  ShootCountDown(tc.time);
               }
               break;
            case ACTOR_PLAYER:
            case ACTOR_ENEMY:
               break;
            case ACTOR_TIME_BOMB:
               break;

            case ACTOR_CANNON:
            default:
               i = C_human::Tick(tc);
               break;
            }
         }else{
            if(allow_tick)
               i = C_human::Tick(tc);
         }

         bool tick_model = true;

         if(!frame->IsOn()){
            tick_model = false;
         }else{
                              //if guarding...
            if((!program.size() || program.front()->prg_item==PRG_GUARD) &&
               !force_model_tick && !turn_angle){
                                 //check if we've breath pose
               switch(curr_pose){
               case POSE_BREATH: case POSE_BREATH+0x20: case POSE_BREATH+0x40:
               case POSE_COLT_BREATH: case POSE_COLT_BREATH+0x20: case POSE_COLT_BREATH+0x40:
               case POSE_BAZOOKA_BREATH: case POSE_BAZOOKA_BREATH+0x20:
               case POSE_PANZER_BREATH: case POSE_PANZER_BREATH+0x20:
               case POSE_CLIMB_BREATH:
                  {
                                 //check last render time
                     assert(vis_body);
                     if(vis_body){
                        if(vis_body->GetLastRenderTime()!=mission.GetScene()->GetLastRenderTime())
                           tick_model = false;
                     }

                     /*PI3D_visual vis_base = I3DCAST_VISUAL(frame->FindChildFrame("Trup*", ENUMF_VISUAL | ENUMF_USEMASK));
                     assert(vis_base);
                     if(vis_base->GetLastRenderTime()!=mission.GetScene()->GetLastRenderTime())
                        tick_model = false;*/
                  }
                  break;
               }
            }
         }
         if(tick_model){
            model->Tick(tc.time);
            force_model_tick = false;
         }
         return i;
      }
   }
   return 0;
}

//----------------------------
//----------------------------

LPC_actor C_game_mission::CreateActor(int type, dword data){

   LPC_actor ap = NULL;
   switch(type){
   case ACTOR_NULL: ap = new C_actor(*this, ACTOR_NULL); break;
   case ACTOR_PLAYER: ap = new C_player(*this); break;
   case ACTOR_ENEMY: ap = new C_enemy(*this); break;
   default: ap = CreateActor1(type, data);
   }
   if(ap){
      actors.push_back(ap);
      ap->Release();
   }
   return ap;
}

//----------------------------
